﻿Imports System.Math
Module Affichage_Courbes_Dessin
    ''' <summary> Affichage de la courbe des moments sur support variès: écran, image ou imprimante </summary>
    ''' <param name="g">handle graphique </param>
    ''' <param name="i_trav">n° de travée</param>
    ''' <param name="support">type de support: 1=écran / 2 =image / 3 = imprimante</param>
    Public Sub Affichage_Moment(ByVal g As Graphics, ByVal i_trav As Integer, ByVal Support As Integer, ByVal i_comb As Integer, ByVal largeur As Integer, ByVal Hauteur As Integer, ByVal ELU_ELS As Integer,
                                ByVal M(,,) As Double, ByVal Mmax(,,) As Double, ByVal Mmin(,,) As Double, ByVal M1d(,,) As Double, ByVal M2d(,,) As Double,
                                ByVal M3d(,,) As Double, ByVal Mur(,,,) As Double, ByVal x1MAX(,) As Integer, ByVal ΔM(,) As Double)  'affichage des moments
        Dim hauteur_restante, redm1, m1, m2, redH, redW As Double
        Dim i, j, xx, nbLit As Integer
        Dim X, Y, X1, Y1, oriX, oriY As Single
        Dim msg, F_m1MAX, F_Mmin, F_X As String
        Dim w As SizeF
        Dim myPen As New Pen(Color.Black, 1)
        Dim myPen1 As New Pen(Color.Black, 1)
        Dim myPen2 As New Pen(Color.Black, 1)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)

        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                'détermination des coefficient de réduction:  lap(0)=0
                redW = (largeur * 0.8) / PlanCont.Item(i_trav - 1).Lx
                redH = (0.1 * Hauteur) / PlanCont.Item(i_trav - 1).H
                oriX = CSng(0.1 * largeur) : oriY = CSng(0.02 * Hauteur)

            Case 2 'image
                'détermination des coefficient de réduction:  lap(0)=0
                'image 530 x 330
                redW = (largeur * 0.9) / PlanCont.Item(i_trav - 1).Lx
                redH = (0.1 * Hauteur) / PlanCont.Item(i_trav - 1).H
                oriX = 15 : oriY = 5
                myFont = New Font("Times New Roman", 8, FontStyle.Regular)
                myPen = New Pen(Color.Black, 1)

            Case 3 'imprimante - Format A4

        End Select

        Dim myBrush As New SolidBrush(Color.Black)

        'oriX: origine au nu de l'appui gauche
        'oriY: origine au bord supérieur de la poutre
        j = 1

        'dessin de la poutre
        'dessus
        myPen = New Pen(Color.Black, 2)
        Select Case i_trav
            Case 1  'travée n°1
                'appui gauche
                If PlanCont.Item(0).LappG > 0.03 Then 'pas de console gauche
                    X = CSng(oriX - redW * PlanCont.Item(0).LappG) : Y = oriY : X1 = X : Y1 = CSng(Y + redH * (PlanCont.Item(0).H + 0.2)) '0.2 correspond au départ du poteau sur lequel s'appuie la poutre
                    g.DrawLine(myPen, X, Y, X1, Y1)
                    X = CSng(oriX) : Y = CSng(oriY + redH * PlanCont.Item(0).H) : X1 = X : Y1 = CSng(Y + redH * 0.2)
                    g.DrawLine(myPen, X, Y, X1, Y1)
                    X = oriX : Y = oriY : X1 = CSng(X - redW * PlanCont.Item(0).LappG) : Y1 = Y
                    g.DrawLine(myPen, X, Y, X1, Y1)
                Else
                    X = oriX : Y = oriY : X1 = X : Y1 = CSng(Y + redH * PlanCont.Item(0).H)
                    g.DrawLine(myPen, X, Y, X1, Y1)
                End If
                'appui droit
                X = oriX : Y = oriY : X1 = CSng(oriX + redW * PlanCont.Item(0).Lx) : Y1 = Y
                g.DrawLine(myPen, X, Y, X1, Y1)
                X = oriX : Y = CSng(oriY + redH * PlanCont.Item(0).H) : X1 = CSng(oriX + redW * PlanCont.Item(0).Lx) : Y1 = Y
                g.DrawLine(myPen, X, Y, X1, Y1)
                If i_trav < PlanCont.Count Then
                    X = CSng(oriX + redW * PlanCont.Item(0).Lx) : Y = oriY : X1 = CSng(X + redW * (PlanCont.Item(0).LappD + 0.2)) : Y1 = Y
                    g.DrawLine(myPen, X, Y, X1, Y1)
                    Y = CSng(oriY + redH * (PlanCont.Item(0).H + 0.2)) : X1 = X : Y1 = CSng(oriY + redH * PlanCont.Item(0).H)
                    g.DrawLine(myPen, X, Y, X, Y1)
                    X = CSng(oriX + redW * (PlanCont.Item(0).Lx + PlanCont.Item(0).LappD)) : X1 = X : Y1 = CSng(oriY + redH * PlanCont.Item(0).H)
                    g.DrawLine(myPen, X, Y, X, Y1)
                    Y = Y1 : X1 = CSng(X + redW * 0.2)
                    g.DrawLine(myPen, X, Y, X1, Y1)
                Else
                    X = CSng(oriX + redW * PlanCont.Item(0).Lx) : Y = oriY : X1 = CSng(X + redW * PlanCont.Item(0).LappD) : Y1 = Y
                    g.DrawLine(myPen, X, Y, X1, Y1)
                    Y = CSng(oriY + redH * PlanCont.Item(0).H) : X1 = X : Y1 = CSng(Y + (redH * 0.2))
                    g.DrawLine(myPen, X, Y, X1, Y1)
                    X = CSng(oriX + redW * (PlanCont.Item(0).Lx + PlanCont.Item(0).LappD)) : Y = oriY
                    X1 = X : Y1 = CSng(Y + (redH * (0.2 + PlanCont.Item(0).H)))
                    g.DrawLine(myPen, X, Y, X1, Y1)
                End If
            Case Is < PlanCont.Count
                X = CSng(oriX - redW * (PlanCont.Item(i_trav - 1).LappG + 0.2)) : Y = oriY
                X1 = CSng(oriX + redW * (PlanCont.Item(i_trav - 1).Lx + PlanCont.Item(i_trav - 1).LappD + 0.2)) : Y1 = oriY
                g.DrawLine(myPen, X, Y, X1, Y1)
                Y = CSng(oriY + redH * PlanCont.Item(i_trav - 1).H) : X1 = CSng(X + redW * 0.2) : Y1 = Y
                g.DrawLine(myPen, X, Y, X1, Y1)
                X = X1 : Y1 = CSng(Y + redH * 0.2)
                g.DrawLine(myPen, X, Y, X1, Y1)
                X = CSng(X + redW * PlanCont.Item(i_trav - 1).LappG) : X1 = X
                g.DrawLine(myPen, X, Y1, X1, Y)
                X1 = CSng(X + redW * PlanCont.Item(i_trav - 1).Lx)
                g.DrawLine(myPen, X, Y, X1, Y)
                g.DrawLine(myPen, X1, Y, X1, Y1)
                X = CSng(X1 + redW * PlanCont.Item(i_trav - 1).LappD)
                g.DrawLine(myPen, X, Y1, X, Y)
                X = CSng(oriX + redW * (PlanCont.Item(i_trav - 1).Lx + PlanCont.Item(i_trav - 1).LappD)) : X1 = CSng(X + redW * 0.2)
                g.DrawLine(myPen, X, Y, X1, Y)
            Case PlanCont.Count
                X = CSng(oriX - redW * (PlanCont.Item(i_trav - 1).LappG + 0.2)) : Y = oriY
                If PlanCont.Item(i_trav - 1).LappD > 0.03 Then 'pas de console droite
                    X1 = CSng(oriX + redW * (PlanCont.Item(i_trav - 1).Lx + PlanCont.Item(i_trav - 1).LappD))
                Else
                    X1 = CSng(oriX + redW * PlanCont.Item(i_trav - 1).Lx)
                End If
                Y1 = oriY
                g.DrawLine(myPen, X, Y, X1, Y1)
                Y = CSng(oriY + redH * PlanCont.Item(i_trav - 1).H) : X1 = CSng(X + redW * 0.2) : Y1 = Y
                g.DrawLine(myPen, X, Y, X1, Y1)
                X = X1 : Y1 = CSng(Y + redH * 0.2)
                g.DrawLine(myPen, X, Y, X1, Y1)
                X = CSng(X + redW * PlanCont.Item(i_trav - 1).LappG) : X1 = X
                g.DrawLine(myPen, X, Y1, X1, Y)
                X1 = CSng(X + redW * PlanCont.Item(i_trav - 1).Lx)
                g.DrawLine(myPen, X, Y, X1, Y)
                'droite
                If PlanCont.Item(i_trav - 1).LappD > 0.03 Then 'pas de console droite
                    g.DrawLine(myPen, X1, Y, X1, Y1)
                    X = CSng(X1 + redW * PlanCont.Item(i_trav - 1).LappD)
                    g.DrawLine(myPen, X, Y1, X, oriY)
                Else
                    g.DrawLine(myPen, X1, Y, X1, oriY)
                End If
        End Select
        'axe appui gauche
        myPen = New Pen(Color.Black, 1)
        myPen.DashStyle = Drawing.Drawing2D.DashStyle.DashDotDot
        If i_trav > 1 Then
            X = CSng(oriX - redW * PlanCont.Item(i_trav - 1).LappG / 2)
            g.DrawLine(myPen, X, 5, X, Hauteur - 15)
        End If
        If PlanCont.Item(i_trav - 1).LappG > 0.03 Then 'pas de console gauche
            X = CSng(oriX - redW * PlanCont.Item(i_trav - 1).LappG / 2)
            g.DrawLine(myPen, X, 5, X, Hauteur - 15)
        End If
        'axe appui droit
        If PlanCont.Item(i_trav - 1).LappD > 0.03 Or i_trav < PlanCont.Count Then  'pas de console droite
            X = CSng(oriX + redW * (PlanCont.Item(i_trav - 1).Lx + PlanCont.Item(i_trav - 1).LappD / 2))
            g.DrawLine(myPen, X, 5, X, Hauteur - 15)
        End If



        'dessin des aciers longitudinaux
        myPen = New Pen(Color.Blue, 1)
        myPen.DashStyle = Drawing.Drawing2D.DashStyle.Solid
        For j = 1 To 3
            With PlanCont.Item(i_trav - 1)
                Select Case j
                    Case 1
                        Select Case .Type_Acier_Travée
                            Case 1
                                For i = 1 To .TS_trav.Count
                                    X = CSng(.TS_trav.Item(i - 1).X1acier * redW) + oriX : X1 = CSng(.TS_trav.Item(i - 1).X2acier * redW) + oriX
                                    Y = CSng(oriY + redH * (PlanCont.Item(i_trav - 1).H) - 1 - i * 3)
                                    g.DrawLine(myPen, X, Y, X1, Y)
                                Next i
                            Case 2
                                For i = 1 To .LitInf.Count
                                    X = CSng(.LitInf.Item(i - 1).X1acier * redW) + oriX : X1 = CSng(.LitInf.Item(i - 1).X2acier * redW) + oriX
                                    Y = CSng(oriY + redH * (PlanCont.Item(i_trav - 1).H) - 1 - i * 3)
                                    g.DrawLine(myPen, X, Y, X1, Y)
                                Next i
                        End Select
                    Case 2
                        Select Case .Type_Acier_Appui_Gauche
                            Case 1
                                For i = 1 To .TS_AppG.Count
                                    X = CSng(.TS_AppG.Item(i - 1).X1acier * redW) + oriX : X1 = CSng(.TS_AppG.Item(i - 1).X2acier * redW) + oriX
                                    Y = CSng(oriY + 2 + i * 2)
                                    g.DrawLine(myPen, X, Y, X1, Y)
                                Next i
                            Case 2
                                For i = 1 To .LitSupG.Count
                                    X = CSng(.LitSupG.Item(i - 1).X1acier * redW) + oriX : X1 = CSng(.LitSupG.Item(i - 1).X2acier * redW) + oriX
                                    Y = CSng(oriY + 2 + i * 2)
                                    g.DrawLine(myPen, X, Y, X1, Y)
                                Next i
                        End Select
                    Case 3
                        Select Case .Type_Acier_Appui_Droit
                            Case 1
                                For i = 1 To .TS_AppD.Count
                                    X = CSng(.TS_AppD.Item(i - 1).X1acier * redW) + oriX : X1 = CSng(.TS_AppD.Item(i - 1).X2acier * redW) + oriX
                                    Y = CSng(oriY + 2 + i * 2)
                                    g.DrawLine(myPen, X, Y, X1, Y)
                                Next i
                            Case 2
                                For i = 1 To .LitSupD.Count
                                    X = CSng(.LitSupD.Item(i - 1).X1acier * redW) + oriX : X1 = CSng(.LitSupD.Item(i - 1).X2acier * redW) + oriX
                                    Y = CSng(oriY + 2 + i * 2)
                                    g.DrawLine(myPen, X, Y, X1, Y)
                                Next i
                        End Select

                End Select
            End With
        Next j

        'dessin des moments
        'détermination du coefficient de réduction des moments
        With PlanCont.Item(i_trav - 1)
            Select Case ELU_ELS
                Case 1 'ELU fondamental
                    'm1 = Max(Abs(.m2d.Item(ELU_ELS).M.Item(0)), Abs(.m3d.Item(ELU_ELS).M.Item(CInt(.Lc * 100))))
                    'm1 = Max(m1, Abs(.Mmax.Item(ELU_ELS).M.Item(.x1MAX.Item(ELU_ELS))))
                    m1 = Max(Abs(M2d(ELU_ELS, i_trav, 0)), Abs(M3d(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100)))))
                    m1 = Max(m1, Abs(Mmax(ELU_ELS, i_trav, x1MAX(ELU_ELS, i_trav))))
                    If m1 = 0 Then
                        myFont = New Font("Times New Roman", 12, FontStyle.Bold)
                        msg = "Aucune combinaison n'a été renseignée !!!"
                        Y = CSng(Hauteur / 2) 'CSng(PbImage.Height / 2)
                        w = g.MeasureString(msg, myFont)
                        X = (largeur - w.Width) / 2 ' CSng(PbImage.Width - w.Width) / 2
                        g.DrawString(msg, myFont, myBrush, X, Y)
                        Exit Sub
                    End If

                    m2 = Max(Mur(ELU_ELS, i_trav, 1, 4), Mur(ELU_ELS, i_trav, 2, 4))
                    If m2 < Mur(ELU_ELS, i_trav, 3, 4) Then m1 = Mur(ELU_ELS, i_trav, 3, 4)
                    If m2 > m1 Then m1 = m2
                    Select Case Support
                        Case 1 'écran
                            hauteur_restante = (Hauteur - oriY - redH * (.H + 0.2))
                        Case 2 'image
                            hauteur_restante = (330 - oriY - redH * (.H + 0.2))
                    End Select
                    redm1 = (hauteur_restante / (2 * m1 * 1.1))                'coefficient de réduction des moments
                Case 2 'ELU accidentel
                    '        'Select Case type_image
                    '        '    Case 1
                    '        '        Call image_feu()
                    '        '        Exit Sub
                    '        '    Case 2, 3, 4
                    '        '        Picture1.Cls()
                    '        msg = "Non disponible pour cette version logicielle"
                    '        Y = CSng(Image.Height / 2)
                    '        w = g.MeasureString(msg, myFont)
                    '        X = CSng(Image.Width - w.Width) / 2
                    '        g.DrawString(msg, myFont, myBrush, X, Y)
                    '        Exit Sub
                    '        'End Select
                Case 3  'ELS
                    '        If fiss(1) = 1 Then 'si fissuration peu préjudiciable
                    '            myFont = New Font("Times New Roman", 12, FontStyle.Bold)
                    '            msg = "La fissuration est classée peu préjudiciable." & vbCrLf & _
                    '            "Le calcul à l'Etat Limite de Service n'a pas d'intérét. " & vbCrLf & _
                    '            "En conséquence, aucun calcul n'a été réalisé à cet Etat Limite."
                    '            Y = CSng(Image.Height / 2)
                    '            w = g.MeasureString(msg, myFont)
                    '            X = CSng(Image.Width - w.Width) / 2
                    '            g.DrawString(msg, myFont, myBrush, X, Y)
                    '            Exit Sub
                    '        End If
                    '        If Abs(-m2d(ELU_ELS, i_trav, 0)) > Abs(-m3d(ELU_ELS, i_trav, CInt(lc(i_trav) * 100))) Then m1 = Abs(-m2d(ELU_ELS, i_trav, 0)) Else m1 = Abs(-m3d(ELU_ELS, i_trav, CInt(lc(i_trav) * 100)))
                    '        If Abs(m1MAX(ELU_ELS, i_trav)) > m1 Then m1 = Abs(m1MAX(ELU_ELS, i_trav))
                    '        If m1 = 0 Then
                    '            myFont = New Font("Times New Roman", 12, FontStyle.Bold)
                    '            msg = "Aucune combinaison n'a été renseignée !!!"
                    '            Y = CSng(Image.Height / 2)
                    '            w = g.MeasureString(msg, myFont)
                    '            X = CSng(Image.Width - w.Width) / 2
                    '            g.DrawString(msg, myFont, myBrush, X, Y)
                    '            Exit Sub
                    '        End If
                    '        If mur(ELU_ELS, i_trav, 1, 4) > mur(ELU_ELS, i_trav, 2, 4) Then m1 = mur(ELU_ELS, i_trav, 1, 4) Else m1 = mur(ELU_ELS, i_trav, 2, 4)
                    '        If m1 < mur(ELU_ELS, i_trav, 3, 4) Then m1 = mur(ELU_ELS, i_trav, 3, 4)
                    '        hauteur_restante = (Image.Height - oriY - redH * (h(i_trav) + 0.2))
                    '        redm1 = (hauteur_restante / (2 * m1 * 1.1)) 'coefficient de réduction des moments
            End Select
        End With
        'dessin du moment
        '' dessin des Axes X et Mt
        myPen = New Pen(Color.Black, 1)
        '-->Axe des X
        oriY = CSng(oriY + redH * (PlanCont.Item(i_trav - 1).H + 0.2))
        If Mur(ELU_ELS, i_trav, 3, 4) > Mur(ELU_ELS, i_trav, 2, 4) Then m1 = Mur(ELU_ELS, i_trav, 3, 4) Else m1 = Mur(ELU_ELS, i_trav, 2, 4)
        m1 = m1 * redm1
        If m1 < hauteur_restante / 4 Then m1 = hauteur_restante / 4 'imposer une hauteur minimale
        oriY = CSng(oriY + m1 * 1.1)
        X = oriX : X1 = CSng(oriX + redW * PlanCont.Item(i_trav - 1).Lx) : Y = oriY : Y1 = Y
        g.DrawLine(myPen, X, Y, X1, Y1)
        '-->Origine des X
        g.DrawLine(myPen, oriX, oriY + 2, X, oriY - 2)
        msg = "0"
        g.DrawString(msg, myFont, myBrush, oriX, oriY)
        '-->Axe des Mt
        X = CSng(oriX + redW * PlanCont.Item(i_trav - 1).Lx / 2) : X1 = X
        If Mur(ELU_ELS, i_trav, 3, 4) > Mur(ELU_ELS, i_trav, 2, 4) Then m1 = Mur(ELU_ELS, i_trav, 3, 4) Else m1 = Mur(ELU_ELS, i_trav, 2, 4)
        m1 = m1 * redm1
        Y = CSng(oriY - m1 * 1.05)
        m1 = Mur(ELU_ELS, i_trav, 1, 4) : Y1 = CSng(Hauteur - 15)
        g.DrawLine(myPen, X, Y, X1, Y1)
        '-->Extrémité sens porteur Lx
        X = CSng(oriX + redW * PlanCont.Item(i_trav - 1).Lx)
        msg = (PlanCont.Item(i_trav - 1).Lx * 100).ToString("0")
        g.DrawString(msg, myFont, myBrush, X, oriY)


        'dessin du moment de flexion
        X1 = 0 'x2 = 0 : x3 = 0 : x4 = 0
        'If ELU_ELS = 2 Then
        '    'Select Case type_image
        '    '    Case 1 'feu normal

        '    '    Case 2 'feu eclatement
        '    '    Case 3 'seisme
        '    '    Case 4 'autre
        '    'End Select
        'Else
        '    Call moment()
        'End If
        Select Case i_trav
            Case 1
                With PlanCont.Item(0)
                    If .LappG < 0.05 Then 'existence d'une console à gauche consolG = 1
                        F_Mmin = Format(Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * 1000, "####0.00")
                        msg = F_Mmin & " KN.m"
                        w = g.MeasureString(msg, myFont)
                        X = CSng(oriX + redW * .Lx / 2)
                        Y = CSng(oriY + Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * redm1)
                        g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                        Y = CSng(oriY + Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * redm1 - w.Height)
                        g.DrawString(msg, myFont, myBrush, X + 5, Y)
                    Else
                        'Affichage moment maxi en travée
                        F_m1MAX = Format(Mmax(ELU_ELS, i_trav, x1MAX(ELU_ELS, i_trav)) * 1000, "####0.00")
                        msg = F_m1MAX & " kN.m"
                        myFont = New Font("Times New Roman", 8, FontStyle.Regular)
                        w = g.MeasureString(msg, myFont)
                        X = CSng(oriX + redW * .Lx / 2)
                        Y = CSng(oriY + Mmax(ELU_ELS, i_trav, x1MAX(ELU_ELS, i_trav)) * redm1)
                        g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                        g.DrawString(msg, myFont, myBrush, X + 5, Y + 5) 'affichage moment
                        xx = CInt(x1MAX(ELU_ELS, i_trav) - .a1 * 100)
                        X = CSng(oriX + redW * xx / 100)
                        g.DrawLine(myPen, X, oriY + 2, X, oriY - 2)
                        F_X = Format(x1MAX(ELU_ELS, i_trav) - .a1 * 100, "##0")
                        msg = F_X & " cm"
                        g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse

                        'Affichage moment appui intermédiaire appui droit
                        'Affichage moment appui d'about et armature correspondante
                        If i_trav < PlanCont.Count Then
                            F_Mmin = Format(Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * 1000, "####0.00")
                            msg = F_Mmin & " kN.m"
                            w = g.MeasureString(msg, myFont)
                            X = CSng(oriX + redW * .Lx / 2)
                            Y = CSng(oriY + Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * redm1)
                            g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                            Y = CSng(oriY + Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * redm1 - w.Height)
                            g.DrawString(msg, myFont, myBrush, X + 5, Y)
                            'affichage de l'abscisse de l'armature sur appui droit
                            Select Case .Type_Acier_Appui_Droit
                                Case 1
                                    For i = 1 To .TS_AppD.Count
                                        X = CSng(oriX + redW * .TS_AppD.Item(i - 1).X1acier)
                                        msg = (.TS_AppD.Item(i - 1).X1acier * 100).ToString("0") & " cm"
                                        g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                                    Next
                                Case 2
                                    For i = 1 To .LitSupD.Count
                                        X = CSng(oriX + redW * .LitSupD.Item(i - 1).X1acier)
                                        msg = (.LitSupD.Item(i - 1).X1acier * 100).ToString("0") & " cm"
                                        g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                                    Next
                            End Select
                            'Affichage moment appui d'about
                            If Aff.Reprise_M0_1_porteur = True Then
                                'F_Mmin = Format(Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * 1000, "####0.00")
                                'msg = F_Mmin & " kN.m"
                                'w = g.MeasureString(msg, myFont)
                                'X = CSng(oriX + redW * .Lx / 2)
                                'Y = CSng(oriY + Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * redm1)
                                'g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                                'Y = CSng(oriY + Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * redm1 - w.Height)
                                'g.DrawString(msg, myFont, myBrush, X + 5, Y)
                                'affichage de l'abscisse de l'armature sur appui about
                                Select Case .Type_Acier_Appui_Gauche
                                    Case 1
                                        For i = 1 To .TS_AppG.Count
                                            X = CSng(oriX + redW * .TS_AppG.Item(i - 1).X2acier)
                                            msg = (.TS_AppG.Item(i - 1).X2acier * 100).ToString("0") & " cm"
                                            g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                                        Next
                                    Case 2
                                        For i = 1 To .LitSupG.Count
                                            X = CSng(oriX + redW * .LitSupG.Item(i - 1).X2acier)
                                            msg = (.LitSupG.Item(i - 1).X2acier * 100).ToString("0") & " cm"
                                            g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                                        Next
                                End Select
                            End If
                        End If

                    End If
                End With
            Case Is < PlanCont.Count
                With PlanCont.Item(i_trav - 1)
                    'Affichage moment maxi en travée
                    F_m1MAX = Format(Mmax(ELU_ELS, i_trav, x1MAX(ELU_ELS, i_trav)) * 1000, "####0.00")
                    msg = F_m1MAX & " kN.m"
                    myFont = New Font("Times New Roman", 8, FontStyle.Regular)
                    xx = CInt(x1MAX(ELU_ELS, i_trav)) ' - kap(i_trav, 1) * Lap(i_trav - consolG) * 50)
                    w = g.MeasureString(msg, myFont)
                    X = CSng(oriX + redW * .Lx / 2)
                    Y = CSng(oriY + Mmax(ELU_ELS, i_trav, x1MAX(ELU_ELS, i_trav)) * redm1)
                    g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                    g.DrawString(msg, myFont, myBrush, X + 5, Y + 5) 'affichage moment
                    xx = CInt(x1MAX(ELU_ELS, i_trav)) ' - kap(i_trav, 1) * Lap(i_trav - consolG) * 50)
                    X = CSng(oriX + redW * xx / 100)
                    g.DrawLine(myPen, X, oriY + 2, X, oriY - 2)
                    F_X = Format(x1MAX(ELU_ELS, i_trav)) '- kap(i_trav, 1) * Lap(i_trav - consolG) * 50, "##0")
                    msg = F_X & " cm"
                    g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                    'Affichage moment  mini  sur appui gauche
                    F_Mmin = Format(Mmin(ELU_ELS, i_trav, 0) * 1000, "####0.00")
                    msg = F_Mmin & " kN.m"
                    w = g.MeasureString(msg, myFont)
                    X = CSng(oriX + redW * .Lx / 2)
                    Y = CSng(oriY + Mmin(ELU_ELS, i_trav, 0) * redm1)
                    g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                    Y = CSng(oriY + Mmin(ELU_ELS, i_trav, 0) * redm1 - w.Height)
                    g.DrawString(msg, myFont, myBrush, X + 5, Y)
                    'affichage abscisse armature sur appui gauche
                    Select Case .Type_Acier_Appui_Gauche
                        Case 1
                            For i = 1 To .TS_AppG.Count
                                X = CSng(oriX + redW * .TS_AppG.Item(i - 1).X2acier)
                                msg = (.TS_AppG.Item(i - 1).X2acier * 100).ToString("0") & " cm"
                                g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                            Next
                        Case 2
                            For i = 1 To .LitSupG.Count
                                X = CSng(oriX + redW * .LitSupG.Item(i - 1).X2acier)
                                msg = (.LitSupG.Item(i - 1).X2acier * 100).ToString("0") & " cm"
                                g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                            Next
                    End Select
                    'Affichage moment  mini  sur appui droit
                    F_Mmin = Format(Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * 1000, "####0.00")
                    msg = F_Mmin & " kN.m"
                    w = g.MeasureString(msg, myFont)
                    X = CSng(oriX + redW * .Lx / 2)
                    Y = CSng(oriY + Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * redm1)
                    g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                    Y = CSng(oriY + Mmin(ELU_ELS, i_trav, CInt(Truncate(.Lcx * 100))) * redm1 - w.Height)
                    g.DrawString(msg, myFont, myBrush, X + 5, Y)
                    'affichage de l'abscisse de l'armature sur appui droit
                    Select Case .Type_Acier_Appui_Droit
                        Case 1
                            For i = 1 To .TS_AppD.Count
                                X = CSng(oriX + redW * .TS_AppD.Item(i - 1).X1acier)
                                msg = (.TS_AppD.Item(i - 1).X1acier * 100).ToString("0") & " cm"
                                g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                            Next
                        Case 2
                            For i = 1 To .LitSupD.Count
                                X = CSng(oriX + redW * .LitSupD.Item(i - 1).X1acier)
                                msg = (.LitSupD.Item(i - 1).X1acier * 100).ToString("0") & " cm"
                                g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                            Next
                    End Select
                End With
            Case PlanCont.Count
                With PlanCont.Item(PlanCont.Count - 1)
                    If .LappD < 0.05 Then
                        'x2 = Mmin(ELU_ELS, i_trav, 0)
                        F_Mmin = Format(Mmin(ELU_ELS, i_trav, 0) * 1000, "####0.00")
                        msg = F_Mmin & " KN.m"
                        w = g.MeasureString(msg, myFont)
                        X = CSng(oriX + redW * .Lx / 2)
                        Y = CSng(oriY + Mmin(ELU_ELS, i_trav, 0) * redm1)
                        g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                        Y = CSng(oriY + Mmin(ELU_ELS, i_trav, 0) * redm1 - w.Height)
                        g.DrawString(msg, myFont, myBrush, X + 5, Y)
                    Else
                        'Affichage moment maxi en travée
                        F_m1MAX = Format(Mmax(ELU_ELS, i_trav, x1MAX(ELU_ELS, i_trav)) * 1000, "####0.00")
                        msg = F_m1MAX & " kN.m"
                        myFont = New Font("Times New Roman", 8, FontStyle.Regular)
                        xx = CInt(x1MAX(ELU_ELS, i_trav)) '- kap(i_trav, 1) * Lap(i_trav - consolG) * 50)
                        w = g.MeasureString(msg, myFont)
                        X = CSng(oriX + redW * .Lx / 2)
                        Y = CSng(oriY + Mmax(ELU_ELS, i_trav, x1MAX(ELU_ELS, i_trav)) * redm1)
                        g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                        g.DrawString(msg, myFont, myBrush, X + 5, Y + 5) 'affichage moment
                        xx = CInt(x1MAX(ELU_ELS, i_trav)) '- kap(i_trav, 1) * Lap(i_trav - consolG) * 50)
                        X = CSng(oriX + redW * xx / 100)
                        g.DrawLine(myPen, X, oriY + 2, X, oriY - 2)
                        F_X = Format(x1MAX(ELU_ELS, i_trav)) ' - kap(i_trav, 1) * Lap(i_trav - consolG) * 50, "##0")
                        msg = F_X & " cm"
                        g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                        'Affichage moment  mini en travée
                        F_Mmin = Format(Mmin(ELU_ELS, i_trav, 0) * 1000, "####0.00")
                        msg = F_Mmin & " KN.m"
                        w = g.MeasureString(msg, myFont)
                        X = CSng(oriX + redW * .Lx / 2)
                        Y = CSng(oriY + Mmin(ELU_ELS, i_trav, 0) * redm1)
                        g.DrawLine(myPen, X + 2, Y, X - 2, Y)
                        Y = CSng(oriY + Mmin(ELU_ELS, i_trav, 0) * redm1 - w.Height)
                        g.DrawString(msg, myFont, myBrush, X + 5, Y)
                        'affichage abscisse armature sur appui gauche
                        Select Case .Type_Acier_Appui_Gauche
                            Case 1
                                For i = 1 To .TS_AppG.Count
                                    X = CSng(oriX + redW * .TS_AppG.Item(i - 1).X2acier)
                                    msg = (.TS_AppG.Item(i - 1).X2acier * 100).ToString("0") & " cm"
                                    g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                                Next
                            Case 2
                                For i = 1 To .LitSupG.Count
                                    X = CSng(oriX + redW * .LitSupG.Item(i - 1).X2acier)
                                    msg = (.LitSupG.Item(i - 1).X2acier * 100).ToString("0") & " cm"
                                    g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                                Next
                        End Select
                        'affichage abscisse armature sur appui droit
                        Select Case .Type_Acier_Appui_Gauche
                            Case 1
                                For i = 1 To .TS_AppD.Count
                                    X = CSng(oriX + redW * .TS_AppG.Item(i - 1).X1acier)
                                    msg = (.TS_AppD.Item(i - 1).X1acier * 100).ToString("0") & " cm"
                                    g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                                Next
                            Case 2
                                For i = 1 To .LitSupD.Count
                                    X = CSng(oriX + redW * .LitSupD.Item(i - 1).X1acier)
                                    msg = (.LitSupD.Item(i - 1).X1acier * 100).ToString("0") & " cm"
                                    g.DrawString(msg, myFont, myBrush, X, oriY)  'affichage abscisse
                                Next
                        End Select
                    End If
                End With
        End Select
        'Affichage des courbes de moments
        myPen = New Pen(Color.Red, 1) : myPen1 = New Pen(Color.Green, 1) : myPen2 = New Pen(Color.Chocolate, 1)
        For xx = 0 To CInt(Truncate(PlanCont.Item(i_trav - 1).Lcx * 100)) - 2 Step 2
            X = CSng(oriX + (redW * xx / 100) - (PlanCont.Item(i_trav - 1).a1 * redW))
            X1 = CSng(oriX + (redW * (xx + 2) / 100) - (PlanCont.Item(i_trav - 1).a1 * redW))
            If PlanCont.Item(i_trav - 1).LappD > 0.05 And PlanCont.Item(i_trav - 1).LappG > 0.05 Then
                'moment positif en travée
                Y = CSng(oriY + Mmax(ELU_ELS, i_trav, xx) * redm1) : Y1 = CSng(oriY + Mmax(ELU_ELS, i_trav, xx + 2) * redm1)
                g.DrawLine(myPen, X, Y, X1, Y1)
                'décalage al moment positif en travée
                Y = CSng(oriY + M1d(ELU_ELS, i_trav, xx) * redm1) : Y1 = CSng(oriY + M1d(ELU_ELS, i_trav, xx + 2) * redm1)
                g.DrawLine(myPen1, X, Y, X1, Y1)
            End If
            'moment négatif sur appui
            Y = CSng(oriY + Mmin(ELU_ELS, i_trav, xx) * redm1) : Y1 = CSng(oriY + Mmin(ELU_ELS, i_trav, xx + 2) * redm1)
            g.DrawLine(myPen, X, Y, X1, Y1)
            If PlanCont.Item(i_trav - 1).LappG > 0.05 Then
                'décalage al moment négatif sur appui gauche
                Y = CSng(oriY + M2d(ELU_ELS, i_trav, xx) * redm1) : Y1 = CSng(oriY + M2d(ELU_ELS, i_trav, xx + 2) * redm1)
                g.DrawLine(myPen1, X, Y, X1, Y1)
            End If
            If PlanCont.Item(i_trav - 1).LappD > 0.05 Then
                'décalage al moment négatif sur appui droit
                Y = CSng(oriY + M3d(ELU_ELS, i_trav, xx) * redm1) : Y1 = CSng(oriY + M3d(ELU_ELS, i_trav, xx + 2) * redm1)
                g.DrawLine(myPen1, X, Y, X1, Y1)
            End If
        Next
        If Aff.Ecretage_Moment = True Then
            Select Case i_trav
                Case 1
                    Y = CSng(oriY + (M3d(ELU_ELS, i_trav, CInt(Truncate(PlanCont.Item(i_trav - 1).Lcx * 100))) + ΔM(i_trav, 3)) * redm1)
                    X = CSng(oriX + (redW * PlanCont.Item(i_trav - 1).Lcx) - (PlanCont.Item(i_trav - 1).a2 * redW))
                    X1 = CSng(X - 0.6 * redW) 'provisoire
                    g.DrawLine(myPen2, X, Y, X1, Y)
                Case PlanCont.Count
                    'appui 1
                    Y = CSng(oriY + (M2d(ELU_ELS, i_trav, 0) + ΔM(i_trav, 2)) * redm1)
                    X = CSng(oriX - (PlanCont.Item(i_trav - 1).a1 * redW))
                    X1 = CSng(X + 0.6 * redW) 'provisoire
                    g.DrawLine(myPen2, X, Y, X1, Y)
                Case Else
                    'appui 1
                    Y = CSng(oriY + (M2d(ELU_ELS, i_trav, 0) + ΔM(i_trav, 2)) * redm1)
                    X = CSng(oriX - (PlanCont.Item(i_trav - 1).a1 * redW))
                    X1 = CSng(X + 0.6 * redW) 'provisoire
                    g.DrawLine(myPen2, X, Y, X1, Y)
                    'appui 2
                    Y = CSng(oriY + (M3d(ELU_ELS, i_trav, CInt(Truncate(PlanCont.Item(i_trav - 1).Lcx * 100))) + ΔM(i_trav, 3)) * redm1)
                    X = CSng(oriX + (redW * PlanCont.Item(i_trav - 1).Lcx) - (PlanCont.Item(i_trav - 1).a2 * redW))
                    X1 = CSng(X - 0.6 * redW) 'provisoire
                    g.DrawLine(myPen2, X, Y, X1, Y)
            End Select

            ' 
        End If

        'affichage de la combinaison souhaité
        Select Case Support
            Case 1 'écran
                If i_comb >= 1 Then
                    myPen = New Pen(Color.SkyBlue, 1)

                    For xx = 0 To CInt(Truncate(PlanCont.Item(i_trav - 1).Lcx * 100)) - 2 Step 2
                        X = CSng(oriX + (redW * xx / 100) - (PlanCont.Item(i_trav - 1).a1 * redW))
                        X1 = CSng(oriX + (redW * (xx + 2) / 100) - (PlanCont.Item(i_trav - 1).a1 * redW))
                        Y = CSng(oriY + M(i_comb, i_trav, xx) * redm1)
                        Y1 = CSng(oriY + M(i_comb, i_trav, xx + 2) * redm1)
                        g.DrawLine(myPen, X, Y, X1, Y1)
                    Next
                End If
            Case 2

        End Select

        'Dessin des courbes enveloppes par les moments résistants
        myPen1 = New Pen(Color.Blue, 1)
        With PlanCont.Item(i_trav - 1)
            For j = 1 To 3
                Select Case j
                    Case 1
                        Mur(ELU_ELS, i_trav, j, 0) = 0
                        Select Case .Type_Acier_Travée
                            Case 1
                                nbLit = .TS_trav.Count
                            Case 2
                                nbLit = .LitInf.Count
                        End Select
                        If i_trav = 1 And .LappG < 0.05 Then nbLit = 0 'Console à gauche
                        If i_trav = PlanCont.Count And .LappD < 0.05 Then nbLit = 0 'Console à droite
                    Case 2
                        Mur(ELU_ELS, i_trav, j, 0) = 0
                        Select Case .Type_Acier_Appui_Gauche
                            Case 1
                                nbLit = .TS_AppG.Count
                            Case 2
                                nbLit = .LitSupG.Count
                        End Select
                        If i_trav = 1 And .LappG < 0.05 Then nbLit = 0 'Console à gauche
                    Case 3
                        Mur(ELU_ELS, i_trav, j, 0) = 0
                        Select Case .Type_Acier_Appui_Droit
                            Case 1
                                nbLit = .TS_AppD.Count
                            Case 2
                                nbLit = .LitSupD.Count
                        End Select
                        If i_trav = PlanCont.Count And .LappD < 0.05 Then nbLit = 0 'Console à droite
                End Select
                For i = 1 To nbLit
                    If i = nbLit Then
                        'If i_trav = 3 And j = 2 Then Stop
                        'dessin de la courbe de moment résistant du dernier lit
                        Select Case j
                            Case 1 'acier en travée
                                Select Case .Type_Acier_Travée
                                    Case 1
                                        X = CSng(oriX + redW * .TS_trav.Item(i - 1).X1acierLS) ' + (Lap(i_trav - consolG) / 2)) * 100 'changement d'origine du repère
                                        X1 = CSng(oriX + redW * .TS_trav.Item(i - 1).X2acierLS)
                                    Case 2
                                        X = CSng(oriX + redW * .LitInf.Item(i - 1).X1acierLS) ' + (Lap(i_trav - consolG) / 2)) * 100 'changement d'origine du repère
                                        X1 = CSng(oriX + redW * .LitInf.Item(i - 1).X2acierLS) ' + (Lap(i_trav - consolG) / 2)) * 100 'changement d'origine du repère
                                End Select
                                Y = CSng(oriY + Mur(ELU_ELS, i_trav, j, i) * redm1)
                                g.DrawLine(myPen1, X, Y, X1, Y)
                            Case 2
                                X = oriX  'origine = axe de l'appui gauche
                                Select Case .Type_Acier_Appui_Gauche
                                    Case 1
                                        X1 = CSng(oriX + redW * .TS_AppG.Item(i - 1).X2acierLS)
                                    Case 2
                                        X1 = CSng(oriX + redW * .LitSupG.Item(i - 1).X2acierLS)
                                End Select
                                Y = CSng(oriY - Mur(ELU_ELS, i_trav, j, i) * redm1)
                                g.DrawLine(myPen1, X, Y, X1, Y)
                            Case 3
                                Select Case .Type_Acier_Appui_Droit
                                    Case 1
                                        X = CSng(oriX + redW * .TS_AppD.Item(i - 1).X1acierLS)
                                    Case 2
                                        X = CSng(oriX + redW * .LitSupD.Item(i - 1).X1acierLS)
                                End Select
                                X1 = CSng(oriX + redW * .Lx) ' + (Lap(i_trav - consolG) / 2) + (Lap(i_trav + 1 - consolG) / 2)) * 100
                                Y = CSng(oriY - Mur(ELU_ELS, i_trav, j, i) * redm1)
                                g.DrawLine(myPen1, X, Y, X1, Y)
                        End Select

                    Else
                        'dessin de la courbe de moment résistant du premier lit (et du deuxième lit si 3 lits)
                        'dessin des moments résistants - partie plate
                        Select Case j
                            Case 1
                                Select Case .Type_Acier_Travée
                                    Case 1
                                        'côté gauche aciers inférieurs
                                        X = CSng(oriX + redW * .TS_trav.Item(i - 1).X1acierLS)
                                        X1 = CSng(oriX + redW * .TS_trav.Item(i).X1acier)
                                        Y = CSng(oriY + Mur(ELU_ELS, i_trav, j, i) * redm1)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                        'côté droit aciers inférieurs
                                        X = CSng(oriX + redW * .TS_trav.Item(i).X2acier)
                                        X1 = CSng(oriX + redW * .TS_trav.Item(i - 1).X2acierLS)
                                        Y = CSng(oriY + Mur(ELU_ELS, i_trav, j, i) * redm1)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                    Case 2
                                        'côté gauche aciers inférieurs
                                        X = CSng(oriX + redW * .LitInf.Item(i - 1).X1acierLS)
                                        X1 = CSng(oriX + redW * .LitInf.Item(i).X1acier)
                                        Y = CSng(oriY + Mur(ELU_ELS, i_trav, j, i) * redm1)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                        'côté droit aciers inférieurs
                                        X = CSng(oriX + redW * .LitInf.Item(i).X2acier)
                                        X1 = CSng(oriX + redW * .LitInf.Item(i - 1).X2acierLS)
                                        Y = CSng(oriY + Mur(ELU_ELS, i_trav, j, i) * redm1)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                End Select
                            Case 2 ' côté gauche aciers supérieurs
                                Select Case .Type_Acier_Appui_Gauche
                                    Case 1
                                        If i_trav = PlanCont.Count And i = 1 And .LappD < 0.01 Then 'Console à droite
                                            X = CSng(oriX + redW * .TS_AppG.Item(i).X2acier)
                                            X1 = CSng(oriX + redW * .TS_AppG.Item(i - 1).X2acierLS)
                                        Else
                                            X = CSng(oriX + redW * .TS_AppG.Item(i).X2acier)
                                            X1 = CSng(oriX + redW * .TS_AppG.Item(i - 1).X2acierLS)
                                        End If
                                        Y = CSng(oriY - Mur(ELU_ELS, i_trav, j, i) * redm1)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                    Case 2
                                        If i_trav = PlanCont.Count And i = 1 And .LappD < 0.01 Then 'Console à droite
                                            X = CSng(oriX + redW * .LitSupG.Item(i).X2acier)
                                            X1 = CSng(oriX + redW * .LitSupG.Item(i - 1).X2acierLS)
                                        Else
                                            X = CSng(oriX + redW * .LitSupG.Item(i).X2acier)
                                            X1 = CSng(oriX + redW * .LitSupG.Item(i - 1).X2acierLS)
                                        End If
                                        Y = CSng(oriY - Mur(ELU_ELS, i_trav, j, i) * redm1)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                End Select
                            Case 3 'côté droit aciers supérieurs
                                Select Case .Type_Acier_Appui_Droit
                                    Case 1
                                        If i_trav = 1 And i = 1 And .LappG < 0.01 Then 'Console à gauche
                                            X = CSng(oriX)
                                            X1 = CSng(oriX + redW * .TS_AppD.Item(i - 1).X1acier)
                                        Else
                                            X = CSng(oriX + redW * .TS_AppD.Item(i - 1).X1acierLS)
                                            X1 = CSng(oriX + redW * .TS_AppD.Item(i).X1acier)
                                        End If
                                        Y = CSng(oriY - Mur(ELU_ELS, i_trav, j, i) * redm1)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                    Case 2
                                        If i_trav = 1 And i = 1 And .LappG < 0.01 Then 'Console à gauche
                                            X = CSng(oriX)
                                            X1 = CSng(oriX + redW * .LitSupD.Item(i - 1).X1acier)
                                        Else
                                            X = CSng(oriX + redW * .LitSupD.Item(i - 1).X1acierLS)
                                            X1 = CSng(oriX + redW * .LitSupD.Item(i).X1acier)
                                        End If
                                        Y = CSng(oriY - Mur(ELU_ELS, i_trav, j, i) * redm1)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                End Select

                        End Select
                    End If
                    'dessin des raccordements entre moments résistants - partie inclinée
                    Select Case j
                        Case 1
                            Select Case .Type_Acier_Travée
                                Case 1
                                    'côté gauche aciers inférieurs -
                                    X = CSng(oriX + .TS_trav.Item(i - 1).X1acierLS * redW)
                                    X1 = CSng(oriX + .TS_trav.Item(i - 1).X1acier * redW)

                                    Y1 = CSng(oriY + Mur(ELU_ELS, i_trav, j, i - 1) * redm1)
                                    Y = CSng(Mur(ELU_ELS, i_trav, j, i) * redm1) : Y = CSng(oriY + Y)
                                    If j = 1 And i = 1 Then
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                    Else
                                        g.DrawLine(myPen1, X, Y, X1, Y1)
                                    End If
                                    'côté droit aciers inférieurs 
                                    If i_trav = PlanCont.Count And i = 1 And .LappD < 0.01 Then 'Console à droite

                                    Else
                                        X = CSng(oriX + .TS_trav.Item(i - 1).X2acierLS * redW)
                                        X1 = CSng(oriX + .TS_trav.Item(i - 1).X2acier * redW)
                                    End If
                                    Y = CSng(Mur(ELU_ELS, i_trav, j, i) * redm1) : Y = CSng(oriY + Y)
                                    Y1 = CSng(oriY + Mur(ELU_ELS, i_trav, j, i - 1) * redm1)
                                    If i = 1 Then
                                        'If X2acierLS(i_trav, j, 1) < X2acier(i_trav, j, 2) Then X = CSng(oriX + X2acier(i_trav, j, 2) * redW)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                    Else
                                        g.DrawLine(myPen1, X, Y, X1, Y1)
                                    End If
                                Case 2
                                    'côté gauche aciers inférieurs -
                                    X = CSng(oriX + .LitInf.Item(i - 1).X1acierLS * redW)
                                    X1 = CSng(oriX + .LitInf.Item(i - 1).X1acier * redW)

                                    Y1 = CSng(oriY + Mur(ELU_ELS, i_trav, j, i - 1) * redm1)
                                    Y = CSng(Mur(ELU_ELS, i_trav, j, i) * redm1) : Y = CSng(oriY + Y)
                                    If j = 1 And i = 1 Then
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                    Else
                                        g.DrawLine(myPen1, X, Y, X1, Y1)
                                    End If
                                    'côté droit aciers inférieurs 
                                    If i_trav = PlanCont.Count And i = 1 And .LappD < 0.01 Then 'Console à droite

                                    Else
                                        X = CSng(oriX + .LitInf.Item(i - 1).X2acierLS * redW)
                                        X1 = CSng(oriX + .LitInf.Item(i - 1).X2acier * redW)
                                    End If
                                    Y = CSng(Mur(ELU_ELS, i_trav, j, i) * redm1) : Y = CSng(oriY + Y)
                                    Y1 = CSng(oriY + Mur(ELU_ELS, i_trav, j, i - 1) * redm1)
                                    If i = 1 Then
                                        'If X2acierLS(i_trav, j, 1) < X2acier(i_trav, j, 2) Then X = CSng(oriX + X2acier(i_trav, j, 2) * redW)
                                        g.DrawLine(myPen1, X, Y, X1, Y)
                                    Else
                                        g.DrawLine(myPen1, X, Y, X1, Y1)
                                    End If
                            End Select
                        Case 2 '- côté gauche aciers supérieurs
                            Select Case .Type_Acier_Appui_Gauche
                                Case 1
                                    'If i_trav = PlanCont.Count And i = 1 And .LappD < 0.01 Then 'Console à droite

                                    'Else
                                    X = CSng(oriX + .TS_AppG.Item(i - 1).X2acierLS * redW)
                                    X1 = CSng(oriX + .TS_AppG.Item(i - 1).X2acier * redW)
                                ' End If
                                Case 2
                                    'If i_trav = PlanCont.Count And i = 1 And .LappD < 0.01 Then 'Console à droite

                                    'Else
                                    X = CSng(oriX + .LitSupG.Item(i - 1).X2acierLS * redW)
                                    X1 = CSng(oriX + .LitSupG.Item(i - 1).X2acier * redW)
                                    ' End If
                            End Select
                            Y = CSng(Mur(ELU_ELS, i_trav, j, i) * redm1) : Y = CSng(oriY - Y)
                            Y1 = CSng(oriY - Mur(ELU_ELS, i_trav, j, i - 1) * redm1)
                            g.DrawLine(myPen1, X, Y, X1, Y1)
                        Case 3 'côté droit aciers supérieurs
                            Select Case .Type_Acier_Appui_Droit
                                Case 1
                                    X = CSng(oriX + .TS_AppD.Item(i - 1).X1acierLS * redW)
                                    X1 = CSng(oriX + .TS_AppD.Item(i - 1).X1acier * redW)
                                Case 2
                                    X = CSng(oriX + .LitSupD.Item(i - 1).X1acierLS * redW)
                                    X1 = CSng(oriX + .LitSupD.Item(i - 1).X1acier * redW)
                            End Select

                            Y1 = CSng(oriY - Mur(ELU_ELS, i_trav, j, i - 1) * redm1) 'x5 = x5 * red1 + 3900 Else x5 = -x5 * red1 + 3900
                            Y = CSng(Mur(ELU_ELS, i_trav, j, i) * redm1) : Y = CSng(oriY - Y)
                            g.DrawLine(myPen1, X, Y, X1, Y1)
                    End Select
                Next i
            Next j
        End With
        'dessin des graduations: tout les 10 cm
        X1 = 0 : i = 1
        Do While X1 < PlanCont.Item(i_trav - 1).Lx
            X1 = CSng(X1 + 0.1)
            myPen = New Pen(Color.Black, 1)
            X = CSng(oriX + X1 * redW)
            If Fix(CInt(X1 * 100) / 100) = i Then
                Y = oriY + 5 : Y1 = oriY - 5 : i = i + 1
            Else
                Y = oriY + 2 : Y1 = oriY - 2
            End If
            g.DrawLine(myPen, X, Y, X, Y1)
        Loop

    End Sub
End Module
