﻿''' <summary>
''' Classe encapsulant toutes les éléments formant les résultats numériques des efforts
''' </summary>
<Serializable()> Public Class Result
    ''' <summary>
    '''N° de la combinaison
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Num As Integer
    ''' <summary>
    ''' Valeur du Moment suivant X - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Mx As New List(Of M_x)
    ''' <summary>
    ''' Valeur du Moment maximal suivant X - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Mx_max As New M_x
    ''' <summary>
    ''' Valeur du Moment minimal suivant X - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Mx_min As New M_x
    ''' <summary>
    ''' Valeur du Moment Maximal suivant X sur l'intervalle i - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Mx_Interval_Max As New List(Of M_x)
    ''' <summary>
    ''' Valeur du Moment Minimal suivant X sur l'intervalle i - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Mx_Interval_min As New List(Of M_x)
    ''' <summary>
    ''' Valeur du Moment suivant y - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property My As New List(Of M_y)
    ''' <summary>
    ''' Valeur du Moment Maximal suivant Y - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property My_Max As New M_y
    ''' <summary>
    ''' Valeur du Moment minimal suivant Y - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property My_min As New M_y
    ''' <summary>
    ''' Valeur du Moment Maximal suivant Y sur l'intervalle - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property My_Interval_Max As New List(Of M_y)
    ''' <summary>
    ''' Valeur du Moment minimal suivant Y sur l'intervalle i - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property My_Interval_min As New List(Of M_y)
    ''' <summary>
    ''' Valeur de l'effort tranchant suivant X - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vx As New List(Of V_x)
    ''' <summary>
    ''' Valeur de l'effort tranchant Maximal suivant X - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vx_Max As New V_x
    ''' <summary>
    ''' Valeur de l'effort tranchant minimal suivant X - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vx_min As New V_x
    ''' <summary>
    ''' Valeur de l'effort tranchant  positif ou nul suivant x - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vx_Interval_Max As New List(Of V_x)
    ''' <summary>
    ''' Valeur de l'effort tranchant négatif ou nul suivant x sur l'intervalle i - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vx_Interval_min As New List(Of V_x)
    <Xml.Serialization.XmlIgnore> Public Property Vy As New List(Of V_y)
    ''' <summary>
    ''' Valeur de l'effort tranchant Maximal suivant Y - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vy_Max As New V_y
    ''' <summary>
    ''' Valeur de l'effort tranchant minimal suivant Y - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vy_min As New V_y
    ''' <summary>
    ''' Valeur de l'effort tranchant   positif ou nul suivant y sur l'intervalle i - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vy_Interval_Max As New List(Of V_y)
    ''' <summary>
    ''' Valeur du Moment Minimal  négatif ou nul suivant y sur l'intervalle i - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Vy_Interval_min As New List(Of V_y)
    ''' <summary>
    ''' Valeur du couple de torsion sur dalle - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Cz As New List(Of C_z)
    ''' <summary>
    ''' Valeur du couple de torsion Maximal sur dalle - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Cz_Max As New C_z
    ''' <summary>
    ''' Valeur du couple de torsion minimal sur dalle - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Cz_min As New C_z
    ''' <summary>
    ''' Valeur de la réaction d'appui sur côté x - unité: MN/m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Rx As New List(Of R_x)
    ''' <summary>
    ''' Valeur de la réaction Maximale d'appui sur côté x - unité: MN/m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Rx_Max As New R_x
    ''' <summary>
    ''' Valeur de la réaction minimale d'appui sur côté x - unité: MN/m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Rx_min As New R_x
    ''' <summary>
    ''' Valeur de la réaction d'appui sur côté y - unité: MN/m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Ry As New List(Of R_y)
    ''' <summary>
    ''' Valeur de la réaction Maximale d'appui sur côté y - unité: MN/m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Ry_Max As New R_y
    ''' <summary>
    ''' Valeur de la réaction minimale d'appui sur côté y - unité: MN/m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Ry_min As New R_y
    ''' <summary>
    ''' Valeur de non-soulèvement des angles pour chaque angle - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property R_angle As Double
    ''' <summary>
    ''' Valeur de la flèche suivant x et y- unité: m 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property W_fl As New List(Of W_fl)
    ''' <summary>
    ''' Valeur Maximale de la flèche suivant x et y- unité: m 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property W_fl_Max As New W_fl
    ''' <summary>
    ''' Valeur minimale de la flèche suivant x et y- unité: m 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property W_fl_min As New W_fl
End Class
''' <summary>
''' Valeur du Moment suivant X - unité: MN.m
''' </summary>
<Serializable()> Public Class M_x
    ''' <summary>
    ''' Valeur de l'abscisse X - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property x As Double
    ''' <summary>
    ''' Valeur de l'ordonnée y - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property y As Double
    ''' <summary>
    ''' Valeur du moment de flexion suivant x pour les coordonnées x et y - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property M As Double
End Class
''' <summary>
''' Valeur du Moment suivant y - unité: MN.m
''' </summary>
<Serializable()> Public Class M_y
    ''' <summary>
    ''' Valeur de l'abscisse X - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property x As Double
    ''' <summary>
    ''' Valeur de l'ordonnée y - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property y As Double
    ''' <summary>
    ''' Valeur du moment de flexion suivant y pour les coordonnées x et y - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property M As Double
End Class
''' <summary>
''' Valeur de l'effort tranchant suivant X - unité: MN 
''' </summary>
<Serializable()> Public Class V_x
    ''' <summary>
    ''' Valeur de l'abscisse X - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property x As Double
    ''' <summary>
    ''' Valeur de l'ordonnée y - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property y As Double
    ''' <summary>
    ''' Valeur de l'effort tranchant suivant X pour les coordonnées x et y - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property V As Double
End Class
''' <summary>
''' Valeur de l'effort tranchant suivant Y - unité: MN 
''' </summary>
<Serializable()> Public Class V_y
    ''' <summary>
    ''' Valeur de l'abscisse X - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property x As Double
    ''' <summary>
    ''' Valeur de l'ordonnée y - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property y As Double
    ''' <summary>
    ''' Valeur de l'effort tranchant suivant Y pour les coordonnées x et y - unité: MN 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property V As Double
End Class
''' <summary>
''' Valeur du couple de torsion sur dalle - unité: MN.m
''' </summary>
<Serializable()> Public Class C_z
    ''' <summary>
    ''' Valeur de l'abscisse X - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property x As Double
    ''' <summary>
    ''' Valeur de l'ordonnée y - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property y As Double
    ''' <summary>
    ''' Valeur du couple de torsion sur dalle - unité: MN.m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Cz As Double
End Class
''' <summary>
''' Valeur de la réaction d'appui sur côté x - unité: MN/m
''' </summary>
<Serializable()> Public Class R_x
    ''' <summary>
    ''' Valeur de l'ordonnée y - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property y As Double
    ''' <summary>
    ''' Valeur de la réaction d'appui sur côté x - unité: MN/m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Rx As Double
End Class
''' <summary>
''' Valeur de la réaction d'appui sur côté y - unité: MN/m
''' </summary>
<Serializable()> Public Class R_y
    ''' <summary>
    ''' Valeur de l'abscisse X - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property x As Double
    ''' <summary>
    ''' Valeur de la réaction d'appui sur côté x - unité: MN/m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property Ry As Double
End Class
''' <summary>
''' Valeur de la flèche suivant x et y- unité: m 
''' </summary>
<Serializable()> Public Class W_fl
    ''' <summary>
    ''' Valeur de l'abscisse X - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property x As Double
    ''' <summary>
    ''' Valeur de l'ordonnée y - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property y As Double
    ''' <summary>
    ''' Valeur de la flèche suivant x et y- unité: m 
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public Property wfl As Double
End Class

