﻿''' <summary>
''' Classe encapsulant tous les aspects généraux concernant l'affaire comme le projeteur, l'imprimante, etc. ...
''' </summary>
<Serializable()> Public Class clsAffaire
    Dim x_ELU, x_ELU_EQ, x_ELS_car, x_ELS_QP As Integer 'x_ELU_A,
    Dim _FileName As String = String.Empty
    Dim _msgData As String = String.Empty
    Dim _msgResult As String = String.Empty
    Dim _i_result As Integer = 1
    Dim _i_data As Integer = 1
    Dim _Editeur As Integer = 1
    ''' <summary>
    ''' nom du fichier de données
    ''' </summary>
    Public Property FileName As String
        Get
            FileName = _FileName
        End Get
        Set(value As String)
            If IsNumeric(value) = True Then
                Throw New ArgumentException("Le fichier ne peut pas être une valeur numérique.")
            Else
                _FileName = value
            End If
        End Set
    End Property
    ''' <summary>
    '''Répertoire du fichier de données
    ''' </summary>
    Public Property msgData As String '
        Get
            msgData = _msgData
        End Get
        Set(value As String)
            If IsNumeric(value) = True Then
                Throw New ArgumentException("Le fichier ne peut pas être une valeur numérique.")
            Else
                _msgData = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Répertoire des notes de calculs
    ''' </summary>
    Public Property msgResult As String '
        Get
            msgResult = _msgResult
        End Get
        Set(value As String)
            If IsNumeric(value) = True Then
                Throw New ArgumentException("Le fichier ne peut pas être une valeur numérique.")
            Else
                _msgResult = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' n° du répertoire des notes de calcul
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property i_result As Integer
        Get
            i_result = _i_result
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("Le n° du répertoire des notes de calcul n'est pas numérique.")
            ElseIf value < 1 Then
                Throw New ArgumentException("La n° du répertoire des notes de calcul doit être supérieur ou  égal à 1.")
            Else
                _i_result = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' n° du répertoire du fichier de données
    ''' </summary>
    Public Property i_data As Integer
        Get
            i_data = _i_data
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("Le n° du répertoire du fichier de données n'est pas numérique.")
            ElseIf value < 1 Then
                Throw New ArgumentException("La n° du répertoire du fichier de données doit être supérieur ou  égal à 1.")
            Else
                _i_data = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' nom du redacteur
    ''' </summary>
    ''' <value>peut être une valeur numérique (code par exemple) ou un nom littéral </value>
    ''' <returns>généralement le nom de l'ingénieur calvulateur ou du projeteur</returns>
    ''' <remarks>Nom du projeteur et non pas du vérificateur</remarks>
    Public Property Redacteur As String
    ''' <summary>
    ''' nom du chantier
    ''' </summary>
    ''' <value>peut être une valeur numérique (code par exemple) ou un nom littéral </value>
    ''' <returns>généralement le nom du chantier</returns>
    ''' <remarks>peut être aussi le nom de l'affaire</remarks>
    Public Property Chantier As String
    ''' <summary>
    ''' Editeur: 1=éditeur interne / 2=Word /
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Editeur As Integer
        Get
            Editeur = _Editeur
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("Le n° de l'éditeur n'est pas numérique.")
            ElseIf value < 1 Then
                Throw New ArgumentException("La n° de l'éditeur doit être supérieur ou  égal à 1.")
            Else
                _Editeur = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Recommandations Professionnelles: faux si non pris en charge / Vrai si pris en charge
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Reco_Fr As Boolean = False


    ''' <summary>
    ''' Décalage de l'effort tranchant suivant A.6.2.3(5): faux si pas de décalage
    ''' </summary>
    Public Property Decalage_ET As Boolean = False
    ''' <summary>
    ''' Appliquer la minoration pour les charges appliquées près de l'appui pour le calcul de l'Effort Tranchant suivant conditions de l'article  6.2.3(8) de l'EN1992-1-1: 
    ''' faux si pas de minoration
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property MinorationQ_ET As Boolean = False
    ''' <summary>
    ''' Valeur du 1ier intervalle depuis le nu d'appui: 0 au nu d'appui / 1 à St/2 / 2 à St
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property St As Integer = 1
    ''' <summary>
    ''' appuis d'about: true si 0.15M0/ false si pas de reprise - Plancher unidirectionnel
    ''' </summary>
    Public Property Reprise_M0_1_porteur As Boolean = False
    ''' <summary>
    ''' Existence ou pas d'un encastrement partiel pour travée isostatique Plancher unidirectionnel- Si partiel = True / Si libre = False
    ''' </summary>
    Public Property EncastPartiel_1_porteur As Boolean
    ''' <summary>
    ''' Application du §9.3.1.2(2) de l'EN1992-1-1 - 15% Moment Maximal en travée sur appuis de rives et 25% sur appuis intermédiaires - Plancher bidirectionnel
    ''' </summary>
    ''' <value> Vrai si application de l'article sinon False</value>
    Public Property Reprise_M0_2_porteur As Boolean = False
    ''' <summary>
    ''' armatures transversales sur appuis: true si existe/ false si supprimé (moment transversal négligeable)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property HA_Trans_Appui As Boolean = False
    ''' <summary>
    ''' n° du fichier d'aide
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property FichierAide As Integer
    ''' <summary>
    ''' Message d'avertissement
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property msg_Avertiss As New List(Of String)
    ''' <summary>
    ''' Choix du diamètre du mandrin: 1=Ø mini; 2=Ø suivant eq. 8.1
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Option_Mandrin As Integer = 1
    ' ''' <summary>
    ' ''' Limitation du ø d'armature Effort Tranchant: False si pas de limitation
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks></remarks>
    'Public Property Lim_øET As Boolean = False
    ' ''' <summary>
    ' ''' ø limite d'armature Effort Tranchant: HA8 par défaut
    ' ''' </summary>
    ' ''' <value></value>
    ' ''' <returns></returns>
    ' ''' <remarks></remarks>
    'Public Property øLimET As Double = 0.008
    ''' <summary>
    ''' acier intérieur sous forme d'étrier=1/ épingle=2/ rien=3
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Etrier As Integer = 2
    ''' <summary>
    ''' Nombre de lits d'acier de couture de la table
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property NbLit_Couture As Integer = 2
    ''' <summary>
    ''' Appliquer dégression charge exploitation: faux si pas de dégression
    ''' </summary>
    Public Property degression As Boolean = False
    ''' <summary>
    ''' Appliquer redistribution limitée moment Art. 5.5 EN1992-1-1: faux si pas de redistribution
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    ''' 
    Public Property Redistrib_limit As Boolean = False
    ''' <summary>
    ''' valeur coefficient δ Art. 5.5 EN1992-1-1 
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property δ As Double = 1
    ''' <summary>
    ''' Ecretage moment Art. 5.5 EN1992-1-1: faux si pas d'écretage
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Ecretage_Moment As Boolean = False
    ''' <summary>
    ''' durée d'utilisation du projet: 0=10 ans, 1=25 ans, 2=50 ans, 3=100 ans
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Duree As Integer = 2
    ''' <summary>
    ''' Humidité relative - Calcul contrainte
    ''' </summary>
    Public Property RH As Integer = 40
    ''' <summary>
    ''' age béton au chargement initial - Calcul contrainte
    ''' </summary>
    Public Property t0 As Integer = 100
    ''' <summary>
    ''' age béton au chargement final:0=10ans/ 1=25ans/2=50ans/3=100ans - Calcul contrainte
    ''' </summary>
    Public Property tinf As Integer = 2 'φinf
    ''' <summary>
    ''' Humidité relative - Calcul Flèche
    ''' </summary>
    Public Property RH_Fl As Integer = 40
    ''' <summary>
    ''' age béton au chargement initial - Calcul Flèche
    ''' </summary>
    Public Property t0_Fl As Integer = 100
    ''' <summary>
    ''' age béton au chargement final:0=10ans/ 1=25ans/2=50ans/3=100ans - Calcul Flèche
    ''' </summary>
    Public Property tinf_Fl As Integer = 2 'φinf
    ''' <summary>
    ''' coef de fluage à t infini
    ''' </summary>
    Public Property φinf As Double = 0 '
    ''' <summary>
    ''' Affichage du découpage des prédalles avant calcul: coché=Vrai Affichage demandée / Faux si pas d'affichage
    ''' </summary>
    Public Property Affich_Predal As Boolean = True
    ''' <summary>
    ''' Console: retour en équerre de l'acier de flexion: vrai si oui/ False si non
    ''' </summary>
    Public Property Consol_Equerre As Boolean = False
    ''' <summary>
    ''' Distance entre l'acier et le bord (m)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Consol_ET As Double = 0.05
    ''' <summary>
    ''' Distance entre le bas de la poutre et l'acier en équerre
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Consol_a As Double = 0.1
    ''' <summary>
    ''' nbre de suspentes minimum
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Suspente_nb As Integer = 3
    ''' <summary>
    ''' % de reprise de l'effort suspendue par la poutre support
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Suspente_repris As Double = 1
    ''' <summary>
    ''' Indique si le programme doit harmoniser les enrobages entre toutes les travées - True si oui/ False si non
    ''' </summary>
    ''' <value>true/false</value>
    ''' <returns>true/false</returns>
    ''' <remarks>Sans objet pour travée unique</remarks>
    Public Property Harmonisation_Enrobage As Boolean = False

#Region "Combinaisons"
    ''' <summary>
    ''' indice Maxi combinaisons ELU Structure (= fondamental)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ELU As Integer
        Get
            ELU = x_ELU
        End Get
    End Property
    ''' <summary>
    '''  indice Maxi  combinaisons ELU Equilibre
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ELU_EQ As Integer
        Get
            ELU_EQ = x_ELU_EQ
        End Get
    End Property
    ''' <summary>
    '''  indice Maxi  combinaisons ELS caractéristique
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ELScar As Integer
        Get
            ELScar = x_ELS_car
        End Get
    End Property
    ''' <summary>
    '''  indice Maxi  combinaisons ELS quasi_permanent
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property ELSQP As Integer
        Get
            ELSQP = x_ELS_QP
        End Get
    End Property
    '''' <summary>
    ''''  indice Maxi  combinaisons ELU accidentel
    '''' </summary>
    '''' <value></value>
    '''' <returns></returns>
    '''' <remarks></remarks>
    'Public ReadOnly Property ELUA As Integer
    '    Get
    '        ELUA = x_ELU_A
    '    End Get
    'End Property
    ''' <summary>
    ''' Affection de chaque combinaison dans un état limite: ELU Structure, ELU accidentel, ELU équilibre, ELS caractéristique, ELS Quasi-Permanent
    ''' </summary>
    Public Sub Combinaison_ELU_ELS()
        Dim Comb As New Combinaison
        For Each Comb In Combinaisons
            Select Case Comb.Type
                Case 1 '"ELU fondamental"
                    If x_ELU < Comb.Num Then x_ELU = Comb.Num
                Case 2 '"ELU Equilibre"
                    If x_ELU_EQ < Comb.Num Then x_ELU_EQ = Comb.Num
                Case 3 '"ELS - Combinaison caractéristique
                    If x_ELS_car < Comb.Num Then x_ELS_car = Comb.Num
                Case 4 '"ELS - Combinaison quasi-permanente
                    If x_ELS_QP < Comb.Num Then x_ELS_QP = Comb.Num
                Case Else
                    Stop
                    ' If x_ELU_A < Comb.Num Then x_ELU_A = Comb.Num
            End Select
        Next
    End Sub
#End Region
End Class

''' <summary>
''' Classe encapsulant tous les détails permettant de définir la note de calcul
''' </summary>
<Serializable()> Public Class Detail_Ndc
    ''' <summary>
    ''' Détail du calcul de l'acier de flexion: 0 = sans détail / 1 = avec détail
    ''' </summary>
    Public Property FlexionAs As Integer = 0
    ''' <summary>
    ''' Détail du calcul RdM des moments de flexion: 0 = sans détail / 1 = avec détail
    ''' </summary>
    Public Property Moment_Flexion As Integer = 0
End Class
