﻿Imports System.Math
''' <summary>
''' Classe encapsulant toutes les caractéristiques de barres longitudinales HA formant armature
''' </summary>
<Serializable()> Public Class Ferraillage_HA

    ''' <summary>
    ''' nombre de barres par lit
    ''' </summary>
    Public Property nbar As Integer
    ''' <summary>
    ''' diamètre conventionnel de la barre d'acier Haute Adhérence
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property φHA As Double
    ''' <summary>
    ''' abscisse de l'extrémité gauche du lit d'acier
    ''' </summary>
    Public Property X1acier As Double
    ''' <summary>
    ''' abscisse gauche à partir de laquelle le lit d'acier est totalement ancré
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property X1acierLS As Double
    ''' <summary>
    ''' abscisse de l'extrémité droite du lit d'acier
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property X2acier As Double
    ''' <summary>
    ''' abscisse droite à partir de laquelle le lit d'acier est totalement ancré
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property X2acierLS As Double
    ''' <summary>
    ''' longueur L1 sur appui gauche
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property L11acier As Double
    ''' <summary>
    ''' longueur L2 sur appui gauche
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property L12acier As Double
    ''' <summary>
    ''' longueur L3 sur appui gauche
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property L13acier As Double
    ''' <summary>
    ''' diamètre du mandrin pour l'acier sur appui gauche
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property φDM1 As Double
    ''' <summary>
    ''' longueur L1 sur appui droit
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property L21acier As Double
    ''' <summary>
    ''' longueur L2 sur appui droit
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property L22acier As Double
    ''' <summary>
    ''' longueur L3 sur appui droit
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property L23acier As Double
    ''' <summary>
    ''' diamètre du mandrin pour l'acier sur appui droit
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property φDM2 As Double
    ''' <summary>
    ''' longueur développée totale du lit n°1,2 ou 3 sur la travée i1 et i1+1, applicable aux aciers en chapeaux - Pour les aciers en partie basse, lacier1 = longeur totale y compris appui
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Lacier1 As Double
    ''' <summary>
    ''' longueur développée totale du lit n°1,2 ou 3 sur la travée i1, hors appui pour les aciers en chapeaux et hors appuis pour les aciers en partie basse
    ''' </summary>
    Public Property Lacier2 As Double
    ''' <summary>
    ''' diamètre acier imposé par le projeteur 
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property phiProj As Double
    ''' <summary>
    ''' angle de l'ancrage courbe
    ''' </summary>
    Public Property Angle As Integer = 120
    ''' <summary>
    '''Pour barre construction: =1 partie haute et reprend 0.15M0/ =2 partie basse/ =3 partie haute,ne prends pas 0.15M0
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Type As Integer

    ''' <summary>
    ''' Espacement Maximum entre barres - Unité: m
    ''' </summary>
    Public Property EspMax As Double
    ''' <summary>
    ''' Espacement minimum entre barres - Unité: m
    ''' </summary>
    Public Property Espmin As Double
    ''' <summary>
    ''' Espace entre la 1ière barre et le bord de l'appui 1 - Unité: m
    ''' </summary>
    Public Property S1 As Double
    ''' <summary>
    ''' Espace entre la 1ière barre et le bord de l'appui 2 - Unité: m
    ''' </summary>
    Public Property S2 As Double
    ''' <summary>
    ''' Espacement cournat entre barres - Unité: m
    ''' </summary>
    Public Property Scourant As Double


    ''' <summary>
    ''' retourne l'aire d'un lit d'armature
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function Aire() As Double
        Aire = nbar * PI * φHA ^ 2 / 4
    End Function

    Private Sub Poubelle()
        'Dim x_ai1, x_ai2, x_ai3 As Double
        'Public Property φInf() As Double
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 1 inférieur
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarInf1 As Integer
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 2 inférieur
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarInf2 As Integer
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 3 inférieur
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarInf3 As Integer
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 1 supérieur gauche
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarSupG1 As Integer
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 2 supérieur gauche
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarSupG2 As Integer
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 3 supérieur gauche
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarSupG3 As Integer
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 1 supérieur droit
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarSupD1 As Integer
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 2 supérieur droit
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarSupD2 As Integer
        ' ''' <summary>
        ' ''' nombre de barres sur le lit 3 supérieur droit
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property nbarSupD3 As Integer
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 1 inférieur
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φInf1 As Double
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 2 inférieur
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φInf2 As Double
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 3 inférieur
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φInf3 As Double
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 1 supérieur gauche
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φSupG1 As Double
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 2 supérieur gauche
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φSupG2 As Double
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 3 supérieur gauche
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φSupG3 As Double
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 1 supérieur droit
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φSupD1 As Double
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 2 supérieur droit
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φSupD2 As Double
        ' ''' <summary>
        ' ''' diamètre barres sur le lit 3 supérieur droit
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property φSupD3 As Double
        ' ''' <summary>
        ' ''' nombre de coupures de cadre suivant lit inférieur
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property ncadreInf As Integer
        ' ''' <summary>
        ' ''' nombre de coupures de cadre suivant lit supérieur gauche
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property ncadresupG As Integer
        ' ''' <summary>
        ' ''' nombre de coupures de cadre suivant lit supérieur droit
        ' ''' </summary>
        ' ''' <value></value>
        ' ''' <returns></returns>
        ' ''' <remarks></remarks>
        'Public Property ncadresupD As Integer
        'Public ReadOnly Property Ainf1 As Double
        '    Get
        '        Ainf1 = x_ai1
        '    End Get
        'End Property
        'Public ReadOnly Property Ainf2 As Double
        '    Get
        '        Ainf2 = x_ai2
        '    End Get
        'End Property
        'Public ReadOnly Property Ainf3 As Double
        '    Get
        '        Ainf3 = x_ai3
        '    End Get
        'End Property
        'Public ReadOnly Property AsupG1 As Double
        '    Get
        '        AsupG1 = x_ai1
        '    End Get
        'End Property
        'Public ReadOnly Property AsupG2 As Double
        '    Get
        '        AsupG2 = x_ai2
        '    End Get
        'End Property
        'Public ReadOnly Property AsupG3 As Double
        '    Get
        '        AsupG3 = x_ai3
        '    End Get
        'End Property
        'Public ReadOnly Property AsupD1 As Double
        '    Get
        '        AsupD1 = x_ai1
        '    End Get
        'End Property
        'Public ReadOnly Property AsupD2 As Double
        '    Get
        '        AsupD2 = x_ai2
        '    End Get
        'End Property
        'Public ReadOnly Property AsupD3 As Double
        '    Get
        '        AsupD3 = x_ai3
        '    End Get
        'End Property
        'Public Property X1acierInf1 As Double
        'Public Property X1acierLSInf1 As Double
        'Public Property X2acierInf1 As Double
        'Public Property X2acierLSInf1 As Double
        'Public Property X1acierInf2 As Double
        'Public Property X1acierLSInf2 As Double
        'Public Property X2acierInf2 As Double
        'Public Property X2acierLSInf2 As Double
        'Public Property X1acierInf3 As Double
        'Public Property X1acierLSInf3 As Double
        'Public Property X2acierInf3 As Double
        'Public Property X2acierLSInf3 As Double
        'Public Property X1acierSupG1 As Double
        'Public Property X1acierLSSupG1 As Double
        'Public Property X2acierSupG1 As Double
        'Public Property X2acierLSSupG1 As Double
        'Public Sub Geometrie()
        '    x_ai1 = nbarInf1 * PI * φInf1 ^ 2 / 4
        '    x_ai2 = nbarInf2 * PI * φInf2 ^ 2 / 4
        '    x_ai3 = nbarInf3 * PI * φInf3 ^ 2 / 4
        'End Sub

    End Sub
End Class

''' <summary>
''' Classe encapsulant toutes les caractéristiques des treillis soudés ADETS formant armature
''' </summary>
<Serializable()> Public Class Ferraillage_TS

    Dim _Interval As Integer = 1
    Dim _Position As Integer = 1
    '''' <summary>
    '''' Nombre de lits - mini = 1
    '''' </summary>
    'Public Property nbLitMax As Integer = 1
    '''' <summary>
    '''' indice du TS Max
    '''' </summary>
    'Public Property MaxTS As Integer = 1
    ''' <summary>
    ''' indice du TS retenu
    ''' </summary>
    Public Property indTS As Integer = 1
    ''' <summary>
    ''' abscisse de l'extrémité gauche du lit d'acier
    ''' </summary>
    Public Property X1acier As Double
    ''' <summary>
    ''' abscisse gauche à partir de laquelle le lit d'acier est totalement ancré
    ''' </summary>
    Public Property X1acierLS As Double
    ''' <summary>
    ''' abscisse de l'extrémité droite du lit d'acier
    ''' </summary>
    Public Property X2acier As Double
    ''' <summary>
    ''' abscisse droite à partir de laquelle le lit d'acier est totalement ancré
    ''' </summary>
    Public Property X2acierLS As Double
    ''' <summary>
    ''' longueur L1 sur appui gauche
    ''' </summary>
    Public Property L11acier As Double
    ''' <summary>
    ''' longueur L2 sur appui gauche
    ''' </summary>
    Public Property L12acier As Double
    ''' <summary>
    ''' longueur L3 sur appui gauche
    ''' </summary>
    Public Property L13acier As Double
    ''' <summary>
    ''' diamètre du mandrin pour l'acier sur appui gauche
    ''' </summary>
    Public Property φDM1 As Double
    ''' <summary>
    ''' longueur L1 sur appui droit
    ''' </summary>
    Public Property L21acier As Double
    ''' <summary>
    ''' longueur L2 sur appui droit
    ''' </summary>
    Public Property L22acier As Double
    ''' <summary>
    ''' longueur L3 sur appui droit
    ''' </summary>
    Public Property L23acier As Double
    ''' <summary>
    ''' diamètre du mandrin pour l'acier sur appui droit
    ''' </summary>
    Public Property φDM2 As Double
    ''' <summary>
    ''' longueur développé totale du lit n°1,2 ou 3 sur la travée i1 et i1+1, applicable aux aciers en chapeaux
    ''' </summary>
    Public Property Lacier1 As Double
    ''' <summary>
    ''' longueur développé totale du lit n°1,2 ou 3 sur la travée i1, hors appui pour les aciers en chapeaux et avec appuis pour les aciers en partie basse
    ''' </summary>
    Public Property Lacier2 As Double
    ''' <summary>
    ''' longueur L1 sur appui haut ou bas
    ''' </summary>
    Public Property L31acier As Double
    ''' <summary>
    ''' longueur L2 sur appui haut ou bas
    ''' </summary>
    Public Property L32acier As Double
    ''' <summary>
    ''' longueur L3 sur appui haut ou bas
    ''' </summary>
    Public Property L33acier As Double
    ''' <summary>
    ''' largeur suivant Y du panneau de TS - unité:m
    ''' </summary>
    Public Property LacierY As New List(Of Double)
    ''' <summary>Nombre de panneaux du modèle 1, 1 seul panneau pour le modèle 2</summary>
    ''' <remarks>Le modèle n°2 sert de complément aux panneaux de modèle 1 pour finir de couvrir la travée dans le sens de la largeur</remarks>
    Public Property nbrePanneaux As Integer = 1
    ''' <summary>Recouvrement des aciers de répartition entre 2 TS identiques - Unité: m </summary>
    ''' <remarks>Calcul suivant longueur forfaitaire de l'EC2</remarks>
    Public Property RecouvTr As Double
    ''' <summary>
    ''' Détermine à quel intervalle de calcul appartient ce panneau de TS
    ''' </summary>
    Public Property Intervalle As Integer
        Get
            Intervalle = _Interval
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur Intervalle n'est pas numérique.")
            ElseIf value < 1 Then
                Throw New ArgumentException("La valeur Intervalle doit être supérieure ou égale à 1.")
            Else
                _Interval = value
            End If
        End Set
    End Property
    ''' <summary>
    ''' Position du panneau de TS: 1 = en partie basse / 2 = en partie haute
    ''' </summary>
    Public Property Position As Integer
        Get
            Position = _Position
        End Get
        Set(value As Integer)
            If Not IsNumeric(value) Then
                Throw New ArgumentException("La valeur Intervalle n'est pas numérique.")
            ElseIf value < 1 Then
                Throw New ArgumentException("La valeur Intervalle doit être supérieure ou égale à 1.")
            Else
                _Position = value
            End If
        End Set
    End Property
End Class

''' <summary>
''' Classe encapsulant toutes les caractéristiques des barres HA formant armature d'effort tranchant ou suspente
''' </summary>
<Serializable()> Public Class Ferraillage_HA_Tranchant
    ''' <summary>
    ''' diamètre conventionnel de la barre d'acier Haute Adhérence
    ''' </summary>
    Public Property φHA As Double
    ''' <summary>
    ''' Espacement entre cadre - Unité: m
    ''' </summary>
    Public Property st As New List(Of Double)
    ''' <summary>
    ''' Espacement entre cadre - Sens longitudinal Unité: m
    ''' </summary>
    Public Property st_Long As Double
    ''' <summary>
    ''' Espacement entre cadre - Sens transversal Unité: m
    ''' </summary>
    Public Property st_Trans As Double
    ''' <summary>
    ''' Espacement entre cadre et about - Sens longitudinal Unité: m
    ''' </summary>
    Public Property st_Long_about As Double
    ''' <summary>
    ''' Espacement entre cadre et about - Sens transversal Unité: m
    ''' </summary>
    Public Property st_Trans_About As Double
    '''' <summary>
    '''' diamètre acier imposé par le projeteur 
    '''' </summary>
    'Public Property φProj As Double
    '''' <summary>
    '''' diamètre maxi acier imposé par le projeteur 
    '''' </summary>
    'Public Property φLimit As Double
    ''' <summary>
    ''' nbre de modèle d'armature d'effort tranchant retenu
    ''' </summary>
    Public Property nModele As Integer
    ''' <summary>
    ''' longueur totale développé du cadre
    ''' </summary>
    Public Property LtCadre As Double
    ''' <summary>
    ''' longueur totale développé de l'étrier ou épingle
    ''' </summary>
    Public Property LtEpingle As Double
    ''' <summary>
    ''' nbre d'epingle/Etrier suivant valeur booléenne .Etrier sur la coupe
    ''' </summary>
    Public Property nepingle As Integer

    ''' <summary>
    ''' modèle du type d'armature d'effort tranchant. Par défaut, modèle n°1
    ''' </summary>
    Public ReadOnly modele As Integer = 1
    ''' <summary>
    ''' distance entre fibre extrème comprimé et cdg acier tendu pour effort tranchant
    ''' </summary>
    Public Property d_Tr As Double
    ''' <summary>
    ''' retourne l'aire totale des brins d'acier formant armatures d'effort tranchant sur un cours
    ''' </summary>
    Public Function Aire() As Double
        Aire = PI * φHA ^ 2 / 4
    End Function
    '''' <summary>
    '''' nbre total de cadres sur la poutre
    '''' </summary>
    '''' <returns></returns>
    '''' <remarks></remarks>
    'Public Function nCadre() As Integer
    '    nCadre = nAt_G + nAt_D
    'End Function
End Class
