﻿'''<summary>Classe Acier: encapsule toutes les caractéristiques de l'armature utilisé: résistance, etc. ...</summary>
<Serializable()> Public Class Acier
    Private x_k, x_εuk As Double
    ' Private d() As Double = {0.05, 0.07, 0.07, 0.07, 0.7, 0.1, 0.1} 'diamètre des mandrins de cintrage- TS
    ''' <summary>
    ''' coefficient partiel relatif à l'acier - situation durable ou transitoire
    ''' </summary>
    ''' <value> =1.15</value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property γsd As Double = 1.15
    ''' <summary>
    ''' coefficient partiel relatif à l'acier - situation accidentelle
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property γsa As Double = 1
    ''' <summary>
    ''' déformation relative sous charge maximale
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property εuk As Double
        Get
            εuk = x_εuk
        End Get
    End Property
    ''' <summary>
    ''' module d'élasticité de l'acier = 200 GPa
    ''' </summary>
    Public ReadOnly Es As Integer = 200000
    ''' <summary>
    ''' Limite caractéristique d'élasticité
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property fyk As Integer
    ''' <summary>
    ''' valeur minimale k = (ft/fy)k
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public ReadOnly Property k As Double
        Get
            k = x_k
        End Get
    End Property
    ''' <summary>
    ''' classe de l'acier: 1=A, 2=B et 3= C
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property classe As Integer
    ''' <summary>
    ''' coefficient d'équivalence acier/beton: n (pris généralement égal à 15)
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property n_Cont As Double = 15.0
    ''' <summary>
    ''' coefficient d'équivalence n: imposé = True / calculé = False 
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property n_Forcer_Cont As Boolean = True
    ''' <summary>
    ''' coefficient d'équivalence acier/beton: n (pris généralement égal à 15)
    ''' </summary>
    Public Property n_Fl As Double = 15.0
    ''' <summary>
    ''' coefficient d'équivalence n: imposé = True / calculé = False 
    ''' </summary>
    Public Property n_Forcer_Fl As Boolean = True
    ''' <summary>
    ''' angle du crochet pour ancrage armature longitudinale sur appui angle en °
    ''' </summary>
    ''' <value></value>
    ''' <returns>La valeur de l'angle est fixée à 135°</returns>
    ''' <remarks>La valeur est fixe et constante pour cette version logicielle</remarks>
    Public Property angl_Arma As Integer = 135
    ''' <summary>
    ''' Positionnement des armatures: 1=espacées/2=regroupées 2 par 2/3=1ier lit regroupe 2 lits/4=1ier lit regroupe 3 lits
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Position_Arma As Integer = 1
    ''' <summary>
    ''' Longueur maximale commercialisable de barres HA: en FRANCE = 12m, unité:m
    ''' </summary>
    Public Property HA_Lg_Max As Double = 12
    ''' <summary>
    ''' Position en portefeuille pour les barres HA dépassant la longueur maximale commercialisable: VRAI si dépasse
    ''' </summary>
    Public Property Position_Portefeuille As Boolean = True
    ''' <summary>
    ''' Armature longitudinale: vrai si autorisé sinon False
    ''' </summary>
    Public Property Ha_Lg As New List(Of Boolean) 'From {True, True, True, True, True, True, True, True, False, False}
    ''' <summary>
    ''' Armature transversale: vrai si autorisé sinon False
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Ha_Tr As New List(Of Boolean) 'From {True, True, True, True, False, False, False, False, False, False}
    ''' <summary>
    ''' Diamètre normalisé des barres HA en FRANCE - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property Ø_Norm As New List(Of Double) From {0.006, 0.008, 0.01, 0.012, 0.014, 0.016, 0.02, 0.025, 0.032, 0.04}
    ''' <summary>
    ''' Diamètre du mandrin pour barre longitudinale - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property dmL As New List(Of Double) From {0.063, 0.08, 0.1, 0.125, 0.16, 0.16, 0.2, 0.25, 0.32, 0.4}
    ''' <summary>
    ''' Diamètre du mandrin pour barre transversale - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property dmT As New List(Of Double) From {0.032, 0.04, 0.05, 0.063, 0.08, 0.08, 0.1, 0.125, 0.16, 0.2}
    ''' <summary>
    ''' Diamètre du mandrin pour barre coudée - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property dmC As New List(Of Double) From {0.1, 0.125, 0.16, 0.2, 0.2, 0.25, 0.32, 0.4, 0.5, 0.5}
    ''' <summary>
    ''' Diamètre du mandrin série de Renard - unité: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property dmR As New List(Of Double) From {0.016, 0.02, 0.025, 0.03, 0.032, 0.04, 0.05, 0.063, 0.07, 0.08, 0.1, 0.125, 0.15, 0.16, 0.2, 0.25, 0.3, 0.32, 0.4, 0.5, 0.63, 0.8}
    ''' <summary>
    ''' Diamètre du mandrin pour barre de treillis soudé - unité: m
    ''' </summary>
    ''' <returns></returns> 
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property dmTS As New List(Of Double) From {0.06, 0.07, 0.07, 0.07, 0.07, 0.08, 0.09, 0.07, 0.07, 0.07, 0.07, 0.08, 0.09}
    ''' <summary>
    ''' TS (avec indice): vrai si ce TS est autorisé à être posé sinon False
    ''' </summary>
    Public Property TS As New List(Of Boolean) 'From {True, True, True, True, True, True, True, True, True, True, True, True, True}
    ''' <summary>
    ''' diamètre de l'acier longitudinal du TS n°i - unité: m
    ''' </summary>
    ''' <returns></returns>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property Ølong As New List(Of Double) From {5.5 * 0.001, 6 * 0.001, 7 * 0.001, 6 * 0.001, 7 * 0.001, 8 * 0.001, 9 * 0.001, 6 * 0.001, 7 * 0.001, 0.007, 7 * 0.001, 8 * 0.001, 9 * 0.001} 'diamètre longitudinal
    ''' <summary>
    ''' Espacement de l'acier longitudinal du TS n°i - unité: m
    ''' </summary>
    ''' <returns></returns>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property Esp_Long As New List(Of Double) From {0.2, 0.15, 0.15, 0.1, 0.1, 0.1, 0.1, 0.2, 0.15, 0.15, 0.1, 0.1, 0.1} 'Esp longitudinal
    ''' <summary>
    ''' Section longitudinale du TS n°i - unité: m²
    ''' </summary>
    ''' <returns></returns>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property As_long As New List(Of Double) From {1.19 * 0.0001, 1.89 * 0.0001, 2.57 * 0.0001, 2.83 * 0.0001, 3.85 * 0.0001, 5.03 * 0.0001, 6.36 * 0.0001, 1.42 * 0.0001, 2.57 * 0.0001, 0.000257, 3.85 * 0.0001, 5.03 * 0.0001, 6.36 * 0.0001} 'section longitudinale
    ''' <summary>
    ''' section transversale du TS n°i - unité: m²
    ''' </summary>
    ''' <returns></returns>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property As_trans As New List(Of Double) From {1.19 * 0.0001, 1.28 * 0.0001, 1.28 * 0.0001, 1.28 * 0.0001, 1.28 * 0.0001, 1.68 * 0.0001, 2.52 * 0.0001, 1.42 * 0.0001, 2.57 * 0.0001, 0.000257, 3.85 * 0.0001, 5.03 * 0.0001, 6.36 * 0.0001} 'section transversale
    ''' <summary>
    ''' Espacement de l'acier transversal du TS n°i - unité: m
    ''' </summary>
    ''' <returns></returns>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property Esp_trans As New List(Of Double) From {0.2, 0.3, 0.3, 0.3, 0.3, 0.3, 0.25, 0.2, 0.15, 0.15, 0.1, 0.1, 0.1} 'Esp transversal
    ''' <summary>
    ''' diamètre de l'acier transversal du TS n°i - unité: m
    ''' </summary>
    ''' <returns></returns>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property Øtrans As New List(Of Double) From {5.5 * 0.001, 7 * 0.001, 7 * 0.001, 7 * 0.001, 7 * 0.001, 8 * 0.001, 8 * 0.001, 6 * 0.001, 7 * 0.001, 0.007, 7 * 0.001, 8 * 0.001, 9 * 0.001} 'diamètre transversal    ''' <summary>
    ''' <summary>
    ''' nbre de fils - Sens porteur - pour la largeur du panneau
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property nbre_fils_N As New List(Of Integer) From {12, 16, 16, 24, 24, 24, 24, 12, 16, 16, 24, 24, 24}
    ''' <summary>
    ''' nbre de fils - Sens Non porteur ou transversal - pour la longueur du panneau
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property nbre_fils_ntrans As New List(Of Integer) From {24, 20, 20, 20, 20, 20, 24, 20, 40, 20, 60, 60, 60}
    ''' <summary>
    ''' nom du TS, dans l'ordre: "ST 10", "ST 20", "ST 25", "ST 30", "ST 35", "ST 50", "ST 60", "ST 15C", "ST 25C", "ST 40C", "ST 50C", "ST 65C"
    ''' </summary>
    ''' <returns></returns>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property nomTS As New List(Of String) From {"ST 10", "ST 20", "ST 25", "ST 30", "ST 35", "ST 50", "ST 60", "ST 15C", "ST 25C", "ST 25CS", "ST 40C", "ST 50C", "ST 65C"}
    ''' <summary>
    ''' Poids nominal en kg/m² pour chaque type de TS Adets
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property Poids_TS As New List(Of Double) From {1.87, 2.487, 3.02, 3.226, 4.026, 5.267, 6.986, 2.22, 4.026, 4.026, 6.04, 7.9, 9.98}
    ''' <summary>
    ''' Largeur d'un panneau pour chaque type de TS Adets - Unite: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property Larg_TS As New List(Of Double) From {2.4, 2.4, 2.4, 2.4, 2.4, 2.4, 2.4, 2.4, 2.4, 2.4, 2.4, 2.4, 2.4}
    ''' <summary>
    ''' Longueur d'un panneau pour chaque type de TS Adets - Unite: m
    ''' </summary>
    <Xml.Serialization.XmlIgnore> Public ReadOnly Property Long_TS As New List(Of Double) From {4.8, 6, 6, 6, 6, 6, 6, 4, 6, 3, 6, 6, 6}
    ''' <summary>
    ''' Initialisation des données pour la qualité d'acier retenue
    ''' </summary>
    Public Sub Initialisation()
        Select Case classe
            Case 1
                x_εuk = 2.5 : x_k = 1.05
            Case 2
                x_εuk = 5 : x_k = 1.08
            Case 3
                x_εuk = 7.5 : x_k = 1.15
        End Select
    End Sub
End Class
'''<summary>Classe Beton: encapsule toutes les caractéristiques du béton utilisé: résistance, etc. ...</summary>
<Serializable()> Public Class Beton
    Dim x_fctm, x_fctk05, x_Ecm As Double
    Dim x_fcm As Integer
    ''' <summary>
    ''' coefficient partiel relatif au béton - situation durable ou transitoire
    ''' </summary>
    Public Property γcd As Double = 1.5
    ''' <summary>
    ''' coefficient partiel relatif au béton - situation accidentelle
    ''' </summary>
    Public Property γca As Double = 1
    ''' <summary>
    ''' résistance caractéristique à la compression sur cylindre
    ''' </summary>
    Public Property fck As Integer
    ''' <summary>
    ''' résistance moyenne à la compression sur cylindre
    ''' </summary>
    Public ReadOnly Property fcm As Integer
        Get
            fcm = x_fcm
        End Get
    End Property
    ''' <summary>
    ''' Limitation de la contrainte du béton suivant disposition article 7.2
    ''' </summary>
    Public Property Limitation_Contrainte_Beton As Boolean
    ''' <summary>
    ''' contrainte traction moyenne
    ''' </summary>
    Public ReadOnly Property fctm As Double
        Get
            fctm = x_fctm
        End Get
    End Property
    ''' <summary>
    ''' contrainte traction fractile 5%
    ''' </summary>
    Public ReadOnly Property fctk05 As Double
        Get
            fctk05 = x_fctk05
        End Get
    End Property
    ''' <summary>
    ''' diamètre granulat - EN1992-1-1 A8.2(1)
    ''' </summary>
    Public Property dg As Double = 0.02
    ''' <summary>
    ''' module d'élasticité moyen court terme
    ''' </summary>
    Public ReadOnly Property Ecm As Double
        Get
            Ecm = x_Ecm
        End Get
    End Property
    ''' <summary>
    ''' Classe du ciment: 0= S, 1=N et 2=R
    ''' </summary>
    Public Property Classe As Integer
    ''' <summary>
    ''' type de ciment: 1 = ciment CEM I sans cendre volante/ 2 = autre ciment
    ''' </summary>
    Public Property Ciment As Integer
    ''' <summary>
    ''' Initialisation des données pour le béton retenue
    ''' </summary>
    Public Sub Initialisation()
        Select Case fck
            Case 12
                x_fctm = 1.6 : x_fcm = 20 : x_fctk05 = 1.1 : x_Ecm = 27000
            Case 16
                x_fctm = 1.9 : x_fcm = 24 : x_fctk05 = 1.3 : x_Ecm = 29000
            Case 20
                x_fctm = 2.2 : x_fcm = 28 : x_fctk05 = 1.5 : x_Ecm = 30000
            Case 25
                x_fctm = 2.6 : x_fcm = 33 : x_fctk05 = 1.8 : x_Ecm = 31000
            Case 30
                x_fctm = 2.9 : x_fcm = 38 : x_fctk05 = 2 : x_Ecm = 33000
            Case 35
                x_fctm = 3.2 : x_fcm = 43 : x_fctk05 = 2.2 : x_Ecm = 34000
            Case 40
                x_fctm = 3.5 : x_fcm = 48 : x_fctk05 = 2.5 : x_Ecm = 35000
            Case 45
                x_fctm = 3.8 : x_fcm = 53 : x_fctk05 = 2.7 : x_Ecm = 36000
            Case 50
                x_fctm = 4.1 : x_fcm = 58 : x_fctk05 = 2.9 : x_Ecm = 37000
            Case 55
                x_fctm = 4.2 : x_fcm = 63 : x_fctk05 = 3.0 : x_Ecm = 38000
            Case 60
                x_fctm = 4.4 : x_fcm = 68 : x_fctk05 = 3.1 : x_Ecm = 39000
            Case 70
                x_fctm = 4.6 : x_fcm = 78 : x_fctk05 = 3.2 : x_Ecm = 41000
            Case 80
                x_fctm = 4.8 : x_fcm = 88 : x_fctk05 = 3.4 : x_Ecm = 42000
            Case 90
                x_fctm = 5 : x_fcm = 98 : x_fctk05 = 3.5 : x_Ecm = 44000
        End Select
    End Sub
End Class
