﻿Imports System.IO
Imports System.Math
Imports System.Xml.Serialization
Module General
    ''' <summary>
    ''' Classe encapsulant toutes les caractéristiques du plancher en cours de calcul
    ''' </summary>
    Public PlanCont As New List(Of Plancher)

    Public Combinaisons As New List(Of Combinaison)
    Public Aciers As New List(Of Acier)
    Public bet As New Beton
    Public aci As New Acier
    Public Aff As New clsAffaire
    Public det_Ndc As New Detail_Ndc

    Public Function Cotgt(ByVal A As Double) As Double
        'détermination de la cotangente
        'A = angle en radian
        Dim b, b1 As Double
        Cotgt = 0
        Try
            b = A Mod (PI / 2)
            b1 = Truncate(b * 100)
            If b1 > 1 Then 'pour éliminer les multiples de Pi/2
                Cotgt = 1 / Tan(A)
            Else
                Cotgt = 0
            End If
        Catch ex As Exception
            MessageBox.Show("erreur sur donnée angle", "Fonction cotangente", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Function
    Public Function checkAscii(ByVal keyAscii As Integer, Optional ByVal positif As Boolean = False) As Integer
        checkAscii = Abs(keyAscii)
        If keyAscii < 0 Then
            If Abs(keyAscii) = 44 Then
                Exit Function
            End If
        End If
        If Abs(keyAscii) = 8 Then Exit Function ' touche del utilisable
        If Abs(keyAscii) = 44 Then Exit Function
        If positif = False And Abs(keyAscii) = 45 Then Exit Function 'touche - pour les nombres négatifs
        If Abs(keyAscii) < 48 Or Abs(keyAscii) > 57 Then checkAscii = 0
    End Function
    Public Sub Gestion_Keypress(ByRef ee As System.Windows.Forms.KeyPressEventArgs, ByVal text1 As System.Windows.Forms.TextBox,
                               ByVal positif As Boolean, ByVal entier As Boolean)
        Dim keyAscii As Integer
        Dim Lettre1 As Boolean = False
        keyAscii = Asc(ee.KeyChar)
        If text1.SelectionLength = text1.Text.Length Then text1.Clear() : Lettre1 = True 'Pour gérer la 1ière lettre tapée dans le textbox
        If keyAscii = Asc(".") Then
            If Lettre1 = False And entier = False Then 'le text1 comporte plus de 1 chiffre et le chiffre ne doit pas être un entier, remplacer . par ,
                text1.Text = text1.Text + ","
                text1.SelectionStart = Len(text1.Text) + 1
            End If
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc(",") Then
            If Lettre1 = True Then 'le text1 comporte  1 chiffre, on ne valide pas la frappe
                ee.Handled = True
                Exit Sub
            ElseIf entier = True Then 'si entier, frappe non validée
                ee.Handled = True
                Exit Sub
            End If
        End If
        If keyAscii = Asc("&") Then
            text1.Text = text1.Text + "1"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("é") Then
            text1.Text = text1.Text + "2"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = 34 Then ' code "
            text1.Text = text1.Text + "3"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("'") Then
            text1.Text = text1.Text + "4"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("(") Then
            text1.Text = text1.Text + "5"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If positif = True Then 'seulement si la valeur >0
            If keyAscii = Asc("-") Then
                text1.Text = text1.Text + "6"
                text1.SelectionStart = Len(text1.Text) + 1
                ee.Handled = True
                Exit Sub
            End If
        End If
        If keyAscii = Asc("è") Then
            text1.Text = text1.Text + "7"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("_") Then
            text1.Text = text1.Text + "8"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("ç") Then
            text1.Text = text1.Text + "9"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        If keyAscii = Asc("à") Then
            text1.Text = text1.Text + "0"
            text1.SelectionStart = Len(text1.Text) + 1
            ee.Handled = True
            Exit Sub
        End If
        keyAscii = checkAscii(keyAscii, positif)
        If keyAscii = 0 Then ee.Handled = True
    End Sub
    ''' <summary>Gestion des entrées en cellule datagridview</summary>
    ''' <param name="toto">j = n° de travée</param>
    '''<param name="Verif">Vrai si l'entrée a pu être traité, Faux si l'entrée n'est pas une valeur numérique</param>
    Public Sub Gestion_CelluleDbl(ByRef toto As String, ByRef Verif As Boolean)
        Dim position As Integer = 0
        Dim tutu As Double
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        'remplace le point par la virgule
        toto = Replace(toto, ".", ",")
        'supprime le caractère -
        toto = Replace(toto, "-", "")
        'vérification finale ne fois le traitement précédent effectué
        If Not Double.TryParse(toto, tutu) Then Verif = False

    End Sub
    Public Sub Lecture_fichier_Ini(ByVal filename As String, ByRef Verif As Boolean)
        Dim myStreamReader As StreamReader = Nothing
        Dim toto, titi(20) As String

        Try
            myStreamReader = File.OpenText(filename)
            toto = myStreamReader.ReadLine 'on n'affecte aucune valeur sur la première ligne
            toto = myStreamReader.ReadLine 'ligne de commentaire
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Redacteur = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Chantier = CStr(titi(1))
            'fichiers
            toto = myStreamReader.ReadLine  'ligne suivante
            Aff.msgResult = toto
            toto = myStreamReader.ReadLine   'ligne suivante
            Aff.msgData = toto
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.i_result = CInt(titi(1)) : Aff.i_data = CInt(titi(2))
            'Code de calcul
            toto = myStreamReader.ReadLine 'pour sauter la ligne
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Reco_Fr = CBool(titi(1))
            'Editeur
            toto = myStreamReader.ReadLine 'pour sauter la ligne
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Editeur = CInt(titi(1))
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " + Environment.NewLine + "Exception: " + ex.Message & ex.StackTrace, "General: Module lecture fichier ini", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Verif = False
        Finally
            If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
        End Try

    End Sub
    Private Sub LectureGen(ByVal toto As String, ByRef titi() As String)
        Dim blanc(15), i, j, position As Integer
        Dim tutu As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
    Public Sub Variables_generales()
        'Dim i As Integer
        'variables par défaut, inscrites en dur dans le logiciel
        'Ey = 210000 '''Module d'élasticité longitudinal de l'acier, en N/mm²// 
        'G = 80770 'Module d'élasticité transversal de l'acier, en N/mm² 
        'Général
        With Aff
            .msgData = Directory.GetCurrentDirectory.ToString() & "\Data"
            .msgResult = Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul"
            .i_data = 1
            .i_result = 1
            .Redacteur = "LeFux_Ingenierie"
            .Chantier = "A_définir"
            .Reco_Fr = False 'pas d'application des recommandations professionnelles
            .Editeur = 1
        End With
        'Matériaux
        'Beton - valeurs par défaut
        With bet
            .fck = 25
            .γcd = 1.5
            .γca = 1.2
            .Classe = 1 'Classe N
            .Ciment = 2 'autres
        End With
        'Acier - valeurs par défaut
        With aci
            .γsd = 1.15 'combinaison fondamentale
            .γsa = 1 'combinaison acidentelle
            .fyk = 500
            .classe = 2
        End With
        'Ferraillage
        aci.Position_Arma = 1 'armatures regroupées
        'Autres
        Aff.Duree = 2 : Aff.tinf = 2 '50 ans
        With aci
            .n_Cont = 15 : .n_Forcer_Cont = True 'coefficient d'équivalence pour le calcul des contraintes
            .n_Fl = 15 : .n_Forcer_Fl = True 'coefficient d'équivalence pour le calcul des flèches
        End With
        Aff.St = 1 '1ier cadre à st/2
        Aff.Etrier = 2 'armature intérieure sous forme d'épingle
    End Sub
    Public Sub Ecriture_Hypothese_Note_de_calcul(ByRef rtf As To_Rtf.RtfAnsiTextWriter) '   RtfAnsiTextWriter)
        Dim msg As String = String.Empty
        Dim msgi(10) As String
        Dim i, ipout(10), j, k As Integer
        '
        '-->  §  Titre de la note de calcul et §1-1  Règlement de calcul
        Call Titre_Chap1(rtf)
        '
        '-->  §  Géométrie - §1-2
        rtf.WriteStartGroup() : rtf.NewParagraph() : rtf.FontSize = 12 : rtf.FontSize = 10
        rtf.Underline = True : rtf.WriteString("1 - 2 Caractéristiques géométriques du plancher") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()
        Select Case PlanCont.Count
            Case 1
                With PlanCont.Item(0)
                    rtf.WriteString("Plancher isostatique ") : rtf.NewLine()
                    rtf.WriteString("-  Distance entre nus d'appui: " & (.Lx * 100).ToString() & "cm suivant X et " & (.Ly * 100).ToString() & "cm suivant Y.") : rtf.NewLine()
                    rtf.WriteString("-  Portées utiles: " & Truncate(.Lcx * 100).ToString() & "cm suivant X et " & (.Lcy * 100).ToString() & "cm suivant Y.") : rtf.NewLine()
                    If .Prefa_h < 0.01 Then
                        rtf.WriteString("-  Dalle pleine coulée en place - hauteur: " & (.H * 100).ToString() & "cm.") : rtf.NewLine()
                    Else
                        rtf.WriteString("-  Dalle coulée sur prédalles préfabriquées - hauteur totale: " & (.H * 100).ToString() & "cm.") : rtf.NewLine()
                        rtf.WriteString("-  Prédalles - nombre: " & .Prefa_nb.ToString("#") & " - Largeur variable " & .Prefa_Ly.Item(0).ToString("#0.000") & "m; longueur " & .Prefa_Lx.Item(0).ToString("#0.000") & "m; hauteur " _
                                        & (.Prefa_h * 100).ToString() & "cm.") : rtf.NewLine()
                    End If
                    rtf.WriteString("Appui gauche: Largeur = " & (.LappG * 100).ToString() & "cm") : rtf.WriteString(" - Appui droit: Largeur =" & (.LappD * 100).ToString() & "cm")
                    rtf.WriteString(" - Appui haut: Largeur = " & (.LappH * 100).ToString() & "cm") : rtf.WriteString(" - Appui bas: Largeur = " & (.LappB * 100).ToString() & "cm.") : rtf.NewLine()
                End With

            Case 2
                If PlanCont.Item(0).LappG < 0.02 Then
                    rtf.WriteString("Plancher isostatique avec console gauche") : rtf.NewLine()
                ElseIf PlanCont.Item(1).LappD < 0.02 Then
                    rtf.WriteString("Plancher isostatique avec console droite") : rtf.NewLine()
                Else
                    rtf.WriteString("Plancher unidirectionnel continue sur 3 appuis")
                    k = 1
                End If
            Case 3
                If PlanCont.Item(0).LappG < 0.02 And PlanCont.Item(2).LappD < 0.02 Then
                    rtf.WriteString("Plancher isostatique avec consoles gauche et droite") : rtf.NewLine()
                ElseIf PlanCont.Item(0).LappG < 0.02 Then
                    rtf.WriteString("Plancher unidirectionnel continue sur 3 appuis avec console gauche")
                ElseIf PlanCont.Item(2).LappG < 0.02 Then
                    rtf.WriteString("Plancher unidirectionnel continue sur 3 appuis avec console droite")
                Else
                    rtf.WriteString("Plancher unidirectionnel continue sur 4 appuis")
                End If
                k = 1
            Case Else
                If PlanCont.Item(0).LappG < 0.05 Then i = -1 Else i = 0
                If PlanCont.Item(PlanCont.Count - 1).LappD < 0.05 Then j = -1 Else j = 0
                rtf.WriteString("Plancher unidirectionnel continue sur " & (PlanCont.Count + 1 + i + j).ToString & " appuis") : rtf.NewLine()
        End Select
        If k = 1 Then
            rtf.WriteString(" - Portée: ") : rtf.NewLine()
            For i = 0 To PlanCont.Count - 1
                With PlanCont.Item(i)
                    rtf.WriteString(" - Travée n°" & (i + 1).ToString() & ": " & .Lx.ToString("#0.00") & " m suivant X et " & .Ly.ToString("#0.00") & " m suivant Y.") : rtf.NewLine()
                    If .Prefa_h >= 0.04 Then
                        rtf.WriteString("-  Dalle coulée en oeuvre sur prédalles préfabriquées - hauteur totale: " & (.H * 100).ToString() & "cm.") : rtf.NewLine()
                        rtf.WriteString("-  Prédalle  - nombre: " & .Prefa_nb.ToString("#") & " - Largeur variable " & .Prefa_Ly.Item(0).ToString("#0.000") & "m; longueur " & .Prefa_Lx.Item(0).ToString("#0.000") & "cm; hauteur " _
                                        & (.Prefa_h * 100).ToString() & "cm.") : rtf.NewLine()
                    Else
                        rtf.WriteString("          Dalle pleine coulée en place - hauteur: " & (.H * 100).ToString() & "cm.") : rtf.NewLine()
                    End If
                    rtf.WriteString("          Appui gauche: " & (.LappG * 100).ToString() & " cm - Appui droit: " & (.LappD * 100).ToString() & "cm - Appui haut: " &
                                                   (.LappH * 100).ToString() & "cm - Appui bas: " & (.LappB * 100).ToString() & "cm.") : rtf.NewLine()
                End With
            Next
            rtf.NewLine()
        End If
        rtf.WriteEndGroup()
        '
        '-->  §  Matériaux  §1-3
        Call Chap_Materiaux(rtf)
        '
        '-->  §  Autres données  Environnement - Incendie - Seisme  §1-4
        Call Chap_Environnement(rtf)
        '
        '-->  §  Chargement - Combinaison
        rtf.WriteStartGroup() : rtf.FontSize = 12 : rtf.FontSize = 10
        rtf.Underline = True : rtf.WriteString("1 - 5 Chargement") : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("-  Cas de charge par travée   -   Unités: daN/m² pour les charges et m pour les longueurs.") : rtf.NewLine()
        rtf.NewParagraph() : rtf.FontSize = 9
        'Ligne 1
        rtf.BeginRow()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Cas") : rtf.EndCell()
        rtf.DeclareCell(1600) : rtf.BeginCell(True) : rtf.WriteString("Nature") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Schéma") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Application") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("P1 ou P") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("P2") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("a") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("b") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("c") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("d") : rtf.EndCell() : rtf.EndRow()
        'ligne 2
        For i = 1 To PlanCont.Count
            rtf.BeginRow() : rtf.DeclareCell(8800) : rtf.BeginCell(True) : rtf.WriteString("Travée n°" & i.ToString) : rtf.EndCell() : rtf.EndRow()
            For j = 1 To PlanCont.Item(i - 1).Chge.Count
                With PlanCont.Item(i - 1).Chge
                    rtf.BeginRow() : rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).Num.ToString) : rtf.EndCell()
                    Select Case .Item(j - 1).Nature
                        Case 1
                            msg = "Permanente"
                        Case 2
                            msg = "Exploit. Cat. A/B"
                        Case 3
                            msg = "Exploit. Cat. C/D"
                        Case 4
                            msg = "Exploit. Cat. E"
                        Case 5
                            msg = "Exploit. Cat. F"
                        Case 6
                            msg = "Exploit. Cat. G"
                        Case 7
                            msg = "Exploit. Cat. H"
                        Case 8
                            msg = "Neige"
                        Case 9
                            msg = "Vent"
                    End Select
                    rtf.DeclareCell(1600) : rtf.BeginCell(True) : rtf.WriteString(msg) : rtf.EndCell()
                    rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).schem.ToString) : rtf.EndCell()
                    Select Case .Item(j - 1).suspendue
                        Case 1
                            msg = "Supérieure"
                        Case 2
                            msg = "Inférieure"
                    End Select
                    rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(msg) : rtf.EndCell()
                    rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString((.Item(j - 1).P1 * 100000).ToString("#,##0.0")) : rtf.EndCell()
                    Select Case .Item(j - 1).schem
                        Case 1 'uniformément répartie
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(" - ") : rtf.EndCell()
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(" - ") : rtf.EndCell()
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(" - ") : rtf.EndCell()
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(" - ") : rtf.EndCell()
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(" - ") : rtf.EndCell() : rtf.EndRow()
                        Case Else
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString((.Item(j - 1).P2 * 100000).ToString("#,##0.0")) : rtf.EndCell()
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).a.ToString("#0.000")) : rtf.EndCell()
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).b.ToString("#0.000")) : rtf.EndCell()
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).c.ToString("#0.000")) : rtf.EndCell()
                            rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).d.ToString("#0.000")) : rtf.EndCell() : rtf.EndRow()
                    End Select

                End With
            Next
        Next
        rtf.WriteEndGroup()
        '
        '-->  §  Combinaisons
        Call Chap_Combinaisons(rtf)

    End Sub
    Private Sub Titre_Chap1(ByRef rtf As To_Rtf.RtfAnsiTextWriter)
        rtf.WriteStartGroup()
        rtf.NewParagraph(To_Rtf.RtfAnsiTextWriter.Align.Center) : rtf.Bold = True : rtf.FontSize = 18 : rtf.Underline = True
        rtf.WriteString("Dimensionnement d'un plancher en béton armé suivant l'Eurocode 2")
        rtf.NewLine()
        rtf.Bold = False : rtf.FontSize = 10 : rtf.Underline = False : rtf.NewParagraph(To_Rtf.RtfAnsiTextWriter.Align.Left)
        Dim dt As New DateTime
        dt = DateTime.Now
        rtf.WriteString("Note de calcul du ") : rtf.WriteString(dt.ToString("dddd d MMMM yyyy à HH:mm:ss")) : rtf.NewLine()
        rtf.WriteString("Rédacteur : " & Aff.Redacteur) : rtf.NewLine()
        rtf.WriteString("Chantier : " & Aff.Chantier) : rtf.NewLine()
        rtf.WriteString("Logiciel : Plancher BA  -  version " & My.Application.Info.Version.ToString & "   2016 - " & DateTime.Now.Year.ToString) : rtf.NewLine()
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("1 - Rappel des hypothèses") : rtf.Bold = False
        rtf.FontSize = 10 : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
        rtf.Underline = True : rtf.WriteString("1 - 1 Codes de calcul") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()
        rtf.WriteString("-  EN 1992-1-1 d'octobre 2005 et annexe nationale ")
        If Aff.Reco_Fr = True Then
            rtf.NewLine() : rtf.WriteString("-  Recommandations professionnelles françaises")
        Else
            rtf.NewLine() : rtf.WriteString("-  Pas de prise en compte des Recommandations professionnelles françaises - mars 2007.")
        End If
        If PlanCont(0).Prefa_h < 0.01 Then

        Else
            rtf.NewLine() : rtf.WriteString("-  Cahier des Prescriptions Techniques Prédalles - Cahier du CSTB Avril 2016.")
        End If
        rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub
    Private Sub Chap_Materiaux(ByRef rtf As To_Rtf.RtfAnsiTextWriter)
        Dim msg As String = String.Empty
        rtf.WriteStartGroup() : rtf.FontSize = 12 : rtf.FontSize = 10
        rtf.Underline = True : rtf.WriteString("1 - 3 Données sur les matériaux") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()
        Select Case bet.Classe
            Case 0 'S
                msg = "S"
            Case 1 'N
                msg = "N"
            Case 2 'R
                msg = "R"
        End Select
        rtf.WriteString("-  béton - fck = " & bet.fck.ToString & " MPa - diamètre granulat: " & (bet.dg * 1000).ToString & " mm - Classe ciment: " & msg) : rtf.NewLine()
        Select Case PlanCont.Item(0).Type_Acier_Travée
            Case 1 'TS
                rtf.WriteString("-  armatures treillis soudé haute adhérence conforme EN 10080 - fyk = " & aci.fyk.ToString & " MPa - classe ductilité ")
                Select Case aci.classe
                    Case 1
                        msg = "A"
                    Case 2
                        msg = "B"
                    Case 3
                        msg = "C"
                End Select
                rtf.WriteString(msg) : rtf.NewLine()
            Case 2 'quadrillage barres HA
                rtf.WriteString("-  armatures barres haute adhérence conforme EN 10080 - fyk = " & aci.fyk.ToString & " MPa - classe ductilité ")
                Select Case aci.classe
                    Case 1
                        msg = "A"
                    Case 2
                        msg = "B"
                    Case 3
                        msg = "C"
                End Select
                rtf.WriteString(msg) : rtf.NewLine()
        End Select
        rtf.WriteEndGroup()
    End Sub
    Private Sub Chap_Environnement(ByRef rtf As To_Rtf.RtfAnsiTextWriter)
        Dim msg As String = String.Empty
        Dim i As Integer
        rtf.WriteStartGroup() : rtf.NewParagraph() : rtf.FontSize = 12 : rtf.FontSize = 10
        rtf.Underline = True : rtf.WriteString("1 - 4 Autres données") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()

        rtf.WriteString("-  Environnement : ") : rtf.NewLine()
        If PlanCont.Item(0).Enrobage = False Then
            rtf.WriteString(" ■ Durée d'utilisation: ")
            Select Case Aff.Duree
                Case 0
                    rtf.WriteString("10 ans") : rtf.NewLine()
                Case 1
                    rtf.WriteString("25 ans") : rtf.NewLine()
                Case 2
                    rtf.WriteString("50 ans") : rtf.NewLine()
                Case 3
                    rtf.WriteString("100 ans") : rtf.NewLine()
            End Select
        End If
        For i = 1 To PlanCont.Count
            If PlanCont.Item(i - 1).Enrobage = False Then
                msg = ""
                rtf.WriteString(" ■ Travée n°" & i.ToString & ": ")
                With PlanCont.Item(i - 1)
                    If .XD1 = True Then msg = " XD1"
                    If .XD2 = True Then msg = msg + " XD2"
                    If .XD3 = True Then msg = msg + " XD3"
                    If .XS1 = True Then msg = msg + " XS1"
                    If .XS2 = True Then msg = msg + " XS2"
                    If .XS3 = True Then msg = msg + " XS3"
                    If .XC2 = True Then msg = msg + " XC2"
                    If .XC3 = True Then msg = msg + " XC3"
                    If .XC4 = True Then msg = msg + " XC4"
                    If .X0 = True Then msg = msg + " X0"
                    If .XC1 = True Then msg = msg + " XC1"
                    If msg = "" Then msg = "Sans Objet"
                End With
                rtf.WriteString(msg) : rtf.NewLine()
                Call Determination_Enrobage(i) 'par travée
            Else
                msg = " ■ Travée n°" & i.ToString & ": aucune classe d'exposition n'a été renseignée. La vérification aux Etats Limites de Service et la limitation des ouvertures des fissures ne " _
                & "pourront être évaluées."
                Aff.msg_Avertiss.Add(msg)
            End If
        Next
        If Aff.harmonisation_enrobage = True Then
            Call Harmonisation_Enrobage()
        Else
            If PlanCont.Count > 1 Then
                msg = "Enrobage: aucune mesure d'harmonisation d'enrobage entre les différentes travées n'a été prise."
                Aff.msg_Avertiss.Add(msg)
            End If
        End If
        rtf.WriteString("-  Enrobage nominal: ") : rtf.NewLine()
        For i = 1 To PlanCont.Count
            rtf.WriteString(" ■ Travée n°" & i.ToString & ": inférieur = ")
            With PlanCont.Item(i - 1)
                rtf.WriteString((.enrInf * 100).ToString("#0.0") & " cm; latéral = " & (.enrLat * 100).ToString("0.0") & " cm; supérieur = " & (.enrSup * 100).ToString("0.0") _
                                & " cm.") : rtf.NewLine()
            End With
        Next
        rtf.WriteString("-  Largeur de fissure admissible : ")
        Dim Maitrise_Fissuration As Boolean = False
        For i = 1 To PlanCont.Count
            With PlanCont.Item(i - 1)
                If .XD1 = True Or .XD2 = True Or .XD3 = True Or .XS1 = True Or .XS2 = True Or .XS3 = True Or .XC2 = True Or .XC3 = True Or .XC4 = True Or
                                  .X0 = True Or .XC1 = True Then
                    Maitrise_Fissuration = True : Exit For
                End If
            End With
        Next
        If Maitrise_Fissuration = True Then
            rtf.NewLine()
            For i = 1 To PlanCont.Count
                With PlanCont.Item(i - 1)
                    rtf.WriteString(" ■ Travée n°" & i.ToString & ": ")
                    If .XD1 = True Or .XD2 = True Or .XS1 = True Or .XS2 = True Or .XS3 = True Or .XD3 = True Then
                        rtf.WriteString("Wmax = 0,20 mm") : rtf.NewLine()
                    ElseIf .XC2 = True Or .XC3 = True Or .XC4 = True Then
                        rtf.WriteString("Wmax = 0,30 mm") : rtf.NewLine()
                    ElseIf .X0 = True Or .XC1 = True Then
                        rtf.WriteString("Wmax = 0,40 mm") : rtf.NewLine()
                    Else
                        rtf.WriteString("Sans objet") : rtf.NewLine()
                    End If
                End With
            Next
        Else
            rtf.WriteString("Sans objet") : rtf.NewLine()
        End If
        rtf.WriteString("-  Classe de la tenue au feu : ")
        msg = String.Empty
        For i = 1 To PlanCont.Count
            msg = msg & " travée n°" & i.ToString
            With PlanCont.Item(i - 1)
                Select Case .Feu_REI
                    Case -1, 0
                        msg = msg & "= Sans conditions -"
                    Case 1 '30''
                        msg = msg & "= REI30 -"
                    Case 2
                        msg = msg & "= REI60 -"
                    Case 3
                        msg = msg & "= REI90 -"
                    Case 4
                        msg = msg & "= REI120 -"
                    Case 5
                        msg = msg & "= REI180 -"
                    Case 6
                        msg = msg & "= REI240 -"
                End Select
            End With
        Next
        rtf.WriteString(msg) : rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub
    Private Sub Chap_Combinaisons(ByRef rtf As To_Rtf.RtfAnsiTextWriter)
        Dim i, k As Integer
        rtf.WriteStartGroup() : rtf.NewParagraph() : rtf.FontSize = 12 : rtf.FontSize = 10
        rtf.WriteString("-  Combinaisons") : rtf.NewLine()
        rtf.WriteEndGroup()
        For i = 1 To Aff.ELU
            rtf.WriteStartGroup()
            rtf.NewParagraph()
            rtf.FontSize = 12 : rtf.FontSize = 8
            rtf.WriteString("* " & i.ToString & "  -  ELU STR") : rtf.NewLine()
            rtf.WriteEndGroup()
            Call Affichage_Comb(i, rtf)
            k = i
        Next
        For i = k + 1 To Aff.ELU_EQ
            rtf.WriteStartGroup()
            rtf.NewParagraph()
            rtf.FontSize = 12 : rtf.FontSize = 8
            rtf.WriteString("* " & i.ToString & "  -  ELU EQU") : rtf.NewLine()
            rtf.WriteEndGroup()
            Call Affichage_Comb(i, rtf)
            k = i
        Next
        For i = k + 1 To Aff.ELScar
            rtf.WriteStartGroup()
            rtf.NewParagraph()
            rtf.FontSize = 12 : rtf.FontSize = 8
            rtf.WriteString("* " & i.ToString & "  -  ELS caractéristique") : rtf.NewLine()
            rtf.WriteEndGroup()
            Call Affichage_Comb(i, rtf)
            k = i
        Next
        For i = k + 1 To Aff.ELSQP
            rtf.WriteStartGroup()
            rtf.NewParagraph()
            rtf.FontSize = 12 : rtf.FontSize = 8
            rtf.WriteString("* " & i.ToString & "  -  ELS  quasi-permanent") : rtf.NewLine()
            rtf.WriteEndGroup()
            Call Affichage_Comb(i, rtf)
        Next
    End Sub
    Public Sub Plaque_Ecriture_Entree_Donnees(ByRef rtf As To_Rtf.RtfAnsiTextWriter)
        Dim msg As String = String.Empty
        Dim msgi(10) As String
        Dim i, ipout(10), j As Integer
        '
        '-> Titre de la note de calcul
        Call Titre_Chap1(rtf)
        '
        '--> § Géométrie
        rtf.WriteStartGroup() : rtf.NewParagraph() : rtf.FontSize = 12 : rtf.FontSize = 10
        rtf.Underline = True : rtf.WriteString("1 - 2  Caractéristiques géométriques du plancher") : rtf.Underline = False : rtf.FontSize = 9 : rtf.NewLine()
        rtf.WriteString("Plancher bidirectionnel composé de dalle(s) isostatique(s) ") : rtf.NewLine()
        For i = 0 To PlanCont.Count - 1
            With PlanCont.Item(i)
                rtf.WriteString(" - Travée n°" & (i + 1).ToString() & ": " & .Lx.ToString("#0.00") & " m suivant X et " & .Ly.ToString("#0.00") & " m suivant Y.") : rtf.NewLine()
                rtf.WriteString("          Dalle pleine coulée en place - hauteur: " & (.H * 100).ToString() & "cm.") : rtf.NewLine()
                rtf.WriteString("          Appui gauche: " & (.LappG * 100).ToString() & " cm - Appui droit: " & (.LappD * 100).ToString() & "cm - Appui haut: " &
                                                   (.LappH * 100).ToString() & "cm - Appui bas: " & (.LappB * 100).ToString() & "cm.") : rtf.NewLine()
            End With
        Next
        rtf.NewLine()
        rtf.WriteEndGroup()
        '
        '-->  §  Matériaux
        Call Chap_Materiaux(rtf)
        '
        '-->  §  Autres données  Environnement - Incendie - Seisme  §1-4
        Call Chap_Environnement(rtf)
        '
        '-->  §  Charges  
        rtf.WriteStartGroup() : rtf.NewParagraph() : rtf.FontSize = 12 : rtf.FontSize = 10
        rtf.Underline = True : rtf.WriteString("1 - 5  Chargement") : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("-  Cas de charge par travée   -   Unités: daN/m² pour les charges et m pour les longueurs.") : rtf.NewLine()
        rtf.NewParagraph() : rtf.FontSize = 9
        'Ligne 1
        rtf.BeginRow()
        rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString("Cas") : rtf.EndCell()
        rtf.DeclareCell(1600) : rtf.BeginCell(True) : rtf.WriteString("Nature") : rtf.EndCell()
        rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString("Application") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("P") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Ox") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("Oy") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("lx") : rtf.EndCell()
        rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString("ly") : rtf.EndCell() : rtf.EndRow()
        'ligne 2
        For i = 1 To PlanCont.Count
            rtf.BeginRow() : rtf.DeclareCell(8800) : rtf.BeginCell(True) : rtf.WriteString("Travée n°" & i.ToString) : rtf.EndCell() : rtf.EndRow()
            For j = 1 To PlanCont.Item(i - 1).Chge.Count
                With PlanCont.Item(i - 1).Chge
                    rtf.BeginRow() : rtf.DeclareCell(600) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).Num.ToString) : rtf.EndCell() 'n° de cas
                    Select Case .Item(j - 1).Nature
                        Case 1
                            msg = "Permanente"
                        Case 2
                            msg = "Exploit. Cat. A/B"
                        Case 3
                            msg = "Exploit. Cat. C/D"
                        Case 4
                            msg = "Exploit. Cat. E"
                        Case 5
                            msg = "Exploit. Cat. F"
                        Case 6
                            msg = "Exploit. Cat. G"
                        Case 7
                            msg = "Exploit. Cat. H"
                        Case 8
                            msg = "Neige"
                        Case 9
                            msg = "Vent"
                    End Select
                    rtf.DeclareCell(1600) : rtf.BeginCell(True) : rtf.WriteString(msg) : rtf.EndCell()
                    Select Case .Item(j - 1).suspendue
                        Case 1
                            msg = "Supérieure"
                        Case 2
                            msg = "Inférieure"
                    End Select
                    rtf.DeclareCell(1000) : rtf.BeginCell(True) : rtf.WriteString(msg) : rtf.EndCell()
                    rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString((.Item(j - 1).P1 * 100000).ToString("#,##0.0")) : rtf.EndCell()
                    rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).Ox.ToString("#0.000")) : rtf.EndCell()
                    rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).Oy.ToString("#0.000")) : rtf.EndCell()
                    rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).Lx.ToString("#0.000")) : rtf.EndCell()
                    rtf.DeclareCell(800) : rtf.BeginCell(True) : rtf.WriteString(.Item(j - 1).Ly.ToString("#0.000")) : rtf.EndCell() : rtf.EndRow()


                End With
            Next
        Next
        rtf.WriteEndGroup()
        '
        '-->   §  Combinaisons
        Call Chap_Combinaisons(rtf)

    End Sub
    ''' <summary>Routine calculant l'enrobage fonction de XC1, XC2, etc. ... </summary>
    ''' <param name="Ntrav">n° de travée</param>
    Private Sub Determination_Enrobage(ByVal Ntrav As Integer)
        Dim Cmin, Cminb, Cdev As Double 'CminDur,
        Dim j, struct As Integer
        Dim msg As String
        Dim cmind(18) As Double
        Dim Compact_Enrobage As Boolean = False
        'Cmin = 0.01 '10mm
        Cminb = 0.008 'diamètre barre mini HA8
        If bet.dg > 0.032 Then Cminb = Cminb + 0.005
        Cdev = 0.01
        For j = 1 To 18 : cmind(j) = 2 : Next 'pour ré-initialiser à chaque poutre
        With PlanCont.Item(Ntrav - 1)
            Compact_Enrobage = True 'voir guide EGF
            'minoration suivant la classe de résistance du béton pour les classe d'exposition
            If .X0 = True Then
                msg = "Travée n°" & Ntrav.ToString & ": l'Annexe Nationale impose, à minima, une classe XC1 pour tout plancher de bâtiment."
                Aff.msg_Avertiss.Add(msg)
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is >= 50 'MPa
                        struct = struct - 2
                    Case Is >= 30 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(True, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, struct, cmind(1))
            End If
            If .XC1 = True Then
                If .H <= 0.25 Then Compact_Enrobage = True ' suivant commentaire de la commission de normalisation
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 20
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XC1 est C20/25."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 50 'MPa
                        struct = struct - 2
                    Case Is >= 30 'MPa
                        struct = struct - 1
                End Select
                If bet.Ciment = 1 And bet.fck >= 35 Then
                    'utilisation de ciment CEM I sans cendre volante
                    struct = struct - 1
                End If
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, True, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, struct, cmind(2))
            End If
            If .XC2 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 25
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XC2 est C25/30."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 55 'MPa
                        struct = struct - 2
                    Case Is >= 30 'MPa
                        struct = struct - 1
                End Select
                If bet.Ciment = 1 And bet.fck >= 35 Then
                    'utilisation de ciment CEM I sans cendre volante
                    struct = struct - 1
                End If
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, True, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, struct, cmind(3))
            End If
            If .XC3 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XC3 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 55 'MPa
                        struct = struct - 2
                    Case Is >= 30 'MPa
                        struct = struct - 1
                End Select
                If bet.Ciment = 1 And bet.fck >= 35 Then
                    'utilisation de ciment CEM I sans cendre volante
                    struct = struct - 1
                End If
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, True, False, False, False, False, False, False, False, False, False, False, False, False, False, False, struct, cmind(4))
            End If
            If .XC4 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XC4/XF1/XF3 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 35 'MPa
                        struct = struct - 1
                End Select
                If bet.Ciment = 1 And bet.fck >= 35 Then
                    'utilisation de ciment CEM I sans cendre volante
                    struct = struct - 1
                End If
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, True, False, False, False, False, False, False, False, False, False, False, False, False, False, struct, cmind(5))
            End If
            If .XD1 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD1/XD2/XS1/XA1/XA2 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 40 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, True, False, False, False, False, False, False, False, False, False, False, False, False, struct, cmind(6))
            End If
            If .XD2 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD1/XD2/XS1/XA1/XA2 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 40 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, True, False, False, False, False, False, False, False, False, False, False, False, struct, cmind(7))
            End If
            If .XD3 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 35
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD3/XS3/XF2/XF4/XA3 est C35/45."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 70 'MPa
                        struct = struct - 2
                    Case Is >= 45 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, True, False, False, False, False, False, False, False, False, False, False, struct, cmind(8))
            End If
            If .XS1 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD1/XD2/XS1/XA1/XA2 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 40 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, True, False, False, False, False, False, False, False, False, False, struct, cmind(9))
            End If
            If .XS2 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 35
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XS2 est C35/45."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 40 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, True, False, False, False, False, False, False, False, False, struct, cmind(10))
            End If
            If .XS3 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 35
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD3/XS3/XF2/XF4/XA3 est C35/45."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 70 'MPa
                        struct = struct - 2
                    Case Is >= 45 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, False, True, False, False, False, False, False, False, False, struct, cmind(11))
            End If
            If .XF1 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XC4/XF1/XF3 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 35 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, False, False, True, False, False, False, False, False, False, struct, cmind(12))
            End If
            If .XF2 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 35
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD3/XS3/XF2/XF4/XA3 est C35/45."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 70 'MPa
                        struct = struct - 2
                    Case Is >= 45 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, False, False, False, True, False, False, False, False, False, struct, cmind(13))
            End If
            If .XF3 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XC4/XF1/XF3 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 35 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, False, False, False, False, True, False, False, False, False, struct, cmind(14))
            End If
            If .XF4 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 35
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD3/XS3/XF2/XF4/XA3 est C35/45."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 70 'MPa
                        struct = struct - 2
                    Case Is >= 45 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, False, False, False, False, False, True, False, False, False, struct, cmind(15))
            End If
            If .XA1 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD1/XD2/XS1/XA1/XA2 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 40 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, True, False, False, struct, cmind(16))
            End If
            If .XA2 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 30
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD1/XD2/XS1/XA1/XA2 est C30/37."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 60 'MPa
                        struct = struct - 2
                    Case Is >= 40 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, True, False, struct, cmind(17))
            End If
            If .XA3 = True Then
                Call Initialisation_Struct(Compact_Enrobage, struct)
                Select Case bet.fck
                    Case Is < 35
                        msg = "Travée n°" & Ntrav.ToString & ": La résistance minimale à la compression pour une classe d'exposition XD3/XS3/XF2/XF4/XA3 est C35/45."
                        Aff.msg_Avertiss.Add(msg)
                    Case Is >= 70 'MPa
                        struct = struct - 2
                    Case Is >= 45 'MPa
                        struct = struct - 1
                End Select
                If struct < 1 Then struct = 1
                Call Tableau_Enrobage44(False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, True, struct, cmind(18))
            End If

            Cmin = Cminb
            'If Cmin < CminDur Then Cmin = CminDur
            'affectation des résultats
            For j = 1 To 18
                If cmind(j) < 0.1 Then 's'il a été modifié -< valeur max 65mm
                    If Cmin < cmind(j) Then
                        Cmin = cmind(j) ': num_Expo = i
                    End If
                End If
            Next
            .enrInf = Cmin + Cdev
            .enrLat = Cmin + Cdev
            .enrSup = Cmin + Cdev
        End With

    End Sub
    Private Sub Harmonisation_Enrobage()
        'Harmonisation des enrobages entre travées
        Dim cmax As Double = 0
        For i = 1 To PlanCont.Count
            With PlanCont.Item(i - 1)
                If cmax < .enrLat Then cmax = .enrLat 'détermination de la valeur maxi
            End With
        Next
        For i = 1 To PlanCont.Count
            With PlanCont.Item(i - 1)
                .enrInf = cmax
                .enrLat = cmax
                .enrSup = cmax
            End With
        Next
    End Sub
    Private Sub Initialisation_Struct(ByVal Compact_Enrobage As Boolean, ByRef struct As Integer)
        struct = 4
        'minoration ou majoration suivant durée
        Select Case Aff.Duree
            Case 0, 1 ' 10 ou 25 ans
                struct = struct - 1
            Case 2 'soit 50 ans soit la classe S4
                struct = struct
            Case 3 '100 ans
                struct = struct + 2
        End Select
        If Compact_Enrobage = True Then struct = struct - 1
    End Sub
    Private Sub Tableau_Enrobage44(ByVal X0 As Boolean, ByVal XC1 As Boolean, ByVal XC2 As Boolean, ByVal XC3 As Boolean, ByVal XC4 As Boolean, ByVal XD1 As Boolean,
                           ByVal XD2 As Boolean, ByVal XD3 As Boolean, ByVal XS1 As Boolean, ByVal XS2 As Boolean, ByVal XS3 As Boolean, ByVal XF1 As Boolean,
                           ByVal XF2 As Boolean, ByVal XF3 As Boolean, ByVal XF4 As Boolean, ByVal XA1 As Boolean, ByVal XA2 As Boolean, ByVal XA3 As Boolean,
                           ByVal struct As Integer, ByRef Cmindur As Double)
        Select Case struct
            Case 1 'S1
                If X0 = True Or XC1 = True Then Cmindur = 0.01
                If XC2 = True Or XC3 = True Then Cmindur = 0.01
                If XC4 = True Or XF1 = True Or XF3 = True Then Cmindur = 0.015
                If XD1 = True Or XS1 = True Or XA1 = True Then Cmindur = 0.02
                If XD2 = True Or XS2 = True Or XA2 = True Then Cmindur = 0.025
                If XD3 = True Or XS3 = True Or XF2 = True Or XF4 = True Or XA3 = True Then Cmindur = 0.03
            Case 2 'S2
                If X0 = True Or XC1 = True Then Cmindur = 0.01
                If XC2 = True Or XC3 = True Then Cmindur = 0.015
                If XC4 = True Or XF1 = True Or XF3 = True Then Cmindur = 0.02
                If XD1 = True Or XS1 = True Or XA1 = True Then Cmindur = 0.025
                If XD2 = True Or XS2 = True Or XA2 = True Then Cmindur = 0.03
                If XD3 = True Or XS3 = True Or XF2 = True Or XF4 = True Or XA3 = True Then Cmindur = 0.035
            Case 3 'S3
                If X0 = True Or XC1 = True Then Cmindur = 0.01
                If XC2 = True Or XC3 = True Then Cmindur = 0.02
                If XC4 = True Or XF1 = True Or XF3 = True Then Cmindur = 0.025
                If XD1 = True Or XS1 = True Then Cmindur = 0.03
                If XD2 = True Or XS2 = True Or XA2 = True Then Cmindur = 0.035
                If XD3 = True Or XS3 = True Or XF2 = True Or XF4 = True Or XA3 = True Then Cmindur = 0.04
            Case 4 'S4
                If X0 = True Then Cmindur = 0.01
                If XC1 = True Then Cmindur = 0.015
                If XC2 = True Or XC3 = True Then Cmindur = 0.025
                If XC4 = True Or XF1 = True Or XF3 = True Then Cmindur = 0.03
                If XD1 = True Or XS1 = True Or XA1 = True Then Cmindur = 0.035
                If XD2 = True Or XS2 = True Or XA2 = True Then Cmindur = 0.04
                If XD3 = True Or XS3 = True Or XF2 = True Or XF4 = True Or XA3 = True Then Cmindur = 0.045
            Case 5 'S5
                If X0 = True Then Cmindur = 0.015
                If XC1 = True Then Cmindur = 0.02
                If XC2 = True Or XC3 = True Then Cmindur = 0.03
                If XC4 = True Or XF1 = True Or XF3 = True Then Cmindur = 0.035
                If XD1 = True Or XS1 = True Or XA1 = True Then Cmindur = 0.04
                If XD2 = True Or XS2 = True Or XA2 = True Then Cmindur = 0.045
                If XD3 = True Or XS3 = True Or XF2 = True Or XF4 = True Or XA3 = True Then Cmindur = 0.05
            Case Is >= 6 'S6
                If X0 = True Then Cmindur = 0.02
                If XC1 = True Then Cmindur = 0.025
                If XC2 = True Or XC3 = True Then Cmindur = 0.035
                If XC4 = True Or XF1 = True Or XF3 = True Then Cmindur = 0.04
                If XD1 = True Or XS1 = True Or XA1 = True Then Cmindur = 0.045
                If XD2 = True Or XS2 = True Or XA2 = True Then Cmindur = 0.05
                If XD3 = True Or XS3 = True Or XF2 = True Or XF4 = True Or XA3 = True Then Cmindur = 0.055
        End Select
    End Sub
    Private Sub Affichage_Comb(ByVal i As Integer, ByRef rtf As To_Rtf.RtfAnsiTextWriter)
        Dim msg1, msgi(10) As String
        Dim i1, ipout(10), j As Integer
        For j = 1 To PlanCont.Count
            msgi(j) = String.Empty
            ipout(j) = 0
        Next
        Dim comb As New Combinaison
        Dim dalle As New Plancher
        Dim chge As New Charge

        For Each comb In Combinaisons
            For Each dalle In PlanCont
                i1 = PlanCont.IndexOf(dalle)
                For Each chge In PlanCont.Item(PlanCont.IndexOf(dalle)).Chge
                    j = PlanCont.Item(PlanCont.IndexOf(dalle)).Chge.IndexOf(chge)
                    If comb.Trav = i1 + 1 And comb.Charge = j + 1 And comb.Num = i Then
                        If ipout(i1 + 1) = 0 Then msg1 = String.Empty Else msg1 = "+"
                        msgi(i1 + 1) = msgi(i1 + 1) & msg1 & comb.Pond.ToString("0.00") & ".[" & comb.Charge.ToString("#") & "]"
                        ipout(i1 + 1) = 1
                    End If
                Next
            Next
        Next
        rtf.WriteStartGroup()
        rtf.NewParagraph()
        rtf.FontSize = 12 : rtf.FontSize = 8
        For j = 1 To PlanCont.Count
            If msgi(j).Length > 18 Then
                rtf.WriteString(msgi(j)) : rtf.InsertTab()
            ElseIf msgi(j).Length > 9 Then
                rtf.WriteString(msgi(j)) : rtf.InsertTab() : rtf.InsertTab()
            Else
                rtf.WriteString(msgi(j)) : rtf.InsertTab() : rtf.InsertTab() : rtf.InsertTab()
            End If

        Next
        rtf.NewLine()
        'dessin de la poutre
        For j = 1 To PlanCont.Count
            rtf.WriteString("__________________________|") '27 touches
        Next
        rtf.NewLine()
        For j = 1 To PlanCont.Count
            Select Case j
                Case 1
                    If PlanCont.Item(0).LappG > 0.05 Then
                        rtf.WriteString("Δ                               ") '32 touches
                    Else
                        rtf.WriteString("                                ") '32 touches
                    End If
                Case PlanCont.Count
                    If PlanCont.Item(PlanCont.Count - 1).LappD > 0.05 Then
                        rtf.WriteString("Δ                               Δ") '33 touches
                    Else
                        rtf.WriteString("                                ") '32 touches
                    End If
                Case Else
                    rtf.WriteString("Δ                               ") '32 touches
            End Select
        Next
        rtf.NewLine()
        rtf.WriteEndGroup()
    End Sub
    Public Function Mise_en_Forme_date(ByVal Toto As String) As String
        Dim toti As String
        toti = Replace(Toto, "/", "_")
        Toto = Replace(toti, " ", "_")
        toti = Replace(Toto, ":", "_")
        Mise_en_Forme_date = toti
    End Function

#Region " Code de lecture du fichier de données "

#Region "Sérialization"
    ''' <summary>Routine sauvegardant les données objet par sérialization </summary>
    Public Sub SerializeData()
        Dim Fichier_Plancont As String = String.Empty
        Dim Fichier_Acier As String = String.Empty
        Dim Fichier_Beton As String = String.Empty
        Dim Fichier_Combinaisons As String = String.Empty
        Dim Fichier_Affaire As String = String.Empty

        Dim myStreamWriter As StreamWriter = Nothing
        Try
            myStreamWriter = File.CreateText(Aff.FileName)
            myStreamWriter.WriteLine("Plancher béton armé - Fichiers de sauvegarde de l'affaire")
            Fichier_Plancont = "Fichier_Plancont_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Plancont)
            Fichier_Acier = "Fichier_Acier_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Acier)
            Fichier_Beton = "Fichier_Beton_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Beton)
            Fichier_Combinaisons = "Fichier_Combinaisons_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Combinaisons)
            Fichier_Affaire = "Fichier_Affaire_" & Mise_en_Forme_date(CStr(DateTime.Now))
            myStreamWriter.WriteLine(Fichier_Affaire)
            myStreamWriter.Flush()
        Catch exc As Exception
            MessageBox.Show("Le fichier de sauvegarde ne peut être crée." + Environment.NewLine + "SVP, verifiez que le nom du fichier est correct, et que vouz avez la permission de lire ou d'écrire " +
              "dans le répertoire indiqué." + Environment.NewLine + Environment.NewLine + "Erreur: " + exc.Message, "Sauvegarde des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            ' fermer le fichier si pas de création possible
            If myStreamWriter IsNot Nothing Then myStreamWriter.Close()
        End Try
        'Sérialise les objets
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Plancont & ".xml", PlanCont)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Acier & ".xml", aci)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Beton & ".xml", bet)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Combinaisons & ".xml", Combinaisons)
        Call SerializeSysKeys(Aff.msgData & "\" & Fichier_Affaire & ".xml", Aff)

    End Sub
    Private Sub SerializeSysKeys(ByVal Path As String, ByVal Objet As Object)
        Try
            Call SaveXmlData(Path, Objet)
        Catch ex As Exception
            MessageBox.Show("Problème de sérialisation!" & Environment.NewLine & "Erreur: " + ex.Message, "Sauvegarde des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub SaveXmlData(ByVal Path As String, ByVal Objet As Object)
        Dim Type As Type = Objet.GetType
        Dim Serializeur As New XmlSerializer(Type)
        Dim Fi As New FileInfo(Path)
        If Fi.Directory.Exists = False Then System.IO.Directory.CreateDirectory(Fi.DirectoryName)
        'Sérialization
        Using fs As New FileStream(Path, FileMode.Create, FileAccess.Write)
            Serializeur.Serialize(fs, Objet)
            fs.Close()
        End Using
    End Sub
#End Region

#Region "Déserialization"
    ''' <summary>Routine lisant et affectant les données objet par sauvegardées par sérialization </summary>
    Public Sub DeSerializeData(ByVal Racine As String, ByRef Verif As Boolean)
        Dim toto, titi(20) As String
        Dim Fichier_Plancont As String = String.Empty
        Dim Fichier_Acier As String = String.Empty
        Dim Fichier_Beton As String = String.Empty
        Dim Fichier_Combinaisons As String = String.Empty
        Dim Fichier_Affaire As String = String.Empty
        Dim myStreamReader As StreamReader = Nothing

        Try
            myStreamReader = File.OpenText(Aff.FileName)
            toto = myStreamReader.ReadLine 'barre de titre
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Plancont = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Acier = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Beton = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Combinaisons = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
            Fichier_Affaire = CStr(titi(1))
        Catch exc As Exception
            MessageBox.Show("Le fichier de sauvegarde ne peut être lu." + Environment.NewLine + "SVP, verifiez que le nom du fichier est correct, et que vouz avez la permission de lire ou d'écrire " +
              "dans le répertoire indiqué." + Environment.NewLine + Environment.NewLine + "Erreur: " + exc.Message, "Lecture des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            If myStreamReader IsNot Nothing Then myStreamReader.Close() 'fermer le fichier si pas de création possible
        End Try
        'DéSérialise les objets
        If Racine + "\" <> Aff.msgData Then
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Plancont & ".xml", PlanCont, 1)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Acier & ".xml", aci, 2)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Beton & ".xml", bet, 3)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Combinaisons & ".xml", Combinaisons, 4)
            Call DeSerializeSysKeys(Racine & "\" & Fichier_Affaire & ".xml", Aff, 5)
        Else
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Plancont & ".xml", PlanCont, 1)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Acier & ".xml", aci, 2)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Beton & ".xml", bet, 3)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Combinaisons & ".xml", Combinaisons, 4)
            Call DeSerializeSysKeys(Aff.msgData & "\" & Fichier_Affaire & ".xml", Aff, 5)
        End If

    End Sub
    Private Sub DeSerializeSysKeys(ByVal Path As String, ByVal Objet As Object, ByVal i As Integer)
        ' Try
        Call LoadXmlData(Path, Objet)
            Select Case i
                Case 1
                    PlanCont = CType(Objet, List(Of Plancher))
                Case 2
                    aci = CType(Objet, Acier)
                Case 3
                    bet = CType(Objet, Beton)
                Case 4
                    Combinaisons = CType(Objet, List(Of Combinaison))
                Case 5
                    Aff = CType(Objet, clsAffaire)
            End Select

        'Catch ex As Exception
        '    MessageBox.Show("Problème de Désérialisation!" & Environment.NewLine & "Erreur: " + ex.Message, "Module DeSerializeSysKeys", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        'End Try
    End Sub
    Private Sub LoadXmlData(ByVal Path As String, ByRef Objet As Object)

        ' Try
        Dim Type As Type = Objet.GetType
            Dim Serializeur As New XmlSerializer(Type)
            Dim Fi As New FileInfo(Path)
            If Fi.Directory.Exists = False Then System.IO.Directory.CreateDirectory(Fi.DirectoryName)
            'Sérialization
            Using fs As New FileStream(Path, FileMode.Open, FileAccess.Read)
                Objet = Serializeur.Deserialize(fs)
                fs.Close()
            End Using
        'Catch ex As Exception
        '    MessageBox.Show("Problème de Désérialisation!" & Environment.NewLine & "Erreur: " + ex.Message, "Module LoadXmlData", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        'End Try
    End Sub
#End Region

    Private Sub Lecture_chaine(ByVal toto As String, ByRef titi() As String)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel)
        Dim blanc(20), i, j, position As Integer
        Dim tutu As String

        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        If titi(1) = "'" Then Exit Sub 'cette chaine correspond à un commentaire, sortie du programme
        'supprime tout commentaire dans la chaine
        position = InStr(1, toto, "'")
        If position <> 0 Then
            toto = Microsoft.VisualBasic.Left(toto, position - 1)
            toto = Trim(toto)
        End If
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub
#End Region

    ''COMMENTAIRES :
    ''le logiciel détermine la modélisation du plancher suivant le mode de construction, la géométrie, les charges appliquées.
    Public Sub Decoupage_Predalles()
        'Modele: =1 portée sur 2 appuis
        '        =2 portée sur 4 ppuis
        Dim dalle As New Plancher
        Dim i, j, k As Integer
        Dim L, Lx As Double

        For Each dalle In PlanCont
            With dalle
                If .Lx > 2 * .Ly Or .Ly > 2 * .Lx Then .modele_calcul = 1 'condition EC2: §5.3.1(5)
                If .Prefa = True Then
                    .modele_calcul = 1 'calcul sur 2 appuis
                    Lx = .Lx + .Prefa_ReposG + .Prefa_ReposD
                    'sens de portée = lx - Découpage suivant Ly
                    i = CInt(Truncate(.Ly / (.Prefa_L + .Prefa_esp)))
                    L = .Ly - i * (.Prefa_L + .Prefa_esp)
                    For j = 0 To i - 1
                        .Prefa_Ly.Add(.Prefa_L) 'j'affecte au iière travée la largeur préférentielle
                        .Prefa_Lx.Add(Lx)
                        k = ((PlanCont.IndexOf(dalle) + 1) * 10) + (j + 1)
                        .Prefa_Num.Add(k)
                    Next
                    .Prefa_Ly.Add(L) : .Prefa_Lx.Add(Lx) : .Prefa_Num.Add(k + 1)
                    .Prefa_nb = i + 1 '= nbre de prédalles pour la travée i
                End If
            End With
        Next
    End Sub

#Region " Poubelle "
    'Public Sub Lecture_fichier(ByRef Donnee_OK As Boolean)
    '    Dim myStreamReader As StreamReader = Nothing
    '    Dim i, j, j1, total As Integer
    '    Dim toto, msg, titi(20) As String
    '    ' Dim Version As Double
    '    PlanCont.Clear()
    '    Combinaisons.Clear()
    '    Aciers.Clear()
    '    Call Variables_generales() 'réinitialisation des classes AFF, Aci, Bet
    '    Try
    '        Donnee_OK = True
    '        myStreamReader = File.OpenText(Aff.FileName)
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi)
    '        If titi(1) <> "plancher" Then
    '            msg = "Il manque l'entête Plancher dans votre fichier." &  Environment.NewLine & "Votre fichier n'est pas compatible avec le programme"
    '            MessageBox.Show(msg, "Lecture fichier données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    '            Donnee_OK = False : Exit Sub
    '            'ElseIf titi(1) = "dallage" Then
    '            '    If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
    '            '    Version = CDbl(titi(2))
    '            '    If Version <> 1 Then
    '            '        msg = "La version de votre fichier n'est pas compatible avec le programme"
    '            '        MsgBox(msg, style, title)
    '            '        Donnee_OK = False : Exit Sub
    '            '    End If
    '        End If
    '        toto = myStreamReader.ReadLine 'ligne de commentaire "sauvegarde de la configuration de l'affaire"
    '        toto = myStreamReader.ReadLine
    '        Aff.Redacteur = toto 'lecture litérale
    '        toto = myStreamReader.ReadLine
    '        Aff.Chantier = toto 'lecture litérale
    '        toto = myStreamReader.ReadLine
    '        Aff.msgResult = toto 'lecture litérale
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi)
    '        Aff.msgData = toto 'lecture litérale
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        Aff.i_result = CInt(titi(1)) : Aff.i_data = CInt(titi(2))
    '        'Environnement
    '        'toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi)
    '        'Aff.Decalage_ET = CBool(titi(1)) : Aff.MinorationQ_ET = CBool(titi(2)) : Aff.St = CInt(titi(3)) ' : Aff.Lim_øET = CBool(titi(4)) _
    '        ' : Aff.øLimET = CDbl(titi(5)) : Aff.NbLit_Couture = CInt(titi(6))
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi)
    '        Aff.Reprise_M0_1_porteur = CBool(titi(1)) : Aff.EncastPartiel_1_porteur = CBool(titi(2)) : Aff.Reprise_M0_2_porteur = CBool(titi(3)) : Aff.EncastPartiel_2_porteur = CBool(titi(4))
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi)
    '        Aff.Ecretage_Moment = CBool(titi(1)) : Aff.Redistrib_limit = CBool(titi(2)) : Aff.δ = CDbl(titi(3)) : Aff.Affich_Predal = CBool(titi(4)) : Aff.Reco_Fr = CBool(titi(5))
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi)
    '        aci.n_Forcer_Cont = CBool(titi(1)) : aci.n_Cont = CDbl(titi(2)) : Aff.RH = CInt(titi(3)) : Aff.t0 = CInt(titi(4)) : Aff.tinf = CInt(titi(5))
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi)
    '        aci.n_Forcer_Fl = CBool(titi(1)) : aci.n_Fl = CDbl(titi(2)) : Aff.RH_Fl = CInt(titi(3)) : Aff.t0_Fl = CInt(titi(4)) : Aff.tinf_Fl = CInt(titi(5))
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi)
    '        aci.angl_Arma = CInt(titi(1)) : Aff.Option_Mandrin = CInt(titi(2))
    '        'Matériaux
    '        toto = myStreamReader.ReadLine 'ligne de commentaire
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        bet.fck = CInt(titi(1)) : bet.dg = CDbl(titi(2)) : bet.Classe = CInt(titi(3)) : bet.Ciment = CInt(titi(4)) : bet.γcd = CDbl(titi(5)) : bet.γca = CDbl(titi(6))
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        aci.fyk = CInt(titi(1)) : aci.classe = CInt(titi(2)) : aci.γsd = CDbl(titi(3)) : aci.γsa = CDbl(titi(4))
    '        'Géométrie
    '        toto = myStreamReader.ReadLine 'ligne de commentaire
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        total = CInt(titi(1))
    '        For i = 0 To total - 1
    '            Dim dalle As New Plancher
    '            With dalle
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                .Nom = CStr(titi(1)) : .modele_calcul = CInt(titi(2)) : .Lx = CDbl(titi(3)) : .Ly = CDbl(titi(4)) : .H = CDbl(titi(5)) : .Isostatique = CBool(titi(6))
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                .LappH = CDbl(titi(1)) : .AppuiH = CInt(titi(2)) : .LappG = CDbl(titi(3)) : .AppuiG = CInt(titi(4)) : .LappB = CDbl(titi(5)) : .AppuiB = CInt(titi(6)) : .LappD = CDbl(titi(7)) : .AppuiD = CInt(titi(8))
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                .Prefa = CBool(titi(1))
    '                If .Prefa = True Then
    '                    .Prefa_h = CDbl(titi(2)) : .Prefa_L = CDbl(titi(3)) : .Prefa_esp = CDbl(titi(4)) : .Prefa_etai = CBool(titi(5)) : .Prefa_etai_L = CDbl(titi(6))
    '                    toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                    .Prefa_ReposLisse = CInt(titi(1)) : .Prefa_ReposG = CDbl(titi(2)) : .Prefa_ReposD = CDbl(titi(3)) : .Prefa_Reprise = CInt(titi(4)) : .Prefa_t = CInt(titi(5)) : .Prefa_fragile = CBool(titi(6))
    '                End If
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                j = CInt(titi(1))
    '                If j >= 1 Then
    '                    Dim trem As New Tremie
    '                    For j1 = 1 To j
    '                        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                        trem._xA = CDbl(titi(1)) : trem._yA = CDbl(titi(2)) : trem._Lx = CDbl(titi(3)) : trem._Ly = CDbl(titi(4)) : trem._Cloison = CBool(titi(5)) : trem._type_chevetre = CInt(titi(6))
    '                        ._Tremie.Add(trem)
    '                    Next
    '                    trem = Nothing
    '                End If
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                .Enrobage = CBool(titi(1)) : .enrInf = CDbl(titi(2)) : .enrLat = CDbl(titi(3)) : .enrSup = CDbl(titi(4))
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                .X0 = CBool(titi(1)) : .XC1 = CBool(titi(2)) : .XC2 = CBool(titi(3)) : .XC3 = CBool(titi(4)) : .XC4 = CBool(titi(5)) : .XD1 = CBool(titi(6)) : .XD2 = CBool(titi(7)) : .XD3 = CBool(titi(8))
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                .XS1 = CBool(titi(1)) : .XS2 = CBool(titi(2)) : .XS3 = CBool(titi(3)) : .XF1 = CBool(titi(4)) : .XF2 = CBool(titi(5)) : .XF3 = CBool(titi(6)) : .XF4 = CBool(titi(7)) : .XA1 = CBool(titi(8)) : .XA2 = CBool(titi(9)) : .XA3 = CBool(titi(10))
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                .Feu_REI = CInt(titi(1)) : .feu_EpCarrelage = CDbl(titi(2)) 'Feu
    '            End With
    '            PlanCont.Add(dalle)
    '            dalle = Nothing 'Pour vider l'objet
    '        Next
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        Aff.Duree = CInt(titi(1))    'durée d'utilisation du projet
    '        'Ferraillage
    '        toto = myStreamReader.ReadLine 'ligne de commentaire
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        For i = 0 To 9
    '            With aci
    '                .Ha_Lg.Item(i) = CBool(titi(i + 1))
    '            End With
    '        Next
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        For i = 0 To 9
    '            With aci
    '                .Ha_Tr.Item(i) = CBool(titi(i + 1))
    '            End With
    '        Next
    '        For i = 0 To PlanCont.Count - 1
    '            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '            With PlanCont.Item(i)
    '                .Type_Acier_Travée = CInt(titi(1)) ' Acier_Travée
    '                .Type_Acier_Appui_Droit = CInt(titi(2)) ' Acier_Travée 'identique pour tous
    '                .Type_Acier_Appui_Gauche = CInt(titi(3)) ' Acier_Travée 'identique pour tous
    '                .MaxnbLitTravee = CInt(titi(4)) 'nbLitMax
    '                .MaxnbLitAppui = CInt(titi(5)) 'nbLitMax1
    '                .Choix_Esp = CInt(titi(6)) 'Choix_Espacement
    '                .EspMax = CDbl(titi(7)) 'Emax
    '                .Espmin = CDbl(titi(8)) 'Emin
    '            End With
    '        Next
    '        For i = 0 To PlanCont.Count - 1
    '            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '            For j = 1 To 2
    '                Dim fer As New Ferraillage_HA
    '                fer.phiProj = CDbl(titi(j)) : PlanCont.Item(i).LitInf.Add(fer) : fer = Nothing
    '            Next
    '            For j = 3 To 4
    '                Dim fer As New Ferraillage_HA
    '                fer.phiProj = CDbl(titi(j)) : PlanCont.Item(i).LitSupG.Add(fer) : fer = Nothing
    '            Next
    '            For j = 5 To 6
    '                Dim fer As New Ferraillage_HA
    '                fer.phiProj = CDbl(titi(j)) : PlanCont.Item(i).LitSupD.Add(fer) : fer = Nothing
    '            Next
    '            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '            For j = 1 To 2
    '                Dim fer As New Ferraillage_HA
    '                fer.phiProj = CDbl(titi(j)) : PlanCont.Item(i).LitInf_Y.Add(fer) : fer = Nothing
    '            Next
    '            For j = 3 To 4
    '                Dim fer As New Ferraillage_HA
    '                fer.phiProj = CDbl(titi(j)) : PlanCont.Item(i).LitSupG_Y.Add(fer) : fer = Nothing
    '            Next
    '            For j = 5 To 6
    '                Dim fer As New Ferraillage_HA
    '                fer.phiProj = CDbl(titi(j)) : PlanCont.Item(i).LitSupD_Y.Add(fer) : fer = Nothing
    '            Next
    '        Next
    '        'For Each Ptre In PoutCont
    '        '    toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        '    Ptre.HATr.φProj = CDbl(titi(1)) : Aff.Etrier = CInt(titi(2)) ': Ptre.LitAppG.phiProj = CDbl(titi(2)) : Ptre.LitAppD.phiProj = CDbl(titi(3))
    '        'Next
    '        'toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        'Aff.Consol_Equerre = CBool(titi(1)) : Aff.Consol_a = CDbl(titi(2)) : Aff.Consol_ET = CDbl(titi(3)) 'ferraillage console
    '        'toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        'Aff.Suspente_repris = CDbl(titi(1)) : Aff.Suspente_nb = CInt(titi(2)) 'ferraillage acier de reprise 
    '        'charges
    '        toto = myStreamReader.ReadLine 'ligne de commentaire
    '        For i = 1 To PlanCont.Count
    '            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '            total = CInt(titi(1))
    '            For j = 1 To total
    '                Dim Chge As New Charge
    '                toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '                Chge.Num = CInt(titi(1)) : Chge.Nature = CInt(titi(2)) : Chge.schem = CInt(titi(3)) : Chge.suspendue = CInt(titi(4))
    '                Chge.P1 = CDbl(titi(5)) : Chge.P2 = CDbl(titi(6)) : Chge.a = CDbl(titi(7)) : Chge.b = CDbl(titi(8)) : Chge.c = CDbl(titi(9))
    '                Chge.d = CDbl(titi(10)) : Chge.taux = CDbl(titi(11))
    '                PlanCont.Item(i - 1).Chge.Add(Chge)
    '                Chge = Nothing
    '            Next
    '        Next
    '        'Combinaison
    '        toto = myStreamReader.ReadLine 'ligne de commentaire
    '        toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '        total = CInt(titi(1))
    '        For i = 0 To total - 1
    '            Dim Cmb As New Combinaison
    '            toto = myStreamReader.ReadLine : Call Lecture_chaine(toto, titi) 'ligne suivante
    '            Cmb.Num = CInt(titi(1)) : Cmb.Type = CInt(titi(2)) : Cmb.Trav = CInt(titi(3)) : Cmb.Charge = CInt(titi(4)) : Cmb.Pond = CDbl(titi(5))
    '            Combinaisons.Add(Cmb)
    '            Cmb = Nothing
    '        Next

    '    Catch exc As Exception
    '        MessageBox.Show("Le fichier ne peut être ouvert ou lu." +  Environment.NewLine + "SVP, verifiez que le nom du fichier est correct, et que vouz avez la permission de lire ou d'écrire " +
    '          "dans le répertoire indiqué." +  Environment.NewLine +  Environment.NewLine + "Erreur: " + exc.Message, "Sauvegarde des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    '        Donnee_OK = False
    '    Finally
    '        ' fermer le fichier si pas de création possible
    '        If Not myStreamReader Is Nothing Then myStreamReader.Close()
    '    End Try
    'End Sub


    'Public Sub Ecriture_Fichier_Données()
    '    Dim myStreamWriter As StreamWriter
    '    Dim dalle As New Plancher
    '    Dim j As Integer
    '    Try
    '        With Aff
    '            myStreamWriter = File.CreateText(.FileName)
    '            myStreamWriter.WriteLine("Plancher béton armé")
    '            'sauvegarde de la configuration de l'affaire
    '            myStreamWriter.WriteLine("sauvegarde de la configuration de l'affaire")
    '            myStreamWriter.WriteLine(.Redacteur)
    '            myStreamWriter.WriteLine(.Chantier)
    '            'répertoire
    '            myStreamWriter.WriteLine(.msgResult)
    '            myStreamWriter.WriteLine(.msgData)
    '            myStreamWriter.WriteLine(.i_result & " " & .i_data)
    '            '  myStreamWriter.WriteLine(Aff.Decalage_ET & " " & Aff.MinorationQ_ET & " " & Aff.St) '& " " & Aff.Lim_øET & " " & Aff.øLimET & " " & Aff.NbLit_Couture)
    '            myStreamWriter.WriteLine(Aff.Reprise_M0_1_porteur & " " & Aff.EncastPartiel_1_porteur & " " & Aff.Reprise_M0_2_porteur & " " & Aff.EncastPartiel_2_porteur)
    '            myStreamWriter.WriteLine(Aff.Ecretage_Moment & " " & Aff.Redistrib_limit & " " & Aff.δ & " " & Aff.Affich_Predal & " " & Aff.Reco_Fr)
    '            myStreamWriter.WriteLine(aci.n_Forcer_Cont & " " & aci.n_Cont & " " & Aff.RH & " " & Aff.t0 & " " & Aff.tinf)
    '            myStreamWriter.WriteLine(aci.n_Forcer_Fl & " " & aci.n_Fl & " " & Aff.RH_Fl & " " & Aff.t0_Fl & " " & Aff.tinf_Fl)
    '        End With
    '        myStreamWriter.WriteLine(aci.angl_Arma & " " & Aff.Option_Mandrin)
    '        myStreamWriter.WriteLine("Materiaux")
    '        myStreamWriter.WriteLine(bet.fck & " " & bet.dg & " " & bet.Classe & " " & bet.Ciment & " " & bet.γcd & " " & bet.γca)
    '        myStreamWriter.WriteLine(aci.fyk & " " & aci.classe & " " & aci.γsd & " " & aci.γsa) ' & " " & angle1 & " " & angle2 & " " & angle3)
    '        myStreamWriter.WriteLine("Géométrie - Classe d'exposition")
    '        myStreamWriter.WriteLine(PlanCont.Count)
    '        For Each dalle In PlanCont
    '            With dalle
    '                myStreamWriter.WriteLine(.Nom & " " & .modele_calcul & " " & .Lx & " " & .Ly & " " & .H & " " & .Isostatique)
    '                myStreamWriter.WriteLine(.LappH & " " & .AppuiH & " " & .LappG & " " & .AppuiG & " " & .LappB & " " & .AppuiB & " " & .LappD & " " & .AppuiD)
    '                myStreamWriter.WriteLine(.Prefa & " " & .Prefa_h & " " & .Prefa_L & " " & .Prefa_esp & " " & .Prefa_etai & " " & .Prefa_etai_L)
    '                If .Prefa = True Then myStreamWriter.WriteLine(.Prefa_ReposLisse & " " & .Prefa_ReposG & " " & .Prefa_ReposD & " " & .Prefa_Reprise & " " & .Prefa_t & " " & .Prefa_fragile)
    '                myStreamWriter.WriteLine(dalle._Tremie.Count)
    '                For j = 1 To dalle._Tremie.Count
    '                    myStreamWriter.WriteLine(._Tremie.Item(j - 1)._xA & " " & ._Tremie.Item(j - 1)._yA & " " & ._Tremie.Item(j - 1)._Lx & " " & ._Tremie.Item(j - 1)._Ly & " " & ._Tremie.Item(j - 1)._Cloison _
    '                                                & " " & ._Tremie.Item(j - 1)._type_chevetre)
    '                Next
    '                myStreamWriter.WriteLine(.Enrobage & " " & .enrInf & " " & .enrLat & " " & .enrSup)
    '                myStreamWriter.WriteLine(.X0 & " " & .XC1 & " " & .XC2 & " " & .XC3 & " " & .XC4 & " " & .XD1 & " " & .XD2 & " " & .XD3)
    '                myStreamWriter.WriteLine(.XS1 & " " & .XS2 & " " & .XS3 & " " & .XF1 & " " & .XF2 & " " & .XF3 & " " & .XF4 & " " & .XA1 & " " & .XA2 & " " & .XA3)
    '                myStreamWriter.WriteLine(.Feu_REI & " " & .feu_EpCarrelage)  'feu
    '            End With
    '        Next
    '        myStreamWriter.WriteLine(Aff.Duree)
    '        '§ concernant le Ferraillage
    '        myStreamWriter.WriteLine("Ferraillage")
    '        With aci
    '            myStreamWriter.WriteLine(.Ha_Lg.Item(0) & " " & .Ha_Lg.Item(1) & " " & .Ha_Lg.Item(2) & " " & .Ha_Lg.Item(3) & " " & .Ha_Lg.Item(4) & " " & .Ha_Lg.Item(5) & " " &
    '                .Ha_Lg.Item(6) & " " & .Ha_Lg.Item(7) & " " & .Ha_Lg.Item(8) & " " & .Ha_Lg.Item(9))
    '            myStreamWriter.WriteLine(.Ha_Tr.Item(0) & " " & .Ha_Tr.Item(1) & " " & .Ha_Tr.Item(2) & " " & .Ha_Tr.Item(3) & " " & .Ha_Tr.Item(4) & " " & .Ha_Tr.Item(5) & " " &
    '              .Ha_Tr.Item(6) & " " & .Ha_Tr.Item(7) & " " & .Ha_Tr.Item(8) & " " & .Ha_Tr.Item(9))
    '        End With
    '        For Each dalle In PlanCont
    '            With dalle
    '                myStreamWriter.WriteLine(.Type_Acier_Travée & " " & .Type_Acier_Appui_Droit & " " & .Type_Acier_Appui_Gauche & " " & .MaxnbLitTravee & " " &
    '                                         .MaxnbLitAppui & " " & .Choix_Esp & " " & .EspMax & " " & .Espmin)
    '            End With
    '        Next
    '        '  -->ferraillage imposée
    '        For Each dalle In PlanCont
    '            myStreamWriter.WriteLine(dalle.LitInf.Item(0).phiProj & " " & dalle.LitInf.Item(1).phiProj & " " &
    '                                    dalle.LitSupG.Item(0).phiProj & " " & dalle.LitSupG.Item(1).phiProj & " " &
    '                                      dalle.LitSupD.Item(0).phiProj & " " & dalle.LitSupD.Item(1).phiProj)
    '            myStreamWriter.WriteLine(dalle.LitInf_Y.Item(0).phiProj & " " & dalle.LitInf_Y.Item(1).phiProj & " " &
    '                                   dalle.LitSupG_Y.Item(0).phiProj & " " & dalle.LitSupG_Y.Item(1).phiProj & " " &
    '                                     dalle.LitSupD_Y.Item(0).phiProj & " " & dalle.LitSupD_Y.Item(1).phiProj)
    '        Next
    '        'For Each Ptre In PoutCont
    '        '    myStreamWriter.WriteLine(Ptre.HATr.φProj & " " & Aff.Etrier) ' & " " & Ptre.LitAppG.phiProj & " " & Ptre.LitAppD.φHA)
    '        'Next
    '        'myStreamWriter.WriteLine(Aff.Consol_Equerre & " " & Aff.Consol_a & " " & Aff.Consol_ET) 'ferraillage console
    '        'myStreamWriter.WriteLine(Aff.Suspente_repris & " " & Aff.Suspente_nb) 'ferraillage acier de reprise 
    '        'charges
    '        myStreamWriter.WriteLine("Charges")
    '        Dim i, i1 As Integer
    '        For i = 1 To PlanCont.Count
    '            With PlanCont.Item(i - 1).Chge
    '                myStreamWriter.WriteLine(.Count)
    '                For i1 = 1 To .Count
    '                    myStreamWriter.WriteLine(.Item(i1 - 1).Num & " " & .Item(i1 - 1).Nature & " " & .Item(i1 - 1).schem & " " & .Item(i1 - 1).suspendue _
    '                        & " " & .Item(i1 - 1).P1 & " " & .Item(i1 - 1).P2 & " " & .Item(i1 - 1).a & " " & .Item(i1 - 1).b & " " & .Item(i1 - 1).c & " " & .Item(i1 - 1).d & " " & .Item(i1 - 1).taux)
    '                Next
    '            End With
    '        Next
    '        'Combinaison
    '        myStreamWriter.WriteLine("Combinaison")
    '        Dim Cmb As New Combinaison
    '        myStreamWriter.WriteLine(Combinaisons.Count)
    '        For Each Cmb In Combinaisons
    '            myStreamWriter.WriteLine(Cmb.Num & " " & Cmb.Type & " " & Cmb.Trav & " " & Cmb.Charge & " " & Cmb.Pond)
    '        Next
    '        ' Flush the stream to ensure everything is flushed
    '        myStreamWriter.Flush()
    '    Catch exc As Exception
    '        MessageBox.Show("Le fichier ne peut être ouvert ou lu." + vbCrLf + "SVP, verifiez que le nom du fichier est correct, " + "et que vouz avez la permission de lire ou d'écrire " +
    '          "dans le répertoire indiqué." + vbCrLf + vbCrLf + "Erreur: " + exc.Message, "Sauvegarde des données", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    '    Finally
    '        ' Close the object if it has been created.
    '        If Not myStreamWriter Is Nothing Then myStreamWriter.Close()
    '    End Try
    'End Sub
#End Region
End Module
