﻿Imports System.IO
Public Class frmConfig

    Private Sub frmConfig_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Try
            Dim KEY As Microsoft.Win32.RegistryKey = My.Computer.Registry.ClassesRoot.OpenSubKey("Word.Application")
            If KEY Is Nothing Then RbtnWord.Visible = False
            'appel au module Affichage
            Call Affichage()
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier de configuration: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub BtnSauvegarde_Click(sender As System.Object, e As System.EventArgs) Handles BtnSauvegarde.Click
        Dim Verif As Boolean = True
        Dim filename As String = String.Empty

        Try
            filename = My.Computer.FileSystem.CurrentDirectory.ToString & "\cfg_PlancherBA_EC2.ini"
            Call Lecture(Verif)
            If Verif = False Then Exit Sub
            Call Ecriture_fichier_Cfg_Ini(filename)
            Me.Dispose()
            Me.Close() 'quitte le formulaire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub BtnQuit_Click(sender As Object, e As EventArgs) Handles BtnQuit.Click
        Me.Dispose()
        Me.Close() 'quitte le formulaire
    End Sub
    Private Sub BtnReinit_Click(sender As System.Object, e As System.EventArgs) Handles BtnReinit.Click
        Dim reponse As Integer
        reponse = MessageBox.Show("Attention, vous allez modifier vos préférences !!!!" & Environment.NewLine & "Voulez-vous continuer?", "Plancher BA EC2", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1)
        If reponse = 6 Then
            Call Variables_generales() 'appel au modules contenant les variables par defaut, écrites en dur dans le logiciel, se trouve dans le module General.vb
            Call Affichage()
        End If

    End Sub
    Private Sub Lecture(ByRef Verif As Boolean)
        Try
            'onglet général
            If RbtnDatadefaut.Checked = True Then
                Aff.msgData = Directory.GetCurrentDirectory.ToString() & "\Data" : Aff.i_data = 1
            Else
                If LblData.Text = String.Empty Then
                    MessageBox.Show("Erreur lors de la lecture du champ de texte concernant le répertoire des données.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Verif = False
                ElseIf LblData.Text = Directory.GetCurrentDirectory.ToString() & "\Data" Then
                    Aff.i_data = 1
                Else
                    Aff.msgData = LblData.Text : Aff.i_data = 2
                End If
            End If
            If RbtnResultDefaut.Checked = True Then
                Aff.msgResult = Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul" : Aff.i_result = 1
            Else
                If LblResult.Text = String.Empty Then
                    MessageBox.Show("Erreur lors de la lecture du champ de texte concernant le répertoire des données.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Verif = False
                ElseIf LblResult.Text = Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul" Then
                    Aff.i_result = 1
                Else
                    Aff.msgResult = LblResult.Text : Aff.i_result = 2
                End If
            End If
            If TxtRedacteur.Text = String.Empty Then
                Aff.Redacteur = "A_definir"
            Else
                Aff.Redacteur = TxtRedacteur.Text
            End If
            If TxtChantier.Text = String.Empty Then
                Aff.Chantier = "A_definir"
            Else
                Aff.Chantier = TxtChantier.Text
            End If
            'onglet Codes de calcul
            If ChkbReco_Fr.Checked Then Aff.Reco_Fr = True Else Aff.Reco_Fr = False
            'Onglet Editeur
            If RbtnEditeurInterne.Checked = True Then Aff.Editeur = 1
            If RbtnWordPad.Checked = True Then Aff.Editeur = 2
            If RbtnWord.Checked = True Then Aff.Editeur = 3
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du formulaire, veuillez le corriger" + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Verif = False
        End Try
    End Sub
    Private Sub Affichage()
        Dim msg As String
        'Onglet général
        TxtChantier.Text = Aff.Chantier
        TxtRedacteur.Text = Aff.Redacteur
        If Aff.i_result = 1 Then RbtnResultDefaut.Checked = True Else RbtnResultPerso.Checked = True
        If Aff.i_data = 1 Then RbtnDatadefaut.Checked = True Else RbtndataPerso.Checked = True
        LblData.Text = Aff.msgData
        lblResult.Text = Aff.msgResult

        'Onglet codes
        If Aff.Reco_Fr = True Then ChkbReco_Fr.Checked = True Else ChkbReco_Fr.Checked = False
        'Onglet Editeur
        Select Case Aff.Editeur
            Case 1
                RbtnEditeurInterne.Checked = True
            Case 2 'WordPad
                RbtnWordPad.Checked = True
            Case 3 'Word
                RbtnWord.Checked = True
        End Select
    End Sub

    Public Sub Ecriture_fichier_Cfg_Ini(ByVal filename As String)
        Dim myStreamWriter As StreamWriter = Nothing
        Try
            ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter = File.CreateText(filename)
            myStreamWriter.WriteLine("Fichier des valeurs par défauts Plancher BA EC2")
            myStreamWriter.WriteLine("Onglet Général")
            myStreamWriter.WriteLine(Aff.Redacteur)
            myStreamWriter.WriteLine(Aff.Chantier)
            'répertoire
            myStreamWriter.WriteLine(Aff.msgResult)
            myStreamWriter.WriteLine(Aff.msgData)
            myStreamWriter.WriteLine(Aff.i_result & " " & Aff.i_data)
            myStreamWriter.WriteLine("Onglet codes de calcul")
            myStreamWriter.WriteLine(Aff.Reco_Fr)
            myStreamWriter.WriteLine("Onglet Editeur")
            myStreamWriter.WriteLine(Aff.Editeur)
            myStreamWriter.Flush() ' Obligatoire - Vide le tampon pour être sûr que tout soit écrit dans le fichier

        Catch exc As Exception
            Dim msg As String
            msg = "Le fichier n'a pas pu être ouvert ou écrit" + Environment.NewLine + "Vérifiez que le nom du fichier et son chemin d'accès soient exact" +
                 Environment.NewLine + Environment.NewLine + "Exception: " + exc.Message
            MessageBox.Show(msg, "Module écriture fichier configuration", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then myStreamWriter.Close()
        End Try
    End Sub

    Private Sub BtnResultModif_Click(sender As System.Object, e As System.EventArgs) Handles BtnResultModif.Click
        Try
            With FolderBrowserDialog1
                'En principe, après avoir créé un FolderBrowserDialog, vous définissez RootFolder à l'emplacement à partir duquel commencer la navigation. 
                'Vous pouvez choisir un emplacement dans la liste des dossiers système spéciaux, notamment Program Files, Programmes, System ou Démarrage, qui contiennent des informations communes.  
                .RootFolder = Environment.SpecialFolder.Desktop
                ' Si vous le voulez, vous pouvez aussi définir la propriété Description afin de fournir des instructions supplémentaires à l'utilisateur.
                .Description = "Selectionnez le répertoire pour les notes de calcul"
                ' Vous pouvez utiliser la propriété ShowNewFolderButton pour déterminer si l'utilisateur est en mesure de créer des dossiers à l'aide du bouton Nouveau dossier.
                .ShowNewFolderButton = True
                If .ShowDialog = DialogResult.OK Then ' Windows.Forms.
                    If .SelectedPath = String.Empty Then
                        MessageBox.Show("Aucune sélection", "Modification de répertoire ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Else
                        LblResult.Text = .SelectedPath
                    End If
                End If

            End With
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Modification de répertoire ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    Private Sub RbtnResultDefaut_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnResultDefaut.CheckedChanged
        If RbtnResultDefaut.Checked = True Then BtnResultModif.Enabled = False : LblResult.Text = Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul"
    End Sub

    Private Sub RbtnResultPerso_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnResultPerso.CheckedChanged
        If RbtnResultPerso.Checked = True Then BtnResultModif.Enabled = True : BtnResultModif.Focus()
    End Sub

    Private Sub RbtnDatadefaut_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnDatadefaut.CheckedChanged
        If RbtnDatadefaut.Checked = True Then BtnDataModif.Enabled = False : LblData.Text = Directory.GetCurrentDirectory.ToString() & "\Data"
    End Sub

    Private Sub RbtndataPerso_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtndataPerso.CheckedChanged
        If RbtndataPerso.Checked = True Then BtnDataModif.Enabled = True : BtnDataModif.Focus()
    End Sub

    Private Sub BtnDataModif_Click(sender As System.Object, e As System.EventArgs) Handles BtnDataModif.Click
        Try
            With FolderBrowserDialog1
                .RootFolder = Environment.SpecialFolder.Desktop
                .Description = "Selectionnez le répertoire pour les fichiers de données"
                .ShowNewFolderButton = True
                If .ShowDialog = DialogResult.OK Then
                    If .SelectedPath = String.Empty Then
                        MessageBox.Show("Aucune sélection", "Modification de répertoire ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    Else
                        LblData.Text = .SelectedPath
                    End If
                End If

            End With
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Modification de répertoire ...", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub


    Private Sub BtnOK_Click(sender As Object, e As EventArgs) Handles BtnOK.Click
        Dim Verif As Boolean = True
        Try
            Call Lecture(Verif)
            If Verif = False Then Exit Sub
            Me.Dispose()
            Me.Close() 'quitte le formulaire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du formulaire:  " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub BtnHlpRecoFr_Click(sender As Object, e As EventArgs) Handles BtnHlpRecoFr.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 28
        frm1.Show()
    End Sub
    Private Sub BtnHlpCPT_Click(sender As Object, e As EventArgs) Handles BtnHlpCPT.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        Aff.FichierAide = 29
        frm1.Show()
    End Sub

    Private Sub Label3_Click(sender As Object, e As EventArgs) Handles lblResult.Click

    End Sub
End Class