﻿Imports System.Math
Imports System.Drawing.Drawing2D


Module Affichage_Coffrage_Ferraillage
    ''' <summary> Affichage des plans de coffrage ferraillage sur support variès: écran, image ou imprimante </summary>
    ''' <param name="g">handle graphique </param>
    ''' <param name="Niveau"> 1 = Ferraillage inférieur/ 2 = Ferraillage supérieur/ 3 = Calepinage prédalles/ 5 = Ferraillage inférieur complémentaires prédalles</param>
    ''' <param name="support">type de support: 1=écran / 2 =image / 3 = imprimante</param>
    '''<param name="largeur">Largeur du support</param>
    '''<param name="Hauteur">Hauteur du support</param>
    Public Sub Affichage_Dalle_Pleine(ByVal g As Graphics, ByVal Support As Integer, ByVal Niveau As Integer, ByVal largeur As Integer, ByVal Hauteur As Integer)  'affichage des moments
        Dim hauteur_restante As Double ' 
        Dim i As Integer ', i_tot, j
        Dim X, Y, X1, Y1, X2, Y2, X3, Y3, X4, Y4, oriX, oriY As Single
        Dim myPen As New Pen(Color.Black)
        Dim myPen3 As New Pen(Color.Black)
        Dim myPen2 As New Pen(Color.Black)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim Nomenclature As Integer = 0

        'détermination  origine
        Dim L_tot, H_tot, red As Double
        L_tot = PlanCont(0).LappG
        For Each dalle As Plancher In PlanCont
            L_tot = L_tot + dalle.Lx + dalle.LappD
            If H_tot < dalle.Ly Then H_tot = dalle.Ly
        Next
        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                'détermination des coefficient de réduction: 
                Nomenclature = 490 'somme de toutes les colonnes L_col1 = 20 : L_col2 = 250 : L_col3 = 100 : L_col4 = 60 : L_col5 = 40
                'oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 20 '200 pixels
                red = (largeur - Nomenclature) / L_tot
                If H_tot * red > 0.8 * Hauteur Then red = (0.8 * Hauteur) / H_tot
                oriX = CSng(0.5 * (largeur - Nomenclature) - red * L_tot / 2)
                hauteur_restante = Hauteur - red * H_tot
                oriY = CSng(hauteur_restante / 2)

                myPen = New Pen(Color.Black, 1)
                myPen3 = New Pen(Color.Black, 4)
                myPen2 = New Pen(Color.Black, 2)
            Case 2 'image 1350 x 900 
                oriX = 15 : oriY = 15
                Nomenclature = 320
                myFont = New Font("Times New Roman", 8, FontStyle.Regular)
                red = (largeur - Nomenclature - oriX) / L_tot
                If H_tot * red > 0.8 * Hauteur Then red = (0.8 * Hauteur) / H_tot
                oriX = CSng(0.5 * (largeur - Nomenclature) - red * L_tot / 2)
                hauteur_restante = Hauteur - red * H_tot
                oriY = CSng(hauteur_restante / 2)
                myPen = New Pen(Color.Black, 1)
                myPen3 = New Pen(Color.Black, 4)
                myPen2 = New Pen(Color.Black, 2)
            Case 3 'imprimante - Format A4
                ' oriX = 15 : oriY = 15 - Sans intéret car une imprimante a toujours des marges
                Nomenclature = 113
                myFont = New Font("Times New Roman", 8, FontStyle.Regular)
                red = (largeur - Nomenclature) / L_tot
                If H_tot * red > 0.8 * Hauteur Then red = (0.8 * Hauteur) / H_tot
                oriX = CSng(0.5 * (largeur - Nomenclature) - red * L_tot / 2)
                hauteur_restante = Hauteur - red * H_tot
                oriY = CSng(hauteur_restante / 2)
                myPen = New Pen(Color.Black, 0.1)
                myPen3 = New Pen(Color.Black, 0.6)
                myPen2 = New Pen(Color.Black, 0.3)
        End Select
        Dim GrisBeton As Color = Color.FromArgb(200, 200, 160)
        Dim HatchBeton As New HatchBrush(HatchStyle.BackwardDiagonal, GrisBeton, Color.White)
        Dim HatchBrique As New HatchBrush(HatchStyle.HorizontalBrick, Color.DarkRed, Color.White)

        'murs
        'exterieurs horizontal
        X = CSng(oriX) : Y = CSng(oriY)
        X1 = CSng(oriX + red * (PlanCont(0).LappG + PlanCont(0).Lx + PlanCont(0).LappD))
        Y1 = CSng(oriY + red * (PlanCont(0).LappH + PlanCont(0).Ly + PlanCont(0).LappB))
        Select Case PlanCont(0).AppuiH
            Case 1 'beton
                g.FillRectangle(HatchBeton, CSng(X + red * PlanCont(0).LappG), Y, CSng(red * (PlanCont(0).Lx + PlanCont(0).LappD)), CSng(red * (PlanCont(0).LappH))) 'hachurage appui haut
            Case 2 'Maçonnerie
                g.FillRectangle(HatchBrique, CSng(X + red * PlanCont(0).LappG), Y, CSng(red * (PlanCont(0).Lx + PlanCont(0).LappD)), CSng(red * (PlanCont(0).LappH))) 'hachurage appui haut
        End Select
        Select Case PlanCont(0).AppuiB
            Case 1 'beton
                g.FillRectangle(HatchBeton, CSng(X + red * PlanCont(0).LappG), CSng(Y1 - red * PlanCont(0).LappB), CSng(red * (PlanCont(0).Lx + PlanCont(0).LappD)), CSng(red * (PlanCont(0).LappB))) 'hachurage appui bas
            Case 2 'Maçonnerie
                g.FillRectangle(HatchBrique, CSng(X + red * PlanCont(0).LappG), CSng(Y1 - red * PlanCont(0).LappB), CSng(red * (PlanCont(0).Lx + PlanCont(0).LappD)), CSng(red * (PlanCont(0).LappB))) 'hachurage appui bas
        End Select

        Select Case PlanCont(0).AppuiG
            Case 1 'beton
                g.FillRectangle(HatchBeton, X, Y, CSng(red * (PlanCont(0).LappG)), CSng(red * (PlanCont(0).LappH + PlanCont(0).Ly + PlanCont(0).LappB)))'hachurage appui gauche
            Case 2 'Maçonnerie
                g.FillRectangle(HatchBrique, X, Y, CSng(red * (PlanCont(0).LappG)), CSng(red * (PlanCont(0).LappH + PlanCont(0).Ly + PlanCont(0).LappB))) 'hachurage appui gauche
        End Select
        g.DrawLine(myPen, oriX, oriY, oriX, Y1) '1iere ligne verticale
        g.DrawLine(myPen, X, Y1, X1, Y1)
        g.DrawLine(myPen, X, Y, X1, Y)
        For i = 1 To PlanCont.Count - 1
            X = CSng(X1 + red * (PlanCont(i).Lx + PlanCont(i).LappD))
            Select Case PlanCont(i).AppuiH
                Case 1 'beton
                    g.FillRectangle(HatchBeton, X1, Y, CSng(red * (PlanCont(i).Lx + PlanCont(i).LappD)), CSng(red * (PlanCont(i).LappH))) 'hachurage appui haut
                Case 2 'Maçonnerie
                    g.FillRectangle(HatchBrique, X1, Y, CSng(red * (PlanCont(i).Lx + PlanCont(i).LappD)), CSng(red * (PlanCont(i).LappH))) 'hachurage appui haut
            End Select
            Select Case PlanCont(i).AppuiB
                Case 1 'beton
                    g.FillRectangle(HatchBeton, X1, CSng(Y1 - red * PlanCont(i).LappB), CSng(red * (PlanCont(i).Lx + PlanCont(i).LappD)), CSng(red * PlanCont(i).LappB)) 'hachurage appui bas
                Case 2 'Maçonnerie
                    g.FillRectangle(HatchBrique, X1, CSng(Y1 - red * PlanCont(i).LappB), CSng(red * (PlanCont(i).Lx + PlanCont(i).LappD)), CSng(red * PlanCont(i).LappB))  'hachurage appui bas
            End Select
            Select Case PlanCont(i).AppuiD
                Case 1 'beton
                    g.FillRectangle(HatchBeton, CSng(X1 - red * PlanCont(PlanCont.Count - 1).LappD), Y, CSng(red * PlanCont(PlanCont.Count - 1).LappD), CSng(red * (PlanCont(PlanCont.Count - 1).LappH + PlanCont(PlanCont.Count - 1).Ly + PlanCont(PlanCont.Count - 1).LappB))) 'hachurage appui droit
                Case 2 'Maçonnerie
                    g.FillRectangle(HatchBrique, CSng(X1 - red * PlanCont(PlanCont.Count - 1).LappD), Y, CSng(red * PlanCont(PlanCont.Count - 1).LappD), CSng(red * (PlanCont(PlanCont.Count - 1).LappH + PlanCont(PlanCont.Count - 1).Ly + PlanCont(PlanCont.Count - 1).LappB))) 'hachurage appui droit

            End Select
            g.DrawLine(myPen, X1, Y, X, Y) : g.DrawLine(myPen, X1, Y1, X, Y1)
            X1 = X
        Next
        Select Case PlanCont(PlanCont.Count - 1).AppuiD
            Case 1 'beton
                g.FillRectangle(HatchBeton, CSng(X1 - red * PlanCont(PlanCont.Count - 1).LappD), Y, CSng(red * PlanCont(PlanCont.Count - 1).LappD), CSng(red * (PlanCont(PlanCont.Count - 1).LappH + PlanCont(PlanCont.Count - 1).Ly + PlanCont(PlanCont.Count - 1).LappB))) 'hachurage appui droit
            Case 2 'Maçonnerie
                g.FillRectangle(HatchBrique, CSng(X1 - red * PlanCont(PlanCont.Count - 1).LappD), Y, CSng(red * PlanCont(PlanCont.Count - 1).LappD), CSng(red * (PlanCont(PlanCont.Count - 1).LappH + PlanCont(PlanCont.Count - 1).Ly + PlanCont(PlanCont.Count - 1).LappB))) 'hachurage appui droit
        End Select
        g.DrawLine(myPen, X1, oriY, X1, Y1) 'dernière ligne verticale
        '
        'interieurs horizontal et vertical
        X = CSng(oriX + red * PlanCont(0).LappG) : Y = CSng(oriY + red * PlanCont(0).LappH)
        X1 = CSng(oriX + red * (PlanCont(0).LappG + PlanCont(0).Lx))
        Y1 = CSng(oriY + red * (PlanCont(0).LappH + PlanCont(0).Ly))
        g.DrawLine(myPen, X, Y, X1, Y) : g.DrawLine(myPen, X, Y1, X1, Y1)
        g.DrawLine(myPen, X, Y, X, Y1) : g.DrawLine(myPen, X1, Y, X1, Y1)
        For i = 1 To PlanCont.Count - 1
            X1 = CSng(X1 + red * (PlanCont(i - 1).LappD))
            X = CSng(X1 + red * PlanCont(i).Lx)
            g.DrawLine(myPen, X1, Y, X, Y) : g.DrawLine(myPen, X1, Y1, X, Y1)
            g.DrawLine(myPen, X1, Y, X1, Y1) : g.DrawLine(myPen, X, Y, X, Y1)
            X1 = X
        Next

        If Niveau = 1 Or Niveau = 3 Or Niveau = 5 Then
            'Affichage trémie
            X = CSng(oriX + red * PlanCont(0).LappG)
            For Each dalle As Plancher In PlanCont
                With dalle
                    Y = CSng(oriY + red * .LappH)
                    For i = 1 To ._Tremie.Count
                        'rectangle trémie
                        X1 = CSng(X + red * ._Tremie.Item(i - 1)._xA) : Y1 = CSng(Y + red * ._Tremie.Item(i - 1)._yA)
                        X2 = CSng(X1 + red * ._Tremie.Item(i - 1)._Lx) : Y2 = CSng(Y1)
                        X3 = X2 : Y3 = CSng(Y1 + red * ._Tremie.Item(i - 1)._Ly)
                        X4 = CSng(X1) : Y4 = Y3
                        Dim P1 As New Point(CInt(X1), CInt(Y1))
                        Dim P2 As New Point(CInt(X2), CInt(Y2))
                        Dim P3 As New Point(CInt(X3), CInt(Y3))
                        Dim P4 As New Point(CInt(X4), CInt(Y4))
                        Dim curvePoints As Point() = {P1, P2, P3, P4, P1}
                        g.DrawPolygon(myPen, curvePoints)
                        'Marquage trémie
                        Dim gPath As New GraphicsPath
                        X2 = CSng(X1 + red * ._Tremie.Item(i - 1)._Lx / 3) : Y2 = CSng(Y1 + red * ._Tremie.Item(i - 1)._Ly / 3)
                        P3 = New Point(CInt(X2), CInt(Y2))
                        curvePoints = {P1, P2, P3, P4, P1}
                        gPath.AddPolygon(curvePoints)
                        g.FillPath(myBrush, gPath)   ' Fill graphics path to screen.
                    Next
                    X = CSng(X + red * .Lx)
                End With

            Next
        End If
        Select Case Niveau
            Case 1 'Ferraillage inférieur
                If PlanCont.Item(0).TS_trav.Count >= 1 Then
                    Call Ferraillages_inferieurs_TS(g, myPen, myPen2, myPen3, myBrush, myFont, red, oriX, oriY, Support)
                Else
                    Call Ferraillages_inferieurs(g, myPen, myPen2, myPen3, myBrush, myFont, red, oriX, oriY, Support)
                End If
                Call Affichage_Nomenclature_Acier(g, Support, Niveau, largeur, Hauteur)  'Affichage Nomenclature Armatures
            Case 2 ' Ferraillage supérieur
                Call Ferraillages_superieurs(g, myPen, myPen2, myPen3, myBrush, myFont, red, oriX, oriY, Support)
                Call Affichage_Nomenclature_Acier(g, Support, Niveau, largeur, Hauteur)
            Case 3 ' Calepinage prédalles
                Call Calepinage_Predalles(g, myPen, myPen3, myBrush, myFont, red, oriX, oriY, Support, largeur)
            Case 5 'Ferraillage inférieur complémentaires prédalles
                Call Ferraillages_inferieurs_Complementaires_Predalles(g, myPen, myPen3, myBrush, myFont, red, oriX, oriY)
                'Affichage Nomenclature Armatures
                Call Affichage_Nomenclature_Acier_inf_Complementaires_Predalles(g, Support, Niveau, largeur, Hauteur)
        End Select


    End Sub
    Private Sub Ferraillages_inferieurs(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen2 As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double,
                                     ByVal OriX As Single, ByVal OriY As Single, ByVal Support As Integer)
        'Ferraillage inférieurs
        Dim i, i1, i_tot As Integer 'j,
        Dim X, Y, X1, Y1, X2, x3, y3, fl, r, d1 As Single '
        Dim msg As String
        Dim w As SizeF
        Dim Rmax As Single

        'armatures principales
        'Affichage Titre
        msg = "PLAN DE FERRAILLAGE:  Armatures inférieures"
        myFont = New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                X = OriX : Y = CSng(OriY - w.Height - 20) : fl = 8
            Case 2 'image
                X = OriX : Y = 20 : fl = 6
            Case 3 'imprimante
                X = OriX : Y = 5 : fl = 2
        End Select
        g.DrawString(msg, myFont, myBrush, X, Y)
        'Affichage Plan
        myFont = New Font("Times New Roman", 9, FontStyle.Regular)
        i_tot = 0 : X2 = OriX
        For Each dalle As Plancher In PlanCont
            'armatures principales
            For i1 = 1 To dalle.LitInf.Count
                r = PlanCont.IndexOf(dalle) Mod 2
                If r > 0.3 Then
                    'i = nombre impair
                    Select Case Support
                        Case 1 'écran
                            d1 = -30
                        Case 2 'image
                            d1 = -5
                        Case 3 'imprimante
                            d1 = -2
                    End Select
                Else
                    Select Case Support
                        Case 1 'écran
                            d1 = 30
                        Case 2 'image
                            d1 = 5
                        Case 3 'imprimante
                            d1 = 2
                    End Select
                End If
                With dalle.LitInf.Item(i1 - 1)
                    'n° de l'acier
                    i_tot += 1 : msg = i_tot.ToString("#") : w = g.MeasureString(msg, myFont)
                    If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                    'dessin armature et ligne de répartition
                    Select Case i1
                        Case 1 '1ier lit
                            X = CSng(X2 + red * (dalle.LappG - .L13acier)) : X1 = CSng(X2 + red * (dalle.LappG + dalle.Lx + .L23acier))
                            Y = CSng(OriY + red * (dalle.LappH + dalle.Ly / 2) + d1)
                            x3 = 0
                        Case 2 '2ième lit
                            If .L13acier > 0.01 Then X = CSng(X2 + red * (dalle.LappG - .L13acier)) Else X = CSng(X2 + red * (dalle.LappG - .X1acier))
                            If .L23acier > 0.01 Then X1 = CSng(X2 + red * (dalle.LappG + dalle.Lx + .L23acier)) Else X = CSng(X2 + red * (dalle.LappG + .X2acier))
                            Y = CSng(OriY + red * (dalle.LappH + dalle.Ly / 2) - 2 * CSng(Rmax * 1.5) + d1)
                            x3 = CSng(dalle.Lx / 6) ' car 1/3 + 1/6 = 1/2, la ligne sera au milieu de la dalle
                    End Select
                    g.DrawLine(mypen3, X, Y, X1, Y) 'armature
                    X = CSng(X2 + red * (dalle.LappG + dalle.Lx / 3 + x3))
                    Y = CSng(OriY + red * (dalle.LappH + .S1)) : Y1 = CSng(OriY + red * (dalle.LappH + dalle.Ly - dalle.LitInf(0).S2))
                    g.DrawLine(mypen, X, Y, X, Y1) 'ligne de répartition
                    'flèche haut
                    g.DrawLine(mypen, X, Y, X - fl, Y + fl) : g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X - fl, Y, X + fl, Y)
                    'valeur du retrait par rapport à l'appui haut - ne s'affiche que pour l'acier 1, identique pour l'acier 2
                    If i1 = 1 Then msg = (.S1 * 100).ToString("#0") : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y)
                    'flèche basse
                    g.DrawLine(mypen, X, Y1, X - fl, Y1 - fl) : g.DrawLine(mypen, X, Y1, X + fl, Y1 - fl) : g.DrawLine(mypen, X - fl, Y1, X + fl, Y1)
                    'valeur du retrait par rapport à l'appui haut - ne s'affiche que pour l'acier 1, identique pour l'acier 2
                    If i1 = 1 Then msg = (.S2 * 100).ToString("#0") : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y1 - w.Height)
                    'rond indicatif
                    X = CSng(X2 + red * (dalle.LappG + dalle.Lx / 3 + x3))
                    Y = CSng(OriY + red * (dalle.LappH + dalle.Ly / 2) + d1)
                    msg = i_tot.ToString("#") : w = g.MeasureString(msg, myFont) '2ieme passage car besoin du Rmax en début de procédure
                    ' msg = "9" : w = g.MeasureString(msg, myFont)
                    If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                    g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                    g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                    g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                End With
            Next

            'armatures secondaires
            For i1 = 1 To dalle.LitInf_Y.Count
                With dalle.LitInf_Y.Item(i1 - 1)
                    'n° de l'acier
                    i_tot += 1 : msg = i_tot.ToString("#") : w = g.MeasureString(msg, myFont)
                    If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                    'dessin armature
                    Select Case i1
                        Case 1 '1ier lit
                            x3 = 0 : y3 = 0
                            Y = CSng(OriY + red * (dalle.LappH - .L13acier)) : Y1 = CSng(OriY + red * (dalle.LappH + .Lacier2))
                        Case 2 '2ième lit
                            x3 = CSng(Rmax * 0.75) : y3 = CSng(Rmax * 0.75)
                            Y = CSng(OriY + red * (dalle.LappH + dalle.Ly - .Lacier2)) : Y1 = CSng(OriY + red * (dalle.LappH + dalle.Ly + .L23acier))
                    End Select
                    X = CSng(X2 + red * (dalle.LappG + 2 * dalle.Lx / 3) - x3)
                    g.DrawLine(mypen2, X, Y, X, Y1) 'armature
                    X = CSng(X2 + red * (dalle.LappG + .S1)) : X1 = CSng(X2 + red * (dalle.LappG + dalle.Lx - .S2))
                    If dalle.LitInf_Y.Count = 2 Then
                        If i1 = 1 Then Y = CSng(OriY + red * (dalle.LappH + dalle.Ly / 3)) Else Y = CSng(OriY + red * (dalle.LappH + dalle.Ly - .Lacier2) - y3)
                    Else
                        Y = CSng(OriY + red * (dalle.LappH + 2 * dalle.Ly / 3)) ' + y3)
                    End If
                    g.DrawLine(mypen, X, Y, X1, Y) 'ligne de répartition
                    'flèche gauche
                    g.DrawLine(mypen, X, Y, X + fl, Y - fl) : g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X, Y - fl, X, Y + fl)
                    If i1 = 1 Or dalle.LitInf_Y.Count = 2 Then msg = (.S1 * 100).ToString("#0") : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y)
                    'flèche droite
                    g.DrawLine(mypen, X1, Y, X1 - fl, Y - fl) : g.DrawLine(mypen, X1, Y, X1 - fl, Y + fl) : g.DrawLine(mypen, X1, Y - fl, X1, Y + fl)
                    If i1 = 1 Or dalle.LitInf_Y.Count = 2 Then msg = (.S2 * 100).ToString("#0") : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, X1 - w.Width - w.Width / 2, Y)
                    'rond indicatif
                    X = CSng(X2 + red * (dalle.LappG + 2 * dalle.Lx / 3) - x3)
                    If dalle.LitInf_Y.Count = 2 Then
                        If i1 = 1 Then Y = CSng(OriY + red * (dalle.LappH + dalle.Ly / 3)) Else Y = CSng(OriY + red * (dalle.LappH + dalle.Ly - .Lacier2) - y3)
                    Else
                        Y = CSng(OriY + red * (dalle.LappH + 2 * dalle.Ly / 3)) ' + y3)
                    End If
                    msg = i_tot.ToString("#") : w = g.MeasureString(msg, myFont) '2ieme passage car besoin du Rmax en début de procédure
                    If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                    g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                    g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                    g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                End With
            Next
            X2 = CSng(X2 + red * (dalle.LappG + PlanCont(i).Lx))
        Next
    End Sub
    Private Sub Ferraillages_inferieurs_TS(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen2 As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double,
                                            ByVal OriX As Single, ByVal OriY As Single, ByVal Support As Integer)
        'Ferraillage inférieurs
        Dim i, i1, i_tot, j, k As Integer ', reste
        Dim X, Y, X0, X1, Y1, X2, Y2, X3, X4 As Single ' Y3,
        Dim msg As String = String.Empty
        Dim Reste As Double
        Dim w As SizeF
        Dim Rmax As Single

        msg = "PLAN DE FERRAILLAGE:  Armatures inférieures"
        myFont = New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                X = OriX : Y = CSng(OriY - w.Height - 20) : X3 = 12 ': Y3 = 30
            Case 2 'image
                X = OriX : Y = CSng(OriY - w.Height - 20) : X3 = 3 ': Y3 = 10
            Case 3 'imprimante
                X = OriX : Y = 5 : X3 = 3 ' : Y3 = 10
        End Select

        g.DrawString(msg, myFont, myBrush, X, Y)
        myFont = New Font("Times New Roman", 9, FontStyle.Regular)
        X0 = OriX 'initialisation
        For i = 1 To PlanCont.Count
            i_tot = 0
            With PlanCont.Item(i - 1)
                For i1 = 1 To .TS_trav.Count
                    If i1 = 2 Then X4 = CSng(red * .Lx / 4) Else X4 = 0
                    '-->le TS complet
                    j = 0 : Y2 = CSng(OriY + red * (.LappH - .TS_trav.Item(i1 - 1).L33acier)) : Y1 = Y2
                    i_tot = i_tot + 1 'n° de TS
                    Do
                        Reste = j Mod 2
                        If Reste = 0 Then k = -1 Else k = 1
                        X = CSng(X0 + red * (.LappG + .Lx / 2) + X3 * k + X4)
                        Y2 = Y1 + CSng(red * .TS_trav.Item(i1 - 1).LacierY(0))
                        g.DrawLine(mypen, X, Y1, X, Y2) 'armature - trait vertical
                        Select Case i1
                            Case 1
                                X1 = CSng(X0 + red * (.LappG - .TS_trav.Item(i1 - 1).L13acier))
                                X2 = CSng(X0 + red * (.LappG + .Lx + .LappH - .TS_trav.Item(i1 - 1).L23acier))
                            Case 2
                                If PlanCont.Item(0).Lit2CouvertureTravee = True Then
                                    'le lit n°2 couvre l'intégralité de la dalle
                                    X1 = CSng(X0 + red * (.LappG - .TS_trav.Item(i1 - 1).L13acier))
                                    X2 = CSng(X0 + red * (.LappG + .Lx + .LappH - .TS_trav.Item(i1 - 1).L23acier))
                                Else
                                    'le lit n°2 couvre uniquement la partie nécessaire à la reprise de l'effort de flexion
                                    X1 = CSng(X0 + red * (.LappG + .TS_trav.Item(i1 - 1).X1acier))
                                    X2 = CSng(X0 + red * (.LappG + .TS_trav.Item(i1 - 1).X2acier))
                                End If
                        End Select
                        g.DrawLine(mypen3, X1, (Y1 + Y2) / 2, X2, (Y1 + Y2) / 2) 'armature - trait horizontal
                        'rond indicatif
                        Y = (Y1 + Y2) / 2
                        msg = i_tot.ToString("#")
                        w = g.MeasureString(msg, myFont)
                        If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                        g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                        g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                        g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                        j += 1
                        Y1 = Y2 - CSng(red * .TS_trav.Item(i1 - 1).RecouvTr)
                    Loop While j < .TS_trav.Item(i1 - 1).nbrePanneaux
                    '--> le TS complémentaire (si existe)
                    If .TS_trav.Item(i1 - 1).LacierY.Count = 2 Then
                        i_tot = i_tot + 1
                        Reste = j Mod 2
                        If Reste = 0 Then k = -1 Else k = 1
                        X = CSng(X0 + red * (.LappG + .Lx / 2) + X3 * k + X4)
                        Y2 = CSng(OriY + red * (.LappH + .Ly + .TS_trav.Item(i1 - 1).L31acier))
                        Y1 = Y2 - CSng(red * .TS_trav.Item(i1 - 1).LacierY(1))
                        Select Case Support
                            Case 1 'écran
                                If Abs(Y2 - Y1) < 30 Then Y1 = Y2 - 30
                            Case 2 'image

                            Case 3 'imprimante
                                If Abs(Y2 - Y1) < 4 * w.Height Then Y1 = Y2 - 4 * w.Height
                        End Select
                        g.DrawLine(mypen, X, Y1, X, Y2) 'armature - trait vertical
                        Select Case i1
                            Case 1
                                X1 = CSng(X0 + red * (.LappG - .TS_trav.Item(i1 - 1).L13acier))
                                X2 = CSng(X0 + red * (.LappG + .Lx + .LappH - .TS_trav.Item(i1 - 1).L23acier))
                            Case 2
                                If PlanCont.Item(0).Lit2CouvertureTravee = True Then
                                    'le lit n°2 couvre l'intégralité de la dalle
                                    X1 = CSng(X0 + red * (.LappG - .TS_trav.Item(i1 - 1).L13acier))
                                    X2 = CSng(X0 + red * (.LappG + .Lx + .LappH - .TS_trav.Item(i1 - 1).L23acier))
                                Else
                                    'le lit n°2 couvre uniquement la partie nécessaire à la reprise de l'effort de flexion
                                    X1 = CSng(X0 + red * (.LappG + .TS_trav.Item(i1 - 1).X1acier))
                                    X2 = CSng(X0 + red * (.LappG + .TS_trav.Item(i1 - 1).X2acier))
                                End If
                        End Select
                        g.DrawLine(mypen3, X1, (Y1 + Y2) / 2, X2, (Y1 + Y2) / 2) 'armature - trait horizontal
                        'rond indicatif
                        Y = (Y1 + Y2) / 2
                        msg = i_tot.ToString("#")
                        w = g.MeasureString(msg, myFont)
                        If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                        g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                        g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                        g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                    End If
                Next
                X0 = CSng(X0 + red * (.LappG + .Lx))
            End With
        Next

    End Sub
    Private Sub Ferraillages_inferieurs_Complementaires_Predalles(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush,
                                                                  ByVal myFont As Font, ByVal red As Double, ByVal OriX As Single, ByVal OriY As Single)
        'Ferraillage inférieurs
        Dim i, j, i_tot, N_Pan, N_Pan1 As Integer '
        Dim X, Y, X1, Y1, X2, Y2 As Single ', fl
        Dim msg As String
        Dim w As SizeF

        'armatures principales
        'Affichage coupe
        msg = "PLAN DE FERRAILLAGE:  Armatures inférieures complémentaires sur prédalles"
        myFont = New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        X = OriX : Y = CSng(OriY - w.Height - 20)
        g.DrawString(msg, myFont, myBrush, X, Y)
        myFont = New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myPen1T As New Pen(Color.Black, 1)
        Dim myPen1P As New Pen(Color.Black, 1)
        Dim myPen2 As New Pen(Color.Black, 2)
        myPen1T.DashStyle = Drawing2D.DashStyle.Dash : myPen1P.DashStyle = Drawing2D.DashStyle.Solid

        '
        '--> dessin des prédalles
        X = CSng(OriX + red * (PlanCont(0).LappG - PlanCont(0).Prefa_ReposG))
        X1 = CSng(OriX + red * (PlanCont(0).LappG + PlanCont(0).Lx + PlanCont(0).Prefa_ReposD))
        For j = 0 To PlanCont.Count - 1
            Y = CSng(OriY + red * (PlanCont(j).LappH)) : Y1 = Y
            '  g.DrawLine(myPen1T, X, Y, X1, Y)
            For i = 0 To PlanCont(j).Prefa_nb - 2
                Y1 = CSng(Y1 + red * PlanCont(j).Prefa_Ly(i))
                g.DrawLine(myPen1T, X, Y1, X1, Y1) 'lignes horizontales
            Next
            ' g.DrawLine(myPen1P, X, Y, X, Y1) : g.DrawLine(myPen1P, X1, Y, X1, Y1) 'lignes verticales
            If j = PlanCont.Count - 1 Then Exit For 'pour éviter le plantage
            X = CSng(X1 + red * (PlanCont(j).LappD - PlanCont(j + 1).Prefa_ReposG))
            X1 = CSng(X + red * (PlanCont(j + 1).Lx + PlanCont(j + 1).Prefa_ReposD))
        Next
        '--> dessin chapeaux sur joints
        X2 = CSng(OriX + red * PlanCont.Item(0).LappG)
        For j = 0 To PlanCont.Count - 1
            N_Pan = N_Pan + 1
            If PlanCont(j).Prefa_TS_joint.LacierY.Count = 2 Then N_Pan1 = N_Pan + 1
            With PlanCont.Item(j)
                Y = CSng(OriY + red * .LappH)

                For i = 0 To PlanCont(j).Prefa_nb - 2
                    X1 = CSng(X2 + red * .Lx) : X = X2
                    Y += CSng(red * .Prefa_Ly(i))
                    Y1 = CSng(Y - red * (.Prefa_TS_joint.Lacier1 / 2))
                    Y2 = CSng(Y + red * .Prefa_TS_joint.Lacier1 / 2)
                    'dessin des armatures
                    Do
                        g.DrawLine(mypen, X, Y1, X, Y2) 'verticale 1
                        g.DrawLine(mypen, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y1, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y2) 'verticale 2
                        g.DrawLine(mypen, X, Y2, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y1) 'ligne oblique 1
                        X += CSng(red * .Prefa_TS_joint.LacierY.Item(0))
                    Loop While CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)) < X1
                    g.DrawLine(mypen, X1, Y1, X1, Y2) 'verticale dernière
                    g.DrawLine(mypen, X, Y2, X1, Y1) 'ligne oblique dernière
                    g.DrawLine(mypen, X2, Y1, X1, Y1) 'ligne horizontale 1
                    g.DrawLine(mypen, X2, Y2, X1, Y2) 'ligne horizontale 2
                    'rond indicatif
                    X = CSng(X2 + red * .Prefa_TS_joint.LacierY.Item(0) / 2)
                    g.FillEllipse(Brushes.White, X - 10, Y - 10, 20, 20)
                    g.DrawEllipse(mypen, X - 10, Y - 10, 20, 20)
                    msg = N_Pan.ToString("#") : w = g.MeasureString(msg, myFont)
                    g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                    If .Prefa_TS_joint.LacierY.Count = 2 Then
                        X = CSng(X1 - red * .Prefa_TS_joint.LacierY.Item(1) / 2)
                        g.FillEllipse(Brushes.White, X - 10, Y - 10, 20, 20)
                        g.DrawEllipse(mypen, X - 10, Y - 10, 20, 20)
                        msg = N_Pan1.ToString("#") : w = g.MeasureString(msg, myFont)
                        g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                    End If
                Next
                X2 = CSng(X2 + red * (.Lx + .LappD))
            End With
            If PlanCont(j).Prefa_TS_joint.LacierY.Count = 2 Then N_Pan = N_Pan + 1
        Next
        '--> dessin chapeaux sur rives latérales
        X2 = CSng(OriX + red * PlanCont.Item(0).LappG)
        If N_Pan1 > N_Pan Then N_Pan = N_Pan1
        For j = 0 To PlanCont.Count - 1
            With PlanCont.Item(j)
                X = X2
                If .Prefa_TS_RiveLaterale.LacierY.Count = 2 Then
                    N_Pan = N_Pan1 + 1 : N_Pan1 = N_Pan + 1
                Else
                    N_Pan = N_Pan1 + 1 : N_Pan1 = N_Pan
                End If
                'Rives hautes
                Y = CSng(OriY + red * .LappH)
                X1 = CSng(X + red * .Lx)
                If .LappH > 0.05 Then
                    Y1 = CSng(Y - red * .Prefa_TS_RiveLaterale.L13acier)
                    Y2 = CSng(Y + red * .Prefa_TS_RiveLaterale.X2acier)
                    Do
                        g.DrawLine(mypen, X, Y1, X, Y2) 'verticale 1
                        g.DrawLine(mypen, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y1, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y2) 'verticale 2
                        g.DrawLine(mypen, X, Y2, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y1) 'ligne oblique 1
                        X += CSng(red * .Prefa_TS_joint.LacierY.Item(0))
                    Loop While CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)) < X1
                    g.DrawLine(mypen, X1, Y1, X1, Y2) 'verticale dernière
                    g.DrawLine(mypen, X, Y2, X1, Y1) 'ligne oblique dernière
                    g.DrawLine(mypen, X2, Y1, X1, Y1) 'ligne horizontale 1
                    g.DrawLine(mypen, X2, Y2, X1, Y2) 'ligne horizontale 2
                    'rond indicatif
                    g.FillEllipse(Brushes.White, CSng(X - red * .Prefa_TS_joint.LacierY.Item(0) / 2) - 10, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2), 20, 20)
                    g.DrawEllipse(mypen, CSng(X - red * .Prefa_TS_joint.LacierY.Item(0) / 2) - 10, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2), 20, 20)
                    msg = N_Pan.ToString("#") : w = g.MeasureString(msg, myFont)
                    g.DrawString(msg, myFont, myBrush, CSng(X - red * .Prefa_TS_joint.LacierY.Item(0) / 2) - w.Width / 2, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2) + 10 - w.Height / 2)
                    If .Prefa_TS_RiveLaterale.LacierY.Count = 2 Then
                        X = CSng(X1 - red * .Prefa_TS_joint.LacierY.Item(1) / 2)
                        g.FillEllipse(Brushes.White, X + 10, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2), 20, 20)
                        g.DrawEllipse(mypen, X + 10, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2), 20, 20)
                        msg = N_Pan1.ToString("#") : w = g.MeasureString(msg, myFont)
                        g.DrawString(msg, myFont, myBrush, X + 20 - w.Width / 2, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2) + 10 - w.Height / 2)
                    End If
                    'côte
                    X1 = X - 100
                    g.DrawLine(mypen, X1 - 5, Y2, X1 + 5, Y2) 'horizontal
                    g.DrawLine(mypen, X1, Y, X1, Y2 + 20) 'vertical
                    msg = (.Prefa_TS_RiveLaterale.X2acier * 100).ToString("0")
                    w = g.MeasureString(msg, myFont)
                    g.DrawString(msg, myFont, myBrush, X1 - w.Width - 1, Y2 + 20 - w.Height)
                End If

                'Rives basses
                X = X2
                Y = CSng(OriY + red * (.LappH + .Ly))
                X1 = CSng(X + red * .Lx)
                If .LappB > 0.05 Then
                    Y1 = CSng(Y + red * .Prefa_TS_RiveLaterale.L13acier)
                    Y2 = CSng(Y - red * .Prefa_TS_RiveLaterale.X2acier)
                    Do
                        g.DrawLine(mypen, X, Y1, X, Y2) 'verticale 1
                        g.DrawLine(mypen, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y1, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y2) 'verticale 2
                        g.DrawLine(mypen, X, Y2, CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)), Y1) 'ligne oblique 1
                        X += CSng(red * .Prefa_TS_joint.LacierY.Item(0))
                    Loop While CSng(X + red * .Prefa_TS_joint.LacierY.Item(0)) < X1
                    g.DrawLine(mypen, X1, Y1, X1, Y2) 'verticale dernière
                    g.DrawLine(mypen, X, Y2, X1, Y1) 'ligne oblique dernière
                    g.DrawLine(mypen, X2, Y1, X1, Y1) 'ligne horizontale 1
                    g.DrawLine(mypen, X2, Y2, X1, Y2) 'ligne horizontale 2
                    'rond indicatif
                    g.FillEllipse(Brushes.White, CSng(X - red * .Prefa_TS_joint.LacierY.Item(0) / 2) - 10, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2), 20, 20)
                    g.DrawEllipse(mypen, CSng(X - red * .Prefa_TS_joint.LacierY.Item(0) / 2) - 10, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2), 20, 20)
                    msg = N_Pan.ToString("#") : w = g.MeasureString(msg, myFont)
                    g.DrawString(msg, myFont, myBrush, CSng(X - red * .Prefa_TS_joint.LacierY.Item(0) / 2) - w.Width / 2, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2) + 10 - w.Height / 2)
                    If .Prefa_TS_RiveLaterale.LacierY.Count = 2 Then
                        X = CSng(X1 - red * .Prefa_TS_joint.LacierY.Item(1) / 2)
                        g.FillEllipse(Brushes.White, X + 10, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2), 20, 20)
                        g.DrawEllipse(mypen, X + 10, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2), 20, 20)
                        msg = N_Pan1.ToString("#") : w = g.MeasureString(msg, myFont)
                        g.DrawString(msg, myFont, myBrush, X + 20 - w.Width / 2, CSng(Y2 - red * .Prefa_TS_RiveLaterale.X2acier / 2) + 10 - w.Height / 2)
                    End If
                    i_tot = N_Pan
                    'côte
                    X1 = X - 100
                    g.DrawLine(mypen, X1 - 5, Y2, X1 + 5, Y2) 'horizontal
                    g.DrawLine(mypen, X1, Y, X1, Y2 - 20) 'vertical
                    msg = (.Prefa_TS_RiveLaterale.X2acier * 100).ToString("0")
                    w = g.MeasureString(msg, myFont)
                    g.DrawString(msg, myFont, myBrush, X1 - w.Width - 1, Y2 - 20 - w.Height)
                End If
                X2 = CSng(X2 + red * (.Lx + .LappD))
            End With

        Next
        '--> dessin renforts de trémies
        X = OriX
        For Each dalle As Plancher In PlanCont
            With dalle
                X = CSng(X + red * .LappG) : Y = CSng(OriY + red * .LappH)
                If ._Tremie.Count = 0 Then Continue For 'passage à la travée suivante
                '
                '--> traitement de trémies avec aciers sur prédalles
                For i = 1 To ._Tremie.Count
                    If ._Tremie.Item(i - 1)._HA_Lx.nbar >= 1 And ._Tremie.Item(i - 1)._type_chevetre = 1 Then
                        'rectangle trémie - point A
                        X1 = CSng(X + red * ._Tremie.Item(i - 1)._xA) : Y1 = CSng(Y + red * ._Tremie.Item(i - 1)._yA) 'point A
                        X2 = CSng(red * ._Tremie.Item(i - 1)._Lx / 2) : Y2 = CSng(red * ._Tremie.Item(i - 1)._Ly / 2) 'cotes au milieux de la trémie
                        'dessin armature perpendiculaire au sens de la portée
                        For j = 1 To ._Tremie.Item(i - 1)._HA_Ly.nbar
                            g.DrawLine(myPen2, X1 - i * 3, CSng(Y1 + Y2 - red * ._Tremie.Item(i - 1)._HA_Ly.Lacier1 / 2), X1 - i * 3, CSng(Y1 + Y2 + red * ._Tremie.Item(i - 1)._HA_Ly.Lacier1 / 2)) 'armature Y gauche centrée
                            g.DrawLine(myPen2, X2 + i * 3, CSng(Y1 + Y2 - red * ._Tremie.Item(i - 1)._HA_Ly.Lacier1 / 2), X2 + i * 3, CSng(Y1 + Y2 + red * ._Tremie.Item(i - 1)._HA_Ly.Lacier1 / 2)) 'armature Y droite centrée
                            msg = "R2_" & (PlanCont.IndexOf(dalle) + 1).ToString & "_" & i.ToString("#") : w = g.MeasureString(msg, myFont)
                            g.DrawString(msg, myFont, myBrush, CSng(X1 + 2 * X2 + red * ._Tremie.Item(i - 1)._HA_Lx.L13acier + 1), CSng(Y1 - 3 - w.Height / 2))
                        Next

                        'dessin armature suivant le sens de la portée
                        'l'armature peut être filante ou pas sur la longueur de la travée et va s'ancrer à chaque extrémité
                        For j = 1 To ._Tremie.Item(i - 1)._HA_Lx.nbar
                            If ._Tremie.Item(i - 1)._HA_Lx.Lacier1 >= .Lx Then
                                'armature filante sur la longueur de la travée
                                g.DrawLine(myPen2, CSng(X - red * ._Tremie.Item(i - 1)._HA_Lx.L13acier), Y1 - i * 3, CSng(X + red * (.Lx + ._Tremie.Item(i - 1)._HA_Lx.L13acier)), Y1 - i * 3) 'armature X haute centrée
                                g.DrawLine(myPen2, CSng(X - red * ._Tremie.Item(i - 1)._HA_Lx.L13acier), Y2 + i * 3, CSng(X + red * (.Lx + ._Tremie.Item(i - 1)._HA_Lx.L13acier)), Y2 + i * 3) 'armature X basse centrée
                            Else
                                'armature centrée sur la longueur de la trémie
                                g.DrawLine(myPen2, CSng(X1 + X2 - red * ._Tremie.Item(i - 1)._HA_Lx.Lacier1 / 2), Y1 - i * 3, CSng(X1 + X2 + red * ._Tremie.Item(i - 1)._HA_Lx.Lacier1 / 2), Y1 - i * 3) 'armature X haute centrée
                                g.DrawLine(myPen2, CSng(X1 + X2 - red * ._Tremie.Item(i - 1)._HA_Lx.Lacier1 / 2), Y2 + i * 3, CSng(X1 + X2 + red * ._Tremie.Item(i - 1)._HA_Lx.Lacier1 / 2), Y2 + i * 3) 'armature X basse centrée
                            End If
                            msg = "R1_" & (PlanCont.IndexOf(dalle) + 1).ToString & "_" & i.ToString("#") : w = g.MeasureString(msg, myFont)
                            g.DrawString(msg, myFont, myBrush, X1 - 3 - w.Width - 1, CSng(Y1 + 2 * Y2 + red * ._Tremie.Item(i - 1)._HA_Ly.L13acier + 1))
                        Next
                    End If
                Next
                X = CSng(X + red * .Lx)
            End With
        Next

    End Sub


    ''' <summary>
    ''' Dessin des armatures supérieures sur dalles pleines
    ''' </summary>
    ''' <param name="g"></param>
    ''' <param name="mypen"></param>
    ''' <param name="mypen2"></param>
    ''' <param name="mypen3"></param>
    ''' <param name="myBrush"></param>
    ''' <param name="myFont"></param>
    ''' <param name="red"></param>
    ''' <param name="OriX"></param>
    ''' <param name="OriY"></param>
    ''' <param name="Support"></param>
    Private Sub Ferraillages_superieurs(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen2 As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double,
                         ByVal OriX As Single, ByVal OriY As Single, ByVal Support As Integer)
        'Ferraillage supérieurs
        Dim N_Pan As Integer 'j,i,
        Dim X, Y, X2, x22, X3, Y3, fl As Single '
        Dim msg As String = String.Empty
        Dim w As SizeF

        msg = "PLAN DE FERRAILLAGE:  Armatures supérieures"
        myFont = New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        Select Case Support
            Case 1 'écran
                X = OriX : Y = CSng(OriY - w.Height - 20) : X3 = 12 : Y3 = 30 : fl = 8
            Case 2 'image
                X = OriX : Y = 20 : X3 = 6 : Y3 = 15 : fl = 6
            Case 3 'imprimante
                X = OriX : Y = 5 : X3 = 3 : Y3 = 10 : fl = 2
        End Select
        g.DrawString(msg, myFont, myBrush, X, Y)
        myFont = New Font("Times New Roman", 9, FontStyle.Regular)
        '-----------------------------------------------------------------------------------------------------------------------------------------------------------
        'acier sur appui gauche
        With PlanCont.Item(0)
            If .LappG > 0.05 And (Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True) Then
                Select Case .Type_Acier_Appui_Gauche
                    Case 1 ' TS
                        Call Tracé_TS_Sup_Appui_Gauche(g, Support, mypen, mypen3, myBrush, myFont, red, OriX, OriY, 0, N_Pan, fl)
                    Case 2 ' HA
                        Call Tracé_HA_Sup_Appui_Gauche(g, Support, mypen, mypen3, myBrush, myFont, red, OriX, OriY, 0, N_Pan, fl)
                End Select
                X2 = CSng(OriX + red * (.LappG + .Lx + .LappD))
            End If
        End With
        '-----------------------------------------------------------------------------------------------------------------------------------------------------------
        'acier sur appui droit
        If PlanCont.Count > 1 Then
            '--------------------------------------------------------------------------------------------------------------------
            'Appuis intermédiaires
            X2 = CSng(OriX + red * (PlanCont(0).LappG))
            For i = 0 To PlanCont.Count - 2
                Call Tracé_Sup_Appui_Intermediaire(g, Support, mypen, mypen3, myBrush, myFont, red, X2, OriY, i, N_Pan)
                X2 = CSng(X2 + red * (PlanCont(i).Lx + PlanCont(i).LappD))
            Next
            '-------------------------------------------------------------------------------------------------------------------------
            'dernier appui = appui de rive si acier existant
            If Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True Then
                N_Pan += 1
                With PlanCont.Item(PlanCont.Count - 1)
                    Select Case .Type_Acier_Appui_Droit
                        Case 1 'TS
                            If .LappD > 0.05 Then Call Tracé_TS_Sup_Appui_Droit(g, mypen, mypen3, myBrush, myFont, red, X2, OriY, PlanCont.Count - 1, N_Pan, fl)
                        Case 2
                            If .LappD > 0.05 Then Call Tracé_HA_Sup_Appui_Droit(g, mypen, mypen3, myBrush, myFont, red, X2, OriY, PlanCont.Count - 1, N_Pan, fl)
                    End Select
                End With
            End If
        Else
            'Dessin des armatures supérieures pour l'appui droit dans le cas d'une seule travée
            With PlanCont.Item(0)
                If .LappD > 0.05 And (Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True) Then
                    N_Pan += 1
                    X2 = CSng(OriX + red * (.LappG))
                    'acier sur appui de rive
                    Select Case .Type_Acier_Appui_Droit
                        Case 1 'TS
                            Call Tracé_TS_Sup_Appui_Droit(g, mypen, mypen3, myBrush, myFont, red, X2, OriY, 0, N_Pan, fl)
                        Case 2
                            Call Tracé_HA_Sup_Appui_Droit(g, mypen, mypen3, myBrush, myFont, red, X2, OriY, 0, N_Pan, fl)
                    End Select
                End If
            End With
        End If
        X2 = OriX + CSng(red * PlanCont.Item(0).LappG) : x22 = OriX + CSng(red * PlanCont.Item(0).LappG) : N_Pan += 1
        'acier secondaire - Appuis haut et bas
        For Each dalle As Plancher In PlanCont

            With dalle
                'appui haut
                If .LappH > 0.05 And (Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True) Then
                    'If dalle.TS_AppB.Count >= 1 AndAlso dalle.TS_AppB.Item(0).LacierY.Count = 2 Then N_Pan = N_Pan + 1
                    'If dalle.TS_AppD.Count >= 1 AndAlso dalle.TS_AppD.Item(0).LacierY.Count = 2 Then N_Pan = N_Pan + 1
                    Select Case .Type_Acier_Travée
                        Case 1 'TS
                            Call Bar_HA_Sup_S_Reprise_haut_TS(g, mypen, mypen2, myBrush, myFont, PlanCont.IndexOf(dalle), X2, red, OriY, N_Pan, fl)
                        Case 2 'HA
                            Call Bar_HA_Sup_S_Reprise_haut(g, mypen, mypen2, myBrush, myFont, PlanCont.IndexOf(dalle), X2, red, OriY, N_Pan, fl)
                    End Select
                    X2 += CSng(red * (.LappG + .Lx))
                End If
                'appui bas
                If .LappB > 0.05 And (Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True) Then
                    'If .LappH < 0.05 Then
                    '    If dalle.TS_AppB.Count >= 1 AndAlso dalle.TS_AppB.Item(0).LacierY.Count = 2 Then N_Pan = N_Pan + 1
                    '    If dalle.TS_AppD.Count >= 1 AndAlso dalle.TS_AppD.Item(0).LacierY.Count = 2 Then N_Pan = N_Pan + 1
                    'End If
                    Select Case .Type_Acier_Travée
                        Case 1 'TS
                            Call Bar_HA_Sup_S_Reprise_bas_TS(g, mypen, mypen2, myBrush, myFont, PlanCont.IndexOf(dalle), x22, red, OriY, N_Pan, fl)
                        Case 2 'HA
                            Call Bar_HA_Sup_S_Reprise_bas(g, mypen, mypen2, myBrush, myFont, PlanCont.IndexOf(dalle), x22, red, OriY, N_Pan, fl)
                    End Select
                    x22 += CSng(red * (.LappG + .Lx))
                End If
            End With
        Next
    End Sub

#Region "9 Prog de dessin des armatures supérieures appelés depuis le module Ferraillage_Supérieurs"
    ''' <summary>tracé TS supérieurs sur l'appui gauche  </summary>
    ''' <param name="i1">n° de travée</param>
    ''' <param name="N_Pan">n° du TS</param>
    Private Sub Tracé_TS_Sup_Appui_Gauche(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double, ByVal OriX As Single,
                                         ByVal OriY As Single, ByVal i1 As Integer, ByRef N_Pan As Integer, ByVal fl As Single)

        Dim X, Y, X1, Y1 As Single
        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim Rmax As Single

        With PlanCont.Item(i1)
            'N° de TS
            N_Pan = 1 : msg = N_Pan.ToString("#") : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            X = CSng(OriX + red * (.LappG - .TS_AppG.Item(0).L13acier)) : X1 = CSng(OriX + red * (.LappG + .TS_AppG.Item(0).X2acier))
            Y = CSng(OriY + red * .LappH)
            g.DrawLine(mypen, X, Y, X1, Y) 'armature
            Do
                Y1 = Y
                Y += CSng(red * (.TS_AppG.Item(0).LacierY.Item(0)))
                g.DrawLine(mypen, X, Y, X1, Y) 'armature
                g.DrawLine(mypen, X, Y, X1, Y1) 'armature incliné
                g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature 'armature
            Loop While CSng(Y + red * (.TS_AppG.Item(0).LacierY.Item(0))) < CSng(OriY + red * (.LappH + .Ly))
            If .TS_AppG.Item(0).LacierY.Count = 2 Then
                Y1 = Y
                Y += CSng(red * (.TS_AppG.Item(0).LacierY.Item(1)))
                g.DrawLine(mypen, X, Y, X1, Y) 'armature
                g.DrawLine(mypen, X1, Y1, X, Y) 'armature incliné
                g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature 'armature
            End If
            'rond indicatif
            X = CSng(OriX + red * (.LappG + .TS_AppG.Item(0).X2acier) + CSng(Rmax * 0.75))
            Y = CSng(OriY + red * (.LappH + .Ly / 2) - CSng(Rmax * 0.75))
            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            If .TS_AppG.Item(0).LacierY.Count = 2 Then
                N_Pan = N_Pan + 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                Y = CSng(OriY + red * (.LappH + .Ly / 2) - 2 * CSng(Rmax * 1.5))
                g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            End If
            'côte
            X = CSng(OriX + red * .LappG - 2) : X1 = CSng(OriX + red * (.LappG + .TS_AppG.Item(0).X2acier))
            Y = CSng(OriY + red * (.LappH + .Ly / 2) - 3 * CSng(Rmax * 0.75))
            g.DrawLine(mypen, X, Y, X1 + CSng(Rmax * 0.75), Y) 'horizontal
            g.DrawLine(mypen, X1, Y - fl, X1, Y + fl) 'vertical
            msg = (.TS_AppG.Item(0).X2acier * 100).ToString("0")
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X1 + 1, Y - w.Height)

        End With
    End Sub
    ''' <summary>tracé TS supérieurs sur l'appui droit  </summary>
    ''' <param name="i1">n° de travée</param>
    ''' <param name="N_Pan">n° du TS</param>
    Private Sub Tracé_TS_Sup_Appui_Droit(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double, ByVal X2 As Single,
                                         ByVal OriY As Single, ByVal i1 As Integer, ByRef N_Pan As Integer, ByVal fl As Single)
        Dim X, X1, Y, Y1 As Single
        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim Rmax As Single

        With PlanCont.Item(i1)

            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            'acier sur appui de rive droit
            X = CSng(X2 + red * (.Lx + .TS_AppD.Item(0).L23acier)) : X1 = CSng(X2 + red * (.TS_AppD.Item(0).X1acier))
            Y = CSng(OriY + red * .LappH)
            g.DrawLine(mypen, X, Y, X1, Y) 'armature
            Do
                Y1 = Y
                Y += CSng(red * (.TS_AppD.Item(0).LacierY.Item(0)))
                g.DrawLine(mypen, X, Y, X1, Y) 'armature
                g.DrawLine(mypen, X, Y1, X1, Y) 'armature incliné
                g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature 'armature
            Loop While CSng(Y + red * (.TS_Appd.Item(0).LacierY.Item(0))) < CSng(OriY + red * (.LappH + .Ly))
            If .TS_AppD.Item(0).LacierY.Count = 2 Then
                Y1 = Y
                Y += CSng(red * (.TS_AppD.Item(0).LacierY.Item(1)))
                g.DrawLine(mypen, X, Y, X1, Y) 'armature
                g.DrawLine(mypen, X1, Y1, X, Y) 'armature incliné
                g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature 'armature
            End If
            'rond indicatif
            X = CSng(X2 + red * (.TS_AppD.Item(0).X1acier) - CSng(Rmax * 0.75))
            Y = CSng(OriY + red * (.LappH + .Ly / 2) + CSng(Rmax * 0.75))
            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            If .TS_AppD.Item(0).LacierY.Count = 2 Then
                Y = CSng(OriY + red * (.LappH + .Ly / 2) + 2 * CSng(Rmax * 1.5))
                N_Pan = N_Pan + 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            End If
            'côte
            X = CSng(X2 + red * (.Lx) + 2)
            X1 = CSng(X2 + red * (.TS_AppD.Item(0).X1acier))
            Y = CSng(OriY + red * (.LappH + .Ly / 2) - 2 * CSng(Rmax * 0.75))
            g.DrawLine(mypen, X, Y, X1 - CSng(Rmax * 0.75), Y) 'horizontal
            g.DrawLine(mypen, X1, Y - fl, X1, Y + fl) 'vertical
            msg = ((.Lx - .TS_AppD.Item(0).X1acier) * 100).ToString("0")
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X1 - 1 - w.Width, Y - w.Height)
        End With
    End Sub

    Private Sub Tracé_HA_Sup_Appui_Gauche(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double, ByVal OriX As Single,
                                         ByVal OriY As Single, ByVal i1 As Integer, ByRef N_Pan As Integer, ByVal fl As Single)

        Dim X, Y, X1, Y1 As Single
        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim Rmax As Single

        With PlanCont.Item(i1)
            'n° de l'acier concerné
            N_Pan = 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            'acier sur appui de rive gauche
            X = CSng(OriX + red * (.LappG - .LitSupG.Item(0).L13acier)) : Y = CSng(OriY + red * (.LappH + .Ly / 2) - (Rmax * 1.5))
            X1 = CSng(OriX + red * (.LappG + .LitSupG.Item(0).X2acier))
            g.DrawLine(mypen3, X, Y, X1, Y) 'armature
            X = CSng(OriX + red * (.LappG + .LitSupG.Item(0).X2acier) + (Rmax * 0.75))
            Y = CSng(OriY + red * (.LappH + .LitSupG(0).S1)) : Y1 = CSng(OriY + red * (.LappH + .Ly - .LitSupG(0).S2))
            g.DrawLine(mypen, X, Y, X, Y1) 'ligne de répartition
            'flèche haut
            g.DrawLine(mypen, X, Y, X - fl, Y + fl) : g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X - fl, Y, X + fl, Y)
            msg = (.LitSupG(0).S1 * 100).ToString("#0")
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y)
            'flèche basse
            g.DrawLine(mypen, X, Y1, X - fl, Y1 - fl) : g.DrawLine(mypen, X, Y1, X + fl, Y1 - fl) : g.DrawLine(mypen, X - fl, Y1, X + fl, Y1)
            msg = (.LitSupG(0).S2 * 100).ToString("#0")
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y1 - w.Height)
            'rond indicatif
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            X = CSng(OriX + red * (.LappG + .LitSupG.Item(0).X2acier) + (Rmax * 0.75))
            Y = CSng(OriY + red * (.LappH + .Ly / 2) - (Rmax * 1.5))
            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
        End With
    End Sub
    Private Sub Tracé_HA_Sup_Appui_Droit(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double, ByVal X2 As Single,
                                         ByVal OriY As Single, ByVal i1 As Integer, ByRef N_Pan As Integer, ByVal fl As Single)
        Dim X, X1, Y, Y1 As Single
        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim Rmax As Single

        With PlanCont.Item(i1)
            'n° de l'acier concerné
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            'acier sur appui de rive droit
            X = CSng(X2 + red * (.LitSupD.Item(0).X1acier)) : Y = CSng(OriY + red * (.LappH + .Ly / 2) + (Rmax * 1.5))
            X1 = CSng(X2 + red * (.Lx + .LitSupD.Item(0).L23acier))
            g.DrawLine(mypen3, X, Y, X1, Y) 'armature
            X = CSng(X2 + red * (.LitSupD.Item(0).X1acier) - (Rmax * 0.75))
            Y = CSng(OriY + red * (.LappH + .LitSupD(0).S1)) : Y1 = CSng(OriY + red * (.LappH + .Ly - .LitSupD(0).S2))
            g.DrawLine(mypen, X, Y, X, Y1) 'ligne de répartition
            'flèche haut
            g.DrawLine(mypen, X, Y, X - fl, Y + fl) : g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X - fl, Y, X + fl, Y)
            msg = (.LitSupD(0).S1 * 100).ToString("#0") : w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y)
            'flèche basse
            g.DrawLine(mypen, X, Y1, X - fl, Y1 - fl) : g.DrawLine(mypen, X, Y1, X + fl, Y1 - fl) : g.DrawLine(mypen, X - fl, Y1, X + fl, Y1)
            msg = (.LitSupD(0).S2 * 100).ToString("#0") : w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y1 - w.Height)
            'rond indicatif
            X = CSng(X2 + red * (.LitSupD.Item(0).X1acier) - (Rmax * 0.75))
            Y = CSng(OriY + red * (.LappH + .Ly / 2) + (Rmax * 1.5))
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)

        End With
    End Sub
    ''' <summary>
    ''' Tracé des armatures sur appuis intermédiaires (TS ou barres HA)
    ''' </summary>
    ''' <param name="g"></param>
    ''' <param name="Support">=1 sur écran; =2 sur image; =3 sur imprimante A4</param>
    ''' <param name="mypen"></param>
    ''' <param name="mypen3"></param>
    ''' <param name="myBrush"></param>
    ''' <param name="myFont"></param>
    ''' <param name="red"></param>
    ''' <param name="X2"></param>
    ''' <param name="OriY"></param>
    ''' <param name="i1">n° d'index de la travée</param>
    ''' <param name="N_Pan"></param>
    Private Sub Tracé_Sup_Appui_Intermediaire(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double, ByVal X2 As Single,
                                     ByVal OriY As Single, ByVal i1 As Integer, ByRef N_Pan As Integer)
        'acier sur appui intermédiaire
        Dim X, Y, X1, Y1, fl As Single
        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim Rmax As Single
        Dim r As Double
        Dim d1 As Integer
        Dim Affichage_Lit2 As Boolean = False

        Select Case Support
            Case 1 'écran
                fl = 8
            Case 2 'image
                fl = 6
            Case 3 'imprimante
                fl = 2
        End Select
        r = i1 Mod 2
        If r > 0.3 Then
            'i = nombre impair
            Select Case Support
                Case 1 'écran
                    d1 = -30
                Case 2 'image
                    d1 = -20
                Case 3 'imprimante
                    d1 = -3
            End Select
        Else
            Select Case Support
                Case 1 'écran
                    d1 = 30
                Case 2 'image
                    d1 = 20
                Case 3 'imprimante
                    d1 = 3
            End Select
        End If
        With PlanCont.Item(i1)

            Select Case .Type_Acier_Appui_Droit
                Case 1 'TS
                    For i = 1 To .TS_AppD.Count
                        'acier sur appui intermédiaire
                        X = CSng(X2 + red * (.TS_AppD.Item(i - 1).X1acier))
                        X1 = CSng(X2 + red * (.Lx + .LappD + PlanCont.Item(i1 + 1).TS_AppG.Item(i - 1).X2acier))
                        Y = CSng(OriY + red * .LappH)
                        g.DrawLine(mypen, X, Y, X1, Y) 'armature
                        Do
                            Y1 = Y
                            Y += CSng(red * (.TS_AppD.Item(i - 1).LacierY.Item(0)))
                            g.DrawLine(mypen, X, Y, X1, Y) 'armature
                            g.DrawLine(mypen, X, Y, X1, Y1) 'armature incliné
                            g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature 'armature
                        Loop While CSng(Y + red * (.TS_AppG.Item(0).LacierY.Item(0))) < CSng(OriY + red * (.LappH + .Ly))
                        If .TS_AppD.Item(i - 1).LacierY.Count = 2 Then
                            Y1 = Y
                            Y += CSng(red * (.TS_AppD.Item(i - 1).LacierY.Item(1)))
                            g.DrawLine(mypen, X, Y, X1, Y) 'armature
                            g.DrawLine(mypen, X1, Y1, X, Y) 'armature incliné
                            g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature 'armature
                        End If
                        'Côte 
                        Y = CSng(OriY + red * (.LappH + .Ly / 2) + (i * 2 + 1) * d1) : X = CSng(X2 + red * (.TS_AppD.Item(i - 1).X1acier)) : X1 = CSng(X2 + red * .Lx)
                        g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X, Y, X + fl, Y - fl) : g.DrawLine(mypen, X, Y, X1, Y) 'flèche gauche et tiret
                        g.DrawLine(mypen, X1, Y, X1 - fl, Y - fl) : g.DrawLine(mypen, X1, Y, X1 - fl, Y + fl)   'flèche droite
                        msg = ((.Lx - .TS_AppD.Item(i - 1).X1acier) * 100).ToString("#0") : w = g.MeasureString(msg, myFont)
                        g.DrawString(msg, myFont, myBrush, (X + X1) / 2 - w.Width / 2, Y - w.Height)
                        'n° de l'acier concerné
                        N_Pan += 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                        If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                        'rond indicatif
                        If i = 2 Then X2 += 2 * Rmax
                        X = CSng(X2 + red * (0.8 * .Lx)) : Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1)
                        g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                        g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                        g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                        If .TS_AppD.Item(i - 1).LacierY.Count = 2 Then
                            N_Pan += 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                            If d1 > 0 Then Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1 - CSng(Rmax * 1.5)) Else Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1 + CSng(Rmax * 1.5))
                            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                        End If
                    Next

                Case 2 'barres HA
                    'n° de l'acier concerné
                    N_Pan += 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                    If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                    'acier sur appui intermédiaire (= droit)
                    X = CSng(X2 + red * (.LitSupD.Item(0).X1acier)) : Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1)
                    X1 = CSng(X2 + red * (.Lx + .LappD + PlanCont.Item(i1 + 1).LitSupG.Item(0).X2acier))
                    g.DrawLine(mypen3, X, Y, X1, Y) 'armature
                    X = CSng(X2 + red * (0.8 * .Lx)) : Y = CSng(OriY + red * (.LappH + .LitSupD(0).S1)) : Y1 = CSng(OriY + red * (.LappH + .Ly - .LitSupD(0).S2))
                    g.DrawLine(mypen, X, Y, X, Y1) 'ligne de répartition
                    'flèche haut
                    g.DrawLine(mypen, X, Y, X - fl, Y + fl) : g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X - fl, Y, X + fl, Y)
                    msg = (.LitSupD(0).S1 * 100).ToString("#0")
                    w = g.MeasureString(msg, myFont)
                    g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y)
                    'flèche basse
                    g.DrawLine(mypen, X, Y1, X - fl, Y1 - fl) : g.DrawLine(mypen, X, Y1, X + fl, Y1 - fl) : g.DrawLine(mypen, X - fl, Y1, X + fl, Y1)
                    msg = (.LitSupD(0).S2 * 100).ToString("#0")
                    w = g.MeasureString(msg, myFont)
                    g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y1 - w.Height)
                    'rond indicatif
                    msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                    If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                    X = CSng(X2 + red * (0.8 * .Lx)) : Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1)
                    g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                    g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                    g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                    Select Case .Type_Acier_Appui_Droit
                        Case 1 'TS
                            If .TS_AppG.Item(0).LacierY.Count = 2 Then Affichage_Lit2 = True
                        Case 2 'HA
                            'Pas d'affichage particulier dans ce cas pour un ferraillage constitué de barres HA
                    End Select
                    If Affichage_Lit2 = True Then
                        N_Pan += 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                        If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                        Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1 - CSng(Rmax * 1.5))
                        g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                        g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                        g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
                    End If
            End Select

        End With

    End Sub

    Private Sub Bar_HA_Sup_S_Reprise_haut_TS(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal i As Integer, ByVal X2 As Single, ByVal red As Double,
                              ByVal OriY As Single, ByRef N_Pan As Integer, ByVal fl As Single)

        'acier sur appui intermédiaire
        Dim X, Y, X1, Y1, Rmax As Single
        Dim msg As String
        Dim w As SizeF

        With PlanCont.Item(i)
            'n° de l'acier concerné
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            'tracé des lignes Armature et répartition
            Y1 = CSng(OriY + red * (.LappH + .TS_AppH.Item(0).X2acier)) : Y = CSng(OriY + red * (.LappH - .TS_AppH.Item(0).L13acier))
            X = X2
            X1 = CSng(X2 + red * .TS_AppH.Item(0).LacierY.Item(0))
            Do
                g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature verti
                g.DrawLine(mypen, X, Y, X1, Y) : g.DrawLine(mypen, X, Y1, X1, Y1) 'armature horizontale
                g.DrawLine(mypen, X, Y1, X1, Y) 'armature incliné
                X = X1
                X1 += CSng(red * (.TS_AppH.Item(0).LacierY.Item(0)))
            Loop While x1 < CSng(X2 + red * (.Lx))

            If .TS_AppH.Item(0).LacierY.Count = 2 Then
                X1 = X
                X1 += CSng(red * (.TS_AppH.Item(0).LacierY.Item(1)))
                g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature verti
                g.DrawLine(mypen, X, Y, X1, Y) : g.DrawLine(mypen, X, Y1, X1, Y1) 'armature horizontale
                g.DrawLine(mypen, X, Y1, X1, Y) 'armature incliné
            End If
            'rond indicatif
            X = CSng(X2 + red * (.Lx / 2)) : Y = CSng(OriY + red * (.LappH + .TS_AppH.Item(0).X2acier) + CSng(Rmax * 0.75))
            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            If .TS_AppH.Item(0).LacierY.Count = 2 Then
                Y = Y + 2 * CSng(Rmax * 0.75)
                N_Pan = N_Pan + 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            End If
            'côte
            X = CSng(X2 + red * (.Lx / 2) - 2 * CSng(Rmax * 0.75))
            Y = CSng(OriY + red * (.LappH) - 2)
            Y1 = CSng(OriY + red * (.LappH + .TS_AppH.Item(0).X2acier))
            g.DrawLine(mypen, X - fl, Y1, X + fl, Y1) 'horizontal
            g.DrawLine(mypen, X, Y, X, Y1 + 2 * CSng(Rmax * 0.75)) 'vertical
            msg = (.TS_AppH.Item(0).X2acier * 100).ToString("0")
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X - w.Width - 1, Y1 + 2 * CSng(Rmax * 0.75) - w.Height)
            '--------------------
            N_Pan = N_Pan + 1
        End With
    End Sub
    Private Sub Bar_HA_Sup_S_Reprise_haut(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal i As Integer, ByVal X2 As Single, ByVal red As Double,
                                        ByVal OriY As Single, ByRef N_Pan As Integer, ByVal fl As Single)

        'acier sur appui intermédiaire
        Dim X, Y, X1, Y1, Rmax As Single
        Dim msg As String
        Dim w As SizeF

        With PlanCont.Item(i)
            'dimension du rond
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            'Affichage acier et ligne de répartition
            X = CSng(X2 + red * (.Lx / 2)) : Y1 = CSng(OriY + red * (.LappH + .LitSupH.Item(0).X2acier))
            Y = CSng(OriY + red * (.LappH - .LitSupH.Item(0).L13acier))
            g.DrawLine(mypen3, X, Y, X, Y1) 'armature
            X = CSng(X2 + red * (.LitSupH.Item(0).S1)) : X1 = CSng(X2 + red * (.Lx - .LitSupH.Item(0).S2))
            Y = CSng(OriY + red * (.LappH + .LitSupH.Item(0).X2acier) + CSng(Rmax * 0.75))
            g.DrawLine(mypen, X, Y, X1, Y) 'ligne de répartition
            'flèche gauche
            g.DrawLine(mypen, X, Y, X + fl, Y - fl) : g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X, Y - fl, X, Y + fl)
            msg = (.LitSupH.Item(0).S1 * 100).ToString("#0") : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y)
            'flèche droite
            g.DrawLine(mypen, X1, Y, X1 - fl, Y - fl) : g.DrawLine(mypen, X1, Y, X1 - fl, Y + fl) : g.DrawLine(mypen, X1, Y - fl, X1, Y + fl)
            msg = (.LitSupH.Item(0).S2 * 100).ToString("#0") : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, X1 - w.Width - w.Width / 2, Y)
            'rond indicatif
            X = CSng(X2 + red * (.Lx / 2))
            Y = CSng(OriY + red * (.LappH + .LitSupH.Item(0).X2acier) + CSng(Rmax * 0.75))
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            '--------------------
            N_Pan = N_Pan + 1
        End With
    End Sub
    Private Sub Bar_HA_Sup_S_Reprise_bas_TS(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal i As Integer, ByVal X2 As Single, ByVal red As Double,
                                               ByVal OriY As Single, ByRef N_Pan As Integer, ByVal fl As Single)

        'acier sur appui bas
        Dim X, Y, X1, Y1, Rmax As Single
        Dim msg As String
        Dim w As SizeF

        With PlanCont.Item(i)
            'n° de l'acier concerné
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            'tracé des lignes Armature et répartition
            Y1 = CSng(OriY + red * (.LappH + .Ly - .TS_AppB.Item(0).X2acier)) : Y = CSng(OriY + red * (.LappH + .Ly + .TS_AppB.Item(0).L13acier))
            X = X2
            X1 = CSng(X2 + red * .TS_AppB.Item(0).LacierY.Item(0))
            Do
                g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature verti
                g.DrawLine(mypen, X, Y, X1, Y) : g.DrawLine(mypen, X, Y1, X1, Y1) 'armature horizontale
                g.DrawLine(mypen, X, Y1, X1, Y) 'armature incliné
                X = X1
                X1 += CSng(red * (.TS_AppB.Item(0).LacierY.Item(0)))
            Loop While X1 < CSng(X2 + red * (.Lx))
            If .TS_AppB.Item(0).LacierY.Count = 2 Then
                X1 = X
                X1 += CSng(red * (.TS_AppB.Item(0).LacierY.Item(1)))
                g.DrawLine(mypen, X, Y, X, Y1) : g.DrawLine(mypen, X1, Y, X1, Y1) 'armature verti
                g.DrawLine(mypen, X, Y, X1, Y) : g.DrawLine(mypen, X, Y1, X1, Y1) 'armature horizontale
                g.DrawLine(mypen, X, Y1, X1, Y) 'armature incliné
            End If
            'rond indicatif
            X = CSng(X2 + red * (.Lx / 2)) : Y = CSng(OriY + red * (.LappH + .Ly - .TS_AppB.Item(0).X2acier) - CSng(Rmax * 0.75))
            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            If .TS_AppB.Item(0).LacierY.Count = 2 Then
                Y = Y - 2 * CSng(Rmax * 0.75)
                N_Pan = N_Pan + 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
                If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
                g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
                g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            End If
            'côte
            X = CSng(X2 + red * (.Lx / 2) - CSng(Rmax * 1.5))
            Y = CSng(OriY + red * (.LappH + .Ly) + 2)
            Y1 = CSng(OriY + red * (.LappH + .Ly - .TS_AppB.Item(0).X2acier))
            g.DrawLine(mypen, X - fl, Y1, X + fl, Y1) 'horizontal
            g.DrawLine(mypen, X, Y, X, Y1 - 2 * CSng(Rmax * 0.75)) 'vertical
            msg = (.TS_AppB.Item(0).X2acier * 100).ToString("0")
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X - w.Width - 1, Y1 - 2 * CSng(Rmax * 0.75))
            '--------------------
            N_Pan = N_Pan + 1
        End With
    End Sub
    Private Sub Bar_HA_Sup_S_Reprise_bas(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal i As Integer, ByVal X2 As Single, ByVal red As Double,
                                        ByVal OriY As Single, ByRef N_Pan As Integer, ByVal fl As Single)

        'acier sur appui intermédiaire
        Dim X, Y, X1, Y1, Rmax As Single
        Dim msg As String
        Dim w As SizeF

        With PlanCont.Item(i)
            'n° de l'acier concerné
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            'tracé des lignes Armature et répartition
            X = CSng(X2 + red * (.Lx / 2)) : Y1 = CSng(OriY + red * (.LappH + .Ly - .LitSupB.Item(0).X2acier))
            Y = CSng(OriY + red * (.LappH + .Ly + .LappB - .LitSupB.Item(0).L13acier))
            g.DrawLine(mypen3, X, Y, X, Y1) 'armature
            X = CSng(X2 + red * (.LitSupB.Item(0).S1)) : X1 = CSng(X2 + red * (.Lx - .LitSupB.Item(0).S2))
            Y = CSng(OriY + red * (.LappH + .Ly - .LitSupB.Item(0).X2acier) - CSng(Rmax * 0.75))
            g.DrawLine(mypen, X, Y, X1, Y) 'ligne de répartition
            'flèche gauche
            g.DrawLine(mypen, X, Y, X + fl, Y - fl) : g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X, Y - fl, X, Y + fl)
            msg = (.LitSupB.Item(0).S1 * 100).ToString("#0") : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y)
            'flèche droite
            g.DrawLine(mypen, X1, Y, X1 - fl, Y - fl) : g.DrawLine(mypen, X1, Y, X1 - fl, Y + fl) : g.DrawLine(mypen, X1, Y - fl, X1, Y + fl)
            msg = (.LitSupB.Item(0).S2 * 100).ToString("#0") : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, X1 - w.Width - w.Width / 2, Y)
            'rond indicatif
            X = CSng(X2 + red * (.Lx / 2)) : Y = CSng(OriY + red * (.LappH + .Ly - .LitSupB.Item(0).X2acier) - CSng(Rmax * 0.75))
            msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
            '--------------------
            N_Pan = N_Pan + 1
        End With
    End Sub

#End Region

    Private Sub Calepinage_Predalles(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double,
                                    ByVal OriX As Single, ByVal OriY As Single, ByVal Support As Integer, ByVal Largeur As Integer)
        'Découpage des prédalles
        Dim i, j, i_tot, fl, d1, d3, d4 As Integer 'd2,
        Dim X, Y, X1, Y1, X2, Y2, d5 As Single '
        Dim msg As String
        Dim w As SizeF

        'Affichage TITRE
        msg = "PLAN DE CALEPINAGE DES PREDALLES"
        myFont = New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                X = OriX : Y = CSng(OriY - w.Height - 20) : fl = 8
            Case 2 'image
                X = OriX : Y = 20 : fl = 6
            Case 3 'imprimante
                X = OriX : Y = 5 : fl = 2
        End Select
        g.DrawString(msg, myFont, myBrush, X, Y)
        myFont = New Font("Times New Roman", 9, FontStyle.Regular)

        Dim myPen1T As New Pen(Color.Black, 1)
        Dim myPen1P As New Pen(Color.Black, 1)
        Dim myPen2 As New Pen(Color.Black, 2)
        myPen1T.DashStyle = Drawing2D.DashStyle.Dash : myPen1P.DashStyle = Drawing2D.DashStyle.Solid
        X = CSng(OriX + red * (PlanCont(0).LappG - PlanCont(0).Prefa_ReposG))
        X1 = CSng(OriX + red * (PlanCont(0).LappG + PlanCont(0).Lx + PlanCont(0).Prefa_ReposD))
        For j = 0 To PlanCont.Count - 1
            Y = CSng(OriY + red * (PlanCont(j).LappH))
            For i = 0 To PlanCont(j).Prefa_nb - 1
                Y1 = CSng(Y + red * PlanCont(j).Prefa_Ly(i))
                g.DrawLine(myPen1T, X, Y, X1, Y) : g.DrawLine(myPen1T, X, Y1, X1, Y1) 'lignes verticales
                g.DrawLine(myPen1P, X, Y, X, Y1) : g.DrawLine(myPen1P, X1, Y, X1, Y1) 'lignes horizontales
                Select Case Support
                    Case 1 'écran
                        d1 = 60 : d3 = 20 : d4 = 15 ': d5 = 10: d2 = 25
                    Case 2 'Image note de calcul
                        d1 = 60 : d3 = 4 : d4 = 10 ': d5 = 2: d2 = 6 
                    Case 3 'Imprimante
                        d1 = 30 : d3 = 4 : d4 = 10 ': d5 = 2: d2 = 6
                End Select
                'indication du n° de prédalle
                i_tot = ((j + 1) * 10 + (i + 1)) : msg = i_tot.ToString("#0") : w = g.MeasureString(msg, myFont)
                If w.Width > w.Height Then d5 = w.Width Else d5 = w.Height
                X2 = CSng((X + X1) / 2) : Y2 = CSng((Y + Y1) / 2) 'centre du cercle
                g.FillEllipse(Brushes.White, X2 - d5 / 2, Y2 - d5 / 2, d5, d5) 'je peint en Blanc et efface tout ce qui se trouve dessous
                g.DrawEllipse(mypen, X2 - d5 / 2, Y2 - d5 / 2, d5, d5)
                g.DrawString(msg, myFont, myBrush, X2 - d5 / 2, Y2 - d5 / 2)
                'flèche droite
                g.DrawLine(mypen, X2 + d5 / 2, Y2, X2 + d1, Y2)
                g.DrawLine(mypen, X2 + d1, Y2, X2 + d1 - fl, Y2 - fl)
                'flèche gauche
                g.DrawLine(mypen, X2 - d5 / 2, Y2, X2 - d1, Y2)
                g.DrawLine(mypen, X2 - d1, Y2, X2 - d1 + fl, Y2 + fl)
                'dessin de la croix d'orientation
                g.DrawLine(myPen2, X1 - d4 + fl, Y1 - d4, X1 - d4 - fl, Y1 - d4) 'horizontal
                g.DrawLine(myPen2, X1 - d4, Y1 - d4 + fl, X1 - d4, Y1 - d4 - fl) 'vertical
                Y = CSng(Y1 + red * PlanCont(j).Prefa_esp)
            Next
            If j = PlanCont.Count - 1 Then Exit For 'pour éviter le plantage
            X = CSng(X1 + red * (PlanCont(j).LappD - PlanCont(j + 1).Prefa_ReposG))
            X1 = CSng(X + red * (PlanCont(j + 1).Lx + PlanCont(j + 1).Prefa_ReposD))
        Next
        'Affichage Nomenclature Prédalles
        Affichage_Nomenclature_Predalle(g, Support, Largeur)
    End Sub
    Private Sub Affichage_Nomenclature_Predalle(ByVal g As Graphics, ByVal Support As Integer, ByVal Largeur As Integer)

        Dim msg As String
        Dim myPen As New Pen(Color.Black, 1)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim oriX, oriY, x, x1, y, L_col1, L_col2, L_col3, L_col4, H_lig1, H_Lig2 As Single ' y1,

        Dim w As SizeF
        Dim i, i1, i2, i_tot, j1, j2, Sortie As Integer ' j,
        'initialisation de variables

        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                'détermination des coefficient de réduction 
                L_col1 = 80 : L_col2 = 80 : L_col3 = 80 : L_col4 = 80
                oriX = Largeur - L_col1 - L_col2 - L_col3 - L_col4 - 20 '200 pixels
                oriY = 50 '50 pixel
                H_lig1 = 20 : H_Lig2 = 50
            Case 2 'image 1250x890
                L_col1 = 60 : L_col2 = 65 : L_col3 = 65 : L_col4 = 60   'soit un total avec L_col5 de 370
                oriX = Largeur - L_col1 - L_col2 - L_col3 - L_col4 - 20 '200 pixels
                oriY = 20 '50 pixel
                H_lig1 = 20 : H_Lig2 = 40
                myPen = New Pen(Color.Black, 1)
                myBrush = New SolidBrush(Color.Black)
            Case 3 'imprimante - Format A4
                L_col1 = 30 : L_col2 = 30 : L_col3 = 30 : L_col4 = 30
                oriX = Largeur - L_col1 - L_col2 - L_col3 - L_col4 - 10 '200 pixels
                oriY = 5 '5mm
                H_lig1 = 8 : H_Lig2 = 10
                myPen = New Pen(Color.Black, 0.1)
                myBrush = New SolidBrush(Color.Black)
        End Select

        '----------------------------------------------------------------------------
        '              Affichage des prédalles
        '----------------------------------------------------------------------------
        'Affichage coupe
        msg = "NOMENCLATURE DES PREDALLES"
        Dim myFont As New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        x = oriX : y = CSng(oriY - w.Height)
        g.DrawString(msg, myFont, myBrush, x, y)
        myFont = New Font("Times New Roman", 8, FontStyle.Regular)
        'dessin titre colonnes
        x1 = oriX + L_col1 + L_col2 + L_col3 + L_col4
        g.DrawLine(myPen, oriX, oriY, x1, oriY)
        g.DrawLine(myPen, oriX, oriY + H_lig1, x1, oriY + H_lig1)
        x = oriX : y = oriY + H_lig1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
        msg = "N° prédalles"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Largeur (m)"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Longueur (m)"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Poids (Kg)"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        '      détermination du nombre d'armatures à afficher
        i = 0 : i_tot = 0
        Do
            i = i + 1 'n° de travée
            i1 = i * 10 + 1 'n° de prédalle
            Sortie = 0
            With PlanCont.Item(i - 1)
                i2 = i1
                j1 = 0 : j2 = 0 'indice
                Do
                    Do
                        j2 = j2 + 1
                        If j2 > .Prefa_nb - 1 Then Sortie = 1 : Exit Do
                        i2 = i2 + 1 'n° de prédalle
                    Loop While .Prefa_Lx.Item(j1) = .Prefa_Lx.Item(j2) And .Prefa_Ly.Item(j1) = .Prefa_Ly.Item(j2)
                    If Sortie = 0 Then
                        i_tot = i_tot + 1
                        Affichage_Tab_Predalle(g, i, i1, i2 - 1, j1, j2, i_tot, oriX, oriY, L_col1, L_col2, L_col3, L_col4, H_lig1, H_Lig2, Support)
                        i1 = i2 : j1 = j2
                    Else
                        If j1 <= .Prefa_nb Then
                            i_tot = i_tot + 1
                            Affichage_Tab_Predalle(g, i, i1, i2 - 1, j1, j2, i_tot, oriX, oriY, L_col1, L_col2, L_col3, L_col4, H_lig1, H_Lig2, Support)
                        End If
                    End If
                Loop While Sortie = 0
            End With
        Loop While i < PlanCont.Count
        'toutes les lignes verticales
        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
        g.DrawLine(myPen, oriX, oriY, oriX, y)
        x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
        'Ecritures diverses
        x = CSng(oriX)
        Select Case Support
            Case 1
                y = y + 20
            Case 2
                y = y + 5
            Case 3
                y = y + 5
        End Select
        msg = "Repos prédalle sur appui gauche: " & (PlanCont.Item(0).Prefa_ReposG * 100).ToString("#0.0") & " cm." : w = g.MeasureString(msg, myFont)
        g.DrawString(msg, myFont, myBrush, x, y)
        y = y + w.Height
        msg = "Repos prédalle sur appui droit: " & (PlanCont.Item(0).Prefa_ReposD * 100).ToString("#0.0") & " cm." : w = g.MeasureString(msg, myFont)
        g.DrawString(msg, myFont, myBrush, x, y)
        y = y + 2 * w.Height
        msg = "Espace entre prédalles: " & (PlanCont.Item(0).Prefa_esp * 100).ToString("#0.0") & " cm." : w = g.MeasureString(msg, myFont)
        g.DrawString(msg, myFont, myBrush, x, y)
    End Sub
    '''<summary>Affichage du tableau des TS dans la prédalle</summary>
    ''' <param name="g">transfert de la méthode Graphics.</param>
    '''   <param name="i">n° de travée</param>
    ''' <param name="i1">1ier n° de prédalle - base 10</param>
    ''' <param name="i2">dernier n° de prédalle - base 10</param>
    '''  <param name="j1">1ier n° de prédalle - base 0</param>
    ''' <param name="j2">dernier n° de prédalle - base 0</param>
    Private Sub Affichage_Tab_Predalle(ByVal g As Graphics, ByVal i As Integer, ByVal i1 As Integer, ByVal i2 As Integer, ByVal j1 As Integer, ByVal j2 As Integer, ByVal i_tot As Integer,
                                       ByVal oriX As Single, ByVal oriY As Single, ByVal L_col1 As Single, ByVal L_col2 As Single, ByVal L_col3 As Single, ByVal L_col4 As Single,
                                       ByVal H_lig1 As Single, ByVal H_Lig2 As Single, ByVal Support As Integer)
        Dim myPen As New Pen(Color.Black, 1)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Select Case Support
            Case 1 'écran
                myFont = New Font("Times New Roman", 9, FontStyle.Regular)
            Case 2 'image note de calcul  - 1250x890
                myFont = New Font("Times New Roman", 8, FontStyle.Regular)
            Case 3 'imprimante A4
                myFont = New Font("Times New Roman", 8, FontStyle.Regular)
        End Select

        Dim msg As String
        Dim x, y As Single
        Dim Poids As Double 'longAcier, redw, 
        Dim w As SizeF
        With PlanCont.Item(i - 1)
            '--> n°
            If j2 > .Prefa_nb And j1 < .Prefa_nb Then
                msg = i1.ToString("#") & " à " & i2.ToString("#")
            ElseIf j2 - 1 > j1 Then
                msg = i1.ToString("#") & " à " & i2.ToString("#")
            Else
                msg = i1.ToString("#")
            End If

            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2) : w = g.MeasureString(msg, myFont)
            x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
            '--> Largeur (m)
            msg = .Prefa_Ly.Item(j1).ToString("#0.000")
            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
            w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
            '--> Longueur (m)
            msg = .Prefa_Lx.Item(j1).ToString("#0.000")
            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
            w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
            '--> Poids
            Poids = .Prefa_Ly.Item(j1) * .Prefa_Lx.Item(j1) * .Prefa_h * 24000 / 9.81
            msg = Poids.ToString("#,##0.0") : w = g.MeasureString(msg, myFont)
            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
            x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
        End With
        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
        g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4, y)
    End Sub

#Region "Dessin des prédalles individuelles = Carnet des prédalles"
    '''<summary>Dessin de la prédalle</summary>
    ''' <param name="g">transfert de la méthode Graphics.</param>
    '''   <param name="Support">support = 1 -> écran, =2 ->image, =3 ->imprimante</param>
    ''' <param name="NumTrav">n° de travée</param>
    ''' <param name="NumPredal">n° de prédalle</param>
    Public Sub Predalle(ByVal g As Graphics, ByVal Support As Integer, ByVal largeur As Integer, ByVal Hauteur As Integer, ByVal NumTrav As Integer, ByVal NumPredal As Integer, ByVal Titre As String)
        Dim hauteur_restante, trem_Y As Double '  redH, redW
        Dim i, i1, j, L_col1, L_col2, H_lig1 As Integer ',i_tot, i_tot1, H_Lig2
        Dim X, Y, X1, Y1, X2, X3, oriX, oriY, d5 As Single
        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim myPen As New Pen(Color.Black, 1)
        Dim myPen3 As New Pen(Color.Black, 3)
        Dim myPen2 As New Pen(Color.Black, 2)
        Dim myFont As New Font("Times New Roman", 9, FontStyle.Regular)
        Dim myBrush As New SolidBrush(Color.Black)

        'détermination  origine
        Dim L_tot, H_tot, red As Double
        L_tot = PlanCont(NumTrav - 1).LappG + PlanCont(NumTrav - 1).Lx + PlanCont(NumTrav - 1).LappD
        H_tot = 0
        For i = 1 To PlanCont.Item(0).Prefa_nb
            If H_tot < PlanCont.Item(NumTrav - 1).Prefa_Ly.Item(i - 1) Then H_tot = PlanCont.Item(NumTrav - 1).Prefa_Ly.Item(i - 1)
        Next
        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                'détermination des coefficient de réduction:  lap(0)=0
                ' orix et oriy = angle haut gauche de la prédalle
                red = (largeur * 0.4) / L_tot
                If H_tot * red > 0.8 * Hauteur Then red = (0.8 * Hauteur) / H_tot
                oriX = CSng(0.5 * largeur - red * L_tot)
                hauteur_restante = Hauteur - red * H_tot
                oriY = CSng(hauteur_restante / 2)

                L_col1 = 20 : L_col2 = 300 : H_lig1 = 20 ' : H_Lig2 = 50
            Case 2 ''image 1350 x 900 
                'détermination des coefficient de réduction:  lap(0)=0
                oriX = 15 : oriY = 15
                red = (largeur * 0.6) / L_tot
                If H_tot * red > 0.8 * Hauteur Then red = (0.8 * Hauteur) / H_tot
                oriX = CSng(0.62 * largeur - red * L_tot)
                hauteur_restante = Hauteur - red * H_tot
                oriY = CSng(hauteur_restante / 2)
                L_col1 = 20 : L_col2 = 300 : H_lig1 = 20 ': H_Lig2 = 40
                myPen = New Pen(Color.Black, 1)
                myBrush = New SolidBrush(Color.Black)
            Case 3 'imprimante - Format A4
                L_col1 = 30 : L_col2 = 30 ': L_col3 = 30 : L_col4 = 30
                oriX = largeur - L_col1 - L_col2 '- L_col3 - L_col4 - 10 '200 pixels
                oriY = 5 '5mm
                H_lig1 = 8 ': H_Lig2 = 10
                myPen = New Pen(Color.Black, 0.1)
                myBrush = New SolidBrush(Color.Black)
        End Select
        'Affichage coupe
        j = 0
        'Affichage du titre des prédalles
        myFont = New Font("Times New Roman", 16, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        X = oriX
        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                'détermination des coefficient de réduction:  lap(0)=0
                ' orix et oriy = angle haut gauche de la prédalle
                If oriY > 200 Then Y = CSng(oriY - 200 - w.Height) Else Y = CSng(oriY - w.Height - 30)
            Case 2 'image
                'détermination des coefficient de réduction:  lap(0)=0
                'image 530 x 330
                If oriY > 200 Then Y = CSng(oriY - 200 - w.Height) Else Y = CSng(oriY - w.Height - 30)
            Case 3 'imprimante - Format A4
                'format paysage
                Y = 30
        End Select
        g.DrawString(Titre, myFont, myBrush, X, Y)
        myFont = New Font("Times New Roman", 9, FontStyle.Regular)

        With PlanCont.Item(NumTrav - 1)
            'détermination de la valeur i1
            For i1 = 1 To .Prefa_nb
                If NumPredal = i1 Then i1 -= 1 : Exit For
            Next
            If i1 = .Prefa_nb + 1 Then
                MessageBox.Show("Erreur lors du calcul de l'indice de la prédalle" & Environment.NewLine & "Affichage avec les caractéristiques de la prédalle n°1", "Affichage géométrie prédalles", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                i1 = 0
            End If
            'Dessin de la prédalle
            X = CSng(oriX) : X1 = CSng(oriX + red * (.Prefa_Lx.Item(i1)))
            Y = CSng(oriY) : Y1 = CSng(oriY + red * (.Prefa_Ly.Item(i1)))
            g.DrawLine(myPen, X, Y, X1, Y) : g.DrawLine(myPen, X, Y1, X1, Y1) 'lignes horizontales
            g.DrawLine(myPen, X, Y, X, Y1) : g.DrawLine(myPen, X1, Y, X1, Y1) 'lignes verticales
            'Lignes de côtes
            'cote Lx de la prédalle
            Select Case Support
                Case 1 'écran
                    X2 = 10 : X3 = 20
                Case 2 'image
                    X2 = 10 : X3 = 20
                Case 3 'imprimante - Format A4
                    X2 = 5 : X3 = 10
            End Select
            g.DrawLine(myPen, X - X2, Y - X3, X1 + X2, Y - X3) 'lignes horizontales
            g.DrawLine(myPen, X, Y - X3 - X2, X, Y - X3 + X2) : g.DrawLine(myPen, X1, Y - X3 - X2, X1, Y - X3 + X2) 'lignes verticales
            msg = (.Prefa_Lx.Item(i1) * 100).ToString("#0.0")
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, (X + X1) / 2 - w.Width / 2, Y - X3 - X2 - w.Height)
            'cote Lx des aciers dépassant
            '1ier Lit
            'appui gauche
            Select Case .Type_Acier_Travée
                Case 1
                    X1 = CSng(red * (.TS_trav.Item(0).L13acier - .Prefa_ReposG))
                    msg = ((.TS_trav.Item(0).L13acier - .Prefa_ReposG) * 100).ToString("#0.0")
                Case 2
                    X1 = CSng(red * (.LitInf.Item(0).L13acier - .Prefa_ReposG))
                    msg = ((.LitInf.Item(0).L13acier - .Prefa_ReposG) * 100).ToString("#0.0")
            End Select
            Y = CSng(Y - 2 * X3)
            g.DrawLine(myPen, X - X1 - X2, Y, X + X2, Y) 'lignes horizontales
            g.DrawLine(myPen, X - X1, Y - X2, X - X1, Y + X2) : g.DrawLine(myPen, X, Y - X2, X, Y + X2) 'lignes verticales
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X + w.Width, Y - w.Height / 2)
            'dessin TS et côte sur appui droit
            X = CSng(oriX + red * (.Prefa_Lx.Item(i1)))
            Select Case .Type_Acier_Travée
                Case 1
                    If .TS_trav_Portefeuille.Count = 0 Then
                        X1 = CSng(red * (.TS_trav.Item(0).L23acier - .Prefa_ReposD))
                        msg = ((.TS_trav.Item(0).L23acier - .Prefa_ReposD) * 100).ToString("#0.0")
                    Else
                        X1 = CSng(red * (.TS_trav_Portefeuille.Item(0).L23acier - .Prefa_ReposD))
                        msg = ((.TS_trav_Portefeuille.Item(0).L23acier - .Prefa_ReposD) * 100).ToString("#0.0")
                    End If
                Case 2
                    If .TS_trav_Portefeuille.Count = 0 Then
                        X1 = CSng(red * (.LitInf.Item(0).L23acier - .Prefa_ReposD))
                        msg = ((.LitInf.Item(0).L23acier - .Prefa_ReposD) * 100).ToString("#0.0")
                    Else
                        X1 = CSng(red * (.TS_trav_Portefeuille.Item(0).L23acier - .Prefa_ReposD))
                        msg = ((.TS_trav_Portefeuille.Item(0).L23acier - .Prefa_ReposD) * 100).ToString("#0.0")
                    End If
            End Select
            g.DrawLine(myPen, X - X2, Y, X + X1 + X2, Y) 'lignes horizontales
            g.DrawLine(myPen, X, Y - X2, X, Y + X2) : g.DrawLine(myPen, X + X1, Y - X2, X + X1, Y + X2) 'lignes verticales
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X - 2 * w.Width, Y - w.Height / 2)
            '
            Select Case .Type_Acier_Travée
                Case 1
                    If .TS_trav.Count = 2 Then
                        '2ième Lit
                        With .TS_trav.Item(1)
                            'appui gauche
                            If .L13acier > 0.001 Then
                                X1 = CSng(red * (.L13acier - PlanCont.Item(NumTrav - 1).Prefa_ReposG))
                                Y = CSng(Y - 3 * X3)
                                g.DrawLine(myPen, X - X1 - X2, Y, X + X2, Y) 'lignes horizontales
                                g.DrawLine(myPen, X - X1, Y - X2, X - X1, Y + X2) : g.DrawLine(myPen, X, Y - X2, X, Y + X2) 'lignes verticales
                                msg = ((.L13acier - PlanCont.Item(NumTrav - 1).Prefa_ReposG) * 100).ToString("#0.0")
                                w = g.MeasureString(msg, myFont)
                                g.DrawString(msg, myFont, myBrush, X + w.Width, Y - w.Height / 2)
                            End If
                            'appui droit
                            If .L23acier > 0.001 Then
                                X = CSng(oriX + red * (PlanCont.Item(NumTrav - 1).Prefa_Lx.Item(i1)))
                                X1 = CSng(red * (.L23acier - PlanCont.Item(NumTrav - 1).Prefa_ReposD))
                                g.DrawLine(myPen, X - X2, Y, X + X1 + X2, Y) 'lignes horizontales
                                g.DrawLine(myPen, X, Y - X2, X, Y + X2) : g.DrawLine(myPen, X + X1, Y - X2, X + X1, Y + X2) 'lignes verticales
                                msg = ((.L23acier - PlanCont.Item(NumTrav - 1).Prefa_ReposD) * 100).ToString("#0.0")
                                w = g.MeasureString(msg, myFont)
                                g.DrawString(msg, myFont, myBrush, X - 2 * w.Width, Y - w.Height / 2)
                            End If
                        End With
                    End If
                Case 2
                    If .LitInf.Count = 2 Then
                        '2ième Lit
                        'appui gauche
                        If .LitInf.Item(1).L13acier > 0.001 Then
                            X1 = CSng(red * (.LitInf.Item(0).L13acier - .Prefa_ReposG))
                            Y = CSng(Y - 3 * X3)
                            g.DrawLine(myPen, X - X1 - X2, Y, X + X2, Y) 'lignes horizontales
                            g.DrawLine(myPen, X - X1, Y - X2, X - X1, Y + X2) : g.DrawLine(myPen, X, Y - X2, X, Y + X2) 'lignes verticales
                            msg = ((.LitInf.Item(0).L13acier - .Prefa_ReposG) * 100).ToString("#0.0")
                            w = g.MeasureString(msg, myFont)
                            g.DrawString(msg, myFont, myBrush, X + w.Width, Y - w.Height / 2)
                        End If
                        'appui droit
                        If .LitInf.Item(1).L23acier > 0.001 Then
                            X = CSng(oriX + red * (.Prefa_Lx.Item(i1)))
                            X1 = CSng(red * (.LitInf.Item(0).L23acier - .Prefa_ReposD))
                            g.DrawLine(myPen, X - X2, Y, X + X1 + X2, Y) 'lignes horizontales
                            g.DrawLine(myPen, X, Y - X2, X, Y + X2) : g.DrawLine(myPen, X + X1, Y - X2, X + X1, Y + X2) 'lignes verticales
                            msg = ((.LitInf.Item(0).L23acier - .Prefa_ReposD) * 100).ToString("#0.0")
                            w = g.MeasureString(msg, myFont)
                            g.DrawString(msg, myFont, myBrush, X - 2 * w.Width, Y - w.Height / 2)
                        End If
                    End If
            End Select

            'Côte Ly
            X1 = CSng(oriX + red * (.Prefa_Lx.Item(i1)))
            Y = CSng(oriY)
            g.DrawLine(myPen, X1 + X3, Y, X1 + X3 + 2 * X2, Y) 'lignes horizontales
            g.DrawLine(myPen, X1 + X3, Y1, X1 + X3 + 2 * X2, Y1) 'lignes horizontales
            g.DrawLine(myPen, X1 + X3 + X2, Y - X3, X1 + X3 + X2, Y1 + X3) 'lignes verticales
            msg = (.Prefa_Ly.Item(i1) * 100).ToString("#0.0")
            w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, X1 + X3 + X2 + w.Width / 2, (Y + Y1) / 2 - w.Height / 2)
            'Croix en angle pour  orientation  prédalle
            Select Case Support
                Case 1 'écran
                    X2 = 50 : X3 = 20
                Case 2 'image
                    X2 = 50 : X3 = 20
                Case 3 'imprimante - Format A4
                    X2 = 5 : X3 = 3
            End Select
            X = CSng(oriX + red * (.Prefa_Lx.Item(i1)) - X2)
            Y = CSng(oriY + red * (.Prefa_Ly.Item(i1)) - X2)
            g.DrawLine(myPen2, X, CSng(Y + X3 / 2), X + X3, CSng(Y + X3 / 2)) 'lignes horizontales
            g.DrawLine(myPen2, CSng(X + X3 / 2), Y, CSng(X + X3 / 2), Y + X3)   'lignes verticales
            '________________________________________________________________________________________________________________________________________________________________________________________
            'Dessin des aciers TS: 1ier Lit 
            Select Case .Type_Acier_Travée
                Case 1 'TS
                    X = CSng(oriX + red * (.Prefa_ReposG - .TS_trav.Item(0).L13acier)) : Y = CSng(oriY + red * (.Prefa_Ly.Item(i1) / 2))
                    'si dépassement longueur commerciale
                    If .TS_trav_Portefeuille.Count >= 1 Then
                        X1 = CSng(oriX + red * .TS_trav.Item(0).X2acier)
                    Else
                        X1 = CSng(X1 + red * (- .Prefa_ReposD + .TS_trav.Item(0).L23acier))
                    End If
                Case 2 'HA
                    X = CSng(oriX + red * (.Prefa_ReposG - .LitInf.Item(0).L13acier)) : Y = CSng(oriY + red * (.Prefa_Ly.Item(i1) / 2))
                    X1 = CSng(X1 + red * (- .Prefa_ReposD + .LitInf.Item(0).L23acier))
            End Select
            g.DrawLine(myPen3, X, Y, X1, Y) 'acier principal
            X = CSng(oriX + red * (.Lx / 3))
            Y = CSng(oriY) : Y1 = CSng(oriY + red * .Prefa_Ly.Item(i1))
            g.DrawLine(myPen, X, Y, X, Y1) 'acier de répartition
            'rond indicatif
            Y = CSng(oriY + red * (.Prefa_Ly.Item(i1) / 2))
            msg = "1" : w = g.MeasureString(msg, myFont) : w = g.MeasureString(msg, myFont)
            If w.Width > w.Height Then d5 = w.Width Else d5 = w.Height
            g.FillEllipse(Brushes.White, X - d5 / 2, Y - d5 / 2, d5, d5)
            g.DrawEllipse(myPen, X - d5 / 2, Y - d5 / 2, d5, d5)
            g.DrawString(msg, myFont, myBrush, X - d5 / 4, Y - d5 / 2)
            i = 1 'indice de numérotation des armatures
            Select Case .Type_Acier_Travée
                Case 1 'TS
                    If .TS_trav.Count = 2 Then
                        i = 2 : X = CSng(oriX + red * .Prefa_ReposG) : X1 = CSng(oriX + red * (.Prefa_Lx.Item(i1)))
                        If .Lit2CouvertureTravee = True Then
                            'Dessin des aciers TS avec couverture complète de la travée:  2ième lit
                            If .TS_trav.Item(1).L13acier > .Prefa_ReposG Then X = CSng(oriX + red * (.Prefa_ReposG - .TS_trav.Item(1).L13acier))
                            If .TS_trav.Item(1).L23acier > .Prefa_ReposD Then X1 = CSng(oriX + red * (.Prefa_Lx.Item(i1) - .Prefa_ReposD + .TS_trav.Item(1).L23acier))
                        Else
                            If .TS_trav.Item(1).L13acier > .Prefa_ReposG Then X = CSng(oriX + red * (.Prefa_ReposG - .TS_trav.Item(1).L13acier)) Else X = CSng(oriX + red * (.Prefa_ReposG + .TS_trav.Item(1).X1acier))
                            If .TS_trav.Item(1).L23acier > .Prefa_ReposD Then X1 = CSng(oriX + red * (.Prefa_Lx.Item(i1) - .Prefa_ReposD + .TS_trav.Item(1).L23acier)) Else X = CSng(oriX + red * (.Prefa_ReposG + .TS_trav.Item(1).X2acier))
                            X1 = CSng(oriX + red * (.Prefa_ReposG + .TS_trav.Item(1).X1acier))
                        End If
                    End If
                Case 2
                    If .LitInf.Count = 2 Then
                        i = 2 : X = CSng(oriX + red * .Prefa_ReposG) : X1 = CSng(oriX + red * (.Prefa_Lx.Item(i1)))
                        If .Lit2CouvertureTravee = True Then
                            'Dessin des aciers lit HA avec couverture complète de la travée:  2ième lit
                            If .LitInf.Item(1).L13acier > .Prefa_ReposG Then X = CSng(oriX + red * (.Prefa_ReposG - .LitInf.Item(1).L13acier))
                            If .LitInf.Item(1).L23acier > .Prefa_ReposD Then X1 = CSng(oriX + red * (.Prefa_Lx.Item(i1) - .Prefa_ReposD + .LitInf.Item(1).L23acier))
                        Else
                            If .LitInf.Item(1).L13acier > .Prefa_ReposG Then X = CSng(oriX + red * (.Prefa_ReposG - .LitInf.Item(1).L13acier)) Else X = CSng(oriX + red * (.Prefa_ReposG + .LitInf.Item(1).X1acier))
                            If .LitInf.Item(1).L23acier > .Prefa_ReposD Then X1 = CSng(oriX + red * (.Prefa_Lx.Item(i1) - .Prefa_ReposD + .LitInf.Item(1).L23acier)) Else X1 = CSng(oriX + red * (.Prefa_ReposG + .LitInf.Item(1).X2acier))

                        End If

                    End If
            End Select
            If i = 2 Then 'Pour éviter d'écrire 2 fois
                Y = CSng(oriY + red * (3 * .Prefa_Ly.Item(i1) / 4))
                g.DrawLine(myPen3, X, Y, X1, Y) 'acier principal
                X = CSng(oriX + red * (.Lx / 2))
                Y = CSng(oriY) : Y1 = CSng(oriY + red * .Prefa_Ly.Item(i1))
                g.DrawLine(myPen, X, Y, X, Y1) 'acier de répartition
                'rond indicatif
                Y = CSng(oriY + red * (3 * .Prefa_Ly.Item(i1) / 4))
                Select Case Support
                    Case 1 'écran
                        Y1 = 10  '   X2 = 10 : X3 = 20 : 
                    Case 2 'image
                        Y1 = 10 '   X2 = 10 : X3 = 6 :
                    Case 3 'imprimante - Format A4
                        Y1 = 5 '    X2 = 5 : X3 = 3 : 
                End Select
                msg = "2" : w = g.MeasureString(msg, myFont) : w = g.MeasureString(msg, myFont)
                If w.Width > w.Height Then d5 = w.Width Else d5 = w.Height
                g.FillEllipse(Brushes.White, X - d5 / 2, Y - d5 / 2, d5, d5)
                g.DrawEllipse(myPen, X - d5 / 2, Y - d5 / 2, d5, d5)
                g.DrawString(msg, myFont, myBrush, X - d5 / 4, Y - d5 / 2)
                'dessin de la côte entre le bord gauche de la prédalle et le début de l'acier
                X = CSng(oriX - red * .Prefa_ReposG)
                Y = CSng(oriY + red * (2 * .Prefa_Ly.Item(i1) / 3))
                Select Case .Type_Acier_Travée
                    Case 1
                        If .TS_trav.Item(1).L13acier < 0.02 And .TS_trav.Item(1).X1acier > 0.01 Then
                            X1 = CSng(oriX + red * (.Prefa_ReposG + .TS_trav.Item(1).X1acier))
                            msg = (.TS_trav.Item(1).X1acier * 100).ToString("#")
                        End If
                    Case 2
                        If .LitInf.Item(1).L13acier < 0.02 And .LitInf.Item(1).X1acier > 0.01 Then
                            X1 = CSng(oriX + red * (.Prefa_ReposG + .LitInf.Item(1).X1acier))
                            msg = (.LitInf.Item(1).X1acier * 100).ToString("#")
                        End If
                End Select
                g.DrawLine(myPen, X, Y + Y1, X1, Y + Y1) 'cote horizontale
                g.DrawLine(myPen, X1, Y + Y1 + Y1 / 2, X1, Y + Y1 - Y1 / 2)
                w = g.MeasureString(msg, myFont)
                g.DrawString(msg, myFont, myBrush, (X + X1) / 2 - w.Width / 2, Y + Y1 - w.Height - 1)
            End If
            'Acier complémentaire en cas de dépassement de la longueur commerciale: uniquement pour les TS!!!
            If .TS_trav_Portefeuille.Count >= 1 Then
                Select Case Support
                    Case 1 'écran
                        X2 = 5 : X3 = 10
                    Case 2 'image
                        X2 = 3 : X3 = 6
                    Case 3 'imprimante - Format A4
                        X2 = 1 : X3 = 3
                End Select
                Y = CSng(oriY + red * (.Prefa_Ly.Item(i1) / 2) + X3)
                X = CSng(oriX + red * (.Prefa_ReposG + .TS_trav_Portefeuille.Item(0).X1acier))
                X1 = CSng(oriX + red * (.Lx + .TS_trav_Portefeuille.Item(0).L23acier))
                g.DrawLine(myPen3, X, Y, X1, Y) 'acier principal
                X = CSng(oriX + red * .Lx - 3 * X3)
                Y = CSng(oriY) : Y1 = CSng(oriY + red * .Prefa_Ly.Item(i1))
                g.DrawLine(myPen, X, Y, X, Y1) 'acier de répartition
                'rond indicatif
                Y = CSng(oriY + red * (.Prefa_Ly.Item(i1) / 2) + X3)
                i += 1 : msg = i.ToString : w = g.MeasureString(msg, myFont)
                If w.Width > w.Height Then d5 = w.Width Else d5 = w.Height
                g.FillEllipse(Brushes.White, X - d5 / 2, Y - d5 / 2, d5, d5)
                g.DrawEllipse(myPen, X - d5 / 2, Y - d5 / 2, d5, d5)
                g.DrawString(msg, myFont, myBrush, X - d5 / 4, Y - d5 / 2)
                'dessin de la côte du recouvrement
                Select Case Support
                    Case 1 'écran
                        X2 = 5 : X3 = 20
                    Case 2 'image
                        X2 = 4 : X3 = 6
                    Case 3 'imprimante - Format A4
                        X2 = 2 : X3 = 3
                End Select
                Y = CSng(oriY + red * (.Prefa_Ly.Item(i1) / 2) - X3)
                X = CSng(oriX + red * (.Prefa_ReposG + .TS_trav_Portefeuille.Item(0).X1acier))
                X1 = CSng(oriX + red * (.Prefa_ReposG + .TS_trav.Item(0).X2acier))
                g.DrawLine(myPen, X, Y, X1, Y) 'cote horizontale
                g.DrawLine(myPen, X, Y + X2, X, Y - X2) 'cote verticale
                g.DrawLine(myPen, X1, Y + X2, X1, Y - X2) 'cote verticale
                msg = (Code_Eurocode.Recouvrement_Long_TS(.TS_trav.Item(0).indTS) * 100).ToString("#0")
                w = g.MeasureString(msg, myFont)
                g.DrawString(msg, myFont, myBrush, (X + X1) / 2 - w.Width / 2, Y - w.Height - 1)
            End If


            '______________________________________________________________________________________________________________________________________________________________________________________________________
            'dessin de la trémie et des armatures autour de celle-ci
            'vérification sur l'emplacement des trémies - Hypothèse: 2 trémies ne se trouvent pas strictement au même endroit sur 2 prédalles différentes
            If ._Tremie.Count >= 1 Then
                Dim Ly_AppH As Double = 0
                For i = 1 To NumPredal - 1 'les prédalles comportant des trémies seront de modèle unique
                    Ly_AppH = Ly_AppH + .Prefa_Ly.Item(i - 1) + .Prefa_esp
                Next
                'vérification pour toutes les trémie si ces dernières se trouvent dans la prédalle
                For i = 1 To ._Tremie.Count
                    If ._Tremie.Item(i - 1)._yA > Ly_AppH And ._Tremie.Item(i - 1)._yA < Ly_AppH + .Prefa_Ly.Item(NumPredal - 1) Then
                        'la trémie se trouve dans cette prédalle 
                        'calcul distance entre bord horizontal et trémie
                        trem_Y = Ly_AppH + .Prefa_Ly.Item(NumPredal - 1) - ._Tremie.Item(i - 1)._yA
                        trem_Y = .Prefa_Ly.Item(NumPredal - 1) - trem_Y

                        Call Dessin_Tremie_Predalle(g, Support, myPen, myBrush, myFont, red, oriX, oriY, NumTrav, i, ._Tremie.Item(i - 1)._xA, trem_Y, ._Tremie.Item(i - 1)._Lx,
                                                    ._Tremie.Item(i - 1)._Ly, .Prefa_Lx.Item(NumPredal - 1), .Prefa_Ly.Item(NumPredal - 1), .Prefa_ReposG, ._Tremie.Item(i - 1)._type_chevetre, ._Tremie.Item(i - 1)._HA_Lx.nbar,
                                                    ._Tremie.Item(i - 1)._HA_Lx.L13acier, ._Tremie.Item(i - 1)._HA_Lx.Lacier1, ._Tremie.Item(i - 1)._HA_Ly.nbar, ._Tremie.Item(i - 1)._HA_Ly.L13acier,
                                                    ._Tremie.Item(i - 1)._HA_Ly.Lacier1)
                    End If
                Next
            End If
            Call Affichage_Nomenclature_Acier_Dans_Predalle(g, Support, largeur, Hauteur, NumTrav, NumPredal)

        End With
    End Sub
    '''<summary>Affichage des trémies se trouvant dans la prédalle</summary>
    ''' <param name="g">transfert de la méthode Graphics.</param>
    '''   <param name="Support">support = 1 -> écran, =2 ->image, =3 ->imprimante</param>
    ''' <param name="Trav">n° de travée</param>
    Private Sub Dessin_Tremie_Predalle(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double,
                                    ByVal OriX As Single, ByVal OriY As Single, ByVal trav As Integer, ByVal i_tremie As Integer, ByVal trem_xA As Double, ByVal Trem_Ya As Double, ByVal trem_Lx As Double, ByVal Trem_Ly As Double,
                                       ByVal Prefa_Lx As Double, ByVal Prefa_Ly As Double, ByVal reposG As Double, ByVal type_chevêtre As Integer, ByVal HA_Lx_nbar As Integer,
                                       ByVal HA_Lx_L13acier As Double, ByVal HA_Lx_Lacier1 As Double, ByVal HA_Ly_nbar As Integer, ByVal HA_Ly_L13acier As Double, ByVal HA_Ly_Lacier1 As Double)
        Dim X, Y, X1, Y1, X2, Y2, X3, Y3, X4, Y4 As Single
        Dim j As Integer 'i,
        Dim msg As String
        Dim w As SizeF
        Dim d1, d2 As Single
        Dim myPen2 As New Pen(Color.Black, 2)

        Select Case Support
            Case 1 'écran
                d1 = 50 'pixels
            Case 2 'image virtuelle
                d1 = 50
            Case 3 'Imprimante
                d1 = 10
        End Select
        'dessin partie droite
        g.DrawLine(mypen, CSng(OriX + red * (reposG + trem_xA)), CSng(OriY + red * (Trem_Ya + Trem_Ly)), CSng(OriX + red * (reposG + trem_xA + trem_Lx)), CSng(OriY + red * (Trem_Ya + Trem_Ly))) 'bas
        g.DrawLine(mypen, CSng(OriX + red * (reposG + trem_xA)), CSng(OriY + red * (Trem_Ya)), CSng(OriX + red * (reposG + trem_xA + trem_Lx)), CSng(OriY + red * (Trem_Ya))) 'haut
        g.DrawLine(mypen, CSng(OriX + red * (reposG + trem_xA + trem_Lx)), CSng(OriY + red * (Trem_Ya)), CSng(OriX + red * (reposG + trem_xA + trem_Lx)), CSng(OriY + red * (Trem_Ya + Trem_Ly))) 'droit
        g.DrawLine(mypen, CSng(OriX + red * (reposG + trem_xA)), CSng(OriY + red * (Trem_Ya)), CSng(OriX + red * (reposG + trem_xA)), CSng(OriY + red * (Trem_Ya + Trem_Ly))) 'droit
        'Marquage trémie rectangle trémie
        X1 = CSng(OriX + red * (reposG + trem_xA)) : Y1 = CSng(OriY + red * Trem_Ya)
        X2 = CSng(X1 + red * +trem_Lx) : Y2 = CSng(Y1)
        X3 = X1 + CSng(red * trem_Lx / 3) : Y3 = Y1 + CSng(red * Trem_Ly / 3)
        X4 = X1 : Y4 = CSng(OriY + red * (Trem_Ya + Trem_Ly))
        Dim P1 As New Point(CInt(X1), CInt(Y1))
        Dim P2 As New Point(CInt(X2), CInt(Y2))
        Dim P3 As New Point(CInt(X3), CInt(Y3))
        Dim P4 As New Point(CInt(X4), CInt(Y4))
        Dim curvePoints As Point() = {P1, P2, P3, P4, P1}
        Dim gPath As New GraphicsPath
        curvePoints = {P1, P2, P3, P4, P1}
        gPath.AddPolygon(curvePoints)
        g.FillPath(myBrush, gPath)   ' Fill graphics path to screen.
        'Lignes de côte en X
        Y = CSng(OriY - d1)
        g.DrawLine(mypen, CSng(OriX + red * (reposG + trem_xA)), Y, CSng(OriX + red * Prefa_Lx), Y) 'droite
        g.DrawLine(mypen, CSng(OriX + red * (reposG + trem_xA)), Y - 5, CSng(OriX + red * (reposG + trem_xA)), Y + 5) 'vert
        g.DrawLine(mypen, CSng(OriX + red * (reposG + trem_xA + trem_Lx)), Y - 5, CSng(OriX + red * (reposG + trem_xA + trem_Lx)), Y + 5) 'vert
        g.DrawLine(mypen, CSng(OriX + red * Prefa_Lx), Y - 5, CSng(OriX + red * Prefa_Lx), Y + 5) 'vert
        'longueur trémie
        msg = (trem_Lx * 100).ToString("#")
        w = g.MeasureString(msg, myFont)
        X = CSng(OriX + red * (reposG + trem_xA + trem_Lx / 2) - w.Width / 2)
        g.DrawString(msg, myFont, myBrush, X, Y - w.Height - 1)
        'largeur trémie
        X1 = CSng(Prefa_Lx - trem_Lx - trem_xA - reposG)
        msg = (X1 * 100).ToString("#")
        w = g.MeasureString(msg, myFont)
        X = CSng(OriX + red * (reposG + trem_xA + trem_Lx + X1 / 2) - w.Width / 2)
        g.DrawString(msg, myFont, myBrush, X, Y - w.Height - 1)
        'Lignes de côte en y
        X1 = CSng(OriX + red * Prefa_Lx + d1)
        g.DrawLine(mypen, X1, OriY, X1, CSng(OriY + red * (Trem_Ya + Trem_Ly))) 'vert
        g.DrawLine(mypen, X1 - 5, OriY, X1 + 5, CSng(OriY)) 'H
        g.DrawLine(mypen, X1 - 5, CSng(OriY + red * Trem_Ya), X1 + 5, CSng(OriY + red * Trem_Ya)) 'H
        g.DrawLine(mypen, X1 - 5, CSng(OriY + red * (Trem_Ya + Trem_Ly)), X1 + 5, CSng(OriY + red * (Trem_Ya + Trem_Ly))) 'H
        'longueur trémie
        msg = (Trem_Ya * 100).ToString("#")
        w = g.MeasureString(msg, myFont)
        X = CSng(X1 + 2 - w.Width)
        g.DrawString(msg, myFont, myBrush, X, CSng(OriY + red * Trem_Ya / 2 - w.Height / 2))
        'largeur trémie
        msg = (Trem_Ly * 100).ToString("#")
        w = g.MeasureString(msg, myFont)
        g.DrawString(msg, myFont, myBrush, X, CSng(OriY + red * (Trem_Ya + Trem_Ly / 2) - w.Height / 2))
        ' --> dessin des armatures
        If HA_Lx_nbar >= 1 And type_chevêtre = 2 Then
            'aciers dans la prédalle
            'rectangle trémie - point A
            X1 = CSng(OriX + red * (reposG + trem_xA)) : Y1 = CSng(OriY + red * Trem_Ya) 'point A
            X3 = CSng(OriX + red * (reposG + trem_xA + trem_Lx))
            X2 = CSng(red * trem_Lx / 2) : Y2 = CSng(red * Trem_Ly / 2) 'cotes au milieux de la trémie
            Select Case Support
                Case 1 'écran
                    d1 = 3 : d2 = 4'pixels
                Case 2 'image virtuelle
                    d1 = 3 : d2 = 4
                Case 3 'Imprimante
                    d1 = 3 : d2 = 4
            End Select
            'dessin armature perpendiculaire au sens de la portée
            For j = 1 To HA_Ly_nbar
                g.DrawLine(myPen2, X1 - j * d1, CSng(Y1 + Y2 - red * HA_Ly_Lacier1 / 2), X1 - j * d1, CSng(Y1 + Y2 + red * HA_Ly_Lacier1 / 2)) 'armature Y gauche centrée
                g.DrawLine(myPen2, X3 + j * d1, CSng(Y1 + Y2 - red * HA_Ly_Lacier1 / 2), X3 + j * d1, CSng(Y1 + Y2 + red * HA_Ly_Lacier1 / 2)) 'armature Y droite centrée
            Next
            'dessin trait de cote
            msg = "R2." & trav.ToString("#0") & "." & i_tremie.ToString("#0") : w = g.MeasureString(msg, myFont)
            Y3 = CSng(Y1 + Y2 - red * HA_Ly_Lacier1 / 2) + d1
            g.DrawLine(mypen, X1 - j * d1, Y3, X3 + (j + 1) * d1 + w.Width, Y3) 'trait horizontal
            g.DrawLine(mypen, X1 - (j + 1) * d1, Y3 + d1, X1 + d1, Y3 - d1) 'trait oblique 1
            g.DrawLine(mypen, X3 - d1, Y3 + d1, X3 + (j + 1) * d1, Y3 - d1) 'trait oblique 2
            g.DrawString(msg, myFont, myBrush, X3 + (j + 1) * d1, Y3 - w.Height)
            'dessin armature suivant le sens de la portée
            'l'armature peut être filante ou pas sur la longueur de la travée et va s'ancrer à chaque extrémité
            Y2 = CSng(red * Trem_Ly)
            For j = 1 To HA_Lx_nbar
                'If HA_Lx_Lacier1 >= .Lx Then
                '    'armature filante sur la longueur de la travée
                '    g.DrawLine(myPen2, CSng(X - red * HA_Lx_L13acier), Y1 - i * 3, CSng(X + red * (.Lx + HA_Lx_L13acier)), Y1 - i * 3) 'armature X haute centrée
                '    g.DrawLine(myPen2, CSng(X - red * HA_Lx_L13acier), Y2 + i * 3, CSng(X + red * (.Lx + HA_Lx_L13acier)), Y2 + i * 3) 'armature X basse centrée
                'Else
                'armature centrée sur la longueur de la trémie
                g.DrawLine(myPen2, CSng(X1 + X2 - red * HA_Lx_Lacier1 / 2), Y1 - j * d1, CSng(X1 + X2 + red * HA_Lx_Lacier1 / 2), Y1 - j * d1) 'armature X haute centrée
                g.DrawLine(myPen2, CSng(X1 + X2 - red * HA_Lx_Lacier1 / 2), Y1 + Y2 + j * d1, CSng(X1 + X2 + red * HA_Lx_Lacier1 / 2), Y1 + Y2 + j * d1) 'armature X basse centrée
                'End If
            Next
            'dessin trait de cote
            msg = "R1." & trav.ToString("#0") & "." & i_tremie.ToString("#0") : w = g.MeasureString(msg, myFont)
            Y3 = CSng(Y1 + Y2 / 2)
            X3 = CSng(X1 + X2 + red * HA_Lx_Lacier1 / 2) - d1
            g.DrawLine(mypen, X3 - j * d1, Y3, X3 + j * d1 + w.Width, Y3) 'trait horizontal
            g.DrawLine(mypen, X3, Y1 - j * d1, X3, Y1 + Y2 + j * d1) 'trait vertical
            g.DrawLine(mypen, X3 - d1, Y1 + d1, X3 + d1, Y1 - j * d1) 'trait oblique 1
            g.DrawLine(mypen, X3 - d1, Y1 + Y2 + j * d1, X3 + d1, Y1 + Y2 - d1) 'trait oblique 2
            g.DrawString(msg, myFont, myBrush, X3 + j * d1, Y3 - w.Height)
        End If
    End Sub
    Private Sub Affichage_Nomenclature_Acier_Dans_Predalle(ByVal g As Graphics, ByVal Support As Integer, ByVal largeur As Integer, ByVal Hauteur As Integer, ByVal numtrav As Integer, ByVal NumPredal As Integer)

        Dim msg As String
        Dim myPen As New Pen(Color.Black, 1)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim oriX, oriY, x, x1, y, L_col1, L_col2, L_col3, L_col4, H_lig1, H_Lig2 As Single ', y1, startAngle, sweepAngle
        Dim longAcier, L1 As Double ', redw
        Dim w As SizeF
        Dim i, i_tot1, j As Integer ',i_tot,coupure,  i3,w1 
        'initialisation de variables

        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                'détermination des coefficient de réduction 
                L_col1 = 20 : L_col2 = 270 : L_col3 = 100 : L_col4 = 40
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - 20 '200 pixels
                oriY = 20 '50 pixel
                H_lig1 = 20 : H_Lig2 = 50
            Case 2 'image
                L_col1 = 20 : L_col2 = 255 : L_col3 = 75 : L_col4 = 35
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - 20 '200 pixels
                oriY = 35 '50 pixel
                H_lig1 = 20 : H_Lig2 = 50

            Case 3 'imprimante - Format A4
                L_col1 = 4 : L_col2 = 53 : L_col3 = 18 : L_col4 = 8
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - 20 '200 pixels
                oriY = 10 '50 pixel
                H_lig1 = 4 : H_Lig2 = 10
        End Select

        '----------------------------------------------------------------------------
        '              Affichage des aciers
        '----------------------------------------------------------------------------
        'Affichage coupe
        msg = "NOMENCLATURE DES ACIERS"
        Dim myFont8 As New Font("Times New Roman", 8, FontStyle.Regular)
        Dim myFont As New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        x = oriX : y = CSng(oriY - w.Height - 2)
        g.DrawString(msg, myFont, myBrush, x, y)
        myFont = New Font("Times New Roman", 10, FontStyle.Regular)

        'dessin titre colonnes
        x1 = oriX + L_col1 + L_col2 + L_col3 + L_col4
        g.DrawLine(myPen, oriX, oriY, x1, oriY)
        g.DrawLine(myPen, oriX, oriY + H_lig1, x1, oriY + H_lig1)
        x = oriX : y = oriY + H_lig1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)

        msg = "N°"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Armatures"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Forme"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Nbre"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)

        'détermination du nombre d'armatures à afficher
        'aciers ferraillage supérieur
        With PlanCont.Item(numtrav - 1)
            'acier principal
            Select Case .Type_Acier_Travée
                Case 1
                    i_tot1 = .TS_trav.Count
                Case 2
                    i_tot1 = .LitInf.Count
            End Select

            For j = 1 To i_tot1
                '--> n°
                msg = j.ToString("#")
                y = CSng(oriY + H_lig1 + (j - 1) * H_Lig2 + H_Lig2 / 2) : w = g.MeasureString(msg, myFont)
                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                '--> intitulé
                Select Case .Type_Acier_Travée
                    Case 1
                        msg = " TS " & aci.nomTS(.TS_trav.Item(j - 1).indTS) & " - Largeur: " & (.TS_trav.Item(j - 1).LacierY.Item(NumPredal - 1) * 100).ToString("#0.0") & " - Longueur: " & (.TS_trav.Item(j - 1).Lacier2 * 100).ToString("#0.0")
                    Case 2

                End Select
                y = CSng(oriY + H_lig1 + (j - 1) * H_Lig2 + H_Lig2 / 2)
                w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                '--> Forme
                x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (j - 1) * H_Lig2 + H_Lig2 / 2)
                Select Case .Type_Acier_Travée
                    Case 1
                        longAcier = .TS_trav.Item(j - 1).Lacier2 - .TS_trav.Item(j - 1).L13acier + .Prefa_ReposG - .TS_trav.Item(j - 1).L23acier + .Prefa_ReposD
                        Call Figure8(g, Support, myPen, myBrush, myFont, .TS_trav.Item(j - 1).Lacier2, x, y, 1,  , .TS_trav.Item(j - 1).L13acier - .Prefa_ReposG, .TS_trav.Item(j - 1).L23acier - .Prefa_ReposD,
                                     longAcier)
                    Case 2

                End Select
                '--> Nombre de panneaux
                msg = .TS_trav.Item(j - 1).nbrePanneaux.ToString : w = g.MeasureString(msg, myFont)
                x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                y = CSng(oriY + H_lig1 + j * H_Lig2)
                g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4, y)

            Next
            Dim i_tot As Integer
            i_tot = j - 1
            For i = 1 To .TS_trav_Portefeuille.Count
                '--> n°
                msg = (i_tot1 + i).ToString("#")
                y = CSng(oriY + H_lig1 + (i_tot + i - 1) * H_Lig2 + H_Lig2 / 2) : w = g.MeasureString(msg, myFont)
                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                '--> intitulé
                Select Case .Type_Acier_Travée
                    Case 1
                        msg = " TS " & aci.nomTS(.TS_trav_Portefeuille.Item(i - 1).indTS) & " - Largeur: " & (.TS_trav_Portefeuille.Item(i - 1).LacierY.Item(NumPredal - 1) * 100).ToString("#0.0") & " - Longueur: " & (.TS_trav_Portefeuille.Item(i - 1).Lacier2 * 100).ToString("#0.0")
                    Case 2

                End Select
                y = CSng(oriY + H_lig1 + (i_tot + i - 1) * H_Lig2 + H_Lig2 / 2)
                w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                '--> Forme
                x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_tot + i - 1) * H_Lig2 + H_Lig2 / 2)
                Select Case .Type_Acier_Travée
                    Case 1
                        longAcier = .TS_trav_Portefeuille.Item(i - 1).Lacier2 - .TS_trav_Portefeuille.Item(i - 1).L13acier + .Prefa_ReposG - .TS_trav_Portefeuille.Item(i - 1).L23acier + .Prefa_ReposD
                        Call Figure8(g, Support, myPen, myBrush, myFont, .TS_trav_Portefeuille.Item(i - 1).Lacier2, x, y, 1,  , .TS_trav_Portefeuille.Item(i - 1).L13acier - .Prefa_ReposG,
                                     .TS_trav_Portefeuille.Item(i - 1).L23acier - .Prefa_ReposD, longAcier)
                    Case 2

                End Select
                '--> Nombre de panneaux
                msg = .TS_trav_Portefeuille.Item(i - 1).nbrePanneaux.ToString : w = g.MeasureString(msg, myFont)
                x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                y = CSng(oriY + H_lig1 + (i_tot + i) * H_Lig2)
                g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4, y)
            Next

            i_tot = i_tot1 + .TS_trav_Portefeuille.Count
            'dessin de la trémie et des armatures autour de celle-ci
            'vérification sur l'emplacement des trémies - Hypothèse: 2 trémies ne se trouvent pas strictement au même endroit sur 2 prédalles différentes
            If ._Tremie.Count >= 1 Then
                Dim Ly_AppH As Double = 0
                For i = 1 To NumPredal - 1 'les prédalles comportant des trémies seront de modèle unique
                    Ly_AppH = Ly_AppH + .Prefa_Ly.Item(i - 1) + .Prefa_esp
                Next
                'vérification pour toutes les trémie si ces dernières se trouvent dans la prédalle
                For i = 1 To ._Tremie.Count
                    If ._Tremie.Item(i - 1)._yA > Ly_AppH And ._Tremie.Item(i - 1)._yA < Ly_AppH + .Prefa_Ly.Item(NumPredal - 1) And ._Tremie.Item(i - 1)._type_chevetre = 2 Then
                        'la trémie se trouve dans cette prédalle 
                        '--> n°
                        i_tot = i_tot + 1 : msg = i_tot.ToString("#")
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2) : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> intitulé
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        msg = "R1." & numtrav.ToString & "." & i.ToString("#") & ": " & ._Tremie.Item(i - 1)._HA_Lx.nbar.ToString("#") & "HA " & (._Tremie.Item(i - 1)._HA_Lx.φHA * 1000).ToString("#") & " x " &
                            (._Tremie.Item(i - 1)._HA_Lx.Lacier1).ToString("#0.00")
                        w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> Forme
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        longAcier = ._Tremie.Item(i - 1)._HA_Lx.Lacier1
                        'If ._Tremie.Item(i - 1)._HA_Lx.Lacier1 >= .Lx Then
                        '    'armature filante sur la longueur de la travée
                        '    Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, i1, 6, 1)
                        'Else
                        'armature centrée sur la longueur de la trémie
                        L1 = (._Tremie.Item(i - 1)._HA_Lx.Lacier1 - ._Tremie.Item(i - 1)._Lx) / 2
                        Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, 1,  , L1, L1, ._Tremie.Item(i - 1)._Lx)
                        ' End If
                        '--> Nombre de renforts
                        msg = "2" : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
                        g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4, y)

                        'Affichage armature perpendiculaire au sens de la portée
                        'l'armature peut être filante ou pas sur la longueur de la travée et va s'ancrer à chaque extrémité
                        '--> n°
                        i_tot = i_tot + 1 : msg = i_tot.ToString("#")
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2) : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> intitulé
                        msg = "R2." & numtrav.ToString & "." & i.ToString("#") & ": " & ._Tremie.Item(i - 1)._HA_Ly.nbar.ToString("#") & "HA " & (._Tremie.Item(i - 1)._HA_Ly.φHA * 1000).ToString("#") & " x " &
                                (._Tremie.Item(i - 1)._HA_Ly.Lacier1).ToString("#0.00")
                        w = g.MeasureString(msg, myFont) : y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> Forme
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        longAcier = ._Tremie.Item(i - 1)._HA_Ly.Lacier1
                        'armature centrée sur la longueur de la trémie
                        L1 = (._Tremie.Item(i - 1)._HA_Ly.Lacier1 - ._Tremie.Item(i - 1)._Ly) / 2
                        Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, 1,  , L1, L1, ._Tremie.Item(i - 1)._Ly)
                        '--> Nombre de renfort
                        msg = "2" : w = g.MeasureString(msg, myFont)
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
                        g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4, y)
                    End If
                Next
            End If

            '   y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
            g.DrawLine(myPen, oriX, oriY, oriX, y)
            x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
            x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
            x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
            x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)

            'Ecritures diverses
            x = CSng(oriX)
            Select Case Support
                Case 1
                    y = y + 20
                Case 2
                    y = y + 10
                Case 3
                    y = y + 5
            End Select
            msg = "Repos prédalle sur appui gauche: " & (.Prefa_ReposG * 100).ToString("#0.0") & " cm." : w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, x, y)
            y = y + w.Height
            msg = "Repos prédalle sur appui droit: " & (.Prefa_ReposD * 100).ToString("#0.0") & " cm." : w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, x, y)
            y = y + 2 * w.Height
            msg = "Quantitatifs: " : w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, x, y)
            Dim Vol, Vol1 As Double
            y = y + 2 * w.Height : Vol = .Prefa_h * .Prefa_Lx.Item(NumPredal - 1) * .Prefa_Ly.Item(NumPredal - 1)
            msg = " - Béton prédalle: " & Vol.ToString("#0.000") & " m3." : w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, x, y)
            y = y + w.Height
            Select Case .Type_Acier_Travée
                Case 1
                    Vol1 = aci.Poids_TS(.TS_trav.Item(0).indTS) * .Prefa_Lx.Item(NumPredal - 1) * .TS_trav.Item(0).Lacier2
                    If .TS_trav.Count = 2 Then Vol1 = Vol1 + aci.Poids_TS(.TS_trav.Item(1).indTS) * .Prefa_Lx.Item(NumPredal - 1) * .TS_trav.Item(1).Lacier2
                Case 2

            End Select
            msg = " - Acier: " & Vol1.ToString("#,##0.0") & " kg." : w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, x, y)
            y = y + w.Height
            msg = " - Predalle: " & (Vol * 2100 + Vol1).ToString("#,##0.0") & " kg (Masse unitaire d'une prédalle)" : w = g.MeasureString(msg, myFont)
            g.DrawString(msg, myFont, myBrush, x, y)
        End With
    End Sub
#End Region

    '''<summary>Appel au module d'affichage de la nomenclature des armatures inférieures complémentaires venant sur les prédalles sous forme TS ou HA</summary>
    ''' <param name="g">transfert de la méthode Graphics.</param>
    '''   <param name="Support">support = 1 -> écran, =2 ->image, =3 ->imprimante</param>
    Private Sub Affichage_Nomenclature_Acier_inf_Complementaires_Predalles(ByVal g As Graphics, ByVal Support As Integer, ByVal Niveau As Integer, ByVal largeur As Integer, ByVal Hauteur As Integer)

        Dim msg As String
        Dim myPen As New Pen(Color.Black, 1)
        Dim myBrush As New SolidBrush(Color.Black)
        Dim oriX, oriY, x, x1, y, y1, y2, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2 As Single ', startAngle, sweepAngle
        Dim longAcier, L1 As Double
        Dim w As SizeF
        Dim i, i_tot, i_ligne, i1 As Integer ', j,coupure,  i3,w1
        'initialisation de variables

        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran
                L_col1 = 20 : L_col2 = 250 : L_col3 = 100 : L_col4 = 60 : L_col5 = 40
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 20 '200 pixels
                oriY = 20 '50 pixel
                H_lig1 = 20 : H_Lig2 = 50
            Case 2 'image 1350x890
                L_col1 = 20 : L_col2 = 150 : L_col3 = 65 : L_col4 = 35 : L_col5 = 30 'soit un total avec L_col5 de 370
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 20 '200 pixels
                oriY = 20 '50 pixel
                H_lig1 = 20 : H_Lig2 = 40
                myPen = New Pen(Color.Black, 1)
                myBrush = New SolidBrush(Color.Black)

            Case 3 'imprimante - Format A4
                L_col1 = 8 : L_col2 = 55 : L_col3 = 25 : L_col4 = 10 : L_col5 = 10
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 10 '200 pixels
                oriY = 5 '5mm
                H_lig1 = 8 : H_Lig2 = 10
                myPen = New Pen(Color.Black, 0.1)
                myBrush = New SolidBrush(Color.Black)

        End Select

        '----------------------------------------------------------------------------
        '              Affichage des aciers
        '----------------------------------------------------------------------------
        'Affichage coupe
        msg = "NOMENCLATURE DES ACIERS"
        Dim myFont8 As New Font("Times New Roman", 8, FontStyle.Regular)
        Dim myFont As New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        x = oriX
        Select Case Support
            Case 1
                y = CSng(oriY - w.Height - 2) 'uniquement sur écran ou les titres sont décalés
            Case 2 'image
                y = oriY : oriY = oriY + w.Height + 1
            Case 3 'imprimante
                y = oriY : oriY = oriY + w.Height + 1
        End Select
        g.DrawString(msg, myFont, myBrush, x, y)

        myFont = New Font("Times New Roman", 10, FontStyle.Regular)

        'dessin titre colonnes
        x1 = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5
        g.DrawLine(myPen, oriX, oriY, x1, oriY)
        g.DrawLine(myPen, oriX, oriY + H_lig1, x1, oriY + H_lig1)
        x = oriX : y = oriY + H_lig1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
        msg = "N°"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Armatures"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Forme"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        If Support = 1 Then msg = "Mandrin" Else msg = "DM"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        If Support = 1 Then msg = "Nombre" Else msg = "Nbre"
        w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)

        If Support = 1 Then myFont = New Font("Times New Roman", 10, FontStyle.Regular) Else myFont = New Font("Times New Roman", 8, FontStyle.Regular)
        i_tot = 0 : i_ligne = 0 : y = CSng(oriY + H_lig1 + H_Lig2 / 4)
        For i1 = 1 To PlanCont.Count
            With PlanCont.Item(i1 - 1)
                'acier sur joints entre prédalles
                With .Prefa_TS_joint
                    If .LacierY.Count = 2 Then y1 = 0 Else y1 = H_Lig2 / 4
                    '--> n°
                    i_tot = i_tot + 1 : i_ligne += 1 : msg = i_tot.ToString("#") : w = g.MeasureString(msg, myFont)
                    x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y2 = CSng(y + y1 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y2)
                    '--> intitulé
                    If Support = 1 Then
                        msg = " TS " & aci.nomTS(.indTS) & " - Largeur: " & .LacierY.Item(0).ToString & " -Longueur : " & (.Lacier1).ToString("#0.00")
                    Else
                        msg = " TS " & aci.nomTS(.indTS) & " Larg. " & .LacierY.Item(0).ToString & " Long." & (.Lacier1).ToString("#0.00")
                    End If
                    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y2 = CSng(y + y1 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y2)
                    '--> Forme
                    y1 = H_Lig2 / 4
                    x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y2 = CSng(y + y1)
                    longAcier = .Lacier1
                    'j=5 'aciers sur joints entre prédalles
                    L1 = (.Lacier1 - PlanCont.Item(i1 - 1).Prefa_esp) / 2 'longueur de l'acier sur chaque prédalle
                    Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y2, 5, 1, L1, L1, PlanCont.Item(i1 - 1).Prefa_esp)
                    '--> Mandrin
                    msg = "S.O." : w = g.MeasureString(msg, myFont)
                    x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : y2 = CSng(y + y1 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y2)
                    '--> Nombre de panneaux
                    If .LacierY.Count = 2 Then y1 = 0 Else y1 = H_Lig2 / 4
                    msg = .nbrePanneaux.ToString : w = g.MeasureString(msg, myFont)
                    x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : y2 = CSng(y + y1 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y2)
                    'dans le cas d'un 2ième acier
                    If .LacierY.Count = 2 Then
                        '--> n°
                        i_tot = i_tot + 1 : msg = i_tot.ToString("#") : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y2 = CSng(y + H_Lig2 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y2)
                        '--> intitulé
                        If Support = 1 Then
                            msg = " TS " & aci.nomTS(.indTS) & " - Largeur: " & .LacierY.Item(1).ToString & " -Longueur : " & (.Lacier1).ToString("#0.00")
                        Else
                            msg = " TS " & aci.nomTS(.indTS) & " Larg." & .LacierY.Item(1).ToString & " Long." & (.Lacier1).ToString("#0.00")
                        End If
                        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y2 = CSng(y + H_Lig2 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y2)
                        '--> Nombre de panneaux
                        msg = "1" : w = g.MeasureString(msg, myFont) : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : y2 = CSng(y + H_Lig2 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y2)
                    End If
                End With
                y = CSng(oriY + H_lig1 + (i_ligne) * H_Lig2)

            End With
            g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)
            y = CSng(y + H_Lig2 / 4)
        Next
        'acier secondaire - Appuis haut et bas
        For i1 = 1 To PlanCont.Count
            With PlanCont.Item(i1 - 1)
                'appui haut
                If (.LappH > 0.05 Or .LappB > 0.05) And Aff.EncastPartiel_1_porteur = True Then
                    With .Prefa_TS_RiveLaterale
                        '--> n°
                        i_ligne = i_ligne + 1 : i_tot = i_tot + 1 : msg = i_tot.ToString("#")
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 4) : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> intitulé
                        If Support = 1 Then
                            msg = " TS " & aci.nomTS(.indTS) & " - Largeur: " & .LacierY.Item(0).ToString & " -Longueur : " & (.Lacier1).ToString("#0.00")
                        Else
                            msg = " TS " & aci.nomTS(.indTS) & " Larg. " & .LacierY.Item(0).ToString & " Long." & (.Lacier1).ToString("#0.00")
                        End If
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 4)
                        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> Forme
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 2)
                        longAcier = .Lacier2
                        Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, 4, 1, .L13acier, .X2acier, 1)
                        '--> Mandrin
                        msg = "S.O." : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                        '--> Nombre de panneaux
                        msg = .nbrePanneaux.ToString : w = g.MeasureString(msg, myFont)
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 4)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                        y = CSng(oriY + H_lig1 + i_ligne * H_Lig2)
                        g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)
                        If .LacierY.Count = 2 Then
                            '--> n°
                            i_tot = i_tot + 1 : msg = i_tot.ToString("#")
                            y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + 3 * H_Lig2 / 4) : w = g.MeasureString(msg, myFont)
                            x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                            '--> intitulé
                            If Support = 1 Then
                                msg = " TS " & aci.nomTS(.indTS) & " - Largeur: " & .LacierY.Item(1).ToString & " -Longueur : " & (.Lacier1).ToString("#0.00")
                            Else
                                msg = " TS " & aci.nomTS(.indTS) & " Larg." & .LacierY.Item(1).ToString & " Long." & (.Lacier1).ToString("#0.00")
                            End If
                            y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                            w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                            '--> Nombre de panneaux
                            msg = "1" : w = g.MeasureString(msg, myFont)
                            y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                            x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                        End If
                    End With
                End If
            End With
        Next
        y = CSng(oriY + H_lig1 + i_ligne * H_Lig2)

        'acier de renfort autour des trémies
        For Each dalle As Plancher In PlanCont
            With dalle

                If ._Tremie.Count = 0 Then Continue For 'passage à la travée suivante
                '
                '--> traitement de trémies avec aciers sur prédalles
                For i = 1 To ._Tremie.Count
                    If ._Tremie.Item(i - 1)._HA_Lx.nbar >= 1 And ._Tremie.Item(i - 1)._type_chevetre = 1 Then
                        'Affichage armature suivant le sens de la portée
                        'l'armature peut être filante ou pas sur la longueur de la travée et va s'ancrer à chaque extrémité
                        '--> n°
                        i_ligne = i_ligne + 1 : i_tot = i_tot + 1 : msg = i_tot.ToString("#")
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 4) : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> intitulé
                        msg = "R1_" & (PlanCont.IndexOf(dalle) + 1).ToString & "_" & i.ToString("#") : w = g.MeasureString(msg, myFont)
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 4)
                        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        msg = " HA " & (._Tremie.Item(i - 1)._HA_Lx.φHA * 1000).ToString("#") & " x " & (._Tremie.Item(i - 1)._HA_Lx.Lacier1).ToString("#0.00")
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> Forme
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 2)
                        longAcier = ._Tremie.Item(i - 1)._HA_Lx.Lacier1
                        If ._Tremie.Item(i - 1)._HA_Lx.Lacier1 >= .Lx Then
                            'armature filante sur la longueur de la travée
                            Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, i1, 6, 1)
                        Else
                            'armature centrée sur la longueur de la trémie
                            L1 = (._Tremie.Item(i - 1)._HA_Lx.Lacier1 - ._Tremie.Item(i - 1)._Lx) / 2
                            Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, 3, 1, L1, L1, ._Tremie.Item(i - 1)._Lx)
                        End If
                        '--> Mandrin
                        msg = "S.O." : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                        '--> Nombre de barres
                        msg = ._Tremie.Item(i - 1)._HA_Lx.nbar.ToString : w = g.MeasureString(msg, myFont)
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 2)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                        y = CSng(oriY + H_lig1 + i_ligne * H_Lig2)
                        g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)

                        'Affichage armature perpendiculaire au sens de la portée
                        'l'armature peut être filante ou pas sur la longueur de la travée et va s'ancrer à chaque extrémité
                        '--> n°
                        i_ligne = i_ligne + 1 : i_tot = i_tot + 1 : msg = i_tot.ToString("#")
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 4) : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> intitulé
                        msg = "R2_" & (PlanCont.IndexOf(dalle) + 1).ToString & "_" & i.ToString("#") : w = g.MeasureString(msg, myFont)
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 4)
                        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        msg = " HA " & (._Tremie.Item(i - 1)._HA_Ly.φHA * 1000).ToString("#") & " x " & (._Tremie.Item(i - 1)._HA_Ly.Lacier1).ToString("#0.00")
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                        '--> Forme
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 2)
                        longAcier = ._Tremie.Item(i - 1)._HA_Ly.Lacier1
                        'armature centrée sur la longueur de la trémie
                        L1 = (._Tremie.Item(i - 1)._HA_Ly.Lacier1 - ._Tremie.Item(i - 1)._Ly) / 2
                        Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, 3, 1, L1, L1, ._Tremie.Item(i - 1)._Ly)
                        '--> Nombre de barres
                        msg = ._Tremie.Item(i - 1)._HA_Ly.nbar.ToString : w = g.MeasureString(msg, myFont)
                        y = CSng(oriY + H_lig1 + (i_ligne - 1) * H_Lig2 + H_Lig2 / 2)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                        y = CSng(oriY + H_lig1 + i_ligne * H_Lig2)
                        g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)
                    End If
                Next


            End With
        Next
        g.DrawLine(myPen, oriX, oriY, oriX, y)
        x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
        g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)

        msg = "Toutes les côtes sont indiquées en cm." : w = g.MeasureString(msg, myFont)
        y = y + w.Height
        g.DrawString(msg, myFont, myBrush, oriX, y)
        msg = "Angle de pliage: " & aci.angl_Arma & "°" : w = g.MeasureString(msg, myFont)
        y = y + w.Height
        g.DrawString(msg, myFont, myBrush, oriX, y)
        msg = "Diamètre Ø du mandrin en mm." : w = g.MeasureString(msg, myFont)
        y = y + w.Height
        g.DrawString(msg, myFont, myBrush, oriX, y)

    End Sub

    ''' <summary>Nomenclature des barres HA ou des TS placés en travée </summary>
    ''' <param name="Lacier1">Lacier1 = .item(i).Lacier1</param>
    ''' ''' <param name="LacierY">LacierY = .item(i).LacierY.item(0)</param>
    ''' ''' <param name="IndTS">IndTS = .item(i).IndTS</param>
    ''' <param name="φDM1">φDM1 = .item(i).φDM1</param>
    ''' <param name="L11acier">L11acier = .item(i).L11acier</param>
    ''' <param name="L12Acier">L12Acier = .item(i).L12Acier</param>
    ''' <param name="L13acier">L13acier = .item(i).L13acier</param>
    ''' <param name="nbrePanneaux">nbrePanneaux = .Item(i).nbrePanneaux</param>
    ''' <param name="L21acier">L21acier = .item(i).L21acier</param>
    ''' <param name="L22Acier">L22Acier = .item(i).L22Acier</param>
    ''' <param name="L23acier">L23acier = .item(i).L23acier</param>
    ''' <param name="i1">n° de travée</param>
    ''' <param name="i_Arm">n° de position de l'armature dans le lit inférieur</param>
    Private Sub Nomenclature_Mod_Inf(ByVal g As Graphics, ByVal oriX As Single, ByVal oriY As Single, L_col1 As Single, L_col2 As Single, L_col3 As Single, L_col4 As Single, L_col5 As Single,
                                  H_lig1 As Single, H_Lig2 As Single, ByRef i_tot As Integer, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal myFont8 As Font,
                                   ByVal i1 As Integer, ByVal i_Arm As Integer, ByVal IndTS As Integer, ByVal LacierY As Double, ByVal Lacier1 As Double, ByVal Lacier2 As Double, ByVal L11Acier As Double, ByVal L12Acier As Double, ByVal L13acier As Double,
                                     ByVal L21Acier As Double, ByVal L22Acier As Double, ByVal L23acier As Double, ByVal φDM1 As Double, ByVal φDM2 As Double, ByVal nbrePanneaux As Integer, ByVal Type_Acier As Integer,
                                    ByVal nbar As Integer, ByVal φHA As Double, ByVal Scourant As Double)

        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim x, y As Single
        Dim longAcier As Double
        '--> n°
        i_tot = i_tot + 1 : msg = i_tot.ToString("#")
        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2) : w = g.MeasureString(msg, myFont)
        x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        '--> intitulé
        Select Case Type_Acier
            Case 1 'TS
                If Support = 1 Then
                    msg = "TS " & aci.nomTS(IndTS) & " - Largeur: " & LacierY.ToString("#0.00") & " - Longueur: " & Lacier1.ToString("#0.00")
                Else
                    msg = "TS " & aci.nomTS(IndTS) & " Larg." & LacierY.ToString("#0.00") & " Long." & Lacier1.ToString("#0.00")
                End If
            Case 2 'barres HA
                msg = nbar.ToString & " HA" & (φHA * 1000).ToString("#") & " x " & (Lacier1 * 100).ToString("#") & " - S = " & (Scourant * 100).ToString("#.0")
        End Select
        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
        Select Case Support
            Case 1 'écran
                w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
            Case 2 'image
                w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + 1) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
            Case 3 'imprimante
                w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + 1) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
        End Select
        '--> Forme
        x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
        '--> variable suivant appui
        If L12Acier = 0 And L22Acier = 0 Then
            longAcier = Lacier1
            Select Case Support
                Case 1 'écran
                    Call Figure8(g, Support, mypen, myBrush, myFont, longAcier, x, y, 1, i_Arm, L13acier, L23acier, Lacier2)
                Case 2 'image
                    Call Figure8(g, Support, mypen, myBrush, myFont8, longAcier, x, y, 1, i_Arm, L13acier, L23acier, Lacier2)
                Case 3 'imprimante
                    Call Figure8(g, Support, mypen, myBrush, myFont8, longAcier, x, y, 1, i_Arm, L13acier, L23acier, Lacier2)
            End Select
            '--> Mandrin
            msg = "S.O." : w = g.MeasureString(msg, myFont)
            x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
        End If
        If L12Acier > 0.01 And L22Acier = 0 Then
            longAcier = Lacier1
            Select Case Support
                Case 1 'écran
                    Call Figure6(g, Support, mypen, myBrush, myFont, longAcier, x, y, L11Acier) 'crochet à gauche
                Case 2 'image
                    Call Figure6(g, Support, mypen, myBrush, myFont8, longAcier, x, y, L11Acier) 'crochet à gauche
                Case 3 'imprimante
                    Call Figure6(g, Support, mypen, myBrush, myFont8, longAcier, x, y, L11Acier) 'crochet à gauche
            End Select
            '--> Mandrin
            If Support = 1 Then msg = "Ø = " & (φDM1 * 100).ToString("#.0") & " cm" Else msg = (φDM1 * 100).ToString("#.0")
            Select Case Support
                Case 1 'écran
                    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                Case 2 'image
                    w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont8, myBrush, x, y - w.Height / 2)
                Case 3 'imprimante
                    w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont8, myBrush, x, y - w.Height / 2)
            End Select
        End If
        If L12Acier = 0 And L22Acier > 0.01 Then
            longAcier = Lacier1
            Select Case Support
                Case 1 'écran
                    Call Figure7(g, Support, mypen, myBrush, myFont, longAcier, x, y, L13acier, L21Acier) 'crochet à droite
                Case 2 'image
                    Call Figure7(g, Support, mypen, myBrush, myFont, longAcier, x, y, L13acier, L21Acier) 'crochet à droite
                Case 3 'imprimante
                    Call Figure7(g, Support, mypen, myBrush, myFont, longAcier, x, y, L13acier, L21Acier) 'crochet à droite
            End Select
            '--> Mandrin
            If Support = 1 Then msg = "Ø = " & (φDM2 * 100).ToString("#.0") & " cm" Else msg = (φDM2 * 100).ToString("#.0")
            Select Case Support
                Case 1 'écran
                    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                Case 2 'image
                    w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont8, myBrush, x, y - w.Height / 2)
                Case 3 'imprimante
                    w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont8, myBrush, x, y - w.Height / 2)
            End Select
        End If
        If L12Acier > 0.01 And L22Acier > 0.01 Then
            longAcier = Lacier1
            Select Case Support
                Case 1 'écran
                    Call Figure2(g, Support, mypen, myBrush, myFont, longAcier, x, y, L11Acier, L21Acier) 'crochets à gauche et à droite
                Case 2 'image
                    Call Figure2(g, Support, mypen, myBrush, myFont8, longAcier, x, y, L11Acier, L21Acier) 'crochets à gauche et à droite
                Case 3 'imprimante
                    Call Figure2(g, Support, mypen, myBrush, myFont8, longAcier, x, y, L11Acier, L21Acier) 'crochets à gauche et à droite
            End Select
            '--> Mandrin
            If Support = 1 Then msg = "Ø = " & (φDM1 * 100).ToString("#.0") & " cm" Else msg = (φDM1 * 100).ToString("#.0")
            Select Case Support
                Case 1 'écran
                    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                Case 2 'image
                    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                Case 3 'imprimante
                    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
            End Select
        End If
        If Type_Acier = 1 Then 'TS
            '--> Nombre de panneaux
            msg = nbrePanneaux.ToString : w = g.MeasureString(msg, myFont)
            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
            x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
        End If
        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
        g.DrawLine(mypen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)
    End Sub

    ''' <summary>Affichage dans nomenclature des aciers sur About </summary>
    ''' <param name="i_tot">sert à numéroter le nombre de lignes du tableau</param>
    ''' <param name="i_num">sert à numéroter les aciers</param>
    ''' <param name="L_col1">largeur de la colonne 1</param>
    ''' <param name="L_col2">largeur de la colonne 2</param>
    ''' <param name="L_col3">largeur de la colonne 3</param>
    ''' <param name="L_col4">largeur de la colonne 4</param>
    ''' <param name="L_col5">largeur de la colonne 5, ne s'affiche pas pour les armatures sous forme de TS</param>
    ''' <param name="H_lig1">hauteur de la ligne d'entête</param>
    ''' <param name="H_lig2">hauteur d'une ligne quelconque du tableau sauf de la ligne d'entête</param>
    ''' <param name="Lacier1">Lacier1 = .item(i).Lacier1</param>
    ''' ''' <param name="LacierY0">LacierY0 = .item(i).LacierY.item(0)</param>
    ''' ''' <param name="IndTS">IndTS = .item(i).IndTS</param>
    ''' <param name="φDM1">φDM1 = .item(i).φDM1</param>
    ''' <param name="Lx">Lx = .item(i).Lx</param>
    ''' <param name="X1acier">X1acier = .item(i).X1acier</param>
    ''' <param name="X2acier">X2acier = .item(i).X2acier</param>
    ''' <param name="L11acier">L11acier = .item(i).L11acier</param>
    ''' <param name="L12Acier">L12Acier = .item(i).L12Acier</param>
    ''' <param name="L13acier">L13acier = .item(i).L13acier</param>
    ''' <param name="nbrePanneaux">nbrePanneaux = .Item(i).nbrePanneaux</param>
    ''' <param name="L21acier">L21acier = .item(i).L21acier</param>
    ''' <param name="L22Acier">L22Acier = .item(i).L22Acier</param>
    ''' <param name="L23acier">L23acier = .item(i).L23acier</param>
    ''' <param name="Appui">Appui = 1 si appui gauche, appui = 2 si appui droit</param>
    ''' <param name="branchement">s'il s'agit du 1ier ou 2ieme branchement sur le module</param>
    ''' <param name="Nb_Model">nombre de modèle de panneaux, lorsqu'un panneau TS est recoupé en largeur par exemple</param>
    Private Sub Nomenclature_Mod_Sup_About(ByVal g As Graphics, ByVal oriX As Single, ByVal oriY As Single, L_col1 As Single, L_col2 As Single, L_col3 As Single, L_col4 As Single, L_col5 As Single,
                                  H_lig1 As Single, H_Lig2 As Single, ByRef i_tot As Integer, ByRef i_num As Integer, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal myFont8 As Font,
                                  ByVal L11Acier As Double, ByVal L12Acier As Double, ByVal L13acier As Double, ByVal Lacier1 As Double, ByVal Lacier2 As Double, ByVal LacierY0 As Double, ByVal IndTS As Integer, ByVal φDM1 As Double,
                                   ByVal Lx As Double, ByVal X1acier As Double, ByVal X2acier As Double,
                                  ByVal nbrePanneaux As Integer, ByVal L21Acier As Double, ByVal L22Acier As Double, ByVal L23acier As Double, ByVal Appui As Integer, ByVal Type_Acier As Integer,
                                   ByVal nbar As Integer, ByVal φHA As Double, ByVal Scourant As Double, Optional ByVal branchement As Integer = 1, Optional ByVal Nb_Model As Integer = 1)
        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim x, y As Single
        Dim LongAcier As Double
        If branchement = 2 Then
            i_tot = i_tot
        Else
            i_tot = i_tot + 1
        End If
        '--> n°
        i_num += 1 : msg = i_num.ToString("#0") : w = g.MeasureString(msg, myFont)
        '--> intitulé
        Select Case Type_Acier
            Case 1 'TS
                If Support = 1 Then
                    Select Case Nb_Model
                        Case 1
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                            'Affichage du n°
                            x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                            'Affichage de l'intitulé
                            msg = "TS " & aci.nomTS(IndTS) & " - Largeur: " & LacierY0.ToString("#0.00") & " - Longueur : " & Lacier1.ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        Case 2
                            If branchement = 1 Then
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                msg = "TS " & aci.nomTS(IndTS) & " - Largeur: " & LacierY0.ToString("#0.00") & " - Longueur : " & Lacier1.ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            Else
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                msg = "         Largeur: " & LacierY0.ToString("#0.00")
                            End If
                    End Select
                Else
                    Select Case Nb_Model
                        Case 1
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                            'Affichage du n°
                            x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                            'Affichage de l'intitulé
                            msg = "TS " & aci.nomTS(IndTS) & " Larg." & LacierY0.ToString("#0.00") & " Long." & Lacier1.ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        Case 2
                            If branchement = 1 Then
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                msg = "TS " & aci.nomTS(IndTS) & " Larg." & LacierY0.ToString("#0.00") & " Long." & Lacier1.ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            Else
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                msg = "         Largeur: " & LacierY0.ToString("#0.00")
                            End If
                    End Select
                End If
            Case 2 'HA
                'Affichage du n°
                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                'Affichage de l'intitulé
                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                msg = nbar.ToString & " HA" & (φHA * 1000).ToString("#") & " x " & (Lacier1 * 100).ToString("#") & " - S = " & (Scourant * 100).ToString("#.0") : w = g.MeasureString(msg, myFont)
        End Select
        'affichage du texte différent suivant le support
        Select Case Support
            Case 1 'écran
                w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
            Case 2 'image
                w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + 1) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
            Case 3 'imprimante
                w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + 1) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
        End Select
        '--> affichage forme
        If (Type_Acier = 1 And branchement = 1) Or Type_Acier = 2 Then 'pour éviter d'écrire 2 fois avec les TS
            '--> Forme
            x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
            '--> variable suivant appui
            Select Case Appui
                Case 1 'appui gauche
                    If L12Acier = 0 Then
                        LongAcier = Lacier1
                        Select Case Support
                            Case 1 'écran
                                Call Figure8(g, Support, mypen, myBrush, myFont, LongAcier, x, y, 4, 1, L13acier, X2acier, 1)', 0)
                            Case 2 'image
                                Call Figure8(g, Support, mypen, myBrush, myFont8, LongAcier, x, y, 4, 1, L13acier, X2acier, 1)', 0)
                            Case 3 'imprimante
                                Call Figure8(g, Support, mypen, myBrush, myFont8, LongAcier, x, y, 4, 1, L13acier, X2acier, 1) ', 0)
                        End Select
                        '--> Mandrin
                        msg = "S.O." : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                    End If
                    If L12Acier > 0.01 Then
                        LongAcier = Longueur_Acier_Droit(φDM1, L13acier, X2acier, φHA)
                        Select Case Support
                            Case 1 'écran
                                Figure10(g, Support, mypen, myBrush, myFont, LongAcier, x, y, L11Acier)  'crochet gauche
                            Case 2 'image
                                Figure10(g, Support, mypen, myBrush, myFont8, LongAcier, x, y, L11Acier) 'crochet gauche
                            Case 3 'imprimante
                                Figure10(g, Support, mypen, myBrush, myFont8, LongAcier, x, y, L11Acier) 'crochet gauche
                        End Select
                        '--> Mandrin
                        If Support = 1 Then msg = "Ø = " & (φDM1 * 1000).ToString("#0") & " mm" Else msg = (φDM1 * 1000).ToString("#0")
                        w = g.MeasureString(msg, myFont8)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont8, myBrush, x, y - w.Height / 2)
                    End If
                Case 2 'appui droit

                    If L22Acier = 0 Then
                        LongAcier = Lacier1
                        Select Case Support
                            Case 1 'écran
                                Call Figure8(g, Support, mypen, myBrush, myFont, LongAcier, x, y, 4, 1, L23acier, Lacier2, 2)
                            Case 2 'image
                                Call Figure8(g, Support, mypen, myBrush, myFont8, LongAcier, x, y, 4, 1, L23acier, Lacier2, 2)
                            Case 3 'imprimante
                                Call Figure8(g, Support, mypen, myBrush, myFont8, LongAcier, x, y, 4, 1, L23acier, Lacier2, 2)
                        End Select
                        '--> Mandrin
                        msg = "S.O." : w = g.MeasureString(msg, myFont)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
                    End If
                    If L22Acier > 0.01 Then
                        LongAcier = Longueur_Acier_Droit(φDM1, L23acier, Lx - X1acier, φHA)
                        Select Case Support
                            Case 1 'écran
                                Call Figure9(g, Support, mypen, myBrush, myFont, LongAcier, x, y, L21Acier) 'crochet droit
                            Case 2 'image
                                Call Figure9(g, Support, mypen, myBrush, myFont8, LongAcier, x, y, L21Acier) 'crochet droit
                            Case 3 'imprimante
                                Call Figure9(g, Support, mypen, myBrush, myFont8, LongAcier, x, y, L21Acier) 'crochet droit
                        End Select
                        '--> Mandrin
                        If Support = 1 Then msg = "Ø = " & (φDM1 * 1000).ToString("#0") & " mm" Else msg = (φDM1 * 1000).ToString("#0")
                        w = g.MeasureString(msg, myFont8)
                        x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont8, myBrush, x, y - w.Height / 2)
                    End If
            End Select
        End If


        '--> Nombre de panneaux
        If Type_Acier = 1 Then 'uniquement pour TS
            If branchement = 1 Then msg = nbrePanneaux.ToString("#0") Else msg = nbrePanneaux.ToString("1") 'le nbre de panneaux n'a pas été calculé, a faire dans ue prochaine version
            w = g.MeasureString(msg, myFont)
            x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2)
            Select Case Nb_Model
                Case 1
                    y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                Case 2
                    If branchement = 1 Then
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                    Else
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                    End If
            End Select
            g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
        End If
        y = CSng(oriY + H_lig1 + (i_tot) * H_Lig2)
        g.DrawLine(mypen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)
    End Sub
    Private Function Longueur_Acier_Droit(ByVal φDM As Double, ByVal L3 As Double, ByVal X2acier As Double, ByVal φHA As Double) As Double
        Longueur_Acier_Droit = φDM / 2 + L3 + X2acier + φHA
    End Function
    ''' <summary>Affichage dans nomenclature des aciers sur Appuis intermédiaires </summary>
    ''' <param name="Lacier1">Lacier1 = .item(i).Lacier1</param>
    ''' <param name="i_tot">sert à numéroter le nombre de lignes du tableau</param>
    ''' <param name="i_num">sert à numéroter les aciers</param>
    ''' <param name="IndTS">IndTS = .item(i).IndTS</param>
    ''' <param name="nbrePanneaux">nbrePanneaux = .Item(i).nbrePanneaux</param>
    ''' <param name="L_col1">largeur de la colonne 1</param>
    ''' <param name="L_col2">largeur de la colonne 2</param>
    ''' <param name="L_col3">largeur de la colonne 3</param>
    ''' <param name="L_col4">largeur de la colonne 4</param>
    ''' <param name="L_col5">largeur de la colonne 5, ne s'affiche pas pour les armatures sous forme de TS</param>
    ''' <param name="H_lig1">hauteur de la ligne d'entête</param>
    ''' <param name="H_lig2">hauteur d'une ligne quelconque du tableau sauf de la ligne d'entête</param>
    ''' <param name="branchement">s'il s'agit du 1ier ou 2ieme branchement sur le module</param>
    ''' <param name="Nb_Model">nombre de modèle de panneaux, lorsqu'un panneau TS est recoupé en largeur par exemple</param>
    Private Sub Nomenclature_Mod_Sup_Intermediaire(ByVal g As Graphics, ByVal oriX As Single, ByVal oriY As Single, L_col1 As Single, L_col2 As Single, L_col3 As Single, L_col4 As Single, L_col5 As Single,
                                  H_lig1 As Single, H_Lig2 As Single, ByRef i_tot As Integer, ByRef i_num As Integer, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal myFont8 As Font,
                                 ByVal i As Integer, ByVal i1 As Integer, ByVal i2 As Integer, ByVal IndTS As Integer, ByVal Lacier1 As Double, ByVal Lacier2 As Double, ByVal Lacier2p As Double, ByVal LappD As Double,
                                 ByVal nbrePanneaux As Integer, ByVal Type_Acier As Integer, ByVal nbar As Integer, ByVal φHA As Double, ByVal Scourant As Double, Optional ByVal branchement As Integer = 1, Optional ByVal Nb_Model As Integer = 1)

        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim x, y As Single
        Dim longAcier As Double
        Dim L1, L2 As Double
        If branchement = 2 Then
            i_tot = i_tot
        Else
            i_tot = i_tot + 1
        End If
        '--> n°
        i_num += 1 : msg = i_num.ToString("#0") : w = g.MeasureString(msg, myFont)
        x = CSng(oriX + L_col1 / 2 - w.Width / 2)
        '--> intitulé
        Select Case Type_Acier
            Case 1 'TS
                If Support = 1 Then
                    Select Case Nb_Model
                        Case 1
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                            'Affichage du n°
                            y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                            'Affichage de l'intitulé
                            msg = "TS " & aci.nomTS(IndTS) & " - Largeur: " & PlanCont.Item(i1).TS_AppG.Item(i - 1).LacierY.Item(i2).ToString("#0.00") & "  - Longueur: " & (Lacier1).ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        Case 2
                            If branchement = 1 Then
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                'Affichage du n°
                                y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                msg = "TS " & aci.nomTS(IndTS) & " - Largeur: " & PlanCont.Item(i1).TS_AppG.Item(i - 1).LacierY.Item(i2).ToString("#0.00") & "  - Longueur: " & (Lacier1).ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            Else
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                msg = "         Largeur: " & PlanCont.Item(i1).TS_AppG.Item(i - 1).LacierY.Item(i2).ToString("#0.00")
                            End If
                    End Select
                Else
                    Select Case Nb_Model
                        Case 1
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                            'Affichage du n°
                            y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                            'Affichage de l'intitulé
                            msg = "TS " & aci.nomTS(IndTS) & " Larg." & PlanCont.Item(i1).TS_AppG.Item(i - 1).LacierY.Item(i2).ToString("#0.00") & " Long. " & (Lacier1).ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        Case 2
                            If branchement = 1 Then
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                'Affichage du n°
                                y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                msg = "TS " & aci.nomTS(IndTS) & " Larg." & PlanCont.Item(i1).TS_AppG.Item(i - 1).LacierY.Item(i2).ToString("#0.00") & " Long." & (Lacier1).ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            Else
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                msg = "         Largeur: " & PlanCont.Item(i1).TS_AppG.Item(i - 1).LacierY.Item(i2).ToString("#0.00")
                            End If
                    End Select
                End If
                longAcier = Lacier1
                L1 = Lacier2
                L2 = Lacier2p
            Case 2 'HA
                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                'Affichage du n°
                y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                'Affichage de l'intitulé
                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                msg = nbar.ToString & " HA" & (φHA * 1000).ToString("#") & " x " & (PlanCont.Item(i1 - 1).LitSupD.Item(i - 1).Lacier1 * 100).ToString("#0") & " - S = " & (Scourant * 100).ToString("#0.0")
                longAcier = PlanCont.Item(i1 - 1).LitSupD.Item(i - 1).Lacier1
                L1 = PlanCont.Item(i1 - 1).Lx - PlanCont.Item(i1 - 1).LitSupD.Item(i - 1).X1acier
                L2 = PlanCont.Item(i1).LitSupG.Item(i - 1).X2acier
        End Select
        'Affichage différent suivant le support
        Select Case Support
            Case 1 'écran
                w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
            Case 2 'image
                w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + 1) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
            Case 3 'imprimante
                w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + 1) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
        End Select
        'Affichage Forme et mandrin
        If (Type_Acier = 1 And branchement = 1) Or Type_Acier = 2 Then 'pour éviter d'écrire 2 fois avec les TS  If Complement = 0 Then
            '--> Forme
            x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
            Select Case Support
                Case 1 'écran
                    Call Figure8(g, Support, mypen, myBrush, myFont, longAcier, x, y, 3, 1, L1, L2, LappD)', Lacier2, Lacier2p, LappD, L2 est sur le côté droit de la figure
                Case 2 'image
                    Call Figure8(g, Support, mypen, myBrush, myFont8, longAcier, x, y, 3, 1, L1, L2, LappD)
                Case 3 'imprimante
                    Call Figure8(g, Support, mypen, myBrush, myFont8, longAcier, x, y, 3, 1, L1, L2, LappD)
            End Select

            '--> Mandrin
            msg = "S.O." : w = g.MeasureString(msg, myFont)
            x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
        End If

        '--> Nombre de panneaux
        If Type_Acier = 1 Then
            If branchement = 1 Then msg = nbrePanneaux.ToString("#0") Else msg = nbrePanneaux.ToString("1") 'le nbre de panneaux n'a pas été calculé, a faire dans ue prochaine version
            w = g.MeasureString(msg, myFont)
            x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2)
            Select Case Nb_Model
                Case 1
                    y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                Case 2
                    If branchement = 1 Then
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                    Else
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                    End If
            End Select
            g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
        End If
        '-->tracée de la fermeture du tableau
        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
        g.DrawLine(mypen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)
    End Sub
    ''' <summary>Affichage dans nomenclature des aciers sur Appuis haut et bas </summary>
    ''' <param name="Lacier1">Lacier1 = .item(i).Lacier1</param>
    ''' ''' <param name="LacierY">LacierY0 = .item(i).LacierY.item(0)</param>
    ''' <param name="IndTS">IndTS = .item(i).IndTS</param>
    ''' <param name="φDM1">φDM1 = .item(i).φDM1</param>
    ''' <param name="L11acier">L11acier = .item(i).L11acier</param>
    ''' <param name="L12Acier">L12Acier = .item(i).L12Acier</param>
    ''' <param name="L13acier">L13acier = .item(i).L13acier</param>
    ''' <param name="nbrePanneaux">nbrePanneaux = .Item(i).nbrePanneaux</param>
    ''' <param name="i_tot">sert à numéroter le nombre de lignes du tableau</param>
    ''' <param name="i_num">sert à numéroter les aciers</param>
    ''' <param name="L_col1">largeur de la colonne 1</param>
    ''' <param name="L_col2">largeur de la colonne 2</param>
    ''' <param name="L_col3">largeur de la colonne 3</param>
    ''' <param name="L_col4">largeur de la colonne 4</param>
    ''' <param name="L_col5">largeur de la colonne 5, ne s'affiche pas pour les armatures sous forme de TS</param>
    ''' <param name="H_lig1">hauteur de la ligne d'entête</param>
    ''' <param name="H_lig2">hauteur d'une ligne quelconque du tableau sauf de la ligne d'entête</param>
    ''' <param name="branchement">s'il s'agit du 1ier ou 2ieme branchement sur le module</param>
    ''' <param name="Nb_Model">nombre de modèle de panneaux, lorsqu'un panneau TS est recoupé en largeur par exemple</param>
    Private Sub Nomenclature_Mod_Sup_HB(ByVal g As Graphics, ByVal oriX As Single, ByVal oriY As Single, L_col1 As Single, L_col2 As Single, L_col3 As Single, L_col4 As Single, L_col5 As Single,
                                  H_lig1 As Single, H_Lig2 As Single, ByRef i_tot As Integer, ByRef i_num As Integer, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal myFont8 As Font,
                                   ByVal IndTS As Integer, ByVal Lacier1 As Double, ByVal Lacier2 As Double, ByVal LacierY As Double,
                                  ByVal L11Acier As Double, ByVal L12Acier As Double, ByVal L13acier As Double, ByVal nbrePanneaux As Integer, ByVal φDM1 As Double,
                                         ByVal Type_Acier As Integer, ByVal nbar As Integer, ByVal φHA As Double, ByVal Scourant As Double, Optional ByVal branchement As Integer = 1, Optional ByVal Nb_Model As Integer = 1)
        Dim msg As String = String.Empty
        Dim w As SizeF
        Dim x, y As Single
        Dim longAcier As Double
        If branchement = 2 Then
            i_tot = i_tot
        Else
            i_tot = i_tot + 1
        End If
        '--> n°
        i_num += 1 : msg = i_num.ToString("#0") : w = g.MeasureString(msg, myFont)
        '--> intitulé
        Select Case Type_Acier
            Case 1 'TS
                If Support = 1 Then
                    Select Case Nb_Model
                        Case 1
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                            'Affichage du n°
                            x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                            'Affichage de l'intitulé
                            msg = "TS " & aci.nomTS(IndTS) & " - Largeur: " & LacierY.ToString("#0.00") & " - Longueur : " & Lacier1.ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        Case 2
                            If branchement = 1 Then
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                msg = "TS " & aci.nomTS(IndTS) & " - Largeur: " & LacierY.ToString("#0.00") & " - Longueur : " & Lacier1.ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            Else
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                msg = "         Largeur: " & LacierY.ToString("#0.00")
                            End If
                    End Select
                Else
                    Select Case Nb_Model
                        Case 1
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                            'Affichage du n°
                            x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                            'Affichage de l'intitulé
                            msg = "TS " & aci.nomTS(IndTS) & " Larg." & LacierY.ToString("#0.00") & " Long." & Lacier1.ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                        Case 2
                            If branchement = 1 Then
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                                msg = "TS " & aci.nomTS(IndTS) & " Larg." & LacierY.ToString("#0.00") & " Long." & Lacier1.ToString("#0.00") : w = g.MeasureString(msg, myFont)
                            Else
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                'Affichage du n°
                                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                                'Affichage de l'intitulé
                                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                                msg = "         Largeur: " & LacierY.ToString("#0.00")
                            End If
                    End Select
                End If
            Case 2 'HA
                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                'Affichage du n°
                x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
                'Affichage de l'intitulé
                y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                msg = nbar.ToString & " HA" & (φHA * 1000).ToString("#") & " x " & (Lacier1 * 100).ToString("#") & " - S = " & (Scourant * 100).ToString("#.0") : w = g.MeasureString(msg, myFont)
        End Select
        'affichage du texte différent suivant le support
        Select Case Support
            Case 1 'écran
                w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + 2) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
            Case 2 'image
                w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + 1) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
            Case 3 'imprimante
                w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + 1) : y = CSng(y - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
        End Select
        '--> affichage forme
        If (Type_Acier = 1 And branchement = 1) Or Type_Acier = 2 Then 'pour éviter d'écrire 2 fois avec les TS
            '--> Forme
            x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2) : y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
            longAcier = Lacier1
            If L12Acier = 0 Then
                Select Case Support
                    Case 1 'écran
                        Call Figure8(g, Support, mypen, myBrush, myFont, longAcier, x, y, 4, 1, L13acier, Lacier2, 1)
                    Case 2 'image
                        Call Figure8(g, Support, mypen, myBrush, myFont8, longAcier, x, y, 4, 1, L13acier, Lacier2, 1)
                    Case 3 'imprimante
                        Call Figure8(g, Support, mypen, myBrush, myFont8, longAcier, x, y, 4, 1, L13acier, Lacier2, 1)
                End Select
                '--> Mandrin
                msg = "S.O." : w = g.MeasureString(msg, myFont)
                x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
            End If
            If L12Acier > 0.01 Then
                longAcier = Longueur_Acier_Droit(φDM1, L13acier, Lacier2, φHA)
                Select Case Support
                    Case 1 'écran
                        Figure10(g, Support, mypen, myBrush, myFont, longAcier, x, y, L11Acier) 'crochet gauche
                    Case 2 'image
                        Figure10(g, Support, mypen, myBrush, myFont8, longAcier, x, y, L11Acier) 'crochet gauche
                    Case 3 'imprimante
                        Figure10(g, Support, mypen, myBrush, myFont8, longAcier, x, y, L11Acier) 'crochet gauche
                End Select
                '--> Mandrin
                If Support = 1 Then msg = "Ø = " & (φDM1 * 1000).ToString("#0") & " mm" Else msg = (φDM1 * 1000).ToString("#0") : 
                w = g.MeasureString(msg, myFont8)
                x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : g.DrawString(msg, myFont8, myBrush, x, y - w.Height / 2)
            End If
        End If
        '--> Nombre de panneaux
        If Type_Acier = 1 Then 'uniquement pour TS
            '--> Nombre de panneaux
            msg = nbrePanneaux.ToString("#0") '  If branchement = 1 Then msg = nbrePanneaux.ToString("#0") Else msg = nbrePanneaux.ToString("1") 'le nbre de panneaux n'a pas été calculé, a faire dans ue prochaine version
            w = g.MeasureString(msg, myFont)
            x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2)
            Select Case Nb_Model
                Case 1
                    y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 2)
                Case 2
                    If branchement = 1 Then
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + H_Lig2 / 4)
                    Else
                        y = CSng(oriY + H_lig1 + (i_tot - 1) * H_Lig2 + 3 * H_Lig2 / 4)
                    End If
            End Select
            g.DrawString(msg, myFont, myBrush, x, y - w.Height / 2)
        End If
        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
        g.DrawLine(mypen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)
    End Sub

    '''<summary>Appel au module d'affichage de la nomenclature d'armatures de barres HA</summary>
    ''' <param name="g">transfert de la méthode Graphics.</param>
    '''   <param name="Support">support = 1 -> écran, =2 ->image, =3 ->imprimante</param>
    '''  <param name="Niveau">=1 aciers inférieurs/ =2 aciers supérieurs/ =3 ....</param> 
    Private Sub Affichage_Nomenclature_Acier(ByVal g As Graphics, ByVal Support As Integer, ByVal Niveau As Integer, ByVal largeur As Integer, ByVal Hauteur As Integer)

        Dim msg As String
        Dim myBrush As New SolidBrush(Color.Black)
        Dim myPen As New Pen(Color.Black)
        Dim oriX, oriY, x, x1, y, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2 As Single
        Dim w As SizeF
        Dim i, i_tot, i_num, i1, i2, i3, i4 As Integer 'i_ligne,
        'initialisation de variables

        'support = 1 -> écran, =2 ->image, =3 ->imprimante
        Select Case Support
            Case 1 'écran 
                L_col1 = 20 : L_col2 = 250 : L_col3 = 100 : L_col4 = 60 : L_col5 = 0
                For Each dalle As Plancher In PlanCont
                    If dalle.TS_trav.Count >= 1 OrElse dalle.TS_AppB.Count >= 1 OrElse dalle.TS_AppD.Count >= 1 OrElse dalle.TS_AppG.Count >= 1 OrElse dalle.TS_AppH.Count >= 1 Then L_col5 = 40 : Exit For
                Next
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 20 '200 pixels
                oriY = 20 '50 pixel
                H_lig1 = 20 : H_Lig2 = 50
                myPen = New Pen(Color.Black, 1)
                myBrush = New SolidBrush(Color.Black)
            Case 2 'image 1350x890
                L_col1 = 20 : L_col2 = 150 : L_col3 = 65 : L_col4 = 35 : L_col5 = 0 'soit un total avec L_col5 de 370
                For Each dalle As Plancher In PlanCont
                    If dalle.TS_trav.Count >= 1 OrElse dalle.TS_AppB.Count >= 1 OrElse dalle.TS_AppD.Count >= 1 OrElse dalle.TS_AppG.Count >= 1 OrElse dalle.TS_AppH.Count >= 1 Then L_col5 = 30 : Exit For
                Next
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 20 '200 pixels
                oriY = 20 '50 pixel
                H_lig1 = 20 : H_Lig2 = 40
                myPen = New Pen(Color.Black, 1)
                myBrush = New SolidBrush(Color.Black)

            Case 3 'imprimante - Format A4
                L_col1 = 8 : L_col2 = 55 : L_col3 = 25 : L_col4 = 10 : L_col5 = 0
                For Each dalle As Plancher In PlanCont
                    If dalle.TS_trav.Count >= 1 OrElse dalle.TS_AppB.Count >= 1 OrElse dalle.TS_AppD.Count >= 1 OrElse dalle.TS_AppG.Count >= 1 OrElse dalle.TS_AppH.Count >= 1 Then L_col5 = 10 : Exit For
                Next
                oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 10 '200 pixels
                oriY = 5 '5mm
                H_lig1 = 8 : H_Lig2 = 10
                myPen = New Pen(Color.Black, 0.1)
                myBrush = New SolidBrush(Color.Black)
        End Select

        '----------------------------------------------------------------------------
        '              Affichage des aciers
        '----------------------------------------------------------------------------
        'Affichage coupe
        msg = "NOMENCLATURE DES ARMATURES"
        Dim myFont8 As New Font("Times New Roman", 8, FontStyle.Regular)
        Dim myFont As New Font("Times New Roman", 10, FontStyle.Bold)
        w = g.MeasureString(msg, myFont)
        x = oriX
        Select Case Support
            Case 1
                y = CSng(oriY - w.Height - 2) 'uniquement sur écran ou les titres sont décalés
            Case 2 'image
                y = oriY : oriY = oriY + w.Height + 1
            Case 3 'imprimante
                y = oriY : oriY = oriY + w.Height + 1
        End Select
        g.DrawString(msg, myFont, myBrush, x, y)
        myFont = New Font("Times New Roman", 10, FontStyle.Regular)

        'dessin titre colonnes
        x1 = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5
        g.DrawLine(myPen, oriX, oriY, x1, oriY)
        g.DrawLine(myPen, oriX, oriY + H_lig1, x1, oriY + H_lig1)
        x = oriX : y = oriY + H_lig1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
        msg = "N°"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Armatures"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        msg = "Forme"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        If Support = 1 Then msg = "Mandrin" Else msg = "DM"
        w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
        If L_col5 > 1 Then
            If Support = 1 Then msg = "Nombre" Else msg = "Nbre"
            w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
        End If

        'détermination du nombre d'armatures à afficher
        Select Case Niveau
            Case 1 'aciers du ferraillage inférieur
                i_tot = 0 'sert à dertminer le nombre de lignes que doit afficher le tableau. Pour ce cas, nbre de lignes =  nbre d'armatures
                For i1 = 1 To PlanCont.Count
                    With PlanCont.Item(i1 - 1)
                        'Soit TS
                        With .TS_trav
                            For i = 1 To .Count
                                ' i_ligne = i_ligne + 1
                                Call Nomenclature_Mod_Inf(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
                                                 i1, i, .Item(i - 1).indTS, .Item(i - 1).LacierY.Item(0), .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, .Item(i - 1).L11acier, .Item(i - 1).L12acier, .Item(i - 1).L13acier,
                                                .Item(i - 1).L21acier, .Item(i - 1).L22acier, .Item(i - 1).L23acier, .Item(i - 1).φDM1, .Item(i - 1).φDM2, .Item(i - 1).nbrePanneaux, 1, 0, 0, 0)

                                '--> Prise en compte du TS permettant de fermer la travée
                                If .Item(i - 1).LacierY.Count = 2 Then
                                    '  i_ligne = i_ligne + 1
                                    Call Nomenclature_Mod_Inf(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
                                                 i1, i, .Item(i - 1).indTS, .Item(i - 1).LacierY.Item(1), .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, .Item(i - 1).L11acier, .Item(i - 1).L12acier, .Item(i - 1).L13acier,
                                                .Item(i - 1).L21acier, .Item(i - 1).L22acier, .Item(i - 1).L23acier, .Item(i - 1).φDM1, .Item(i - 1).φDM2, 1, 1, 0, 0, 0)
                                End If
                            Next

                        End With
                        'Soit barres HA
                        'acier principal
                        For i2 = 1 To .LitInf.Count
                            Nomenclature_Mod_Inf(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, 0, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
                                                 i1, i2, 0, 0, .LitInf.Item(i2 - 1).Lacier1, .LitInf.Item(i2 - 1).Lacier2, .LitInf.Item(i2 - 1).L11acier, .LitInf.Item(i2 - 1).L12acier, .LitInf.Item(i2 - 1).L13acier,
                                                   .LitInf.Item(i2 - 1).L21acier, .LitInf.Item(i2 - 1).L22acier, .LitInf.Item(i2 - 1).L23acier, .LitInf.Item(i2 - 1).φDM1, .LitInf.Item(i2 - 1).φDM2,
                                                   0, 2, .LitInf.Item(i2 - 1).nbar, .LitInf.Item(i2 - 1).φHA, .LitInf(i2 - 1).Scourant)
                        Next
                        'acier secondaire
                        For i2 = 1 To .LitInf_Y.Count
                            Nomenclature_Mod_Inf(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, 0, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
                                                 i1, i2, 0, 0, .LitInf_Y.Item(i2 - 1).Lacier1, .LitInf_Y.Item(i2 - 1).Lacier2, .LitInf_Y.Item(i2 - 1).L11acier, .LitInf_Y.Item(i2 - 1).L12acier, .LitInf_Y.Item(i2 - 1).L13acier,
                                                .LitInf_Y.Item(i2 - 1).L21acier, .LitInf_Y.Item(i2 - 1).L22acier, .LitInf_Y.Item(i2 - 1).L23acier, .LitInf_Y.Item(i2 - 1).φDM1, .LitInf_Y.Item(i2 - 1).φDM2, 0, 2,
                                                .LitInf_Y.Item(i2 - 1).nbar, .LitInf_Y.Item(i2 - 1).φHA, .LitInf_Y.Item(i2 - 1).Scourant)
                        Next

                        'dessin des lignes verticales du tableau
                        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
                        g.DrawLine(myPen, oriX, oriY, oriX, y)
                        x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
                        x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
                        x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
                        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
                        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
                        ' i_tot = i_tot + .LitInf_nblit + .LitInf_Y_nblit
                        'trémie
                        'acier d'effort tranchant If .HATr.nbarre > 2 Then i = i + 1
                    End With
                Next
            Case 2 'aciers ferraillage supérieur
                i_tot = 0 'sert à dertminer le nombre de lignes que doit afficher le tableau. Pour ce cas, nbre de lignes <>  nbre d'armatures
                i_num = 0 'numérote les aciers, 2 armatures peuvent être dans la même ligne de tableau
                For i1 = 1 To PlanCont.Count
                    With PlanCont.Item(i1 - 1)
                        'acier principal - Appuis gauche et droit
                        Select Case i1
                            Case 1
                                'appui gauche
                                If Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True Then
                                    Select Case .Type_Acier_Appui_Gauche
                                        Case 1
                                            With .TS_AppG
                                                For i2 = 1 To .Count
                                                    Dim branchement As Integer = 0
                                                    For i3 = 1 To .Item(i2 - 1).LacierY.Count
                                                        branchement += 1
                                                        Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                               .Item(i2 - 1).L11acier, .Item(i2 - 1).L12acier, .Item(i2 - 1).L13acier, .Item(i2 - 1).Lacier1, .Item(i2 - 1).Lacier2, .Item(i2 - 1).LacierY.Item(i3 - 1),
                                                                               .Item(i2 - 1).indTS, .Item(i2 - 1).φDM1, PlanCont.Item(i1 - 1).Lx, 0, .Item(i2 - 1).X2acier, .Item(i2 - 1).nbrePanneaux, 0, 0, 0, 1, 1, 0, 0, 0,
                                                                               branchement, .Item(i2 - 1).LacierY.Count)
                                                    Next
                                                Next
                                            End With
                                        Case 2
                                            With .LitSupG
                                                Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, .Item(0).Lacier1, .Item(0).Lacier2, 0, 0, .Item(0).φDM1,
                                                                                PlanCont.Item(i1 - 1).Lx, 0, .Item(0).X2acier, 0, 0, 0, 0, 1, 2, .Item(0).nbar, .Item(0).φHA, .Item(0).Scourant)
                                            End With
                                    End Select
                                End If
                                'appui droit
                                If (Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True) And PlanCont.Count = 1 Then
                                    Select Case .Type_Acier_Appui_Droit
                                        Case 1
                                            With .TS_AppD
                                                For i2 = 1 To .Count
                                                    Dim branchement As Integer = 0
                                                    For i3 = 1 To .Item(i2 - 1).LacierY.Count
                                                        branchement += 1
                                                        Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                        0, 0, 0, .Item(i2 - 1).Lacier1, .Item(i2 - 1).Lacier2, .Item(i2 - 1).LacierY.Item(i3 - 1), .Item(i2 - 1).indTS, .Item(i2 - 1).φDM1,
                                                                                         PlanCont.Item(i1 - 1).Lx, .Item(i2 - 1).X1acier, .Item(i2 - 1).X2acier, .Item(i2 - 1).nbrePanneaux, .Item(i2 - 1).L21acier, .Item(i2 - 1).L22acier,
                                                                                         .Item(i2 - 1).L23acier, 2, 1, 0, 0, 0, branchement, .Item(i2 - 1).LacierY.Count)
                                                    Next
                                                Next

                                            End With
                                        Case 2
                                            With .LitSupD
                                                Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                0, 0, 0, .Item(0).Lacier1, .Item(0).Lacier2, 0, 0, .Item(0).φDM1,
                                                                                PlanCont.Item(i1 - 1).Lx, .Item(0).X1acier, .Item(0).X2acier, 0, .Item(0).L21acier, .Item(0).L22acier, .Item(0).L23acier, 2, 2, .Item(0).nbar, .Item(0).φHA,
                                                                                .Item(0).Scourant)
                                            End With
                                    End Select
                                Else
                                    'appui droit intermédiaire
                                    Select Case .Type_Acier_Appui_Droit
                                        Case 1
                                            With .TS_AppD
                                                For i = 1 To .Count
                                                    Dim branchement As Integer = 0
                                                    For i3 = 1 To .Item(i - 1).LacierY.Count
                                                        branchement += 1
                                                        Call Nomenclature_Mod_Sup_Intermediaire(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                                i, i1, i3 - 1, .Item(i - 1).indTS, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, PlanCont.Item(i1).TS_AppG.Item(i - 1).Lacier2,
                                                                                                PlanCont.Item(i1 - 1).LappD, .Item(i - 1).nbrePanneaux, 1, 0, 0, 0, branchement, .Item(i - 1).LacierY.Count)
                                                    Next '
                                                Next
                                            End With

                                        Case 2
                                            For i = 1 To .LitSupD.Count
                                                With .LitSupD
                                                    Call Nomenclature_Mod_Sup_Intermediaire(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                             i, i1, 0, 0, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, PlanCont.Item(i1).LitSupD.Item(i - 1).Lacier2,
                                                                                            PlanCont.Item(i1 - 1).LappD, 0, 2, .Item(i - 1).nbar, .Item(i - 1).φHA, .Item(i - 1).Scourant)
                                                End With
                                            Next
                                    End Select
                                End If
                            Case PlanCont.Count
                                'appui droit
                                Select Case .Type_Acier_Appui_Droit
                                    Case 1
                                        With .TS_AppD
                                            For i2 = 1 To .Count
                                                Dim branchement As Integer = 0
                                                For i3 = 1 To .Item(i2 - 1).LacierY.Count
                                                    branchement += 1
                                                    Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                    .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, .Item(0).Lacier1, .Item(0).Lacier2, .Item(i2 - 1).LacierY.Item(i3 - 1), .Item(0).indTS, .Item(0).φDM1,
                                                                                    PlanCont.Item(i1 - 1).Lx, 0, .Item(0).X2acier, .Item(0).nbrePanneaux, 0, 0, .Item(i2 - 1).L23acier, 2, 1, 0, 0, 0, branchement, .Item(i2 - 1).LacierY.Count)
                                                Next
                                            Next

                                        End With
                                    Case 2
                                        With .LitSupD
                                            Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, .Item(0).Lacier1, .Item(0).Lacier2, 0, 0, .Item(0).φDM1,
                                                                                  PlanCont.Item(i1 - 1).Lx, .Item(0).X1acier, .Item(0).X2acier, 0, .Item(0).L21acier, .Item(0).L22acier, .Item(0).L23acier,
                                                                                  2, 2, .Item(0).nbar, .Item(0).φHA, .Item(0).Scourant)
                                        End With
                                End Select
                            Case Else ' n'importe quelle travée sauf la 1 et la dernière
                                'appui droit intermédiaire
                                Select Case .Type_Acier_Appui_Droit
                                    Case 1

                                        With .TS_AppD
                                            For i = 1 To .Count
                                                Dim branchement As Integer = 0
                                                For i3 = 1 To .Item(i - 1).LacierY.Count
                                                    branchement += 1
                                                    Call Nomenclature_Mod_Sup_Intermediaire(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                             i, i1, i3 - 1, .Item(i - 1).indTS, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, PlanCont.Item(i1).TS_AppG.Item(i - 1).Lacier2,
                                                                                                 PlanCont.Item(i1 - 1).LappD, .Item(i - 1).nbrePanneaux, 1, 0, 0, 0, branchement, .Item(i - 1).LacierY.Count)

                                                Next
                                            Next
                                        End With


                                    Case 2
                                        For i = 1 To .LitSupD.Count
                                            With .LitSupD
                                                Call Nomenclature_Mod_Sup_Intermediaire(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                                                             i, i1, 0, 0, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, PlanCont.Item(i1).LitSupD.Item(i - 1).Lacier2,
                                                                                                             PlanCont.Item(i1 - 1).LappD, 0, 2, .Item(i - 1).nbar, .Item(i - 1).φHA, .Item(i - 1).Scourant)
                                            End With
                                        Next
                                End Select

                                'If .Type_Acier_Appui_Droit = 2 Then
                                '    '--> Forme
                                '    Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, i1, 3, 1, 0, .LitSupD.Item(0).L23acier)

                                'End If
                        End Select
                        ' i_tot = i_tot + .LitSupD_nblit + .LitSupG_nblit
                        y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
                        g.DrawLine(myPen, oriX, oriY, oriX, y)
                        x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
                        x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
                        x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
                        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
                        x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
                        g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4, y)
                    End With
                Next
                'acier secondaire - Appuis haut et bas
                For i1 = 1 To PlanCont.Count
                    With PlanCont.Item(i1 - 1)
                        'appui haut
                        If .LappH > 0.05 And (Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True) Then
                            Select Case .Type_Acier_Travée
                                Case 1 'TS
                                    For i = 1 To .TS_AppH.Count
                                        With .TS_AppH
                                            Dim branchement As Integer = 0
                                            For i3 = 1 To .Item(i - 1).LacierY.Count
                                                branchement += 1
                                                Call Nomenclature_Mod_Sup_HB(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                             .Item(i - 1).indTS, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, .Item(i - 1).LacierY.Item(i3 - 1),
                                                                            .Item(i - 1).L11acier, .Item(i - 1).L12acier, .Item(i - 1).L13acier, .Item(i - 1).nbrePanneaux, .Item(i - 1).φDM1, 1, 0, 0, 0, branchement, .Item(i - 1).LacierY.Count)
                                            Next
                                        End With
                                    Next
                                Case 2 'HA
                                    With .LitSupH

                                        Call Nomenclature_Mod_Sup_HB(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                         0, .Item(0).Lacier1, .Item(0).Lacier2, 0,
                                                                        .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, 0, .Item(0).φDM1, 2, .Item(0).nbar, .Item(0).φHA, .Item(0).Scourant)
                                    End With
                            End Select
                        End If
                        'appui bas
                        If .LappB > 0.05 And (Aff.Reprise_M0_1_porteur = True Or Aff.Reprise_M0_2_porteur = True) Then
                            Select Case .Type_Acier_Travée
                                Case 1 'TS
                                    For i = 1 To .TS_AppB.Count
                                        With .TS_AppB
                                            Dim branchement As Integer = 0
                                            For i3 = 1 To .Item(i - 1).LacierY.Count
                                                branchement += 1
                                                Call Nomenclature_Mod_Sup_HB(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                             .Item(i - 1).indTS, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, .Item(i - 1).LacierY.Item(i3 - 1),
                                                                            .Item(i - 1).L11acier, .Item(i - 1).L12acier, .Item(i - 1).L13acier, .Item(i - 1).nbrePanneaux, .Item(i - 1).φDM1, 1, 0, 0, 0, branchement, .Item(i - 1).LacierY.Count)
                                            Next
                                        End With
                                    Next
                                Case 2 'HA
                                    With .LitSupB

                                        Call Nomenclature_Mod_Sup_HB(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, i_num, Support, myPen, myBrush, myFont, myFont8,
                                                                         0, .Item(0).Lacier1, .Item(0).Lacier2, 0,
                                                                        .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, 0, .Item(0).φDM1, 2, .Item(0).nbar, .Item(0).φHA, .Item(0).Scourant)
                                    End With
                            End Select

                            ' If .LitSupB.Item(0).L12acier = 0 Then Call Figure8(g, Support, myPen, myBrush, myFont, longAcier, x, y, i1, 2, 1, .LitSupB.Item(0).L13acier, 0)

                        End If
                    End With
                Next
                y = CSng(oriY + H_lig1 + i_tot * H_Lig2)
                g.DrawLine(myPen, oriX, oriY, oriX, y)
                x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
                x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
                x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
                x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
                x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
                g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4, y)
        End Select
        'Ecritures diverses
        Select Case Support
            Case 1
                y = y + 20
            Case 2
                y = y + 5
            Case 3
                y = y + 5
        End Select
        msg = "Toutes les côtes sont indiquées en cm." : w = g.MeasureString(msg, myFont)
        y = y + w.Height
        g.DrawString(msg, myFont, myBrush, oriX, y)
        msg = "Angle de pliage: " & aci.angl_Arma & "°" : w = g.MeasureString(msg, myFont)
        y = y + w.Height
        g.DrawString(msg, myFont, myBrush, oriX, y)
        msg = "Diamètre Ø du mandrin en mm." : w = g.MeasureString(msg, myFont)
        y = y + w.Height
        g.DrawString(msg, myFont, myBrush, oriX, y)
    End Sub

#Region " Procédures figures 2 à 10"

    Private Sub Figure2(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal Longacier As Double, ByVal OriX As Single,
                        ByVal OriY As Single, ByVal L1acier_1 As Double, ByVal L1acier_2 As Double)
        'figure 2:: acier longitudinal bas crochet à gauche et à droite
        Dim F_longAcier, F_L1acier1 As String
        Dim angl, X, Y, X1, Y1, startAngle, sweepAngle As Single
        Dim w As SizeF
        Dim d1 As Single
        Select Case Support
            Case 1 'écran
                OriX = OriX + 20
                d1 = 50
            Case 2 'imprimante
                d1 = 10
            Case 3 'image virtuelle
                d1 = 10
        End Select
        'partie droite
        g.DrawLine(mypen, OriX, OriY, OriX + d1, OriY)
        F_longAcier = Format(Longacier * 100, "## ")
        w = g.MeasureString(F_longAcier, myFont)
        X = OriX + d1 / 2 - w.Width / 2 : Y = OriY + 1
        g.DrawString(F_longAcier, myFont, myBrush, X, Y)
        'crochet gauche
        startAngle = 90 : sweepAngle = 120
        Select Case Support
            Case 1
                X = OriX - 5 : Y = CSng(OriY - 10)
                X1 = 10 : Y1 = 10
            Case 2
                X = OriX - 1 : Y = OriY - 2
                X1 = 2 : Y1 = 2
            Case 3
                X = OriX - 1 : Y = OriY - 2
                X1 = 2 : Y1 = 2
        End Select
        g.DrawArc(mypen, X, Y, X1, Y1, startAngle, sweepAngle) 'angle1DrawArc(blackPen, x, y, width, height, startAngle,sweepAngle)
        angl = CSng((120 - 90) * PI / 180) 'conversion de l'angle en radian
        Select Case Support
            Case 1
                X = CSng(OriX - 5 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 10) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 5 - 5 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 10)
            Case 2
                X = CSng(OriX - 1 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 1) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 1 - 1 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 1)
            Case 3
                X = CSng(OriX - 1 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 1) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 1 - 1 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 1)
        End Select
        g.DrawLine(mypen, X, Y, X1, Y1)
        F_L1acier1 = Format(L1acier_1 * 100, "###")
        w = g.MeasureString(F_L1acier1, myFont)
        Select Case Support
            Case 1
                X = OriX - 6 - w.Width / 2 : Y = OriY - 20
            Case 2
                X = OriX - 2 - w.Width / 2 : Y = OriY - 2
            Case 3
                X = OriX - 2 - w.Width / 2 : Y = OriY - 2
        End Select
        g.DrawString(F_L1acier1, myFont, myBrush, X, Y)
        'crochet droit
        startAngle = 90 : sweepAngle = -120
        Select Case Support
            Case 1
                X = OriX + 45 : Y = CSng(OriY - 10)
                X1 = 10 : Y1 = 10
            Case 2
                X = OriX + 9 : Y = OriY - 1
                X1 = 1 : Y1 = 1
            Case 3
                X = OriX + 9 : Y = OriY - 1
                X1 = 1 : Y1 = 1
        End Select
        g.DrawArc(mypen, X, Y, X1, Y1, startAngle, sweepAngle) 'angle1DrawArc(blackPen, x, y, width, height, startAngle,sweepAngle)
        angl = CSng((120 - 90) * PI / 180) 'conversion de l'angle en radian
        Select Case Support
            Case 1
                X = CSng(OriX + 50 + 5 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X - Cos(angl) * 10) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 5 - 5 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 10)
            Case 2
                X = CSng(OriX + 1 + 1 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X - Cos(angl) * 1) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 1 - 1 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 1)
            Case 3
                X = CSng(OriX + 1 + 1 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X - Cos(angl) * 1) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 1 - 1 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 1)
        End Select
        g.DrawLine(mypen, X, Y, X1, Y1)
        F_L1acier1 = Format(L1acier_2 * 100, "###")
        w = g.MeasureString(F_L1acier1, myFont)
        Select Case Support
            Case 1
                X = OriX + 52 : Y = OriY - 20
            Case 2
                X = OriX + 10 : Y = OriY - 2
            Case 3
                X = OriX + 10 : Y = OriY - 2
        End Select
        g.DrawString(F_L1acier1, myFont, myBrush, X, Y)
    End Sub
    Private Sub Figure6(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal Longacier As Double, ByVal OriX As Single,
                        ByVal OriY As Single, ByVal L1acier_1 As Double)
        'figure 6: acier longitudinal bas crochet à gauche
        Dim F_longAcier, F_L1acier1 As String
        Dim angl, X, Y, X1, Y1, startAngle, sweepAngle As Single
        Dim w As SizeF
        Dim d1 As Single
        Select Case Support
            Case 1 'écran
                OriX = OriX + 20
                d1 = 50
            Case 2 'imprimante
                d1 = 10
            Case 3 'virtuel

        End Select
        'dessin partie droite
        g.DrawLine(mypen, OriX, OriY, OriX + d1, OriY)
        F_longAcier = Format(Longacier * 100, "## ")
        w = g.MeasureString(F_longAcier, myFont)
        X = OriX + d1 / 2 - w.Width / 2 : Y = OriY + 1
        g.DrawString(F_longAcier, myFont, myBrush, X, Y)
        'crochet gauche
        startAngle = 90 : sweepAngle = 120
        Select Case Support
            Case 1
                X = OriX - 5 : Y = CSng(OriY - 10)
                X1 = 10 : Y1 = 10
            Case 2
                X = OriX - 1 : Y = OriY - 2
                X1 = 2 : Y1 = 2
            Case 3
                X = OriX - 1 : Y = OriY - 2
                X1 = 2 : Y1 = 2
        End Select
        g.DrawArc(mypen, X, Y, X1, Y1, startAngle, sweepAngle) 'angle1DrawArc(blackPen, x, y, width, height, startAngle,sweepAngle)
        angl = CSng((120 - 90) * PI / 180) 'conversion de l'angle en radian
        Select Case Support
            Case 1
                X = CSng(OriX - 5 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 10) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 5 - 5 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 10)
            Case 2
                X = CSng(OriX - 1 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 1) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 1 - 1 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 1)
            Case 3
                X = CSng(OriX - 1 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 1) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 1 - 1 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 1)
        End Select
        g.DrawLine(mypen, X, Y, X1, Y1)
        F_L1acier1 = Format(L1acier_1 * 100, "###") ' L1acier * 100 
        w = g.MeasureString(F_L1acier1, myFont)
        Select Case Support
            Case 1
                X = OriX - 6 - w.Width / 2 : Y = OriY - 20
            Case 2
                X = OriX - 2 - w.Width / 2 : Y = OriY - 2
            Case 3

        End Select
        g.DrawString(F_L1acier1, myFont, myBrush, X, Y)
    End Sub
    Private Sub Figure7(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal Longacier As Double, ByVal OriX As Single,
                        ByVal OriY As Single, ByVal Lacier13 As Double, ByVal Lacier23 As Double)
        ''figure 7: acier longitudinal bas crochet à droite
        Dim F_longAcier, F_L1acier1 As String
        Dim angl, X, Y, X1, x11, Y1, startAngle, sweepAngle As Single
        Dim w As SizeF
        Dim d1 As Single
        Select Case Support
            Case 1 'écran
                d1 = 50
            Case 2 'imprimante
                d1 = 10
            Case 3 'image virtuelle
                d1 = 10
        End Select
        'partie droite
        g.DrawLine(mypen, CSng(OriX - d1 / 2), OriY, CSng(OriX + d1 / 2), OriY)
        F_longAcier = Format(Longacier * 100, "##")
        w = g.MeasureString(F_longAcier, myFont)
        X = OriX - w.Width / 2 : Y = OriY + 2
        g.DrawString(F_longAcier, myFont, myBrush, X, Y)
        'crochet
        startAngle = 90 : sweepAngle = -120
        Select Case Support
            Case 1
                X1 = 10 : X = OriX + d1 / 2 - X1 / 2 : Y1 = 10 : Y = CSng(OriY - Y1)
            Case 2
                X = OriX + 9 : Y = OriY - 1
                X1 = 1 : Y1 = 1
            Case 3
                X = OriX + 9 : Y = OriY - 1
                X1 = 1 : Y1 = 1
        End Select
        g.DrawArc(mypen, X, Y, X1, Y1, startAngle, sweepAngle) 'angle1DrawArc(blackPen, x, y, width, height, startAngle,sweepAngle)
        angl = CSng((120 - 90) * PI / 180) 'conversion de l'angle en radian
        Select Case Support
            Case 1
                X = CSng(OriX + d1 / 2 + 5 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                x11 = CSng(X - Cos(angl) * 10) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 5 - 5 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 10)
            Case 2
                X = CSng(OriX + 1 + 1 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                x11 = CSng(X - Cos(angl) * 1) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 1 - 1 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 1)
            Case 3
                X = CSng(OriX + 1 + 1 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                x11 = CSng(X - Cos(angl) * 1) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY - 1 - 1 * Sin(angl))
                Y1 = CSng(Y - Sin(angl) * 1)
        End Select
        g.DrawLine(mypen, X, Y, x11, Y1)
        F_L1acier1 = Format(Lacier23 * 100, "###")
        w = g.MeasureString(F_L1acier1, myFont)
        Select Case Support
            Case 1
                X = OriX + d1 / 2 - X1 / 2 - w.Width : Y = OriY - 10 - w.Height
            Case 2
                X = OriX + d1 / 2 - X1 / 2 - w.Width : Y = OriY - 1 - w.Height
            Case 3
                X = OriX + d1 / 2 - X1 / 2 - w.Width : Y = OriY - 1 - w.Height
        End Select
        g.DrawString(F_L1acier1, myFont, myBrush, X, Y)
        If Lacier13 > 0.01 Then
            Select Case Support
                Case 1
                    X = OriX - d1 / 2 + 10 : Y = OriY + 5 : Y1 = OriY - 5
                Case 2
                    X = OriX - d1 / 2 + 5 : Y = OriY + 2 : Y1 = OriY - 2
                Case 3
                    X = OriX - d1 / 2 + 5 : Y = OriY + 2 : Y1 = OriY - 2
            End Select
            g.DrawLine(mypen, X, Y, X, Y1)
            w = g.MeasureString((Lacier23 * 100).ToString("#"), myFont)
            g.DrawString((Lacier23 * 100).ToString("#"), myFont, myBrush, X - w.Width, Y - w.Height - 2)
        End If
    End Sub
    '''<summary>Figure 8: dessin acier longitudinal droit sans crochet aux extrémités</summary>
    ''' <param name="j">type d'armature: j=1 en travée, j=2 sur appui gauche, j=3 sur appui droit</param>
    ''' <param name="i">n° d'armature</param>
    ''' <param name="L1">longueur coté gauche</param>
    ''' <param name="L2">longueur coté droit</param>
    ''' <param name="L3">longueur partie centrale</param>
    Private Sub Figure8(ByVal g As Graphics, ByVal support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal Longacier As Double, ByVal OriX As Single,
                           ByVal OriY As Single, ByVal j As Integer, Optional ByVal i As Integer = 1, Optional ByVal L1 As Double = 0, Optional ByVal L2 As Double = 0, Optional ByVal L3 As Double = 0)
        'figure 8  dessin acier longitudinal droit sans crochet aux extrémités
        '  L1       L3        L2
        ' ---|--------------|----
        '         Longacier

        Dim msg As String
        Dim x, y As Single
        Dim w As SizeF
        Dim d1 As Integer

        Select Case support
            Case 1 'Sur écran
                d1 = 60 '60 pixels
            ' d2 = 20 '20 pixels
            Case 2 'sur image virtuelle
                d1 = 50 '10 pixels
            Case 3 'sur imprimante
                d1 = 15 '10 mm
        End Select
        'orix = centre de la cellule
        'Longueur totale de l'acier - sous la figure
        g.DrawLine(mypen, CSng(OriX - d1 / 2), OriY, CSng(OriX + d1 / 2), OriY)
        msg = (Longacier * 100).ToString("#0") : w = g.MeasureString(msg, myFont)
        x = CSng(OriX - w.Width / 2) : y = OriY + 2
        g.DrawString(msg, myFont, myBrush, x, y)
        Select Case j
            Case 1 'acier longitudinal bas
                If L1 > 0.01 Then 'longueur acier sur appui gauche
                    g.DrawLine(mypen, CSng(OriX - 0.2 * d1), OriY + 2, CSng(OriX - 0.2 * d1), OriY - 2)
                    msg = (L1 * 100).ToString("##0") : w = g.MeasureString(msg, myFont)
                    x = CSng(OriX - 0.2 * d1 - w.Width) : y = OriY - w.Height
                    g.DrawString(msg, myFont, myBrush, x, y)
                End If
                If L2 > 0.01 Then 'longueur sur appui droit
                    g.DrawLine(mypen, CSng(OriX + 0.2 * d1), OriY + 2, CSng(OriX + 0.2 * d1), OriY - 2)
                    msg = (L2 * 100).ToString("##0") : w = g.MeasureString(msg, myFont)
                    x = CSng(OriX + 0.2 * d1) : y = OriY - w.Height
                    g.DrawString(msg, myFont, myBrush, x, y)
                End If
            Case 2, 3 'acier longitudinal haut sur appui intermédiaire ou acier renfort trémie ou 
                g.DrawLine(mypen, CSng(OriX - 0.5 * d1 / 3), OriY + 2, CSng(OriX - 0.5 * d1 / 3), OriY - 2)
                msg = (L1 * 100).ToString("0") 'partie gauche
                w = g.MeasureString(msg, myFont)
                x = CSng(OriX - 0.5 * d1 - w.Width / 2) : y = OriY - w.Height
                g.DrawString(msg, myFont, myBrush, x, y)
                msg = (L3 * 100).ToString("0") 'partie centrale
                w = g.MeasureString(msg, myFont) : x = OriX - w.Width / 2
                g.DrawString(msg, myFont, myBrush, x, y)
                g.DrawLine(mypen, CSng(OriX + 0.5 * d1 / 3), OriY + 2, CSng(OriX + 0.5 * d1 / 3), OriY - 2)
                msg = (L2 * 100).ToString("##0") 'partie droite
                w = g.MeasureString(msg, myFont) : x = CSng(OriX + d1 / 2 - w.Width / 2)
                g.DrawString(msg, myFont, myBrush, x, y)
            Case 4 'aciers sur appuis haut et bas ou appuis d'about
                If L3 = 1 Then 'longueur acier sur appui gauche
                    g.DrawLine(mypen, CSng(OriX - 0.2 * d1), OriY + 2, CSng(OriX - 0.2 * d1), OriY - 2)
                    msg = (L1 * 100).ToString("##0") : w = g.MeasureString(msg, myFont)
                    x = CSng(OriX - 0.5 * d1) : y = OriY - w.Height
                    g.DrawString(msg, myFont, myBrush, x, y)
                    msg = (L2 * 100).ToString("##0") : w = g.MeasureString(msg, myFont)
                    x = CSng(OriX + 0.3 * d1 - w.Width / 2) : y = OriY - w.Height
                    g.DrawString(msg, myFont, myBrush, x, y)
                End If
                If L3 = 2 Then 'longueur sur appui droit
                    g.DrawLine(mypen, CSng(OriX + 0.2 * d1), OriY + 2, CSng(OriX + 0.2 * d1), OriY - 2)
                    msg = (L2 * 100).ToString("##0") : w = g.MeasureString(msg, myFont)
                    x = CSng(OriX - 0.5 * d1) : y = OriY - w.Height
                    g.DrawString(msg, myFont, myBrush, x, y)
                    msg = (L1 * 100).ToString("##0") : w = g.MeasureString(msg, myFont)
                    x = CSng(OriX + 0.5 * d1 - w.Width)
                    g.DrawString(msg, myFont, myBrush, x, y)
                End If
            Case 5 'aciers sur joints entre prédalles
                g.DrawLine(mypen, CSng(OriX - 0.5 * d1 / 3), OriY + 2, CSng(OriX - 0.5 * d1 / 3), OriY - 2)
                msg = (L1 * 100).ToString("0") 'partie gauche
                w = g.MeasureString(msg, myFont)
                x = CSng(OriX - 0.5 * d1 - w.Width / 2) : y = OriY - w.Height
                g.DrawString(msg, myFont, myBrush, x, y)
                msg = (L3 * 100).ToString("0") 'partie centrale
                w = g.MeasureString(msg, myFont) : x = OriX - w.Width / 2
                g.DrawString(msg, myFont, myBrush, x, y)
                g.DrawLine(mypen, CSng(OriX + 0.5 * d1 / 3), OriY + 2, CSng(OriX + 0.5 * d1 / 3), OriY - 2)
                msg = (L2 * 100).ToString("##0") 'partie droite
                w = g.MeasureString(msg, myFont) : x = CSng(OriX + d1 / 2 - w.Width / 2)
                g.DrawString(msg, myFont, myBrush, x, y)
            Case 6 'Acier de renfort trémie - filant sur toute la longueur de la trémie
                Dim myFont8 As New Font("Times New Roman", 8, FontStyle.Regular)
                msg = "axé - filant sur la travée" : w = g.MeasureString(msg, myFont8)
                x = CSng(OriX - w.Width / 2) : y = OriY - 1 - w.Height
                g.DrawString(msg, myFont, myBrush, x, y)
        End Select
    End Sub
    Private Sub Figure9(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal Longacier As Double, ByVal OriX As Single,
                        ByVal OriY As Single, ByVal L1acier_2 As Double)
        'figure 9: acier longitudinal haut avec crochet droit =   __________
        '                                                                  /
        Dim F_longAcier, F_L1acier1 As String
        Dim angl, X, Y, X1, x11, Y1, startAngle, sweepAngle As Single
        Dim w As SizeF
        Dim d1 As Single
        Select Case Support
            Case 1 'écran
                OriX = OriX
                OriY = OriY - 10
                d1 = 50 'pixels
            Case 2 'image virtuelle
                d1 = 40
            Case 3 'Imprimante
                d1 = 10
        End Select
        'dessin partie droite
        g.DrawLine(mypen, CSng(OriX - d1 / 2), OriY, CSng(OriX + d1 / 2), OriY)
        F_longAcier = Format(Longacier * 100, "##0")
        w = g.MeasureString(F_longAcier, myFont)
        X = OriX - w.Width / 2 : Y = OriY - w.Height
        g.DrawString(F_longAcier, myFont, myBrush, X, Y)
        'Crochet droit
        startAngle = 270 : sweepAngle = 120
        Select Case Support
            Case 1 'écran
                X1 = 10 : X = OriX + d1 / 2 - X1 / 2 : Y = CSng(OriY) : Y1 = 10
            Case 2 'image virtuelle
                X1 = 2 : X = OriX + d1 / 2 - X1 / 2 : Y = CSng(OriY) : Y1 = 2
            Case 3'Imprimante
                X1 = 2 : X = OriX + d1 / 2 - X1 / 2 : Y = CSng(OriY) : Y1 = 2
        End Select
        g.DrawArc(mypen, X, Y, X1, Y1, startAngle, sweepAngle) 'angle1DrawArc(blackPen, x, y, width, height, startAngle,sweepAngle)
        angl = CSng((120 - 90) * PI / 180) 'conversion de l'angle en radian
        Select Case Support
            Case 1 'écran
                X = CSng(OriX + d1 / 2 + 5 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                x11 = CSng(X - Cos(angl) * 10) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY + Y1 / 2 + 5 * Sin(angl))
                Y1 = CSng(Y + Sin(angl) * 10)
            Case 2 'image virtuelle
                X = CSng(OriX + d1 / 2 + 1 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                x11 = CSng(X - Cos(angl) * 2) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY + Y1 / 2 + 1 * Sin(angl))
                Y1 = CSng(Y + Sin(angl) * 2)
            Case 3 'Imprimante
                X = CSng(OriX + d1 / 2 + 1 * Cos(angl)) 'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                x11 = CSng(X - Cos(angl) * 2) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY + Y1 / 2 + 1 * Sin(angl))
                Y1 = CSng(Y + Sin(angl) * 2)
        End Select
        g.DrawLine(mypen, X, Y, x11, Y1)
        F_L1acier1 = Format(L1acier_2 * 100, "##0") 'L1acier(i1, j, i, 2) * 100, "###")
        w = g.MeasureString(F_L1acier1, myFont)
        Select Case Support
            Case 1 'écran
                X = OriX + d1 / 2 - X1 / 2 - w.Width : Y = OriY + 10    '    X = OriX - d1 / 2 - 10 : Y = OriY + 10    
            Case 2 'image virtuelle
                X = OriX + d1 / 2 - X1 / 2 - w.Width : Y = OriY + 10
            Case 3 'Imprimante
                X = OriX + d1 / 2 - X1 / 2 - w.Width : Y = OriY + 1
        End Select
        g.DrawString(F_L1acier1, myFont, myBrush, X, Y)
    End Sub
    Private Sub Figure10(ByVal g As Graphics, ByVal Support As Integer, ByVal mypen As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal Longacier As Double, ByVal OriX As Single,
                            ByVal OriY As Single, ByVal L1acier_1 As Double)
        'figure 10: acier longitudinal haut avec crochet gauche =   __________
        '                                                           \
        Dim F_longAcier, F_L1acier1 As String
        Dim angl, X, Y, X1, Y1, startAngle, sweepAngle As Single
        Dim w As SizeF
        Dim d1 As Single
        Select Case Support
            Case 1 'écran
                OriX = OriX + 20
                OriY = OriY - 10
                d1 = 50 'pixels
            Case 2 'image virtuelle
                d1 = 40
            Case 3 'Imprimante
                d1 = 10
        End Select
        'dessin partie droite
        g.DrawLine(mypen, CSng(OriX - d1 / 2), OriY, CSng(OriX + d1 / 2), OriY)
        F_longAcier = Format(Longacier * 100, "###")
        w = g.MeasureString(F_longAcier, myFont)
        X = OriX - w.Width / 2 : Y = OriY - w.Height
        g.DrawString(F_longAcier, myFont, myBrush, X, Y)
        'crochet gauche
        startAngle = 270 : sweepAngle = -120
        Select Case Support
            Case 1 'écran
                X = OriX - d1 / 2 - 5 : Y = CSng(OriY) : X1 = 10 : Y1 = 10
            Case 2 'Imprimante
                X = OriX - d1 / 2 - 1 : Y = CSng(OriY) : X1 = 2 : Y1 = 2
            Case 3 'image virtuelle
                X = OriX - d1 / 2 - 1 : Y = CSng(OriY) : X1 = 2 : Y1 = 2
        End Select
        g.DrawArc(mypen, X, Y, X1, Y1, startAngle, sweepAngle) 'angle1DrawArc(blackPen, x, y, width, height, startAngle,sweepAngle)
        angl = CSng((120 - 90) * PI / 180) 'conversion de l'angle en radian
        Select Case Support
            Case 1 'écran
                X = CSng(OriX - d1 / 2 - 5 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 10) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY + 5 + 5 * Sin(angl))
                Y1 = CSng(Y + Sin(angl) * 10)
            Case 2 'Imprimante
                X = CSng(OriX - d1 / 2 - 1 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 2) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY + 1 + 1 * Sin(angl))
                Y1 = CSng(Y + Sin(angl) * 2)
            Case 3 'image virtuelle
                X = CSng(OriX - d1 / 2 - 1 * Cos(angl))  'Else X = CSng(OriX + redw * (X2acier(i1, j, i) + L3acier(i1, j, i, appui) + R * Cos(angl)))
                X1 = CSng(X + Cos(angl) * 2) 'Else X1 = CSng(X - Cos(angl) * redw * L1acier(i1, j, i, appui))
                Y = CSng(OriY + 1 + 1 * Sin(angl))
                Y1 = CSng(Y + Sin(angl) * 2)
        End Select
        g.DrawLine(mypen, X, Y, X1, Y1)
        F_L1acier1 = Format(L1acier_1 * 100, "###") 'L1acier(i1, j, i, 1) * 100, "###")
        w = g.MeasureString(F_L1acier1, myFont)
        Select Case Support
            Case 1 'écran
                X = OriX - d1 / 2 - w.Width : Y = OriY + 10
            Case 2 'Imprimante
                X = OriX - d1 / 2 - w.Width : Y = OriY + 2
            Case 3 'image virtuelle
                X = OriX - d1 / 2 - w.Width : Y = OriY + 2
        End Select
        g.DrawString(F_L1acier1, myFont, myBrush, X, Y)
    End Sub
#End Region

#Region "Poubelle"
    'tous les modules codés mais qui ne servent , à conserver au cas ou ..

    'Private Sub Ferraillages_superieurs_TS(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen2 As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal red As Double,
    '                                         ByVal OriX As Single, ByVal OriY As Single, ByVal Support As Integer)
    '    'Ferraillage supérieurs
    '    Dim j, N_Pan As Integer 'i,
    '    Dim X, Y, X1, Y1, X2, X3, Y3, fl As Single '
    '    Dim msg As String = String.Empty
    '    Dim w As SizeF
    '    Dim Rmax As Single

    '    msg = "PLAN DE FERRAILLAGE:  Armatures supérieures"
    '    myFont = New Font("Times New Roman", 10, FontStyle.Bold)
    '    w = g.MeasureString(msg, myFont)
    '    Select Case Support
    '        Case 1 'écran
    '            X = OriX : Y = CSng(OriY - w.Height - 20) : X3 = 12 : Y3 = 30 : fl = 8
    '        Case 2 'image
    '            X = OriX : Y = 5 : X3 = 3 : Y3 = 10 : fl = 2
    '        Case 3 'imprimante
    '            X = OriX : Y = 5 : X3 = 3 : Y3 = 10 : fl = 2
    '    End Select
    '    g.DrawString(msg, myFont, myBrush, X, Y)
    '    myFont = New Font("Times New Roman", 9, FontStyle.Regular)
    '    With PlanCont.Item(0)
    '        'acier sur appui gauche
    '        If .LappG > 0.05 And Aff.Reprise_M0_1_porteur = True Then
    '            N_Pan = 1
    '            Call Tracé_TS_Sup_Appui_Gauche(g, Support, mypen, mypen3, myBrush, myFont, red, OriX, OriY, 0, N_Pan, fl)
    '            X2 = CSng(OriX + red * (.LappG + .Lx + .LappD))
    '        End If
    '    End With
    '    '-----------------------------------------------------------------------------------------------------------------------------------------------------------
    '    'acier sur appui droit
    '    If PlanCont.Count > 1 Then
    '        With PlanCont.Item(0)
    '            'acier sur appui intermédiaire
    '            X = CSng(OriX + red * (.LappG + .TS_AppD.Item(0).X1acier)) : Y = CSng(OriY + red * (.LappH + .Ly / 2) + Y3)
    '            X1 = CSng(OriX + red * (.LappG + .Lx + .LappD + PlanCont.Item(1).TS_AppG.Item(0).X2acier))
    '            g.DrawLine(mypen3, X, Y, X1, Y) 'armature
    '            X = CSng(OriX + red * (.LappG + .TS_AppD.Item(0).X1acier) - X3)
    '            Y = CSng(OriY + red * (.LappH)) : Y1 = CSng(OriY + red * (.LappH + .Ly))
    '            g.DrawLine(mypen, X, Y, X, Y1) 'ligne de répartition
    '            'flèche haute
    '            g.DrawLine(mypen, X, Y, X - fl, Y + fl) : g.DrawLine(mypen, X, Y, X + fl, Y + fl) : g.DrawLine(mypen, X - fl, Y, X + fl, Y)
    '            'flèche basse
    '            g.DrawLine(mypen, X, Y1, X - fl, Y1 - fl) : g.DrawLine(mypen, X, Y1, X + fl, Y1 - fl) : g.DrawLine(mypen, X - fl, Y1, X + fl, Y1)
    '            'rond indicatif
    '            X = CSng(OriX + red * (.LappG + .TS_AppD.Item(0).X1acier))
    '            Y = CSng(OriY + red * (.LappH + .Ly / 2) + Y3)
    '            N_Pan = N_Pan + 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
    '            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
    '            g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
    '            g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
    '            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
    '            If PlanCont.Item(1).TS_AppG.Item(0).LacierY.Count = 2 Then
    '                Y = CSng(OriY + red * (.LappH + .Ly / 2) + 2 * Y3)
    '                N_Pan = N_Pan + 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
    '                If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
    '                g.FillEllipse(Brushes.White, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
    '                g.DrawEllipse(mypen, X - CSng(Rmax * 0.75), Y - CSng(Rmax * 0.75), CSng(Rmax * 1.5), CSng(Rmax * 1.5))
    '                g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
    '            End If
    '            'côte
    '            X = CSng(OriX + red * (.LappG + .Lx) + 2)
    '            X1 = CSng(OriX + red * (.LappG + .TS_AppD.Item(0).X1acier))
    '            Y = CSng(OriY + red * (.LappH + .Ly / 2) - 2 * Y3)
    '            g.DrawLine(mypen, X, Y, X1 - Y3, Y) 'horizontal
    '            g.DrawLine(mypen, X1, Y - fl, X1, Y + fl) 'vertical
    '            msg = ((.Lx - .TS_AppD.Item(0).X1acier) * 100).ToString("0")
    '            w = g.MeasureString(msg, myFont)
    '            g.DrawString(msg, myFont, myBrush, X1 - Y3, Y - w.Height)                '
    '            X2 = CSng(OriX + red * (.LappG + .Lx + .LappD))
    '        End With
    '        '--------------------------------------------------------------------------------------------------------------------
    '        'Appuis intermédiaires
    '        For j = 1 To PlanCont.Count - 2
    '            Call Bar_HA_Sup_P_TS(g, mypen, mypen3, myBrush, myFont, j, X2, red, OriY, N_Pan, Support)
    '            X2 = CSng(X2 + red * (PlanCont(j).Lx + PlanCont(j).LappD))
    '        Next
    '        '-------------------------------------------------------------------------------------------------------------------------
    '        'dernier appui = appui de rive si acier existant
    '        With PlanCont.Item(PlanCont.Count - 1)
    '            If Aff.Reprise_M0_1_porteur = True And .LappD > 0.05 Then Call Tracé_TS_Sup_Appui_Droit(g, mypen, mypen3, myBrush, myFont, red, X2, OriY, PlanCont.Count - 1, N_Pan, fl)

    '        End With
    '    Else
    '        'Dessin des armatures supérieures pour l'appui droit dans le cas d'une seule travée
    '        If PlanCont.Item(0).LappD > 0.05 And Aff.Reprise_M0_1_porteur = True Then Call Tracé_TS_Sup_Appui_Droit(g, mypen, mypen3, myBrush, myFont, red, OriX, OriY, 0, N_Pan, fl)
    '    End If
    '    With PlanCont.Item(0)
    '        'acier secondaire - Appuis haut et bas
    '        '
    '        'appui haut - travée n°1
    '        If .LappH > 0.05 And Aff.EncastPartiel_1_porteur = True Then Call Bar_HA_Sup_S_Reprise_haut_TS(g, mypen, mypen2, myBrush, myFont, 0, OriX, red, OriY, N_Pan, fl)
    '        X2 = CSng(OriX + red * (.LappG + .Lx + .LappD))
    '        'appui haut - travées suivantes
    '        For j = 2 To PlanCont.Count
    '            If PlanCont(j - 2).TS_AppB.Item(0).LacierY.Count = 2 Then N_Pan = N_Pan + 2 Else N_Pan = N_Pan + 1
    '            If PlanCont(j - 1).LappH > 0.05 And Aff.EncastPartiel_1_porteur = True Then
    '                Call Bar_HA_Sup_S_Reprise_haut_TS(g, mypen, mypen2, myBrush, myFont, j - 1, X2, red, OriY, N_Pan, fl)
    '            End If
    '            X2 = CSng(X2 + red * (PlanCont(j - 1).Lx + PlanCont(j - 1).LappD))
    '        Next
    '        '
    '        'appui bas
    '        ' travée n°1
    '        If .LappB > 0.05 And Aff.EncastPartiel_1_porteur = True Then Call Bar_HA_Sup_S_Reprise_bas_TS(g, mypen, mypen2, myBrush, myFont, 0, OriX, red, OriY, N_Pan, fl)
    '        'travée suivante
    '        X2 = CSng(OriX + red * (.LappG + .Lx + .LappD))
    '        For j = 2 To PlanCont.Count
    '            If PlanCont(j - 2).TS_AppH.Item(0).LacierY.Count = 2 Then N_Pan = N_Pan + 2 Else N_Pan = N_Pan + 1
    '            If PlanCont(j - 1).LappB > 0.05 And Aff.EncastPartiel_1_porteur = True Then
    '                Call Bar_HA_Sup_S_Reprise_bas_TS(g, mypen, mypen2, myBrush, myFont, j - 1, X2, red, OriY, N_Pan, fl)
    '            End If
    '            X2 = CSng(X2 + red * (PlanCont(j - 1).Lx + PlanCont(j - 1).LappD))
    '        Next
    '    End With
    'End Sub
    ''''<summary>Appel au module d'affichage de la nomenclature d'armatures sous forme TS</summary>
    '''' <param name="g">transfert de la méthode Graphics.</param>
    ''''   <param name="Support">support = 1 -> écran, =2 ->image, =3 ->imprimante</param>
    'Private Sub Affichage_Nomenclature_Acier_TS_Sup(ByVal g As Graphics, ByVal Support As Integer, ByVal Niveau As Integer, ByVal largeur As Integer, ByVal Hauteur As Integer)

    '    'Dim msg As String
    '    'Dim myPen As New Pen(Color.Black, 1)
    '    'Dim myBrush As New SolidBrush(Color.Black)
    '    'Dim oriX, oriY, x, x1, y, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2 As Single ', startAngle, sweepAngle
    '    'Dim w As SizeF
    '    'Dim i, i_tot, i_ligne, i1 As Integer ',coupure, i3, j, w1 
    '    ''initialisation de variables

    '    ''support = 1 -> écran, =2 ->image, =3 ->imprimante
    '    'Select Case Support
    '    '    Case 1 'écran
    '    '        'détermination des coefficient de réduction 
    '    '        L_col1 = 20 : L_col2 = 250 : L_col3 = 100 : L_col4 = 60 : L_col5 = 40
    '    '        oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 20 '200 pixels
    '    '        oriY = 20 '50 pixel
    '    '        H_lig1 = 20 : H_Lig2 = 50
    '    '        myPen = New Pen(Color.Black, 1)
    '    '        myBrush = New SolidBrush(Color.Black)
    '    '    Case 2 'image 530 x 330
    '    '        L_col1 = 8 : L_col2 = 55 : L_col3 = 25 : L_col4 = 10 : L_col5 = 10
    '    '        oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 5 '200 pixels
    '    '        oriY = 5 '50 pixel
    '    '        H_lig1 = 8 : H_Lig2 = 10
    '    '        myPen = New Pen(Color.Black, 0.1)
    '    '        myBrush = New SolidBrush(Color.Black)
    '    '    Case 3 'imprimante - Format A4
    '    '        L_col1 = 8 : L_col2 = 55 : L_col3 = 25 : L_col4 = 10 : L_col5 = 10
    '    '        oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 10 '200 pixels
    '    '        oriY = 5 '5mm
    '    '        H_lig1 = 8 : H_Lig2 = 10
    '    '        myPen = New Pen(Color.Black, 0.1)
    '    '        myBrush = New SolidBrush(Color.Black)
    '    'End Select

    '    ''----------------------------------------------------------------------------
    '    ''              Affichage des aciers
    '    ''----------------------------------------------------------------------------
    '    ''Affichage coupe
    '    'msg = "NOMENCLATURE DES ARMATURES"
    '    'Dim myFont8 As New Font("Times New Roman", 8, FontStyle.Regular)
    '    'Dim myFont As New Font("Times New Roman", 10, FontStyle.Bold)
    '    'w = g.MeasureString(msg, myFont)
    '    'x = oriX
    '    'Select Case Support
    '    '    Case 1
    '    '        y = CSng(oriY - w.Height - 2) 'uniquement sur écran ou les titres sont décalés
    '    '    Case 2 'image
    '    '        y = oriY : oriY = oriY + w.Height + 1
    '    '    Case 3 'imprimante
    '    '        y = oriY : oriY = oriY + w.Height + 1
    '    'End Select

    '    'g.DrawString(msg, myFont, myBrush, x, y)
    '    'myFont = New Font("Times New Roman", 10, FontStyle.Regular)

    '    ''dessin titre colonnes
    '    'x1 = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5
    '    'g.DrawLine(myPen, oriX, oriY, x1, oriY)
    '    'g.DrawLine(myPen, oriX, oriY + H_lig1, x1, oriY + H_lig1)
    '    'x = oriX : y = oriY + H_lig1 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
    '    'msg = "N°"
    '    'w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
    '    'msg = "Armatures"
    '    'w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
    '    'msg = "Forme"
    '    'w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
    '    'If Support = 1 Then msg = "Mandrin" Else msg = "DM"
    '    'w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
    '    'If Support = 1 Then msg = "Nombre" Else msg = "Nbre"
    '    'w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
    '    ''détermination du nombre d'armatures à afficher
    '    ''aciers ferraillage supérieur
    '    'i_tot = 0
    '    'For i1 = 1 To PlanCont.Count
    '    '    With PlanCont.Item(i1 - 1)
    '    '        'acier principal - Appuis gauche et droit
    '    '        Select Case i1
    '    '            Case 1
    '    '                'appui gauche
    '    '                If .LappG > 0.05 And Aff.Reprise_M0_1_porteur = True Then
    '    '                    With .TS_AppG
    '    '                        Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                             .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(0), .Item(0).indTS, .Item(0).φDM1, 0, 0, .Item(0).X2acier,
    '    '                                             .Item(0).nbrePanneaux, 0, 0, 0, 1, 1, 0, 0, 0)

    '    '                        If .Item(0).LacierY.Count = 2 Then
    '    '                            Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                             .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(1), .Item(0).indTS, .Item(0).φDM1, 0, 0, .Item(0).X2acier,
    '    '                                             1, 0, 0, 0, 1, 1, 0, 0, 0)
    '    '                        End If
    '    '                        i_ligne = i_tot
    '    '                    End With

    '    '                End If
    '    '                If Aff.Reprise_M0_1_porteur = True And PlanCont.Count = 1 Then
    '    '                    With .TS_AppD
    '    '                        Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                             0, 0, 0, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(0), .Item(0).indTS, .Item(0).φDM1, PlanCont.Item(i1 - 1).Lx, .Item(0).X2acier, 0,
    '    '                                             .Item(0).nbrePanneaux, .Item(0).L21acier, .Item(0).L22acier, .Item(0).L23acier, 2, 1, 0, 0, 0)
    '    '                        If .Item(0).LacierY.Count = 2 Then
    '    '                            Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                             0, 0, 0, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(1), .Item(0).indTS, .Item(0).φDM1, PlanCont.Item(i1 - 1).Lx, .Item(0).X2acier, 0,
    '    '                                             1, .Item(0).L21acier, .Item(0).L22acier, .Item(0).L23acier, 2, 1, 0, 0, 0)
    '    '                        End If
    '    '                    End With
    '    '                Else
    '    '                    'appui droit intermédiaire
    '    '                    With .TS_AppD
    '    '                        For i = 1 To .Count
    '    '                            i_ligne = i_ligne + 1
    '    '                            Call Nomenclature_Mod_Sup_Intermediaire(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                                       i, i1, 0, .Item(i - 1).indTS, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, PlanCont.Item(i1).TS_AppG.Item(i - 1).Lacier2,
    '    '                                                       PlanCont.Item(i1 - 1).LappD, PlanCont.Item(i1).TS_AppG.Item(i - 1).nbrePanneaux, 1, 0, 0, 0)
    '    '                            If PlanCont.Item(i1).TS_AppG.Item(i - 1).LacierY.Count = 2 Then
    '    '                                i_ligne = i_ligne + 1
    '    '                                Call Nomenclature_Mod_Sup_Intermediaire(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                                       i, i1, 1, .Item(i - 1).indTS, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, PlanCont.Item(i1).TS_AppG.Item(i - 1).Lacier2,
    '    '                                                       PlanCont.Item(i1 - 1).LappD, 1, 1, 0, 0, 0)
    '    '                            End If
    '    '                        Next
    '    '                    End With
    '    '                End If
    '    '                i_ligne = i_tot
    '    '            Case PlanCont.Count
    '    '                'appui droit
    '    '                i_ligne = i_ligne + 1
    '    '                With .TS_AppD
    '    '                    Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                             0, 0, 0, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(0), .Item(0).indTS, .Item(0).φDM1, PlanCont.Item(i1 - 1).Lx, .Item(0).X2acier, 0,
    '    '                                             .Item(0).nbrePanneaux, .Item(0).L21acier, .Item(0).L22acier, .Item(0).L23acier, 2, 1, 0, 0, 0)
    '    '                    If .Item(0).LacierY.Count = 2 Then
    '    '                        i_ligne = i_ligne + 1
    '    '                        Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                             0, 0, 0, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(1), .Item(0).indTS, .Item(0).φDM1, PlanCont.Item(i1 - 1).Lx, .Item(0).X2acier, 0,
    '    '                                             1, .Item(0).L21acier, .Item(0).L22acier, .Item(0).L23acier, 2, 1, 0, 0, 0)
    '    '                    End If
    '    '                End With
    '    '                With .LitSupD
    '    '                    Call Nomenclature_Mod_Sup_About(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                             0, 0, 0, .Item(0).Lacier1, .Item(0).Lacier2, 0, 0, .Item(0).φDM1, PlanCont.Item(i1 - 1).Lx, .Item(0).X2acier, 0,
    '    '                                             0, .Item(0).L21acier, .Item(0).L22acier, .Item(0).L23acier, 2, 1, 0, 0, 0)
    '    '                End With
    '    '            Case Else
    '    '                'appui droit intermédiaire
    '    '                With .TS_AppD
    '    '                    For i = 1 To .Count
    '    '                        i_ligne = i_ligne + 1
    '    '                        Call Nomenclature_Mod_Sup_Intermediaire(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_ligne, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                                       i, i1, 0, .Item(i - 1).indTS, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, PlanCont.Item(i1).TS_AppG.Item(i - 1).Lacier2, PlanCont.Item(i1 - 1).LappD,
    '    '                                                       PlanCont.Item(i1).TS_AppG.Item(i - 1).nbrePanneaux, 1, 0, 0, 0)

    '    '                        If PlanCont.Item(i1).TS_AppG.Item(i - 1).LacierY.Count = 2 Then
    '    '                            i_ligne = i_ligne + 1
    '    '                            Call Nomenclature_Mod_Sup_Intermediaire(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_ligne, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                                       i, i1, 1, .Item(i - 1).indTS, .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, PlanCont.Item(i1).TS_AppG.Item(i - 1).Lacier2, PlanCont.Item(i1 - 1).LappD,
    '    '                                                       1, 1, 0, 0, 0)
    '    '                        End If
    '    '                    Next
    '    '                End With
    '    '        End Select
    '    '    End With
    '    'Next
    '    ''acier secondaire - Appuis haut et bas
    '    'For i1 = 1 To PlanCont.Count
    '    '    With PlanCont.Item(i1 - 1)
    '    '        'appui haut
    '    '        If .LappH > 0.05 And Aff.EncastPartiel_1_porteur = True Then
    '    '            With .TS_AppH
    '    '                i_ligne = i_ligne + 1
    '    '                Call Nomenclature_Mod_Sup_HB(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                                         .Item(0).indTS, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(0),
    '    '                                                        .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, .Item(0).nbrePanneaux, .Item(0).φDM1, 1, 0, 0, 0)
    '    '                If .Item(0).LacierY.Count = 2 Then
    '    '                    i_ligne = i_ligne + 1
    '    '                    Call Nomenclature_Mod_Sup_HB(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                                         .Item(0).indTS, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(0),
    '    '                                                        .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, 1, .Item(0).φDM1, 1, 0, 0, 0)
    '    '                End If
    '    '            End With
    '    '        End If
    '    '        'appui bas
    '    '        If .LappB > 0.05 And Aff.EncastPartiel_1_porteur = True Then
    '    '            With .TS_AppB
    '    '                i_ligne = i_ligne + 1
    '    '                Call Nomenclature_Mod_Sup_HB(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                                         .Item(0).indTS, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(0),
    '    '                                                        .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, .Item(0).nbrePanneaux, .Item(0).φDM1, 1, 0, 0, 0)
    '    '                If .Item(0).LacierY.Count = 2 Then
    '    '                    i_ligne = i_ligne + 1
    '    '                    Call Nomenclature_Mod_Sup_HB(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '    '                                                         .Item(0).indTS, .Item(0).Lacier1, .Item(0).Lacier2, .Item(0).LacierY.Item(1),
    '    '                                                        .Item(0).L11acier, .Item(0).L12acier, .Item(0).L13acier, 1, .Item(0).φDM1, 1, 0, 0, 0)
    '    '                End If
    '    '            End With
    '    '        End If
    '    '    End With
    '    'Next
    '    'y = CSng(oriY + H_lig1 + i_ligne * H_Lig2)
    '    'g.DrawLine(myPen, oriX, oriY, oriX, y)
    '    'x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
    '    'x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
    '    'g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)

    '    'msg = "Toutes les côtes sont indiquées en cm." : w = g.MeasureString(msg, myFont)
    '    'y = y + w.Height
    '    'g.DrawString(msg, myFont, myBrush, oriX, y)
    '    'msg = "Angle de pliage: 135°" : w = g.MeasureString(msg, myFont)
    '    'y = y + w.Height
    '    'g.DrawString(msg, myFont, myBrush, oriX, y)
    '    'msg = "Diamètre Ø du mandrin en cm." : w = g.MeasureString(msg, myFont)
    '    'y = y + w.Height
    '    'g.DrawString(msg, myFont, myBrush, oriX, y)
    '    'msg = "Pour les TS en chapeaux sur appuis d'about et d'extrémité, un fil " : w = g.MeasureString(msg, myFont)
    '    'y = y + w.Height
    '    'g.DrawString(msg, myFont, myBrush, oriX, y)
    '    'msg = "transversal non coupé doit se trouver à l'intérieur de l'appui." : w = g.MeasureString(msg, myFont)
    '    'y = y + w.Height
    '    'g.DrawString(msg, myFont, myBrush, oriX, y)
    'End Sub
    ''''<summary>Appel au module d'affichage de la nomenclature d'armatures sous forme TS - Ferraillage inférieur</summary>
    '''' <param name="g">transfert de la méthode Graphics.</param>
    ''''   <param name="Support">support = 1 -> écran, =2 ->image, =3 ->imprimante</param>
    'Private Sub Affichage_Nomenclature_Acier_TS_Inf(ByVal g As Graphics, ByVal Support As Integer, ByVal largeur As Integer, ByVal Hauteur As Integer)

    '    Dim msg As String
    '    Dim myBrush As New SolidBrush(Color.Black)
    '    Dim myPen As New Pen(Color.Black)
    '    Dim oriX, oriY, x, x1, y, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2 As Single
    '    Dim w As SizeF
    '    Dim i, i_tot, i_ligne, i1 As Integer
    '    'initialisation de variables

    '    'support = 1 -> écran, =2 ->image, =3 ->imprimante
    '    Select Case Support
    '        Case 1 'écran 
    '            L_col1 = 20 : L_col2 = 250 : L_col3 = 100 : L_col4 = 60 : L_col5 = 40
    '            oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 20 '200 pixels
    '            oriY = 20 '50 pixel
    '            H_lig1 = 20 : H_Lig2 = 50
    '            myPen = New Pen(Color.Black, 1)
    '            myBrush = New SolidBrush(Color.Black)
    '        Case 2 'image 530 x 330
    '            L_col1 = 8 : L_col2 = 55 : L_col3 = 25 : L_col4 = 10 : L_col5 = 10
    '            oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 5 '200 pixels
    '            oriY = 5 '50 pixel
    '            H_lig1 = 8 : H_Lig2 = 10
    '            myPen = New Pen(Color.Black, 0.1)
    '            myBrush = New SolidBrush(Color.Black)

    '        Case 3 'imprimante - Format A4
    '            L_col1 = 8 : L_col2 = 55 : L_col3 = 25 : L_col4 = 10 : L_col5 = 10
    '            oriX = largeur - L_col1 - L_col2 - L_col3 - L_col4 - L_col5 - 10 '200 pixels
    '            oriY = 5 '50 pixel
    '            H_lig1 = 8 : H_Lig2 = 10
    '            myPen = New Pen(Color.Black, 0.1)
    '            myBrush = New SolidBrush(Color.Black)
    '    End Select

    '    '----------------------------------------------------------------------------
    '    '              Affichage des aciers
    '    '----------------------------------------------------------------------------
    '    'Affichage coupe
    '    msg = "NOMENCLATURE DES ARMATURES"
    '    Dim myFont8 As New Font("Times New Roman", 8, FontStyle.Regular)
    '    Dim myFont As New Font("Times New Roman", 10, FontStyle.Bold)
    '    w = g.MeasureString(msg, myFont)
    '    x = oriX
    '    Select Case Support
    '        Case 1
    '            y = CSng(oriY - w.Height - 2) 'uniquement sur écran ou les titres sont décalés
    '        Case 2 'image
    '            y = oriY : oriY = oriY + w.Height + 1
    '        Case 3 'imprimante
    '            y = oriY : oriY = oriY + w.Height + 1
    '    End Select
    '    g.DrawString(msg, myFont, myBrush, x, y)
    '    myFont = New Font("Times New Roman", 10, FontStyle.Regular)

    '    'dessin titre colonnes
    '    x1 = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5
    '    g.DrawLine(myPen, oriX, oriY, x1, oriY)
    '    g.DrawLine(myPen, oriX, oriY + H_lig1, x1, oriY + H_lig1)
    '    x = oriX : y = oriY + H_lig1 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
    '    msg = "N°"
    '    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
    '    msg = "Armatures"
    '    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
    '    msg = "Forme"
    '    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
    '    If Support = 1 Then msg = "Mandrin" Else msg = "DM"
    '    w = g.MeasureString(msg, myFont) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont, myBrush, x, y)
    '    If Support = 1 Then msg = "Nombre" Else msg = "Nbre"
    '    w = g.MeasureString(msg, myFont8) : x = CSng(oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 / 2 - w.Width / 2) : y = CSng(oriY + H_lig1 / 2 - w.Height / 2) : g.DrawString(msg, myFont8, myBrush, x, y)
    '    'détermination du nombre d'armatures à afficher
    '    'aciers ferraillage inférieur
    '    i_tot = 0 : i_ligne = 0
    '    For i1 = 1 To PlanCont.Count
    '        With PlanCont.Item(i1 - 1)
    '            With .TS_trav
    '                For i = 1 To .Count
    '                    ' i_ligne = i_ligne + 1
    '                    Call Nomenclature_Mod_Inf(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, 0, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '                                             i1, .Item(i - 1).indTS, .Item(i - 1).LacierY.Item(0), .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, .Item(i - 1).L11acier, .Item(i - 1).L12acier, .Item(i - 1).L13acier,
    '                                            .Item(i - 1).L21acier, .Item(i - 1).L22acier, .Item(i - 1).L23acier, .Item(i - 1).φDM1, .Item(i - 1).φDM2, .Item(i - 1).nbrePanneaux, 1, 0, 0, 0)

    '                    '--> Prise en compte du TS permettant de fermer la travée
    '                    If .Item(i - 1).LacierY.Count = 2 Then
    '                        '  i_ligne = i_ligne + 1
    '                        Call Nomenclature_Mod_Inf(g, oriX, oriY, L_col1, L_col2, L_col3, L_col4, L_col5, H_lig1, H_Lig2, 0, i_tot, Support, myPen, myBrush, myFont, myFont8,
    '                                             i1, .Item(i - 1).indTS, .Item(i - 1).LacierY.Item(1), .Item(i - 1).Lacier1, .Item(i - 1).Lacier2, .Item(i - 1).L11acier, .Item(i - 1).L12acier, .Item(i - 1).L13acier,
    '                                            .Item(i - 1).L21acier, .Item(i - 1).L22acier, .Item(i - 1).L23acier, .Item(i - 1).φDM1, .Item(i - 1).φDM2, 1, 1, 0, 0, 0)
    '                    End If
    '                Next
    '            End With
    '        End With
    '    Next

    '    y = CSng(oriY + H_lig1 + i_ligne * H_Lig2)
    '    g.DrawLine(myPen, oriX, oriY, oriX, y)
    '    x = oriX + L_col1 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 + L_col2 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 + L_col2 + L_col3 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 + L_col2 + L_col3 + L_col4 : g.DrawLine(myPen, x, oriY, x, y)
    '    x = oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5 : g.DrawLine(myPen, x, oriY, x, y)
    '    g.DrawLine(myPen, oriX, y, oriX + L_col1 + L_col2 + L_col3 + L_col4 + L_col5, y)
    '    Select Case Support
    '        Case 1 'écran
    '            msg = "Toutes les côtes sont indiquées en cm." : w = g.MeasureString(msg, myFont) : y = y + w.Height : g.DrawString(msg, myFont, myBrush, oriX, y)
    '            y = y + w.Height
    '            msg = "Diamètre Ø du mandrin en cm." : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, oriX, y)
    '            y = y + w.Height
    '            msg = "Angle de pliage: 135°" : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, oriX, y)
    '        Case 2 'image
    '            msg = "Toutes les côtes sont indiquées en cm." : w = g.MeasureString(msg, myFont8) : y = y + w.Height : g.DrawString(msg, myFont8, myBrush, oriX, y)
    '            y = y + w.Height
    '            msg = "Diamètre Ø du mandrin en cm." : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, oriX, y)
    '            y = y + w.Height
    '            msg = "Angle de pliage: 135°" : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, oriX, y)
    '        Case 3 'imprimante
    '            msg = "Toutes les côtes sont indiquées en cm." : w = g.MeasureString(msg, myFont) : y = y + w.Height : g.DrawString(msg, myFont, myBrush, oriX, y)
    '            y = y + w.Height
    '            msg = "DM = Diamètre Ø du mandrin en cm." : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, oriX, y)
    '            y = y + w.Height
    '            msg = "Angle de pliage: 135°" : w = g.MeasureString(msg, myFont) : g.DrawString(msg, myFont, myBrush, oriX, y)
    '    End Select

    '    'y = y + w.Height
    'End Sub
    'Private Sub Bar_HA_Inf_P(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal i As Integer, ByVal X2 As Single, ByVal red As Double,
    '                  ByVal OriY As Single, ByVal msg1 As String)
    '    'Ferraillage inférieurs
    '    'armatures principales
    '    Dim X, Y, X1, Y1 As Single
    '    Dim j As Integer
    '    Dim w As SizeF
    '    Dim msg As String
    '    Dim r As Integer
    '    r = i Mod 2
    '    If r > 0.3 Then
    '        'i = nombre impair
    '        j = 30
    '    Else
    '        j = 0
    '    End If
    '    With PlanCont.Item(i)
    '        X = CSng(X2 + red * (- .LitInf(0).L13acier)) : Y = CSng(OriY + red * (.LappH + .Ly / 2) + j)
    '        X1 = CSng(X2 + red * (.Lx + .LitInf(0).L23acier))
    '        g.DrawLine(mypen3, X, Y, X1, Y) 'armature
    '        X = CSng(X2 + red * .Lx / 3)
    '        Y = CSng(OriY + red * (.LappH + .LitInf(0).S1)) : Y1 = CSng(OriY + red * (.LappH + .Ly - .LitInf(0).S2))
    '        g.DrawLine(mypen, X, Y, X, Y1) 'ligne de répartition
    '        'flèche haut
    '        g.DrawLine(mypen, X, Y, X - 8, Y + 8)
    '        g.DrawLine(mypen, X, Y, X + 8, Y + 8)
    '        g.DrawLine(mypen, X - 8, Y, X + 8, Y)
    '        msg = (.LitInf(0).S1 * 100).ToString("#")
    '        w = g.MeasureString(msg, myFont)
    '        g.DrawString((.LitInf(0).S1 * 100).ToString("#"), myFont, myBrush, X + w.Width / 2, Y)
    '        'flèche basse
    '        g.DrawLine(mypen, X, Y1, X - 8, Y1 - 8)
    '        g.DrawLine(mypen, X, Y1, X + 8, Y1 - 8)
    '        g.DrawLine(mypen, X - 8, Y1, X + 8, Y1)
    '        g.DrawString((.LitInf(0).S2 * 100).ToString("#"), myFont, myBrush, X + w.Width / 2, Y1 - w.Height)
    '        'rond indicatif
    '        X = CSng(X2 + red * (.Lx / 3))
    '        Y = CSng(OriY + red * (.LappH + .Ly / 2) + j)
    '        g.FillEllipse(Brushes.White, X - 10, Y - 10, 20, 20)
    '        g.DrawEllipse(mypen, X - 10, Y - 10, 20, 20)
    '        w = g.MeasureString(msg1, myFont)
    '        g.DrawString(msg1, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
    '    End With
    'End Sub
    'Private Sub Bar_HA_Inf_S(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen2 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal i As Integer, ByVal X2 As Single, ByVal red As Double,
    '                     ByVal OriY As Single, ByVal msg1 As String, ByVal i_tot As Integer)
    '    'Ferraillage inférieurs
    '    'armatures principales
    '    Dim X, Y, X1, Y1 As Single
    '    Dim msg As String
    '    Dim w As SizeF

    '    With PlanCont.Item(i)
    '        X = CSng(X2 + red * (2 * .Lx / 3)) : Y = CSng(OriY + red * (.LappH - .LitInf_Y(0).L13acier))
    '        Y1 = CSng(OriY + red * (.LappH + .Ly + .LitInf_Y(0).L23acier))
    '        g.DrawLine(mypen2, X, Y, X, Y1) 'armature
    '        X = CSng(X2 + red * (.LitInf_Y(0).S1)) : X1 = CSng(X2 + red * (.Lx - .LitInf_Y(0).S2))
    '        Y = CSng(OriY + red * (.LappH + 2 * .Ly / 3))
    '        g.DrawLine(mypen, X, Y, X1, Y) 'ligne de répartition
    '        'flèche gauche
    '        g.DrawLine(mypen, X, Y, X + 8, Y - 8)
    '        g.DrawLine(mypen, X, Y, X + 8, Y + 8)
    '        g.DrawLine(mypen, X, Y - 8, X, Y + 8)
    '        msg = (.LitInf_Y(0).S1 * 100).ToString("#")
    '        w = g.MeasureString(msg, myFont)
    '        g.DrawString(msg, myFont, myBrush, X + w.Width / 2, Y)
    '        'flèche droite
    '        g.DrawLine(mypen, X1, Y, X1 - 8, Y - 8)
    '        g.DrawLine(mypen, X1, Y, X1 - 8, Y + 8)
    '        g.DrawLine(mypen, X1, Y - 8, X1, Y + 8)
    '        msg = (.LitInf_Y(0).S2 * 100).ToString("#")
    '        w = g.MeasureString(msg, myFont)
    '        g.DrawString(msg, myFont, myBrush, X1 - w.Width - w.Width / 2, Y)
    '        'rond indicatif
    '        X = CSng(X2 + red * (2 * .Lx / 3))
    '        Y = CSng(OriY + red * (.LappH + 2 * .Ly / 3))
    '        g.FillEllipse(Brushes.White, X - 10, Y - 10, 20, 20)
    '        g.DrawEllipse(mypen, X - 10, Y - 10, 20, 20)
    '        w = g.MeasureString(msg1, myFont)
    '        g.DrawString(msg1, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
    '        If .LitInf_Y(1).nbar >= 1 Then
    '            X = CSng(X2 + red * (2 * .Lx / 3)) - 4 : Y = CSng(OriY + red * (.LappH + .Ly - .LitInf_Y.Item(1).Lacier2 + .LitInf_Y.Item(1).L13acier))
    '            Y1 = CSng(OriY + red * (.LappH + .Ly + .LitInf_Y.Item(1).L13acier))
    '            g.DrawLine(mypen2, X, Y, X, Y1) 'armature
    '            X = X - 20 + 4 : Y = CSng(OriY + red * (.LappH + 2 * .Ly / 3))
    '            g.FillEllipse(Brushes.White, X - 10, Y - 10, 20, 20)
    '            g.DrawEllipse(mypen, X - 10, Y - 10, 20, 20)
    '            i_tot = i_tot + 1 : msg = i_tot.ToString("#")
    '            w = g.MeasureString(msg, myFont)
    '            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
    '        End If
    '    End With
    'End Sub
    'Private Sub Bar_HA_Sup_P_TS(ByVal g As Graphics, ByVal mypen As Pen, ByVal mypen3 As Pen, ByVal myBrush As SolidBrush, ByVal myFont As Font, ByVal i As Integer, ByVal X2 As Single, ByVal red As Double,
    'ByVal OriY As Single, ByRef N_Pan As Integer, ByVal Support As Integer)

    '    'acier sur appui intermédiaire
    '    Dim X, Y, X1, Y1, Rmax As Single
    '    Dim msg As String
    '    Dim w As SizeF
    '    Dim d1, d2, d3, fl As Integer
    '    Dim r As Integer
    '    Select Case Support
    '        Case 1 'écran
    '            d2 = 10 : fl = 8 : d3 = 40
    '        Case 2 'image
    '            d2 = 1 : fl = 2 : d3 = 4
    '        Case 3 'imprimante
    '            d2 = 1 : fl = 2 : d3 = 4
    '    End Select
    '    r = i Mod 2
    '    If r > 0.3 Then
    '        'i = nombre impair
    '        Select Case Support
    '            Case 1 'écran
    '                d1 = -30
    '            Case 2 'image
    '                d1 = -3
    '            Case 3 'imprimante
    '                d1 = -3
    '        End Select
    '    Else
    '        Select Case Support
    '            Case 1 'écran
    '                d1 = 30
    '            Case 2 'image
    '                d1 = 3
    '            Case 3 'imprimante
    '                d1 = 3
    '        End Select
    '    End If
    '    With PlanCont.Item(i)
    '        X = CSng(X2 + red * (.TS_AppD.Item(0).X1acier)) : Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1)
    '        X1 = CSng(X2 + red * (.Lx + .LappD + PlanCont.Item(i + 1).TS_AppG.Item(0).X2acier))
    '        g.DrawLine(mypen3, X, Y, X1, Y) 'armature
    '        X = CSng(X2 + red * (.TS_AppD.Item(0).X1acier) - d2)
    '        Y = CSng(OriY + red * (.LappH)) : Y1 = CSng(OriY + red * (.LappH + .Ly))
    '        g.DrawLine(mypen, X, Y, X, Y1) 'ligne de répartition
    '        'flèche haut
    '        g.DrawLine(mypen, X, Y, X - fl, Y + fl)
    '        g.DrawLine(mypen, X, Y, X + fl, Y + fl)
    '        g.DrawLine(mypen, X - fl, Y, X + fl, Y)
    '        'flèche basse
    '        g.DrawLine(mypen, X, Y1, X - fl, Y1 - fl)
    '        g.DrawLine(mypen, X, Y1, X + fl, Y1 - fl)
    '        g.DrawLine(mypen, X - fl, Y1, X + fl, Y1)
    '        'rond indicatif
    '        X = CSng(X2 + red * (.TS_AppD.Item(0).X1acier) - d2)
    '        Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1)
    '        N_Pan = N_Pan + 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
    '        If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
    '        g.FillEllipse(Brushes.White, X - w.Width, Y - w.Height, CSng(Rmax * 1.5), CSng(Rmax * 1.5))
    '        g.DrawEllipse(mypen, X - w.Width, Y - w.Height, CSng(Rmax * 1.5), CSng(Rmax * 1.5))
    '        g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
    '        If PlanCont.Item(i + 1).TS_AppG.Item(0).LacierY.Count = 2 Then
    '            Y = CSng(OriY + red * (.LappH + .Ly / 2) + d1 + 20)
    '            N_Pan = N_Pan + 1 : msg = N_Pan.ToString : w = g.MeasureString(msg, myFont)
    '            If w.Width > w.Height Then Rmax = w.Width Else Rmax = w.Height
    '            g.FillEllipse(Brushes.White, X - w.Width, Y - w.Height, CSng(Rmax * 1.5), CSng(Rmax * 1.5))
    '            g.DrawEllipse(mypen, X - w.Width, Y - w.Height, CSng(Rmax * 1.5), CSng(Rmax * 1.5))
    '            g.DrawString(msg, myFont, myBrush, X - w.Width / 2, Y - w.Height / 2)
    '        End If
    '        'côte
    '        X = CSng(X2 + red * (.Lx) + 2)
    '        X1 = CSng(X2 + red * (.TS_AppD.Item(0).X1acier))
    '        Y = CSng(OriY + red * (.LappH + .Ly / 2) - 2 * d3)
    '        g.DrawLine(mypen, X, Y, X1 - d3, Y) 'horizontal
    '        g.DrawLine(mypen, X1, Y - fl, X1, Y + fl) 'vertical
    '        msg = ((.Lx - .TS_AppD.Item(0).X1acier) * 100).ToString("0")
    '        w = g.MeasureString(msg, myFont)
    '        g.DrawString(msg, myFont, myBrush, X1 - d3, Y - w.Height)
    '    End With
    'End Sub
#End Region

End Module
